<?php
ob_start();
set_include_path(get_include_path() . PATH_SEPARATOR . '/classes/LIBS/xls_lib');



$priceTypes = array(
    'price_1' => 'KLOSS SERVICES CORPORATION',
    'price_2' => '',
);

$groups = array();

$currentRate = 1;

/// $priceSettingsFile = (isset($_POST['price_type'])) ? '../db/.price_settings_ ' . $_POST['price_type'] . '.txt' : false;
/// $oldData = array();
/// if (file_exists($priceSettingsFile)) {
///    $oldData = @unserialize(file_get_contents($priceSettingsFile));
///    if (!is_array($oldData)) {
///        $oldData = array();
///    }
/// }

if ($sotr_s) foreach ($sotr_s as $key => $value) {
    $mas = explode(" ~ ", $value);
    $groups[$mas[0]] = Array(
        'name' => $mas[4],
        'key' => $key,
        'top' => $mas[1],
        'level' => 0
    );
}

function implodeDb($data) {
    if (is_array($data)) {
        $data = implode(' ~ ', $data);
    }
    return $data;
}

function getCountParents($id, &$array) {
    $result = 0;
    $parentKey = $id;

    if (isset($array[$parentKey]) && !empty($array[$parentKey]['top'])) {
        while (isset($array[$parentKey]) && !empty($array[$parentKey]['top'])) {
            $result += 1;
            $parentKey += $array[$parentKey]['top'];
        }
    } elseif (isset($array[$parentKey]) && !empty($array[$parentKey]['top'])) {
        $result += 1;
    }
    return $result;
}

///  
$sGroups = array();
$sGroups_links = array();
$old_group = $groups;
for ($i = 1; $i <= 3; $i++) {
    foreach ($groups as $id => $row) {
        if ($row['top'] == 'd' || !$id) {
            continue;
        } elseif ($row['top'] == 0) {
            $sGroups[$id] = array(
                'id' => $id,
                'name' => $row['name'],
                'top' => $row['top'],
                'childs' => array()
            );

            $sGroups_links[$id] = &$sGroups[$id]['childs'];

            unset($groups[$id]);
        } else {
            if (!isset($sGroups_links[$row['top']])) {
                continue;
            }

            unset($groups[$id]);

            $sGroups_links[$row['top']][$id] = array(
                'id' => $id,
                'name' => $row['name'],
                'top' => $row['top'],
                'childs' => array()
            );

            $sGroups_links[$id] = &$sGroups_links[$row['top']][$id]['childs'];
        }
    }
}
$groups = $old_group;
unset($old_group);
$dataToUpload = array();

$breads = array();

///===---------------------------------------------------------------------==///
//                       
///===---------------------------------------------------------------------==///
if (isset($_GET['settings'])) {
    $status_string .= ' / <a href="?menu='.$menu.'&amp;leaders"> </a>';

    $breads[] = array(
        'href'  => 's2=1&r=prod&r1=xls_parser&binding=1',
        'title' => ' '
    );

    ///===---------------------------------------------------------------------==///
    //                          
    ///===---------------------------------------------------------------------==///
    if (isset($_GET['create'])) {
        $price = new price(array('name' => $_REQUEST['name']));
        $price->save();
        $price = null;
    } elseif (isset($_REQUEST['id'])) {
        $price = price::load($_REQUEST['id']);
    }
    
    if (isset($_GET['delete']) && $price) {
        $price->delete();
        $price = null;
    }    

    if (isset($_GET['clear']) && $price) {
        $price->delete(true);
        $price = null;
    }

    unset($_GET['create']);
    unset($_GET['delete']);
    
    if ($price == null) {
        $create_uri = '?' . http_build_query($_GET) . '&create';
        $response = <<<PRE
            <form action="$create_uri" method="post" cellpadding="0" cellspacing="0">
            <table class="table table-condensed">
                <tr>
                    <td class="table_head"></td>
                    <td class="table_head">  </td>
                    <td class="table_head"></td>
                </tr>
PRE;
        $prices = price::load_all();
        foreach ($prices as $id => $price) {
            $name = $price->get_name();
            $delete_url = '?' . http_build_query(array_merge($_GET, array('id' => $id, 'delete' => '')));
            $edit_url   = '?' . http_build_query(array_merge($_GET, array('id' => $id)));
            $response .= '<tr class="table_tr">
                <td>
                    <a href="' . $edit_url . '">' . $name . '</a>
                </td>
                <td>
                    ' . ($price->has_upload() ? ' ' : '&mdash;') . '
                </td>
                <td style="text-align: right;">' . <<<PRE
                    <a href="$edit_url"><span class="ico ico-edit"></span></a>&nbsp;
                    <span class="ico ico-del"
                        onclick="if (confirm('     ?')) { window.location.href='{$delete_url}';}"></span>
PRE
                . '</td>
            </tr>';
        }
        $response .= '<tr>
                <td>
                    <input class="forma" type="text" name="name" />
                </td>
                <td colspan="2">
                    <input class="btn" type="submit" value=""/>
                </td>
            </tr>';
        $response .= '</table></form>';
        echo $response;
    }
    ///===---------------------------------------------------------------------==///
    //                         
    ///===---------------------------------------------------------------------==///
    else {
        $breads[] = array(
            'href'  => 's2=1&r=prod&r1=xls_parser&binding=1&id' . $price->get_id(),
            'title' => $price->get_name()
        );
        if (!empty($_POST)) {
            $price->set_options($_POST);
            if (isset($_POST['clear'])) {
                $price->clear_categories();
            }
            $price->save();
        }
        echo $price->render_control($sGroups);
    }
}
///===---------------------------------------------------------------------==///
//                       
///===---------------------------------------------------------------------==///
else {
    if (!empty($_FILES) || isset($_REQUEST['buffer']) || isset($_REQUEST['buffer-with-validate'])) {
        $prices = price::load_all(); 
        $import = new price_imports(false);

        $_has_new_groups = false;
        foreach ($prices as $id => $price) {
            if (isset($_FILES['xls_price']['tmp_name'][$id]) && $_FILES['xls_price']['tmp_name'][$id] != null) {
                $filename = $_FILES['xls_price']['tmp_name'][$id];
                $price->upload($filename);
            }
            $price
                ->set_currency_rate($currentRate)
                ->process($import);
            $_has_new_groups = $_has_new_groups || $price->has_new_groups();
            $price->save();
        }
        
        if ($_has_new_groups) {
            echo '<p><b>    ,    </b></p>';
        }
        if (isset($_REQUEST['import'])) {
            $breads[] = array(
                'href'  => 's2=1&r=prod&r1=xls_parser',
                'title' => '      '
            );
            echo $import->import();
        } else {
            $breads[] = array(
                'href'  => 's2=1&r=prod&r1=xls_parser',
                'title' => '      '
            );
            echo $import->render_imports($groups, false);
        }
    } else {
        $breads[] = array(
            'title' => ' ',
            'href' => 's2=1&r=prod&r1=xls_parser'
        );
        $price = new price();
        echo $price->render_upload();
    }
}
?>
<!-- <center><span class="text_head1"> XLS</span></center><br> -->

<?php 
//echo $body_sect; 
$body_sect = ob_get_contents();
ob_end_clean();


?>
