<?php

class forms_utils {

    function show_result_list($submit_data, array $fields = null, $form_name = false) {
        $output .= '<table class="table">
            <tr>
                <th style="width:140px;"></th>';

        if ($form_name)
            $output .= '<th></th>';
        
        $optional_column = array(
            'name', 'email', 'telephone'
        );

        $optional_names = array(
            'name' => '',
            'email' => 'E-mail',
            'telephone' => ''
        );
        $request_column = array();

        //        
        if ($fields !== null)
            foreach ($fields as $v) {
                $alias = $v['alias'];
                if (in_array($alias, $optional_column) && !in_array($alias, $request_column)) {
                    $request_column[] = $alias;
                }
            }
        else
            $request_column = $optional_column;
        ksort($request_column);

        $count_columns = 2;
        foreach ($request_column as $column) {
            $count_columns++;
            $output .= '<th>' . $optional_names[$column] . '</th>';
        }
        $output .= '<th style="width:140px;"></th>
            </tr>';

        $menu = 'services';
        $page = 'forms';

        $forms_names = array();
        
        if ($submit_data)
            foreach ($submit_data as $k => $v) {
                $output .= '<tr>
                    <td>' . htmlspecialchars($v['date'], null, 'windows-1251') . '</td>';
                if ($form_name) {
                    if (!isset($forms_names[$v['forms_id']])) {
                        global $db;
                        $forms = new forms($db);
                        $forms->id = $v['forms_id'];
                        $data = $forms->load();
                        $forms_names[$v['forms_id']] = $data['name'];
                    }
                    $output .= '<td>' . $forms_names[$v['forms_id']] .'</td>';
                }

                foreach ($request_column as $column) {
                    $output .= '<td>' . htmlspecialchars($v[$column], null, 'windows-1251') . '</td>';
                }

                $output .='<td>
                        <a title="'.$v['comment'].'" href="?menu=' . $menu . '&amp;page=' . $page . '&amp;id=' . $v['forms_id'] . '&amp;submit_data=' . $v['id'] . '"><span class="ico ico-edit"></span></a> ';
                if ($v['processed'] != 1)
                    $output .= '<a href="' . GO . '?menu=' . $menu . '&amp;page=' . $page . '&amp;do=process_submit_data&amp;submit_data_id=' . $v['id'] . '"><span class="ico ico-approver"></span></a> ';
                $output .='<a href="' . GO . '?menu=' . $menu . '&amp;page=' . $page . '&amp;do=delete_submit_data&amp;submit_data_id=' . $v['id'] . '" onclick="return confirm(\'   \');"><span class="ico ico-del"></span></a> ';
                $output .= '</td>
                  </tr>';
            }
        else
            $output .= '<tr><td colspan="' . $count_columns . '">    </tr>';
        $output .= '</table>';
        return $output;
    }

}