<?php
load_lib('admin');


if (!defined('DR'))
    exit('GO HOME, HACKER!!!');
if (!$user->root && !$user->data['access'][$menu][$page][0])
    return;

include DR . '/classes/class.polls.php';

$body_sect = '';
$polls = new polls($db);
$data  = $polls->load();
if ($polls->id && $data != null) {
    $status_string .= '/ <a href="?menu=' . $menu . '&amp;page=' . $page . '"></a> / ' . $data['name'];
    $body_sect .= render_polls_control($polls, $data);
} else {
    $status_string .= '/ ';
    $list = $polls->load();
    $body_sect .= render_polls_list($polls, is_array($data) ? $data : array() );
}




function render_polls_control(Polls $module, $poll = null) {
    if ($poll == null)
        $poll = $module->current;
    $id = $poll['id'];
    $date       = !empty($poll['date']) ? date('d.m.Y', $poll['date']) : '';

    $output .= '
    <form action="' . meno_build_go(array('do' => 'update', 'id' => $id), $page_id) . '" method="post" enctype="multipart/form-data">
        <table class="table table-stripped">
            <tr>
                <td></td>
                <td>
                    <input type="text" name="name" value="' . htmlspecialchars($poll['name']) . '" class="forma" /> 
                </td>
            </tr>
            <tr>
                <td></td>
                <td>
                    <input type="submit" value="" class="btn btn-primary" />
                </td>
            </tr>
        </table>
    </form>';

    $polls_arr = $module->sort_results(unserialize($poll['results']));
    $output.='<form action="' . meno_build_go(array('id' => $id, 'do' => 'update_position')) . '" method="post">
        <table class="table table-stripped">
        <tr>
            <th></th>
            <th> </th>
            <th></th>
            <th></th>
        </tr>';

    if ($polls_arr) {
        foreach ($polls_arr as $key => $num) {
            $output.=
            '<tr>
                <td><a style="cursor: pointer;" onclick="poll_edit_field(' . $id . ',' . $key . ', this)">'    . $num['name'] . '</a></td>
                <td><b>' . $num['res']  . '</b></td>
                <td style="width: 100px"><input style="width: 100px" class="forma" name="position['. $key .']" value="' . $num['order'] . '"/></b></td>
                <td style="width: 100px">' . 
                    '<a style="cursor: pointer;" onclick="poll_edit_field(' . $id . ',' . $key . ', this)"><span class="ico ico-edit"></span></a> ' . 
                    '<a href="' . meno_build_go(array('id' => $id, 'key' => $key, 'do' => 'delete_field')) . '"  onclick="return confirm(\'     ?\');"><span class="ico ico-del"></span></a> ' . 
                '</td>
            </tr>';
        }
        
        $output.= '
            <tr>
                <th> :</td>
                <th>
                    <strong>' . htmlspecialchars($poll['count']) . '</strong> 
                </th>
                <td style="width: 100px"><input style="width: 100px" type="submit" value="" class="btn" /></td>
                <td></td>
            </tr>';
    }
    
    $output.= '
            </table>
        </form>
        <form action="' . meno_build_go(array('id' => $id, 'do' => 'add_field')) . '" method="post">
            <table>
                <tr>
                    <th colspan="2">
                        <input type="text" name="name" class="forma" style="width:350px;" />
                    </th>
                    <th>
                        <input type="submit" value="" class="btn" />
                    </th>
                </tr>
            </table>
        </form>';
    
    $output .= <<<PRE
    <div id="edit_field" class="modular_message"></div>
    <script type="text/javascript">
    <!--
        function poll_edit_field(id, field, el) {
            var get='subservices/ajax.php?service=polls&do=field_form&id='+id+'&field='+field;
            var pos = absPosition(el);
            document.getElementById('edit_field').style.top = pos.y;
            document.getElementById('edit_field').style.display = 'block';
            document.getElementById('edit_field').innerHTML = get_ajax_data(get);		
        }
    //-->
    </script>
PRE;

    return $output;
}

function render_polls_list(Polls $module, array $list) {
    $output = '<form action="' . meno_build_go(array('do' => 'create')) . '" method="post"><table class="table table-stripped"><tr><th></th><th width="100px"></th></tr>';
    if ($list)
        foreach ($list as $pool) {
            $id = $pool['id'];
            $output .= '
                <tr>
                    <td><a title="/" href="' . meno_build_url(array('id' => $id)) .'">' . $pool['name'] . '</a></td>
                    <td>
                        <a title="/" href="' . meno_build_url(array('id' => $id)) .'"><span class="ico ico-edit"></span></a>
                           <a title="/ " href="' . meno_build_go(array('do' =>($pool['vis'] ? 'hide' : 'show'), 'id' => $id)) . '"><span class="ico ico-switch_' . ($pool['vis'] ? 'on' : 'off') . '"></span></a>
                           <a title="!      !" href="' . meno_build_go(array('do' => 'open', 'id' => $id)) . '">
                           <span class="ico ico-' . ($pool['isOpen'] ? 'un' : '') . 'lock"></span></a>
                           <a title="" href="' . meno_build_go(array('do' => 'delete', 'id' => $id)) . '" onclick="return confirm(\'   ?\');"><span class="ico ico-del"></span></a>
                    </td>
                </tr>';
        }
    $output .= '<tr><th><input type="text" name="name" class="forma" style="width:350px;" /></th>
    			  <th><input type="submit" value="" class="btn" /></th></tr></table></form>';
    return $output;
}
?>