<?php

/**
 *  
 */
class account_chains extends Module {

    /**
     *   
     * @var string - db name
     */
    static $table = 'account_chains';

    public function load() {
        if ($this->id !== null) {
            if (($row = $this->_load(self::$table, $this->id))) {
                $this->current = $row;
                return $row;
            }
        }
        return false;
    }
    /**
     *  
     * @param int $id
     * @param int $id_to 
     */
    public function chain($id, $id_to) {
        if (!$this->chainExists($id, $id_to) && $id && $id_to)
            $this->db->insert(self::$table, array('user_id' => $id, 'chain_user' => $id_to));
    }

    public function chainExists($user_id, $user_to) {
        $result = $this->db->query('SELECT 1 FROM `' . self::$table . '` WHERE `user_id` = :id and `chain_user` = :chain', array(
                    "id" => $user_id,
                    "chain" => $user_to
                ));
        return @mysql_result($result, 0, 0) == 1;
    }

    /**
     *  
     * @param int $id
     * @param int $id_to 
     */
    public function broke_chain($id, $id_to) {
        $this->db->delete(self::$table, array('user_id' => $id, 'chain_user' => $id_to));
    }

    public function get_linked_users($user_id) {
        return $this->db->query('
        SELECT `user`.`id` AS "id", CONCAT_WS( " ", `user`.`name` , `user`.`patronim` , `user`.`family` ) AS `name`
        FROM `' . self::$table . '` AS `ch`
        LEFT JOIN `' . account::$table . '` AS `user` ON `ch`.`chain_user` = `user`.`id`
        WHERE `ch`.`user_id`=:id', array('id' => $user_id), db::FETCH_ALL);
    }

    public function get_linked_moders($user_id) {
        return $this->db->query('SELECT `ch`.* ,`user`.`id` as "uid" ,CONCAT_WS(" ",`user`.`name`,`user`.`patronim`,`user`.`family`) as `name`, `user`.`email`
        FROM `' . self::$table . '`  as `ch` LEFT JOIN `' . account::$table . '` as `user` 
            ON `ch`.`user_id`=`user`.`id` 
        WHERE  `ch`.`chain_user`=:id and `user`.`id`', array('id' => $user_id), db::FETCH_ALL);
    }
}

?>