<?php

/**
 * @author Arbora Sergey (http://arbora.ru)
 *
 **/

class banners extends Module{
	public static $table_name = 'banners_nonsys';
	protected $db;
	public $data;
	public $id = null;
	private $trumbal_w = 220;
    private $path = '/content/images/banners/';
    public $allowed_exts = array('swf','png','gif','jpg','jpeg');

	function __construct($db,$id = null){
		$this->db = $db;
		if($id === null){
			if(isset($_REQUEST['id'])) $this->id = (int)$_REQUEST['id'];
		}else $this->id = (int)$id;
	}

	public function load($id = null){
		if($id === null&&$this->id===null){
			$q = 'SELECT * FROM `'.self::$table_name.'`
            	 ORDER BY `sort` DESC, `id` DESC';
			$r = $this->db->query($q);
			while($row = mysql_fetch_assoc($r)){
				$this->data[$row['id']] = $row;
			}
			return $this->data;
		}else{
			if($id!==null) $this->id = (int)$id;
			$q = 'SELECT * FROM `'.self::$table_name.'`
            	 WHERE `id`='.$this->id;
			$r = $this->db->query($q);
			$this->data[$this->id] = mysql_fetch_assoc($r);
			if($this->data[$this->id]) return $this->data[$this->id];
			else return false;
		}
	}
	public function loadById($id=null){
		if (!is_numeric($id)) 
			return false;
		return $this->db->query('SELECT * FROM `'.self::$table_name.'` WHERE `id`="'.$id.'"',null,db::FETCH_ROW);
	}
	function create($array = NULL){
		if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }
		$insert = array(
			'name'=> $array['name'],
			'show_main' => isset($array['show_main']) ? 1 : 0,
			'show_other' => isset($array['show_other']) ? 1 : 0,
			'show_in' => ( isset($array['show_in']) && $array['show_in']) ? @serialize_mysql(explode(',',$array['show_in'])): 0,
			);
			$this->db->insert(self::$table_name,$insert);
		$this->id = $this->db->get_id();
		return $this->id;
	}
	function update($array = null){
        if(!$this->id) return false;
        $this->load();
        if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }
		$update = array(
			'name'=> $array['name'],
			'href' => $array['href'],
			'show_main' => isset($array['show_main']) ? 1 : 0,
			'show_other' => isset($array['show_other']) ? 1 : 0,
			'show_in' => (isset($array['show_in']) && $array['show_in']) ? @serialize_mysql(explode(',',$array['show_in'])) : 0,
			);
			$this->db->update(self::$table_name,$update,array('id'=>$this->id));

	        if (is_uploaded_file($_FILES['image']['tmp_name'])) {
                $name = $_FILES['image']['name'];
                $name = explode('.', $name);
                $ext = end($name);
                $name = 'banner_' . $this->id;
            if (!in_array($ext,$this->allowed_exts)) return '';

            $update = array();
			$update['image'] = "$name.$ext";

            if ($ext=='swf'){
            	$file = ($_FILES['image']['tmp_name']);
            	if (move_uploaded_file($_FILES['image']['tmp_name'],SR.$this->path.$name.'.'.$ext)){
					$update['type'] = 'flash';
            	}
            	else return '';
            }
            else
            {
		        $resize = new upload($_FILES['image']['tmp_name']);
		        if ($resize->uploaded) {
		            $type = $_FILES['image']['type'];
		            $type = explode('/', $type);
		            if ($type[0] != 'image') {
		                return '';
		            }
		            $imgsize = @getimagesize(rtrim(SR,'/') . $this->path . $name. '.' . $ext);
		            $resize->file_new_name_body = $name;
		            $resize->file_new_name_ext = $ext;
		            $resize->image_resize = false;
		            /*
		            if ($this->trumbal_h > 0 && $this->trumbal_w > 0) {
		                $resize->image_x = $this->trumbal_w;
		                $resize->image_y = $this->trumbal_h;
		                $resize->image_ratio_crop = true;
		            } elseif ($this->trumbal_w > 0 && !$this->trumbal_h) {
		                $resize->image_x = $this->trumbal_w;
		                $resize->image_ratio_y = true;
		            } elseif ($this->trumbal_h > 0 && !$this->trumbal_w) {
		                $resize->image_y = $this->trumbal_h;
		                $resize->image_ratio_x = true;
		            }
                    $resize->jpeg_quality = 100;
		            $resize->file_overwrite = true;
            		*/
            		//удаляем на всякий случай
            		if (is_file(SR . $this->path . $this->data[$this->id]['image']))
                		@unlink(SR . $this->path . $this->data[$this->id]['image']);
		            $resize->process(SR . $this->path);
		            if ($resize->error)
		                die($resize->error);
		             $update['type']='image';
		        	}
		       }
			$this->db->update(self::$table_name,$update,array('id'=>$this->id));
        }
		
		if(isset($array['delete_image'])) {
			if(is_file(SR.$this->path.$this->data[$this->id]['icon'])) @unlink(SR.$this->path.$this->data[$this->id]['icon']);
			$this->db->update(self::$table_name,array('image'=>''),array('id'=>$this->id));
		}
        return true;
	}
	function show(){
		$this->db->update(self::$table_name, array('visible'=>'1'),array('id'=>$this->id));
	}

	function hide(){
		$this->db->update(self::$table_name, array('visible'=>'0'),array('id'=>$this->id));
	}

	function delete(){
		if(!$this->id) return false;
		$this->db->delete(self::$table_name,array('id'=>$this->id));
		return true;
	}
	
	public function getPath() {
		return $this->path;
	}
}
?>