<?php
/**
 *  
 *
 * @author  
 */
class Compras extends Module{

    /**
     *   
     * @var type 
     */
    public static $addCartUrl = '/compras/';

    /**
     * 
     * @var array 
     */
    protected $cart_list = array();

    public static $status_img_path = 'content/user_files/status/';

     /**
      *  .
      *       ,      
      *  
      */
    protected $required_params = array('id','cid'); //'price' 

    function __construct($db) {
        parent::__construct();
        //$this->db = $db;
        /* $settings = new settings($db);
          $this->settings = $settings->load('cart'); */
        if (!$_SESSION) {
            session_start();
        }
        if (!isset($_SESSION['compras']))
            $this->cart_list = array();
        else
            $this->cart_list = $_SESSION['compras'];
    }

    public function load(){
    }

    /**
     * add/update 
     * @param array $data
     * @param boolean $replace -      ( )
     */
    public function set($data, $replace = false) {
        if (!isset($data[0]['id']) || !isset($data['cid']))
            return false;
		//       
        if ($this->item_exists($data[0]['id'])) 
		{
            return false;
        }
		//      ,    
        elseif ($this->sect_exists($data['cid'])) 
		{
			$this->add_sect($data);
		}
		else
            $this->add($data);
			
        $this->save();
    }
	
	public function sect_exists($cid = null)
	{	
		if (!$cid) return false;
		if (!empty($this->cart_list))
		{
			foreach ($this->cart_list as $v)
			{
				if ($cid == $v['cid']) return true;
					else continue;
			}
		}
		return false;
	}

    /**
     *    
     * @param array $data 
     */
    public function add($data) 
	{
		$cid = $data['cid'];
        $_ids = array_values($data[0]);
			$data['cid'] = $cid;
			$data[0] = $_ids;
        $this->cart_list[] = $data;
    }
	
	public function add_sect($data) 
	{
		$cid = $data['cid']; //   
		$_ids = array_values($data[0]);
		
			if (!empty($this->cart_list))
			{
				foreach ($this->cart_list as $k => $v)
				{
					if ($cid == $v['cid'])
					{
						$this->cart_list[$k][0][] = $_ids[0];
					}
				}
			}
		
	}

    public function delete($array = array())
    {
        $_data = $this->cart_list;
        
            foreach ($_data as $k => $v)
            {
                if ($array['cid'] == $v['cid'] && !empty($v[0]))
                {
                    foreach ($v[0] as $k_id => $_id) 
                    {
                        if ($_id == $array['id']) unset($_data[$k][0][$k_id]);
                    }
                }
            }

            //     
            foreach ($_data as $k => $v)
            {
                //,     
                if (empty($v[0])) unset($_data[$k]);
            }

            if (empty($_data)) {$this->destroy(); return false;}

            //  
            $i = 0;
            foreach ($_data as $k => $v)
            {
                $_data[$i]['cid'] = $v['cid'];
                $_data[$i][0] = array_values($v[0]);
                $i++;
            }

        $this->cart_list = $_data;
        $this->save();

    }
	
    /**
     *  
     */
    public function destroy() {
        unset($_SESSION['compras']);
        $this->cart_list = array();
		return true;
    }

    /**
     *   
     * @return array
     */
    public function get_compras() {
        return $this->cart_list;
    }

    /**
     *      
     * @param type $id
     * @return type 
     */
    public function item_exists($id) {
		if (!empty($this->cart_list))
		{
			foreach ($this->cart_list as $v)
			{
				if (in_array($id, $v[0]))
					return true;
				else
					continue;
			}
		}
		return false;
    }

    protected function save() {
        $_SESSION['compras'] = $this->cart_list;
    }

    protected function array_key_exists_full($key, $array) {
        if (!is_array($key))
            return array_key_exists($key, $array);
        else {
            $found = true;
            foreach ($key as $k) {
                if (!array_key_exists($k, $array))
                    $found = false;
            }
        }
        return $found;
    }
}

?>
