<?php

/**
 * @author Arbora Sergey (http://arbora.ru)
 *
 *    
 **/


class docs extends Module{
    public static   $table      = 'docs';
    public static   $path       = '/content/user_files/docs/';
    public static   $imgPrefix  = 's_';
    private static  $imgWidth   = 0;
    private static  $imgHeight  = '70';
    
    public function load(){
        return $this->db->query('SELECT * FROM :table',array('table'=>db_name(self::$table)),db::FETCH_ALL);
    }
    function loadById($id){
        $this->id = $id;
        return $this->db->query('SELECT * FROM :table WHERE id=:id',array('table'=>db_name(self::$table),'id'=>$id),db::FETCH_ROW);
    }
    function create($array = array()){
        if (!$array)
            $array = $this->get_request(self::$table,$_REQUEST);
        self::_create(self::$table, $array);
    }
    function delete(){
        $id = $_REQUEST['id'];
        self::_delete(self::$table,$id);
    }
    function update($array = array()){
        if ($_FILES['image']['name'])
            $_REQUEST['image'] = $this->uploadImage();
        if (!$array)
            $array = $this->get_request(self::$table,$_REQUEST);
        if (!$array['id'])
            return;

        $subfile = new subfile($this->db);
        if ($array['id'])
            $subfile->add($array['id'],'docs');
        else
            $subfile->add(mysql_insert_id(),'docs');

        self::_update(self::$table, $array['id'], $array);
        
        if(isset($_POST['delete_image'])) {
            // var_dump($array['id']);die();
            // if(is_file(SR.$this->path.$this->data['image']))
                // unlink(SR.$this->path.$this->data['image']);
            $q = 'UPDATE `'.self::$table.'` SET `image`="" WHERE `id`='.$array['id'];
            $this->db->query($q);
        }
    }
    function uploadImage(){
        if (!$this->id)
            $this->id = $_REQUEST['id'];
        if (!$this->id)
            return false;
        $sql = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`=' . ($this->id);
        $img = @array_pop($this->db->resultAsArray($sql));
        $img = stripslashes($img['image']);
        @unlink(SR . self::$path . $img);
        @unlink(SR . self::$path . self::$imgPrefix . $img);
        $name = get_name_to_file();
        $ext = $_FILES['image']['name'];
        $ext = explode('.', $ext);
        $ext = array_pop($ext);
        $resize = new upload($_FILES['image']['tmp_name']);
        if ($resize->uploaded) {
            $type = $_FILES['image']['type'];
            $type = explode('/', $type);
            if ($type[0] != 'image') {
                continue;
            }
            $resize->file_new_name_body = $name;
            $resize->file_new_name_ext = $ext;
            $resize->process(SR . self::$path);

            $imgsize = @getimagesize(SR . self::$path . $name . '.' . $ext);
            $resize->file_new_name_body = self::$imgPrefix . $name;
            $resize->file_new_name_ext = $ext;
            $resize->image_resize = true;
            if (self::$imgHeight > 0 && self::$imgWidth > 0) {
                $resize->image_x = self::$imgWidth;
                $resize->image_y = self::$imgHeight;
                $resize->image_ratio_fill = true;
            } elseif (self::$imgWidth > 0 && !self::$imgHeight) {
                $resize->image_x = self::$imgWidth;
                $resize->image_ratio_y = true;
            } elseif (self::$imgHeight > 0 && !self::$imgWidth) {
                $resize->image_y = self::$imgHeight;
                $resize->image_ratio_x = true;
            }
            $resize->file_overwrite = true;
            $resize->process(SR . self::$path);
            if ($resize->error)
                echo $resize->error;
            return mysql_real_escape_string($name) . '.' . $ext;
        }
    }
    function deleteImage() {
        if (!$this->id)
            return false;
        $sql = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`=' . ($this->id);
        $img = @array_pop($this->db->resultAsArray($sql));
        if (isset($img['image']))
            $img = $img['image'];
        @unlink(SR . self::$path . $img);
        @unlink(SR . self::$path . self::$imgPrefix . $img);
        return $this->db->query('UPDATE `' . self::$table . '` SET `image`="" WHERE `id`=' . $this->id);
    }

}
?>