<?php



class faq{
	public static $table_name = 'faq';
	private $category_table = 'faq_category';
	
	private $db;
	public $data;
	public $id = null;

	function __construct($db,$id = null){
		$this->db = $db;
		if($id === null){
			if(isset($_REQUEST['id'])) $this->id = (int)$_REQUEST['id'];
		}else $this->id = (int)$id;
	}
	function count($vis=true,$withAns=false, $category = ''){
		$where = array();
		if ($vis == true) $where[] = '`visible`=1';
		if ($withAns == true) $where[] = '`answer`!=""';
		if ($category)	$where[] ="`category`={$category}";
		
		if ($where) $where = ' WHERE '.implode(' AND ',$where);
		else $where = '';
		$q = 'SELECT COUNT(1) FROM `'.self::$table_name.'` '.$where;
		$r = $this->db->query($q);
		if ($r) return mysql_result($r, 0,0);
	}

	function loadByPages($page=1,$hidden = false,$countByPages = 5, $category = ''){
		$where = '';
		
		if ($hidden) 
			$where[] = '`visible` = 1';		
		if($category)
			$where[] = "`category` = '{$category}'";
			
		if($where)
			$where = "WHERE ". implode(" AND ", $where);
		
		$q = 'SELECT * FROM `'.self::$table_name.'` '.$where.' ORDER BY `sort`, `id` DESC  LIMIT '.(($page-1)*$countByPages).','.$countByPages.'';
		$r = $this->db->query($q);
		echo mysql_error();
		while($row = mysql_fetch_assoc($r)){
			$this->data[$row['id']] = $row;
		}
		return $this->data;

	}

	function load($id = null){
		if($id === null && $this->id === null){
			$q = 'SELECT * FROM `'.self::$table_name.'`
            	 ORDER BY `id` DESC';
			$r = $this->db->query($q);
			while($row = mysql_fetch_assoc($r)){
				$this->data[$row['id']] = $row;
			}
			return $this->data;
		}else{
			if($id!==null)
				$this->id = (int)$id;
			$q = 'SELECT * FROM `'.self::$table_name.'`
            	 WHERE `id`='.$this->id;
			$r = $this->db->query($q);
			$this->data[$this->id] = mysql_fetch_assoc($r);
			if($this->data[$this->id])
				return $this->data[$this->id];
			else
				return false;
		}
	}

//	function create($name,$question,$email=""){
	function create($array=null){
		if ($array === null) {
			if (get_magic_quotes_gpc())
				$array = array_map('stripslashes', $_REQUEST);
			else
				$array = $_REQUEST;
		}
		$date = date('d.m.Y');
		$q = 'INSERT INTO `'.self::$table_name.'` (`date`,`name`,`question`,`author_email`,category) VALUES ("'.$date.'","'.mysql_real_escape_string(clearUserText($array['name'])).'","'.mysql_real_escape_string(clearUserText($array['question'])).'","'.mysql_real_escape_string(clearUserText($array['email'])).'","'.$array['category'].'")';
		$r = $this->db->query($q);
		$this->id = $this->db->get_id();
		return $this->id;
	}
	function update($array = null){
        if(!$this->id) return false;
        $this->load();
        if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }
        $q = 'UPDATE `'.self::$table_name.'` SET `name`="'.mysql_real_escape_string(strip_tags($array['name'])).
             '", `question`="'.mysql_real_escape_string($array['question']).
			'", `date`="'.(!$array['date'] ? '' : mysql_real_escape_string($array['date'])).
        	 '", `name_adm`="'.mysql_real_escape_string($array['name_adm']).
        	 '", `date_ans`="'.(!$array['date_ans'] ? '' : mysql_real_escape_string($array['date_ans']) ).
        	 '", `answer`="'.(!$array['answer'] ? date('d.m.Y') : mysql_real_escape_string($array['answer']) ).
			'", `author_email` = "'.(!$array['author_email'] ? '' : mysql_real_escape_string($array['author_email']) ).
			'", `sort` = "'.(!$array['sort'] ? 0 : mysql_real_escape_string($array['sort']) ).
			'", `category` = "'.(!$array['category'] ? 0 : $array['category'] ).
             '" WHERE `id`='.$this->id;
        $this->db->query($q);
	}
	function show(){
		$q = 'UPDATE `'.self::$table_name.'` SET `visible`=1 WHERE `id`='.$this->id;
		$this->db->query($q);
	}

	function hide(){
		$q = 'UPDATE `'.self::$table_name.'` SET `visible`=0 WHERE `id`='.$this->id;
		$this->db->query($q);
	}

	function delete(){
		if(!$this->id) return false;
		//$a = $this->load();
		$q = 'DELETE FROM `'.self::$table_name.'` WHERE `id`='.$this->id;
		$this->db->query($q);
		return true;
	}

	function get_last($limit=1){
		$q = 'SELECT * FROM `'.self::$table_name.'` WHERE `visible`="1" ORDER BY `id` DESC LIMIT '.$limit;
		return $this->db->resultAsArray($q);
	}

	
	///category
	function categoryFindAll($array_key = 'url'){
		$result = $this->db->resultAsArray("
			SELECT * FROM `{$this->category_table}`
		");
			
		$result1 = array();
		foreach($result as $key => &$val){
			$result1[$val[$array_key]] = $val;						
		}
		
		return $result1;
	}
	
	function createCategory($array = null){
		if ($array === null) {
			if (get_magic_quotes_gpc())
				$array = array_map('stripslashes', $_REQUEST);
			else
				$array = $_REQUEST;
		}
		$date = date('d.m.Y');
		$q = 'INSERT INTO `'.$this->category_table.'` (`name`,`url`) VALUES ("'.mysql_real_escape_string(clearUserText($array['name'])).'","'.mysql_real_escape_string(clearUserText($array['url'])).'")';
		$r = $this->db->query($q);				
	}
	
	function updateCategory($array = null){        
        if($array===null){
            if(get_magic_quotes_gpc()) 
				$array=array_map('stripslashes',$_REQUEST);
            else 
				$array = $_REQUEST;
        }
        $q = 'UPDATE `'.$this->category_table.'` SET `name`="'.mysql_real_escape_string(strip_tags($array['name'])).
             '", `url`="'.mysql_real_escape_string($array['url']).			
             '" WHERE `id`='.$this->id;
        $this->db->query($q);
	}
	
	function deleteCategory(){
		if(!$this->id) return false;
		//$a = $this->load();
		$q = 'DELETE FROM `'.$this->category_table.'` WHERE `id`='.$this->id;
		$this->db->query($q);
		return true;
	}
	
}
?>