<?php

/**
 * Sergey:  , -    )))
 * @author   ,    .
 *
 * ,     ,          "",
 *   -)))) ,    ,    )))
 *
 **/

class goods_news{
    
    public static $table_name = 'goods_news';
    public static $table_category = 'goods_news_category';
    public static $path = '/content/images/goods_news/';
    private $db;
    public $data;
    public $id = null;
    public $cid = null;
    private $trumbal_w = 90;
    private $trumbal_h = 90;
    private $trumbm_w = 170;
    private $trumbm_h = 170;
    private $trumbs_w = 800;
    private $trumbs_h = 800;
    private $popPrefix = 's';
    private $itemPrefix = 'm';


    function __construct($db, $id = null){
        $this->db = $db;
        if($id === null){
            if(isset($_REQUEST['id'])) $this->id = (int)$_REQUEST['id'];
        }else $this->id = (int)$id;
    }
    function load($id = null){
        if($id === null&&$this->id===null){
            $q = 'SELECT `id`,`subscr`,`visible`,`name`,UNIX_TIMESTAMP(`date`) as `date`,`anons`,`author`,`image` FROM `'.self::$table_name.
            	 '` ORDER BY `date` DESC,`id` DESC';
            $r = $this->db->query($q);
            while($row = mysql_fetch_assoc($r)){
                $this->data[$row['id']] = $row;
            }
            return $this->data;
        }else{
            if($id!==null) $this->id = (int)$id;
            $q = 'SELECT *,UNIX_TIMESTAMP(`date`) as `date` FROM `'.self::$table_name.'` WHERE `id`='.$this->id;
            $r = $this->db->query($q);
            $this->data[$this->id] = mysql_fetch_assoc($r);
            if($this->data[$this->id]) return $this->data[$this->id];
            else return false;
        }
    }

    //     
    function loadByCatURI($uri){
        if($cid!==null) $this->cid = (int)$cid;
        $q = 'SELECT *,UNIX_TIMESTAMP(`date`) as `date` FROM `'.self::$table_name.'` WHERE `cid`='.$this->cid;
        $this->data[$this->cid] = $this->db->resultAsArray($q);
        if($this->data[$this->cid]) 
            return $this->data[$this->cid];
        else return false;
    }

    //      id 
    function loadByObject($cid, $id, $limit=null){
        if (!is_numeric($cid) || !is_numeric($id)) return false;
        return $this->db->resultAsArray('SELECT *,UNIX_TIMESTAMP(`date`) as `date` FROM `'.self::$table_name.'` WHERE `cid`='.$cid.' AND `object_id`="'.$id.'" AND `visible`'.($limit ? ' LIMIT '.$limit : ''));
    }

    /** 
    * @param $id: id,uri 
    **/
    function getCatName($id = null){
        if (!$id && $this->cid) $id = $this->cid;
        else return false;
        return $this->db->getOne(
            self::$table_category, 
            'title',
            is_numeric($id) ? array('id' => $id) : array('uri' => $id)
        );
    }
    function loadCategories(){
        $result = array();
        $r = $this->db->query('SELECT * FROM `'.self::$table_category.'`');
        while ($row = mysql_fetch_array($r))
            $result[$row['id']] = $row;
        return $result;
    }
      
    /*public function loadDates(){
    	$q='SELECT `id`,`name`,`date` FROM `'.self::$table_name.'` WHERE `visible`';
    	echo $q;
    	$r= $this->db->query($q);
    	if ($r){
    		if ($limit>1){
    			$out=array();
    			while ($news = mysql_fetch_assoc($r)){
    				$out[$news['id']]=$news;
    			}
    			return $out;
    		}
    		else return mysql_fetch_assoc($r);
    	}
    	else return false;
    }*/

    public function loadByPage($pageNumber, $rowsOnPage) {
        $resultArray = array(
            'count' => 0,
            'items' => array()
        );

        $limitStart = ($pageNumber - 1) * $rowsOnPage;
        $limitEnd = $rowsOnPage;

        $whereQuery = ' FROM `'.self::$table_name.'` WHERE `visible` ORDER BY `date` DESC,`id` DESC';
        $countQuery = 'SELECT COUNT(1) ' . $whereQuery;
        $itemsQuery = 'SELECT `id`,`cid`,`visible`,`name`,UNIX_TIMESTAMP(`date`) as `date`,`anons`,`author`,`image`' . $whereQuery . ' LIMIT '.$limitStart.', '.$limitEnd;

        $countSelect = mysql_query($countQuery);

        if(false !== $countSelect && mysql_num_rows($countSelect) > 0) {
            $r = mysql_fetch_row($countSelect);
            $resultArray['count'] = $r[0];
        }

        if($resultArray['count'] > 0) {
            $itemsSelect = mysql_query($itemsQuery);
            if(false !== $itemsSelect && mysql_num_rows($itemsSelect) > 0) {
                while(false !== ($row = mysql_fetch_assoc($itemsSelect))) {
                    $resultArray['items'][] = $row;
                }
            }
        }

        return $resultArray;
    }

    function create($array=null){
        if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }
        if($array['date']){
            $date = explode('.',$array['date']);
            $date = mktime(0,0,0,$date[1],$date[0],$date[2]);
        }else{
            $date = mktime();
        }
        // $cid = $_REQUEST['cid'];
        // if(!$cid) return false;
        $q = 'INSERT INTO `'.self::$table_name.'` (`cid`,`name`,`date`,`author`) 
            VALUES ("'.$cid.'","'.mysql_real_escape_string(strip_tags($array['name'])).'","'.date('Y-m-d',$date).'", "'.mysql_real_escape_string(strip_tags($array['author'])).'")';
        $r = $this->db->query($q);
        $this->id = $this->db->get_id();
        return $this->id;
    }

    function update($array = null){
        if(!$this->id) return false;
        $this->load();
        if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }

        $date = '';
        if(!empty($array['date'])) {
            $date = explode('.',$array['date']);
            $date = mktime(0,0,0,$date[1],$date[0],$date[2]);
            $date = date('Y-m-d',$date);
        }
        $q = 'UPDATE `'.self::$table_name.'` SET `name`="'.mysql_real_escape_string(strip_tags($array['name'])).
             '", `date`="'.$date.
             '", `cid`="'.$array['cid'].
             '", `subscr`="'.(isset($array['subscr']) ? 1 : 0).
             '", `anons`="'.mysql_real_escape_string($array['anons']).
             '", `text`="'.mysql_real_escape_string($array['text']).
             '", `author`="'.mysql_real_escape_string(strip_tags($array['author'])).
             '" WHERE `id`='.$this->id;
        $this->db->query($q);
        $subgallery = new subgallery($this->db);
        // $subgallery->load_size_for_module('news');
        // $subgallery->setCrop('ratio_fill');
        $subgallery->add($this->id,'goods_news');
        
        if ($_FILES['image']['name'])
            $this->uploadImage();
        
        if(isset($array['delete_image'])) {
            if(is_file(SR.self::$path.$this->data[$this->id]['image'])) {unlink(SR.self::$path.$this->data[$this->id]['image']);
        unlink(SR.self::$path.'m'.$this->data[$this->id]['image']);
        unlink(SR.self::$path.'s'.$this->data[$this->id]['image']);};
            $q = 'UPDATE `'.self::$table_name.'` SET `image`="" WHERE `id`='.$this->id;
            $this->db->query($q);
        }
        
        return true;
    }

    function show(){
        $q = 'UPDATE `'.self::$table_name.'` SET `visible`=1 WHERE `id`='.$this->id;
        $this->db->query($q);
    }

    function hide(){
        $q = 'UPDATE `'.self::$table_name.'` SET `visible`=0 WHERE `id`='.$this->id;
        $this->db->query($q);
    }

    function delete(){
        if(!$this->id) return false;
        $q = 'DELETE FROM `'.self::$table_name.'` WHERE `id`='.$this->id;
        $this->db->query($q);
        return true;
    }
    function get_last_news($count = 3, $cid = '') {
        $cid_query = $cid ? 'AND `cid`="'.$cid.'" ' : '';
        $q = 'SELECT `id`,`visible`,`name`,UNIX_TIMESTAMP(`date`) as `date`,`anons`,`author`,`image` FROM `'.self::$table_name.
                 '` WHERE `visible`=1 '.$cid_query.'ORDER BY `date` DESC,`id` DESC LIMIT '.(int)$count;
        $r = $this->db->query($q);
        while($row = mysql_fetch_assoc($r)){
            $this->data[$row['id']] = $row;
        }
        return $this->data;
    }
    public function getPath() {
        return self::$path;
    }	
    function uploadImage() {
        if (!$this->id)
            return false;
        $sql = 'SELECT `image` FROM `' . self::$table_name . '` WHERE `id`=' . ($this->id);
        $img = @array_pop($this->db->resultAsArray($sql));
        $img = stripslashes($img['image']);
        @unlink(SR . self::$path . $img);
        // var_dump(SR . self::$path . $img);die();
        @unlink(SR . self::$path . $img);
        $name = 'goods_news_'.$this->id;
        $ext = $_FILES['image']['name'];
        $ext = explode('.', $ext);
        $ext = array_pop($ext);
        $resize = new upload($_FILES['image']['tmp_name']);
        if ($resize->uploaded) {
            $type = $_FILES['image']['type'];
            $type = explode('/', $type);
            if ($type[0] != 'image') {
                continue;
            }
        /*
         * :
         *  $resize->file_new_name_body = $name;
            $resize->file_new_name_ext = $ext;
            $resize->process(SR . self::$uploadFolder);
        //*/
            // 
            $resize->file_new_name_body = $this->popPrefix . $name ;
            $resize->file_new_name_ext = $ext;
            $resize->file_overwrite = true;
            $resize->image_resize = true;
            $resize->image_ratio_fill = true;
            $resize->image_x = $this->trumbs_w ;
            $resize->image_y = $this->trumbs_h ;
            $resize->image_ratio_x = false;
            $resize->image_ratio_y = false;
            $resize->process(SR . self::$path);


            $resize->file_new_name_body = $this->itemPrefix . $name ;
            $resize->file_new_name_ext = $ext;
            $resize->file_overwrite = true;
            $resize->image_resize = true;
            $resize->image_ratio_fill = true;
            $resize->image_x = $this->trumbm_w ;
            $resize->image_y = $this->trumbm_h ;
            $resize->image_ratio_x = false;
            $resize->image_ratio_y = false;
            $resize->process(SR . self::$path);




            $resize->file_new_name_body = $name;
            $resize->file_new_name_ext = $ext;
            $resize->file_overwrite = true;
            $resize->image_resize = true;
            $resize->image_ratio_fill = true;
            $resize->image_x = $this->trumbal_w;
            $resize->image_y = $this->trumbal_h;
            $resize->image_ratio_x = false;
            $resize->image_ratio_y = false;
            // var_dump($ext);die();
            $resize->process(SR . self::$path);
            if ($resize->error)
                echo $resize->error;
            return $this->db->query('UPDATE `' . self::$table_name . '` SET `image`="' . mysql_real_escape_string($name) . '.' . $ext . '" WHERE `id`=' . $this->id);
        }
    }

    function loadWhereIn($array){
    $in = implode(',',$array);
        $q ='SELECT `id`,`name`,UNIX_TIMESTAMP(`date`) as `date`,`anons`,`author`,`image` 
            FROM `'.self::$table_name.'` WHERE `id` IN('.$in.') ORDER BY `id` DESC';
        $r = $this->db->query($q);
        while($row = mysql_fetch_assoc($r)){
            $this->data[$row['id']] = $row;
        }
        return $this->data;        
    }

    //   ,   
    function getForSubscr(){
        return $this->db->resultAsArray('SELECT `id`,`name`,UNIX_TIMESTAMP(`date`) as `date` FROM `'.self::$table_name.'` WHERE `subscr`');
    }
    //     "/"
    function subscr(){
        $q = 'UPDATE `'.self::$table_name.'` SET `subscr`= IF (`subscr`, 0, 1) WHERE `id`='.$this->id;
        $this->db->query($q);
    }
}
?>