<?php

/**
 *
 *  @author Arbora Sergey (http://arbora.ru)
 *
 *    ? :D
 *   
 *   ?
 *   :
 *  -    
 *  -   /       ,  {{insert_pretext:10}}
 *  -   ,     "" -,    , 
 *  -       get_pretext(int $id)
 *
 *
 **/


class pretext extends Module{
    public static $table = 'pretext';
    
    public function load(){
        return $this->db->query('SELECT * FROM :table',array('table'=>db_name(self::$table)),db::FETCH_ALL);
    }
    function loadById($id){
        return $this->db->query('SELECT * FROM :table WHERE id=:id',array('table'=>db_name(self::$table),'id'=>$id),db::FETCH_ROW);
    }
    function create($array = array()){
        if (!$array)
            $array = $this->get_request(self::$table,$_REQUEST);
        self::_create(self::$table, $array);
    }
    function delete(){
        $id = $_REQUEST['id'];
        self::_delete(self::$table,$id);
    }
    function update($array = array()){
        if (!$array)
            $array = $this->get_request(self::$table,$_REQUEST);
        if (!$array['id'])
            return;
        $array['box'] = isset($array['box']) ? 1:0;
        self::_update(self::$table, $array['id'], $array);
        
        $subgallery = new subgallery($this->db);
        $subgallery->load_size_for_module('pretext');
        $subgallery->setCrop('ratio_fill');
        $subgallery->setMaxWidth(200);
        $subgallery->setMaxHeight(100);
        $subgallery->add($array['id'], 'pretext');
    }

}
?>