<?php

/**
 * @author Arbora Sergey (http://arbora.ru)
 *  
 * 
 **/

class rating {
    public static $table = 'rating';
    public static $data = array();
    protected $db;

    function __construct($db){
        $this->db = $db;
    }
   
    public function load($object_id, $object_type){
        if (!$object_type || !$object_id) 
            return false;            
        $q = 'SELECT * FROM `'.self::$table.'` WHERE `object_id`="'.$object_id.'" AND `object_type`="'.$object_type.'" LIMIT 1';
        $result = $this->db->query($q, null, db::FETCH_ROW);
        if (is_array($result) && count($result))
        	$result['used_ips'] = unserialize($result['used_ips']);
        else{
        	$result = array();
        }
        $this->data = $result;
        return $result;
    }

    public function vote(){
    	if (!isset($_GET['object_id']) || !isset($_GET['object_type']))
    		return false;
    	$IP = $_SERVER['REMOTE_ADDR'];
    	$data = $this->load($_GET['object_id'], $_GET['object_type']);
    	$result = array();
    	
    	if (!$data){ //  
			$this->db->insert(
	    		self::$table,
	    		array(
	    			'total_votes' => 1,
	    			'total_value' => $_GET['vote'],
	    			'object_id'	  => $_GET['object_id'],
	    			'object_type' => $_GET['object_type'],
					'used_ips'	  => serialize(
	    								array($_SERVER['REMOTE_ADDR'] => $_GET['vote']))
	    			)
	    		);
			$result = array(
				'total_votes' => 1,
    			'total_value' => $_GET['vote']
    			);
    	}else{
    		$result = array();
    		//  
	    	$k = $data['total_votes'] * $data['total_value'];
	    	if (is_array($data['used_ips']) && count($data['used_ips'])){
	    		if (!isset($data['used_ips'][$IP])){
	    			$data['used_ips'][$IP] = $_GET['vote'];
	    			++$data['total_votes'];
	    		}else{ //    -     
	    			$k -= $data['used_ips'][$IP];
	    			$result['revote'] = true;
	    		}
	    	}else{
	    		++$data['total_votes'];
	    		$data['used_ips'] = array($_SERVER['REMOTE_ADDR'] => $_GET['vote']);
	    	}

	    	$data['total_value'] = ($k + $_GET['vote']) / ($data['total_votes']);

	    	$this->db->update(
	    		self::$table,
	    		array(
	    			'total_votes' => $data['total_votes'],
	    			'total_value' => $data['total_value'],
	    			'used_ips'	  => serialize(
										array($_SERVER['REMOTE_ADDR'] => $_GET['vote']))
	    			),
	    		array(
	    			'object_id' 	=> $_GET['object_id'],
	    			'object_type' 	=> $_GET['object_type']
	    			)
	    		);

	    	$result['total_votes'] = $data['total_votes'];
    		$result['total_value'] = $data['total_value'];

    	}
    	//  
    	$render = new Template();
    	return $render
                ->clear()
                ->set('revote', $result['revote'])
                ->set('object_id', $_GET['object_id'])
                ->set('object_type', $_GET['object_type'])
                ->set('href', '/actions/?obj=rating&do=vote&object_id='.$_GET['object_id'].'&object_type='.$_GET['object_type'])
                ->set('item_count', 5)
                ->set('vote_count', $result['total_votes'])
                ->set('current_rating', $result['total_value'])
                ->set('current_percent', 150/5*$result['total_value'])
                ->render('/rating/show.php');
    }


}

?>