<?php

/**
 *
 * @improved by Sergey Arbora (http://arbora.ru)
 *
 *     
 * 
 * @todo        
 *
 */

class subgallery {

    public static $table_name = 'subgallery';
    public static $path = '/content/images/subgallery/';
    public static $url = '/content/images/subgallery/';
    private $height = array('s' => 150);
    private $width = array('s' => 150);
    public static $object_id = 0;
    public static $object_type = '';
    public $preview_prefix = array('s');

    public $gallery = array();
    /**
     *   
     *  ratio_fill - default
     *  auto_height
     *  auto_width
     *  crop
     * @var type 
     */
    public $crop = 'ratio_fill';
    /**
     *   
     */
    public $maxWidth = 0;
    /**
     *   
     */
    public $maxHeight = 0;
    /**
     * 
     */
    public $quality = 85;

    public $id = null;
    protected $db = null;

    function __construct($db, $id = null) {
        $this->db = $db;
        if ($id === null && isset($_REQUEST['id']))
            $this->id = (int) $_REQUEST['id'];
        else
            $this->id = (int) $id;
    }
    
    public function setCrop($crop){
        $this->crop = $crop;
    }

    public function setMaxWidth($width){
        $this->maxWidth = $width;
    }

    public function setMaxHeight($height){
        $this->maxHeight = $height;
    }

    public function setQuality($quality){
        $this->quality = $quality;
    }

    public function load($object_id, $object_type) {
        $this->object_id = (int) $object_id;
        if ((string) $object_type)
            $this->object_type = (string) $object_type;
        $query = 'SELECT * FROM `' . self::$table_name . '` WHERE `object_id`=' . $this->object_id .
                ' AND `object_type`="' . mysql_real_escape_string($this->object_type) . '" ORDER BY `order`';
        $result = $this->db->query($query);
        $this->gallery = array();
        while ($row = mysql_fetch_assoc($result)) {
            $this->gallery[$row['id']] = $row;
        }
    }

    function loadAll(){
        $query = 'SELECT * FROM `' . self::$table_name . '`';
        $result = $this->db->query($query);
        $this->gallery = array();
        while ($row = mysql_fetch_assoc($result)) {
            $this->gallery[$row['id']] = $row;
        }
        return $this->gallery;    
    }

    function delete($id = '') {
        if ($id) $this->id = $id;
        $query = 'SELECT `file` FROM `' . self::$table_name . '` WHERE `id`=' . $this->id;
        $result = $this->db->query($query);
        $file = @mysql_result($result, 0, 0);
        @unlink(SR . self::$path . $file);
        @unlink(SR . self::$path . 's' . $file);
        $query = 'DELETE FROM `' . self::$table_name . '` WHERE `id`=' . $this->id;
        $this->db->query($query);
    }

    function clear_object($object_id, $object_type) {
        $query = 'SELECT `id` FROM `' . self::$table_name . '` WHERE `object_id`=' . (int) $object_id .
                ' AND `object_type`="' . mysql_real_escape_string($object_type) . '"';
        $result = $this->db->query($query);
        while ($row = mysql_fetch_assoc($result)) {
            $this->id = $row['id'];
            $this->delete();
        }
        return true;
    }

    function show() {
        $query = 'UPDATE `' . self::$table_name . '` SET `visible`=1 WHERE `id`=' . $this->id;
        if (!mysql_query($query))
            die(mysql_error());
    }

    function hide() {
        $query = 'UPDATE `' . self::$table_name . '` SET `visible`=0 WHERE `id`=' . $this->id;
        $this->db->query($query);
    }

    function add($object_id, $object_type) {
        $this->load_size_for_module($object_type);
        for ($i = 0; $i < count($_FILES['photo_file']['tmp_name']); $i++)
            if (isset($_FILES['photo_file']) && is_file($_FILES['photo_file']['tmp_name'][$i])) {
                $my_name = get_name_to_file();
                $user_name = $_FILES['photo_file']['name'][$i];
                $type = explode('/',$_FILES['photo_file']['type'][$i]);
                if ($type[0]!='image') continue;
                $ext = explode('.', $user_name);
                $ext = array_pop($ext);
                
                $name = SR . self::$path . $my_name . '.' . $ext;
                $resize = new upload($_FILES['photo_file']['tmp_name'][$i]);
                if ($resize->uploaded) {
                    // 
                    if ($this->maxWidth)
                        $resize->image_max_width = $this->maxWidth;
                    if ($this->maxHeight)
                        $resize->image_max_height = $this->maxHeight;

                    $resize->file_new_name_body = $my_name;
                    $resize->file_new_name_ext = $ext;
                    $resize->jpeg_quality = $this->quality;

                    $resize->process(SR . self::$path);
                    if ($resize->error)
                        setMessage('  '.$_FILES['photo_file']['name'][$i].': '.$resize->error,'error');
                    elseif ($this->preview_prefix){
                        foreach ($this->preview_prefix as $v) {
                            $smal_name = SR . self::$path . $v . $my_name . '.' . $ext;
                            $resize->file_new_name_body = $v . $my_name;
                            $resize->file_new_name_ext = $ext;
                            
                            if ($ext == 'gif'){
                                $resize->image_resize = false;
                            }else{
                                $resize->image_resize = true;
                            }

                            if ($this->width[$v] > 0 && $this->height[$v] > 0) {
                                switch ($this->crop) {
                                    case 'crop':
                                        $resize->image_ratio_crop = true;
                                        $resize->image_x = $this->width[$v];
                                        $resize->image_y = $this->height[$v];
                                        break;
                                    case 'auto_height':
                                        $resize->image_ratio_y = true;
                                        $resize->image_x = $this->width[$v];
                                        break;
                                    case 'auto_width':
                                        $resize->image_ratio_x = true;
                                        $resize->image_x = $this->width[$v];
                                        break;
                                    case 'ratio_fill':
                                        $resize->image_ratio_fill = true;
                                        $resize->image_x = $this->width[$v];
                                        $resize->image_y = $this->height[$v];
                                        break;
                                    default:
                                        $resize->image_ratio_fill = true;
                                        $resize->image_x = $this->width[$v];
                                        $resize->image_y = $this->height[$v];
                                }
                            } elseif ($this->width[$v] > 0) {
                                $resize->image_x = $this->width[$v];
                                $resize->image_ratio_y = true;
                            } elseif ($this->height[$v] > 0) {
                                $resize->image_y = $this->height[$v];
                                $resize->image_ratio_x = true;
                            }
                            $resize->file_overwrite = true;
                            $resize->process(SR . self::$path);
                        }
                    }
                }
                if (!$resize->error){
                    $query = 'INSERT INTO `' . self::$table_name . '` (`object_id`,`object_type`,`name`,`caption`,' .
                            '`file`,`order`,`visible`)values(' .
                            (int) $object_id . ',"' . mysql_real_escape_string($object_type) . '","' .
                            mysql_real_escape_string($_REQUEST['photo_name'][$i]) . '","' .
                            mysql_real_escape_string($_REQUEST['photo_caption'][$i]) . '","' .
                            $my_name . '.' . $ext . '",0,1)';
                    $this->db->query($query);
                    $id = $this->db->get_id();
                    $query = 'UPDATE `' . self::$table_name . '` SET `order`=' . $id . ' WHERE `id`=' . $id;
                    $this->db->query($query);
                }
            }
    }

    function show_subgallery() {
        $output = '';
        $output .= '<div class="mysubgallery">';
        if ($this->gallery)
            foreach ($this->gallery as $value) {
                if (!$value['visible'])
                    continue;
                $output .= '<a href="' . self::$url . $value['file'] . '" class="popup" rel="subgallery"><img src="' . self::$url . 's' . $value['file'] . '" /></a>';
            }else
            return false;
        $output .= '</div>';
        return $output;
    }

    function show_gallery_admin($name='') {
        $output = '';

        $script = '<script>
                var photo_array=[];';
        if ($this->gallery)
            foreach ($this->gallery as $value) {
                $output .= '<div class="subgallery photo '.($value['visible'] ? '' : 'hide').'" imgfile="' . $value['file'] . '"
                    link="'.$value['link'].'" pos="'.$value['pos'].'">
                        <img src="' . self::$url . 's' . $value['file'] . '?' . rand(100000, 999999) . '" style="width:' . $this->width . 'px;height:' . $this->height . '" />
                        <a href="'.GO.'?menu=subservices&amp;service=subgallery&amp;do=delete&amp;id=' . $value['id'] . '" class="subgallery delete" onclick="return confirm(\'   ?\');">
                        <span class="ico ico-del"title=""></span></a>
                        <a href="" class="subgallery edit" onclick="show_edit_form(this); return false;" photoid="' . $value['id'] . '">
                        <span class="ico ico-edit" title=""></span></a>
                        ' . ($value['visible'] ?
                                '<a href="'.GO.'?menu=subservices&amp;service=subgallery&amp;do=hide&id=' . $value['id'] . '" class="subgallery show">
                                <span class="ico ico-switch_on" title=""></span></a>' :
                                '<a href="'.GO.'?menu=subservices&amp;service=subgallery&amp;do=show&id=' . $value['id'] . '" class="subgallery show">
                                <span class="ico ico-switch_off" title=""></span></a>') . '
                        </div>';
                $script .= 'photo_array[' . $value['id'] . '] = [\'' . $value['name'] . '\'];';
            }
        $script .='</script>';
        $output .=$script;
        $output .= '<script>
                    function show_edit_form(el) {
                    //alert(el);
                        var my_parent = el.parentNode;
                        var x=my_parent.offsetLeft;
                        var y=my_parent.offsetTop+150;
                        var src=\'/content/images/subgallery/s\'+my_parent.getAttribute(\'imgfile\');
                        var link=my_parent.getAttribute(\'link\');
                        var id=el.getAttribute(\'photoid\');
                        document.getElementById(\'upd_img\').src=src;
                        document.getElementById(\'upd_id\').value=id;
                        document.getElementById(\'upd_link\').value=link;
                        document.getElementById(\'upd_name\').value=photo_array[id][0];
                        document.getElementById(\'editphoto\').style.display="block";
                    }
                    </script>';
        $output .= '<div style="margin-top:10px;">
                    <p><span class="ajax toggle" data-el=".sub_img"> ' . $name . '</span></p>
                    <div class="hide sub_img">
                    :<br/><input type="file" name="photo_file[]" multiple="true" class="subgallery forma" />
    <!--[if lt IE 9]>
        <br/><input type="file" name="photo_file[]" class="subgallery forma"/>
        <br/><input type="file" name="photo_file[]" class="subgallery forma"/>
        <br/><input type="file" name="photo_file[]" class="subgallery forma"/>
        <br/><input type="file" name="photo_file[]" class="subgallery forma"/>

        <script>document.getElementById(\'fileupload_hint\').style.background="none";</script>
    <![endif]-->
<div id="fileupload_hint" class="dark hint">       .     ""        ,      ,   "Ctrl"
    <br/>,   :
    <ul>
        <li>internet explorer 9  </li>
        <li>mozilla firefox 3.6  </li>
        <li>google chrome 11 </li>
        <li>opera 10  </li>
    </ul>
</div></div>
</div>';
        return $output;
    }

    function show_form_edit($id=0, $with_link=false) {
        $output = '';
        $output .= '<div id="editphoto" class="hide modal">
    <div class="modal-header">
        <!--<button class="close" data-dismiss="modal">&times;</button>-->
        <h3> </h3>
    </div>
    <form action="'.GO.'?menu=subservices&amp;service=subgallery&amp;do=update&amp;id='.$id.'" method="post" enctype="multipart/form-data">
        <div class="modal-body">
            <table>
                <tr>
                    <td><img src="" id="upd_img" /></td>
                    <td>';
                        $output .= '<input type="hidden" name="id" value="" id="upd_id"/><br />';
                        $output .= '<input type="text" name="name" class="forma" id="upd_name" style="width:300px;"/><br />';
                        if ($with_link){
                            $output .= '<br />';
                            $output .= '<input type="text" name="link" class="forma" id="upd_link" style="width:300px;"/><br />';
                        }
                        $output .= '
                        <br /><input type="file" name="file" class="forma" id="upd_file" />
                    </td>
            </table>
        </div>
        <div class="modal-footer">
            <a href="#" onclick="document.getElementById(\'editphoto\').style.display=\'none\'; return false;" class="btn"></a>
            <input type="submit" name="photo_update" class="btn btn-primary" value="" />
        </div>

    </form></div>';
        return $output;
    }

    function update($name = null) {

        // var_dump($_POST);die();
        if ($name === null)
            $name = stripslashes($_REQUEST['name']);
        $q = 'SELECT `object_type` FROM `' . self::$table_name . '` WHERE `id`=' . $this->id;
        $r = $this->db->query($q);
        $module = @mysql_result($r, 0, 0);
        $this->load_size_for_module($module);
        $link = isset($_POST['link']) ? ', `link`="'.$_POST['link'].'"' : '';
        $query = 'UPDATE `' . self::$table_name . '` SET `name`="' . mysql_real_escape_string($name) .
                '" ' . $link . ' WHERE `id`=' . $this->id;
        //        echo $query;
        //        die();
        $this->db->query($query);
        if (is_uploaded_file($_FILES['file']['tmp_name'])) {
            $query = 'SELECT `file` FROM `' . self::$table_name . '` WHERE `id`=' . $this->id;
            $result = $this->db->query($query);
            $my_name = mysql_result($result, 0, 0);
            @unlink(SR . self::$path . $my_name);
            @unlink(SR . self::$path . 's' . $my_name);
            $my_name = explode('.', $my_name);
            $my_name = $my_name[0];
            $user_name = $_FILES['file']['name'];
            $ext = array_pop(explode('.', $user_name));
            $resize = new upload($_FILES['file']['tmp_name']);
            if ($resize->uploaded) {
                $resize->file_new_name_body = $my_name;
                $resize->file_new_name_ext = $ext;
                $resize->jpeg_quality = $this->quality;
                $resize->process(SR . self::$path);
                foreach ($this->preview_prefix as $v) {
                    $resize->file_new_name_body = $v . $my_name;
                    $resize->file_new_name_ext = $ext;
                    $resize->image_resize = true;
                    if ($this->width[$v] > 0 && $this->height[$v] > 0) {
                            switch ($this->crop) {
                                case 'crop':
                                    $resize->image_ratio_crop = true;
                                    $resize->image_x = $this->width[$v];
                                    $resize->image_y = $this->height[$v];
                                    break;
                                case 'auto_height':
                                    $resize->image_ratio_y = true;
                                    $resize->image_x = $this->width[$v];
                                    break;
                                case 'auto_width':
                                    $resize->image_ratio_x = true;
                                    $resize->image_x = $this->width[$v];
                                    break;
                                case 'ratio_fill':
                                    $resize->image_ratio_fill = true;
                                    $resize->image_x = $this->width[$v];
                                    $resize->image_y = $this->height[$v];
                                    break;
                                default:
                                    $resize->image_ratio_fill = true;
                                    $resize->image_x = $this->width[$v];
                                    $resize->image_y = $this->height[$v];
                            }
                    } elseif ($this->width[$v] > 0) {
                        $resize->image_x = $this->width[$v];
                        $resize->image_ratio_y = true;
                    } elseif ($this->height[$v] > 0) {
                        $resize->image_y = $this->height[$v];
                        $resize->image_ratio_x = true;
                    }
                    $resize->file_overwrite = true;
                    $resize->process(SR . self::$path);
                }
            }
            /* $name = SR.self::$path.$my_name.'.'.$ext;
              $smal_name = SR.self::$path.'s'.$my_name.'.'.$ext;
              move_uploaded_file($_FILES['file']['tmp_name'],$name);

              foreach($this->preview_prefix as $v){
              $smal_name = SR.self::$path.$v.$my_name.'.'.$ext;
              MakeTrumbal($name,$smal_name,$this->width[$v],$this->height[$v]);
              } */

            //            MakeTrumbal($name,$smal_name,$this->width,$this->height);
            $query = 'UPDATE `' . self::$table_name . '` SET `file`="' . $my_name . '.' . $ext . '" WHERE `id`=' . $this->id;
            $this->db->query($query);
        }
    }

    function load_size_for_module($module) {
        foreach ($this->preview_prefix as $prefix) {
            $q = 'SELECT `value` FROM `' . settings::$table_name . '` WHERE `module`="' . $module . '" AND `field`="' . ($prefix == 's' ? '' : $prefix) . 'photo_width"';
            $r = $this->db->query($q);
            if (mysql_num_rows($r) > 0)
                $this->width[$prefix] = (int) mysql_result($r, 0, 0);
            else
                $this->width[$prefix] = (int) @$this->width[$prefix];
            $q = 'SELECT `value` FROM `' . settings::$table_name . '` WHERE `module`="' . $module . '" AND `field`="' . ($prefix == 's' ? '' : $prefix) . 'photo_height"';
            $r = $this->db->query($q);
            if (mysql_num_rows($r) > 0)
                $this->height[$prefix] = (int) mysql_result($r, 0, 0);
            else
                $this->height[$prefix] = (int) @$this->height[$prefix];
        }
    }
     public function getRandoms($limit=6) {
        $object_type = 'gallery';
        $query = 'SELECT * FROM `' . self::$table_name . '` WHERE 
            `object_type`="' . mysql_real_escape_string($object_type) . '" ORDER BY RAND() LIMIT '.$limit;
        $result = $this->db->query($query);
        $data = array();
        while ($row = mysql_fetch_assoc($result)) {
            $data[$row['id']] = $row;
        }
        return $data;
    }
     public function getFile($id) {
        $q = 'SELECT * FROM '.self::$table_name.' WHERE id="'.(int)$id.'"';
        $r = $this->db->query($q);
        if ($r) return mysql_fetch_assoc($r);
        // if ($r) $file = mysql_fetch_assoc($r);
            // return $r;
            // header('Content-type: application/otherType');
            // header('Content-Disposition: attachment; filename="'.$file['name'].'.'.$file['ext'].'"');
            // echo file_get_contents(SR.self::$path.$file['file']);
        // }
        // return false;
    }

    function raiting(){
        if (!isset($_REQUEST['id'])) return false;
        $id = $_REQUEST['id'];
        $up = isset($_REQUEST['param']) ? ($_REQUEST['param'] == 'up' ? 'true' : false) : false;
        $q  = 'UPDATE `'.self::$table_name.'` SET `raiting`=`raiting`'.($up ? '+' : '-').'1 WHERE `id`='.$id;
        $this->db->query($q);
        // TODO:   
        if (session_id()){
            $_SESSION['likes'][] = $id;
        }
        return $this->db->getOne(self::$table_name,'raiting',array('id'=>$id));
    }

}

?>