<?php

/**
 *
 *  @author Arbora Sergey (http://arbora.ru)
 *
 *   ,  ))) 
 * PS:     ,    ,    )))    .
 *
 * 
 *   2 :
 *      - auto
 *      - manual
 *
 *   MANUAL -      .
 *     MAX_SUBS_IN_LIST     ,      
 *
 **/



if (!defined('MAX_SUBS_IN_LIST')){
    define('MAX_SUBS_IN_LIST', 50);
}


class subscr{
    public static $table_name = 'subscr';
    public static $table_category = 'subscr_category';
    private $db;
    public $data;
    public $id = null;
    public $cid = null;

    function __construct($db,$id = null){
        $this->db = $db;
        if($id === null){
            if(isset($_REQUEST['id'])) $this->id = (int)$_REQUEST['id'];
        }else $this->id = (int)$id;
    }

    function load($id = null){
        if($id === null&&$this->id===null){
            $q = 'SELECT * FROM `'.self::$table_name.'`';
            $r = $this->db->query($q);
            while($row = mysql_fetch_assoc($r)){
                $this->data[$row['id']] = $row;
            }
            return $this->data;
        }else{
            if($id!==null) $this->id = (int)$id;
            $q = 'SELECT * FROM `'.self::$table_name.'`';
            $r = $this->db->query($q);
            $this->data[$this->id] = mysql_fetch_assoc($r);
            if($this->data[$this->id]) return $this->data[$this->id];
            else return false;
        }
    }
    //     
    function loadByCat($cid){
        if($cid!==null) $this->cid = (int)$cid;
        $q = 'SELECT * FROM `'.self::$table_name.'` WHERE `cid`='.$this->cid.' AND `confirmed` AND `deleted`="0"';
        $this->data[$this->cid] = $this->db->resultAsArray($q);
        if($this->data[$this->cid]) 
            return $this->data[$this->cid];
        else return false;
    }
    function getSubsCount($cid){
        if (!$cid || !is_numeric($cid)) return false;
        $row = $this->db->query('SELECT COUNT(1) FROM `'.self::$table_name.'` WHERE `cid`="'.$cid.'" AND `confirmed` AND NOT `deleted`');
        if ($row){
            return mysql_result($row,0,0);
        }
        return false; 
    }

    function loadCategories(){
        $result = array();
        $r = $this->db->query('SELECT *,`date` as `date` FROM `'.self::$table_category.'`');
        while ($row = mysql_fetch_array($r))
            $result[$row['id']] = $row;
        return $result;
    }
    function create($array=null) {
        if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }
        $q = 'INSERT INTO `'.self::$table_category.'` (`auto`,`name`) VALUES ("1","'.mysql_real_escape_string(strip_tags($array['name'])).'")';
        $r = $this->db->query($q);
        $this->id = $this->db->get_id();
        return $this->id;
    }
    //     
    function create_sub() {
        if(!isset($_REQUEST['cid']) || empty($_REQUEST['cid']))  return false;
        if(!isset($_REQUEST['email']) || empty($_REQUEST['email']))  return false;
        
        $q = 'INSERT INTO `'.self::$table_name.'` (`email`,`cid`,`confirmed`) VALUES ("'.mysql_real_escape_string(strip_tags($_REQUEST['email'])).'","'.$_REQUEST['cid'].'","1")';
        $r = $this->db->query($q);
        $this->id = $this->db->get_id();
        return $this->id;
    }

    function update_subs(){
        if (!isset($_REQUEST['email']) || !count($_REQUEST['email'])) return false;
        foreach ($_REQUEST['email'] as $id => $email) {
            $this->db->update(self::$table_name,array('email'=>$email),array('id'=>$id));
        }
    }
    function update($array = null){
        if(!$this->id) return false;
        $this->load();
        if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }
        $q = 'UPDATE `'.self::$table_name.'` SET `name`="'.mysql_real_escape_string(strip_tags($array['name'])).
             '", `date`="'.$date.'" WHERE `id`='.$this->id;
        $this->db->query($q);
        return true;
    }

    function show(){
        $q = 'UPDATE `'.self::$table_name.'` SET `visible`=1 WHERE `id`='.$this->id;
        $this->db->query($q);
    }
    function hide(){
        $q = 'UPDATE `'.self::$table_name.'` SET `visible`=0 WHERE `id`='.$this->id;
        $this->db->query($q);
    }
    function delete(){
        if(!$this->id) return false;
        $q = 'DELETE FROM `'.self::$table_category.'` WHERE `id`='.$this->id;
        $this->db->query($q);
        return true;
    }
    function delete_sub(){
        if (empty($_REQUEST['id'])) return false;
        $q = 'DELETE FROM `'.self::$table_name.'` WHERE `id`='.$_REQUEST['id'];
        $this->db->query($q);
        return true;
    }

    //  
    function confirm($email){
        $q = 'UPDATE `'.self::$table_name.'` SET `confirmed`="1" WHERE `email`="'.$email.'"';
        return $this->db->query($q);   
    }

    //  
    function send(){
        $settings = new settings($this->db);
        $set_data = $settings->load('main');
        $sys_email = $set_data['email']['value'];
        // $sys_email = 'sergey@arbora.ru';
        $title_site = $set_data['title']['value'];

        if (!$_POST['news'] || !is_array($_POST['news']) || !$_POST['group']) return false;
        //   
        $news = new news($this->db);
        $news = $news->loadWhereIn(array_keys($_POST['news'])); 
        $mailText='';
        foreach ($news as $k => $v) {
            $mailText .= '
                <h2>'.$v['name'].'</h2>
                <p class="MsoNormal">'.$v['anons'].'</p>
                <br>
                <a href="http://'.$_SERVER['HTTP_HOST'].'/news/'.$k.'/" target="_blank"> </a>
            ';
        }
        $mailTitle = '  ';
        //  email'  
        $cid = $_POST['group'];
        $emails = $this->loadByCat($cid);
        //   
        // var_dump(date());
        $this->db->query('UPDATE `'.self::$table_category.'` SET `date`=NOW() WHERE `id`="'.$cid.'"');
        // $this->db->update(self::$table_category,array('date' => 'NOW()'), array('id' => $cid));

        if (empty($emails) || !is_array($emails) || !count($emails)) return false;
        $url_site = 'http://'.$_SERVER['HTTP_HOST'];
        // !
        $mail = new PHPMailer();
        $mail->IsMail();
        $mail->FromName = $title_site . ' (' . $url_site . ')';
        $mail->From = $title_site;
        $mail->SetFrom($sys_email);
        $mail->CharSet = "windows-1251";
        $mail->IsHTML(true);
        // $mail->Sender = '';
        $mail->Subject = $mailTitle;
        $mail->Body = $mailText;
        $mail->AltBody = "";
        foreach ($emails as $address) {
            mails::send_email('form-subscr-message', $address['name'], $address['email'], array(
                'news'          => $mailText,
                'user-name'     => $address['name'],
                'unsub-link'    => '<a href="http://'.$_SERVER['HTTP_HOST'].'/subscr/unsubscribe/" target="_blank"></a>'
            ),array(
				'manager-receive' => false
			));
            
        }
    }
    function subscribe($name,$email){
		$max_subs_in_list = 50;
		
        if (empty($email))return false;
            //     email:
            if ($item = $this->db->query('SELECT `id`,`deleted`,`confirmed` FROM '.self::$table_name.' WHERE `email`="'.$email.'"',null,db::FETCH_ALL)){
                if (is_array($item)) $item = $item[0];
                if($item['deleted']){ // ,  
                    $this->db->update(self::$table_name,array('deleted' => '0'),array('id' => $item['id']));
                    return 1;
                }elseif($item['confirmed'] == '0'){
                    return 2;
                }
                return 0;
            }

            /*
            // TODO:   ,    MAX_SUBS_IN_LIST- ,    -  
            $cid = $this->db->query('SELECT `id` FROM `'.self::$table_category.'` WHERE COUNT(1) < MAX_SUBS_IN_LIST AND `auto` LIMIT 1', null, db::FETCH_RESULT);
            var_dump($cid);
            */
            
            //   
            $cid = $this->db->query('SELECT MAX(`id`) as `id` FROM `'.self::$table_category.'` WHERE `auto` LIMIT 1', null, db::FETCH_RESULT);
            if (!$cid){
                //  ,   
                //return true;
				$cid = 0;
				$count = $max_subs_in_list;//$this->MAX_SUBS_IN_LIST;
            }else{
				//      
				$count = $this->db->query('SELECT COUNT(1) as `count` FROM `'.self::$table_name.'` WHERE `cid`="'.$cid.'"', null, db::FETCH_RESULT);				
			}					
			
            if ($count >= $max_subs_in_list/*$this->MAX_SUBS_IN_LIST*/){ //   
                $this->db->insert(self::$table_category,array('name' => ' '.($cid+1)));
                $cid = $this->db->get_id();
                return $this->db->insert(self::$table_name,array('name' => $name, 'email' => $email, 'cid' => $cid));
            }else{ //    
                return $this->db->insert(self::$table_name,array('name' => $name, 'email' => $email, 'cid' => $cid));
            }

    }
    function unsubscribe($email){
        if (empty($email))return false;
        return $this->db->update(self::$table_name,array('deleted'=>'1'),'`email`="'.$email.'"');
    }
}
?>