<?php

load_lib(file);

class vacancy extends Module{
    public static $table_name = 'vacancy';
    
    public static $table_resume = 'vacancy_resume';
    
    public static $folder_path = 'content/user_files/vacancy/';

    public $id = null;
    
    public $data = null;
    
    protected $db;
    //запрещаем загружать файлы этих типов
    public static $ignore_file = array('php','exe','sh','cgi','bat');

    function __construct($db,$id = null){
        $this->db = $db;
        if($id===null) $this->id = (int)$_REQUEST['id'];
        else $this->id = (int)$id;
    }
    function load(){
        if($this->id){
            $q = 'SELECT *,UNIX_TIMESTAMP(`date`) as `date` FROM `'.self::$table_name.'` WHERE `id`='.$this->id.' ORDER BY `id` DESC';
            $r = $this->db->query($q);
            $row = mysql_fetch_assoc($r);
            if(!$row) return false;
            $this->data[$this->id] = $row;
            return $this->data[$this->id];
        }else{
            $q = 'SELECT `id`,`name`,`visible`,`job`,`employer` FROM `'.self::$table_name.'`';
            $r = $this->db->query($q);
            while($row = mysql_fetch_assoc($r)){
                $this->data[$row['id']]=$row;
            }
            return $this->data;
        }
    }
    function load_data(){
        if($this->id){
            $q = 'SELECT *,UNIX_TIMESTAMP(`date`) as `date` FROM `'.self::$table_name.'` WHERE `id`='.$this->id;
            $r = $this->db->query($q);
            $row = mysql_fetch_assoc($r);
            if(!$row) return false;
            $this->data[$this->id] = $row;
            return $this->data[$this->id];
        }else{
            $q = 'SELECT *,UNIX_TIMESTAMP(`date`) as `date` FROM `'.self::$table_name.'` WHERE `visible` ORDER BY `date` DESC';
            $r = $this->db->query($q);
            while($row = mysql_fetch_assoc($r)){
                $this->data[] = $row;
            }
            return $this->data;
        }
    }

    /**
     * Резюме
     */
    function getPath(){
        return self::$folder_path;
    }
    public function add_resume($insert = null){
        $insert = $this->get_request(self::$table_resume, $insert);
        if (is_uploaded_file($_FILES['resume']['tmp_name'])) {
            $ext = explode('.',$_FILES['resume']['name']);
            $ext = end($ext);
                if (in_array($ext,self::$ignore_file))
                    return false;
            $filename = explode('.',$_FILES['resume']['name']);
            //выкидываем расширение
            if (count($filename)>1)
                    array_pop($filename);
            //реальное имя
            $name= get_name_to_file().'.'.$ext;
            $insert['file'] = $name;
            $insert['alias'] = implode('',$filename);
            if (move_uploaded_file($_FILES['resume']['tmp_name'],SR.self::$folder_path.$name)){
                $this->db->insert(self::$table_resume,$insert);
                return $this->db->get_id();
            }
        }
    }

    public function get_resume($id){
        return $this->db->query('SELECT * FROM :table WHERE id=:id',array('table'=>db_name(self::$table_resume),'id'=>$id),db::FETCH_ROW);
    }

    public function delete_resume(){
        $id = (int)$_GET['id'];
        if ($id)
            return $this->db->delete(self::$table_resume,array('id'=>$id));
    }

    public function get_all_resume($vacancy_id){
        return $this->db->query('SELECT * FROM :table_resume WHERE `vacancy_id`=:vacancy_id ORDER BY `id` DESC',array('table_resume'=>new db_name(self::$table_resume),'vacancy_id'=>$vacancy_id ),db::FETCH_ALL);
    }

    function create($array = null){
        if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }
        $q = 'INSERT INTO `'.self::$table_name.'` (`name`,`job`,`employer`) VALUES ("'.mysql_real_escape_string(strip_tags($array['name'])).
        	 '","'.mysql_real_escape_string(strip_tags($array['job'])).
        	 '","'.mysql_real_escape_string(strip_tags($array['employer'])).'")';
        $this->db->query($q);
        return $this->db->get_id();
    }
    function update($array = null){
        if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }
        $date = strtotime($array['date']);
        $q = 'UPDATE `'.self::$table_name.'` SET `name`="'.mysql_real_escape_string(strip_tags($array['name'])).
        	 '",`description`="'.mysql_real_escape_string($array['description']).
        	 '",`job`="'.mysql_real_escape_string(strip_tags($array['job'])).
             '",`schooling`="'.mysql_real_escape_string(strip_tags($array['schooling'])).
             '",`age`="'.mysql_real_escape_string(strip_tags($array['age'])).
             '",`sex`="'.mysql_real_escape_string(strip_tags($array['sex'])).
             '",`experience`="'.mysql_real_escape_string(strip_tags($array['experience'])).
             '",`shedule`="'.mysql_real_escape_string(strip_tags($array['shedule'])).
             '",`employer`="'.mysql_real_escape_string(strip_tags($array['employer'])).
             '",`contact_info`="'.mysql_real_escape_string(strip_tags($array['contact_info'])).            
        	 '",`pay`="'.mysql_real_escape_string(strip_tags($array['pay'])).
             '",`date`="'.date('Y-m-d',$date).
             '",`show_weeks`='.(int)$array['show_weeks'].' WHERE `id`='.$this->id;        
        $this->db->query($q);
        return true;
    }
    function delete(){
        $q = 'DELETE FROM `'.self::$table_name.'` WHERE `id`='.$this->id;
        $this->db->query($q);
    }
    function show(){
        $q = 'UPDATE `'.self::$table_name.'` SET `visible`=1 WHERE `id`='.$this->id;
        $this->db->query($q);
    }
    function hide(){
        $q = 'UPDATE `'.self::$table_name.'` SET `visible`=0 WHERE `id`='.$this->id;
        $this->db->query($q);
    }

    function get_last_vacancy($count = 4){
        $q = 'SELECT *,UNIX_TIMESTAMP(`date`) as `date` FROM `'.self::$table_name.'` WHERE `visible`=1 ORDER BY `date` LIMIT '.(int)$count;
        $r = $this->db->query($q);
        while($row = mysql_fetch_assoc($r)){
            $this->data[$row['id']]=$row;
        }
        return $this->data;
    }
    public function getFile($id){
        $filename = $this->db->query('SELECT `file`,`alias` FROM :table WHERE `id`=:id',array('table'=>new db_name(self::$table_resume),'id'=>$id),db::FETCH_ROW);
        $ext = explode('.',$filename['file']);
        header('Content-type: application/zhopa');
        header('Content-Disposition: attachment; filename="'.$filename['alias'].'.'.end($ext).'"');
        echo file_get_contents(SR.self::$folder_path.$filename['file']);
        die();
    }
}
?>