<?php

/*
 *   
 */

/**
 *  
 * @param array $messages 
 */
function show_messages($messages_array = array(),$count=0,$show_documents = false) {
    global $account,$db;
    if ($show_documents === true)
        $msg = new account_messages();

    $item_render    = new Template();
    $render         = new Template();


    if (empty($messages_array)){
        return $render->render('/account/comments/empty.php');
    }
    $out = '';
    //     ,    " "
    $init_count = $count;

    foreach ($messages_array as $message) {
        $count++;
        $render->clear();
        $item_render->clear();
        $avatar = account::getAvatar($message['user_id']);
        if (!$avatar)
            $avatar = noimg('avatar');

        if ($show_documents === true){
            $docs = $msg->get_attached_documents($message['id']);
        }else $document = '';

        $message['message'] = nl2br($message['message']);
                
            $items .= $item_render
                ->clear()
                ->set('avatar', $avatar)
                ->set('count', $count)
                ->set('docs', $docs)
                ->set('message', $message)
                ->set('account', $account)
                ->set('can_delete', $account->can('delete_message'))
                ->render('/account/comments/item.php');
    }//.(strtotime( $message['update_date']) ? '(: ' . $message['update_date'] . ') ' : '' )
    $list = $render
                ->clear()
                ->set('items', $items)
                ->render('/account/comments/list.php');
    if ($list){
        if (isAjax()){
            return $list;
        }else{
            if ($init_count){
                $render->set('load_block', true);
            }
            return $render
                ->set('items', $list)
                ->set('theme_id', $db->qa[3])
                ->render('/account/comments/show.php');
        }
    }
}

?>
