<?php

/*
 *   
 */

function get_rus_month($month, $case = 1) {
    $months = array(
        1 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        2 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        3 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        4 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        5 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        6 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        7 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        8 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        9 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        10 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        11 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        12 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => '')
    );
    return $months[$month][$case];
}

function get_rus_week($week, $case = 1) {
    $weeks = array(
        1 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        2 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        3 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        4 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        5 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        6 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
        7 => array(1 => '', 2 => '', 3 => '', 4 => '', 5 => '', 6 => '', 7 => ''),
    );
    return $weeks[$week][$case];
}

function convertSize($size) {
    if (!$size)
      return $size;
    $unit = array('', '', '', '', '', 'Pb', 'Eb', 'Zb', 'Yb');
    return round($size / pow(1024, ($i = floor(log($size, 1024)))), 2) . $unit[$i];
}

function clearUri($uri) {
    $uri = strtolower($uri);
    $uri = preg_replace(' /[^a-z0-9-_]/i', ' ', $uri);
    return $uri;
}

/**
 * @deprecated
 * @param array $array
 * @return array 
 */
function clearEmptyArray($array) {
    return array_filter($array);
    /*foreach ($array as $k => $v) {
        if (!$v)
            unset($array[$k]);
    }
    return $array;*/
}


//      
function semantic($i,&$words,&$many,$f){
    $_1_2[1]=" ";$_1_2[2]=" ";$_1_19[1]=" ";$_1_19[2]=" ";$_1_19[3]=" ";$_1_19[4]=" ";$_1_19[5]=" ";$_1_19[6]=" ";$_1_19[7]=" ";$_1_19[8]=" ";$_1_19[9]=" ";$_1_19[10]=" ";$_1_19[11]=" ";$_1_19[12]=" ";$_1_19[13]=" ";$_1_19[14]=" ";$_1_19[15]=" ";$_1_19[16]=" ";$_1_19[17]=" ";$_1_19[18]=" ";$_1_19[19]=" ";$des[2]=" ";$des[3]=" ";$des[4]=" ";$des[5]=" ";$des[6]=" ";$des[7]=" ";$des[8]=" ";$des[9]=" ";
    $hang[1]=" ";$hang[2]=" ";$hang[3]=" ";$hang[4]=" ";$hang[5]=" ";$hang[6]=" ";$hang[7]=" ";$hang[8]=" ";$hang[9]=" ";$namerub[1]=" ";$namerub[2]=" ";$namerub[3]=" ";
    $nametho[1]=" ";$nametho[2]=" ";$nametho[3]=" ";
    $namemil[1]=" ";$namemil[2]=" ";$namemil[3]=" ";
    $namemrd[1]=" ";$namemrd[2]=" ";$namemrd[3]=" ";
    $kopeek[1]=" ";$kopeek[2]=" ";$kopeek[3]=" ";
    //  words    
    $words="";
    $fl=0;
    //    100  999
    if($i >= 100){
      // 
      $jkl = intval($i / 100);
      $words.=$hang[$jkl];
      // " "    
      $i%=100;
    }
    //    20  10 ( 20,   
    // , ...)
    if($i >= 20){
      $jkl = intval($i / 10);
      $words.=$des[$jkl];
      //         1  9
      $i%=10;
      $fl=1;
    }
    // $fem -     
    switch($i){
      case 1: $many=1; break;
      case 2:
      case 3:
      case 4: $many=2; break;
      default: $many=3; break;
    }

    // ,    ,   ,    ...
    if($i){
      if($i < 3 && $f == 1)
       $words.=$_1_2[$i];
      else
       $words.=$_1_19[$i];
    }
}

function num2str($L)
{
    $_1_2[1]=" ";$_1_2[2]=" ";$_1_19[1]=" ";$_1_19[2]=" ";$_1_19[3]=" ";$_1_19[4]=" ";$_1_19[5]=" ";$_1_19[6]=" ";$_1_19[7]=" ";$_1_19[8]=" ";$_1_19[9]=" ";$_1_19[10]=" ";$_1_19[11]=" ";$_1_19[12]=" ";$_1_19[13]=" ";$_1_19[14]=" ";$_1_19[15]=" ";$_1_19[16]=" ";$_1_19[17]=" ";$_1_19[18]=" ";$_1_19[19]=" ";$des[2]=" ";$des[3]=" ";$des[4]=" ";$des[5]=" ";$des[6]=" ";$des[7]=" ";$des[8]=" ";$des[9]=" ";
    $hang[1]=" ";$hang[2]=" ";$hang[3]=" ";$hang[4]=" ";$hang[5]=" ";$hang[6]=" ";$hang[7]=" ";$hang[8]=" ";$hang[9]=" ";$namerub[1]=" ";$namerub[2]=" ";$namerub[3]=" ";
    $nametho[1]=" ";$nametho[2]=" ";$nametho[3]=" ";
    $namemil[1]=" ";$namemil[2]=" ";$namemil[3]=" ";
    $namemrd[1]=" ";$namemrd[2]=" ";$namemrd[3]=" ";
    $kopeek[1]=" ";$kopeek[2]=" ";$kopeek[3]=" ";$s=" ";$s1=" ";
    //  , ..   
    $kop=intval(( $L*100 - intval($L)*100 ));
    //  
    $L=intval($L);

    if($L>=1000000000){
      $many=0;
      semantic(intval($L / 1000000000),$s1,$many,3);
      $s.=$s1.$namemrd[$many];
      $L%=1000000000;
      //  - ,   
      if($L==0)
      {
       $s.=" ";
      }
    }
    if($L >= 1000000){
      $many=0;
      semantic(intval($L / 1000000),$s1,$many,2);
      $s.=$s1.$namemil[$many];
      $L%=1000000;
      //   - ,   
      if($L==0)
      {
       $s.=" ";
      }
    }
    if($L >= 1000){
      $many=0;
      semantic(intval($L / 1000),$s1,$many,1);
      $s.=$s1.$nametho[$many];
      $L%=1000;
      if($L==0)
      {
       $s.=" ";
      }
    }
    if($L != 0){
      $many=0;
      semantic($L,$s1,$many,0);
      $s.=$s1.$namerub[$many];
    }
    //  ,      
    if($kop > 0){
      $many=0;
      semantic($kop,$s1,$many,1);
      $s.=$s1.$kopeek[$many];
    }
    else{
      $s.=" 00 ";
    }
    return $s;
}
/**
 *  
 *  :
 * $num2=3;
 * $words2=Array("", "", "");
 * var int $num -  
 * var array $words -   
 */
function num2word($num,$words) {
  $num=$num%100;
  if ($num>19) { $num=$num%10; }
  switch ($num) {
    case 1:  { return($words[0]); }
    case 2: case 3: case 4:  { return($words[1]); }
    default: { return($words[2]); }
  }
}

function crop_word($word,$length = 30,$title = ''){
  if (strlen($word)> $length && $length > 6){
    $o = $word;
  $word = substr($word,0,((int)$length-6)).'...'.substr($word,-5);
      if ($title)
        $word = '<abbr title="'.$o.'">'.$word.'</abbr>';
  }
  return $word;
}

//     
function serialize_mysql($var){
  return base64_encode(serialize($var));
}
function unserialize_mysql($var){
  return unserialize(base64_decode($var));
}


function xml_to_array($XML)
{

    $XML = trim($XML);
    $returnVal = $XML;
    $emptyTag = '<(.*)/>';
    $fullTag = '<\\1></\\1>';
    $XML = preg_replace ("|$emptyTag|", $fullTag, $XML);
    if (preg_match_all('|<(.*)>(.*)</\\1>|Ums', trim($XML), $matches))
    {
        if (count($matches[1]) > 0) $returnVal = array();
        foreach ($matches[1] as $index => $outerXML)
        {
            $attribute = $outerXML;
            $value = xml_to_array($matches[2][$index]);
            if (! isset($returnVal[$attribute])) $returnVal[$attribute] = array();
                $returnVal[$attribute][] = $value;
        }
    }
    if (is_array($returnVal)) foreach ($returnVal as $key => $value)
    {
        if (is_array($value) && count($value) == 1 && key($value) === 0)
        {
            $returnVal[$key] = $returnVal[$key][0];
        }
    }
    return $returnVal;
}

/**
 *
 *  @author Arbora Sergey
 *  @param price          -  
 *  @param price_descript -  
 *  @param opt            -  (array of params)
 *
 **/

function price_format($p1, $p2=null, $opt=array()){
  global $loader;
  if ($opt['not_fixed'] && $loader->serviceActive('catalog', 'exprice'))
  {
      if($opt['not_fixed'] == 1)
      { //   
          echo '<div class="'.(isset($opt['deprice_css_class']) ? $opt['deprice_css_class'] : 'deprice').'" style="display:table-cell">'.
            number_format((int)$p2,0,'',' ').' <span></span>'
          .'</div>';
		  echo '<div class="price" style="display:table-cell">'.number_format((int)$p1,0,'',' ').' <span></span></div>';
      }
      elseif($current['not_fixed'] == 2)
      { //   
        echo $p2;
      }
  }
  else
  {
    // var_dump($p1,$p2);die();
    return number_format((int)$p1,0,'',' ').' <span></span>';
  }
 
  // if (!is_numeric($price)) return $price;
    // return $price*2;
}
function price_format2($p1, $p2=null, $opt=array()){
  global $loader;
  if ($opt['not_fixed'] && $loader->serviceActive('catalog', 'exprice'))
  {
      if($opt['not_fixed'] == 1)
      { //   
      echo '<div class="price btnbig pr-btn" ><span>'.number_format((int)$p2,0,'',' ').' </span></div>';
      //echo '<div class="'.(isset($opt['deprice_css_class']) ? $opt['deprice_css_class'] : 'deprice').'" style="display:table-cell">'. number_format((int)$p1,0,'',' ').' <span></span></div>';
      }
      elseif($current['not_fixed'] == 2)
      { //   
        echo $p2;
      }
  }
  else
  {
    // var_dump($p1,$p2);die();
    return '<div class="price btnbig pr-btn" ><span>'.number_format((int)$p1,0,'',' ').' </span> </div>';
  }
 
  // if (!is_numeric($price)) return $price;
    // return $price*2;
}
?>
