<?php
/*
 *    
 */


//     $trumb_width  $trumb_height
function MakeTrumbalIn($file, $name, $trumb_width, $trumb_height) {
    //     
    if (!file_exists($file)) {
        echo 'file not found';
        return false;
    }
    //   
    list ($image_width, $image_height, $image_type) = @GetImageSize($file);
    //      
    switch ($image_type) {
        case 1:
            $src_img = imagecreatefromgif($file);
            $type = 'gif';
            $ftype = 'gif';return $name;
            
            break;
        case 2:
            $src_img = imagecreatefromjpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
        case 3:
            $src_img = imagecreatefrompng($file);
            $type = 'png';
            $ftype = 'png';
            break;
        default:
            $src_img = imagecreatefromjpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
    }
    $c_i = $image_width / $image_height;
    $c_t = $trumb_width / $trumb_height;
    if ($c_t < $c_i) {
        $b_h = 0;
        $e_h = $image_height;
        $e_w = (int) $image_width / $c_i * $c_t;
        $b_w = (int) ($image_width - $e_w) / 2;
    } else {
        $b_w = 0;
        $e_w = $image_width;
        $e_h = (int) $image_height * $c_i / $c_t;
        $b_h = (int) ($image_height - $e_h) / 2;
    }

    //header('Content-type: image/'.$type);
    //    ,
    //     ,
    //  ,
    //  
    $dst_img_t = imagecreatetruecolor($trumb_width, $trumb_height);
    $white = imagecolorallocate($dst_img_t, 255, 255, 255);
    imagefill($dst_img_t, 0, 0, $white);
    ImageColorTransparent($dst_img_t, $white);
    $outputfunc = 'image' . $ftype;
    imagecopyresampled($dst_img_t, $src_img, 0, 0, $b_w, $b_h, $trumb_width, $trumb_height, $e_w, $e_h);
    $outputfunc($dst_img_t, $name, 100);
    ImageDestroy($dst_img_t);
    ImageDestroy($src_img);
    return $name;
}

function DeleteImages($name, $thumbPrefix, $textPrefix) {
    global $img;
    $o_name = $img . '/' . $name;
    $th_name = $img . '/' . $thumbPrefix . $name;
    $txt_name = $img . '/' . $textPrefix . $name;
    $r1 = unlink($o_name);
    $r2 = unlink($th_name);
    $r3 = unlink($txt_name);
    return $r1 && $r2 && $r3;
}

/**
 *   
 *
 * @param string $class
 * @param int $id
 *
 */
function DeleteFile($name) {
    global $fileFolder;
    $o_name = $fileFolder . '/' . $name;
    $r1 = unlink($o_name);
    return $r1;
}

function _iMakeTrumbal($file, $trumb_width, $name, $trumb_height) {
    $file_name = $name . '.jpg';
    if (!file_exists($file_name)) {
        touch($file_name); // Create blank file
        chmod($file_name, 0777);
    }
    list ($image_width, $image_height, $image_type) = @GetImageSize($file);
    switch ($image_type) {
        case 1:
            $src_img = ImageCreatefromGif($file);
            $type = 'gif';
            $ftype = 'gif';return $name;
            
            break;
        case 2:
            $src_img = ImageCreatefromJpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
        case 3:
            $src_img = ImageCreatefromPng($file);
            $type = 'png';
            $ftype = 'png';
            break;
        default:
            $src_img = ImageCreatefromJpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
    }
    $or_w = $image_width;
    $or_h = $image_height;
    if ($or_w >= $or_h) {
        $or_h_n = intval($trumb_width / $or_w * $or_h);
        $or_w_n = $trumb_width;
    } else {
        $or_w_n = intval($trumb_width / $or_h * $or_w);
        $or_h_n = $trumb_width;
    }
    if ($image_type == 3 || $image_type == 1)
        $dst_img_t = imagecreate($or_w_n, $or_h_n);
    else
        $dst_img_t = imagecreatetruecolor($or_w_n, $or_h_n);
    if ($image_type == 3) {
        imagealphablending($dst_img_t, false);
        imagesavealpha($dst_img_t, true);
        $trans_colour = imagecolorallocatealpha($dst_img_t, 0, 0, 0, 127);
        imagefill($dst_img_t, 0, 0, $trans_colour);
    }
    $colour = imagecolorallocate($dst_img_t, 244, 228, 212);
    $outputfunc = 'image' . $ftype;
    imagecopyresized($dst_img_t, $src_img, 0, 0, 0, 0, $or_w_n, $or_h_n, $or_w, $or_h);
    $outputfunc($dst_img_t, $name . '.' . $type, 100);
    ImageDestroy($dst_img_t);
    ImageDestroy($src_img);
    return TRUE;
}

function _MakeTrumbal($file, $trumb_width, $name, $trumb_height) {
    $file_name = $name . '.jpg';
    if (!file_exists($file_name)) {
        touch($file_name); // Create blank file
        chmod($file_name, 0777);
    }
    list ($image_width, $image_height, $image_type) = @GetImageSize($file);
    switch ($image_type) {
        case 1:
            $src_img = ImageCreatefromGif($file);
            $type = 'gif';
            $ftype = 'gif';return $name;
            
            break;
        case 2:
            $src_img = ImageCreatefromJpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
        case 3:
            $src_img = ImageCreatefromPng($file);
            $type = 'png';
            $ftype = 'png';
            break;
        default:
            $src_img = ImageCreatefromJpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
    }
    $or_w = $image_width;
    $or_h = $image_height;
    if ($or_w >= $or_h) {
        $or_h_n = intval($trumb_width / $or_w * $or_h);
        $or_w_n = $trumb_width;
    } else {
        $or_w_n = intval($trumb_width / $or_h * $or_w);
        $or_h_n = $trumb_width;
    }
    if ($image_type == 3 || $image_type == 1)
        $dst_img_t = imagecreate($or_w_n, $or_h_n);
    else
        $dst_img_t = imagecreatetruecolor($or_w_n, $or_h_n);
    if ($image_type == 3) {
        imagealphablending($dst_img_t, false);
        imagesavealpha($dst_img_t, true);
        $trans_colour = imagecolorallocatealpha($dst_img_t, 0, 0, 0, 127);
        imagefill($dst_img_t, 0, 0, $trans_colour);
    }
    $colour = imagecolorallocate($dst_img_t, 244, 228, 212);
    $outputfunc = 'image' . $ftype;
    imagecopyresized($dst_img_t, $src_img, 0, 0, 0, 0, $or_w_n, $or_h_n, $or_w, $or_h);
    $outputfunc($dst_img_t, $name . '.' . $type, 100);
    ImageDestroy($dst_img_t);
    ImageDestroy($src_img);
    return TRUE;
}

function MakeTrumbal($file, $name, $trumb_width=0, $trumb_height=0) {
    if ($trumb_width > 0 && $trumb_height > 0) {
        return MakeTrumbalFix($file, $name, $trumb_width, $trumb_height);
    } elseif ($trumb_width > 0) {
        return MakeTrumbalFixWidth($file, $name, $trumb_width);
    } elseif ($trumb_height > 0) {
        return MakeTrumbalFixHeight($file, $name, $trumb_height);
    } else {
        return copy($file, $name);
    }
}

// 
function MakeTrumbalFix($file, $name, $trumb_width, $trumb_height) {
    //     
    if (!file_exists($file)) {
        echo 'file not found';
        return false;
    }
    //   
    list ($image_width, $image_height, $image_type) = @GetImageSize($file);
    //      
    switch ($image_type) {
        case 1:
            $src_img = imagecreatefromgif($file);
            $type = 'gif';
            $ftype = 'gif';return $name;
            
            break;
        case 2:
            $src_img = imagecreatefromjpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
        case 3:
            $src_img = imagecreatefrompng($file);
            $type = 'png';
            $ftype = 'png';
            break;
        default:
            $src_img = imagecreatefromjpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
    }

    if ($image_width >= $trumb_width && $image_height >= $trumb_height) {
        //     
        $c_w = $image_width / $trumb_width;
        $c_h = $image_height / $trumb_height;
        if ($c_w >= $c_h) {
            $i_y = 0;
            $o_y = 0;
            $i_h = $image_height;
            $o_h = $trumb_height;
            $i_x = (int) (($image_width - $trumb_width * $c_h) / 2);
            $o_x = 0;
            $i_w = (int) ($trumb_width * $c_h);
            $o_w = $trumb_width;
        } else {
            $i_x = 0;
            $o_x = 0;
            $i_w = $image_width;
            $o_w = $trumb_width;
            $i_y = (int) (($image_height - $trumb_height * $c_w) / 2);
            $o_y = 0;
            $i_h = (int) ($trumb_height * $c_w);
            $o_h = $trumb_height;
        }
    } elseif ($image_width >= $trumb_width) {
        //    ,   
        $i_x = 0;
        $o_x = 0;
        $i_w = $image_width;
        $o_w = $trumb_width;
        $i_y = 0;
        $o_y = (int) (($trumb_height - $image_height * $trumb_width / $image_width) / 2);
        $i_h = $image_height;
        $o_h = (int) ($image_height * $trumb_width / $image_width);
    } elseif ($image_height >= $trumb_height) {
        //    ,   
        $i_y = 0;
        $o_y = 0;
        $i_h = $image_height;
        $o_h = $trumb_height;
        $i_x = 0;
        $o_x = (int) (($trumb_width - $image_width * $trumb_height / $image_height) / 2);
        $i_w = $image_width;
        $o_w = (int) $image_width * $trumb_height / $image_height;
    } else {
        //     
        $i_x = 0;
        $o_x = (int) (($trumb_width - $image_width) / 2);
        $i_w = $image_width;
        $o_w = $image_width;
        $i_y = 0;
        $o_y = (int) (($trumb_height - $image_height) / 2);
        $i_h = $image_height;
        $o_h = $image_height;
    }
    //    ,
    //     ,
    //  ,
    //  
    $dst_img_t = imagecreatetruecolor($trumb_width, $trumb_height);
    $white = imagecolorallocate($dst_img_t, 255, 255, 255);
    imagefill($dst_img_t, 0, 0, $white);
    ImageColorTransparent($dst_img_t, $white);
    $outputfunc = 'image' . $ftype;
    imagecopyresampled($dst_img_t, $src_img, $o_x, $o_y, $i_x, $i_y, $o_w, $o_h, $i_w, $i_h);
    $outputfunc($dst_img_t, $name, 100);
    chmod($name, 0666);
    ImageDestroy($dst_img_t);
    ImageDestroy($src_img);
    return $name;
}

// 
function MakeTrumbalFixWidth($file, $name, $trumb_width) {
    //     
    if (!file_exists($file)) {
        echo 'file not found';
        return false;
    }
    $trumb_height = 0;
    //   
    list ($image_width, $image_height, $image_type) = @GetImageSize($file);
    //      
    switch ($image_type) {
        case 1:
            $src_img = imagecreatefromgif($file);
            $type = 'gif';
            $ftype = 'gif';return $name;
            
            break;
        case 2:
            $src_img = imagecreatefromjpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
        case 3:
            $src_img = imagecreatefrompng($file);
            $type = 'png';
            $ftype = 'png';
            break;
        default:
            $src_img = imagecreatefromjpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
    }
    $c_w = $image_width / $trumb_width;
    if ($image_width >= $trumb_width) {
        //   
        $i_x = 0;
        $o_x = 0;
        $i_w = $image_width;
        $o_w = $trumb_width;
        $i_y = 0;
        $o_y = 0;
        $i_h = $image_height;
        $o_h = $image_height / $c_w;
    } else {
        //   
        $i_x = 0;
        $o_x = (int) (($trumb_width - $image_width) / 2);
        $i_w = $image_width;
        $o_w = $image_width;
        $i_y = 0;
        $o_y = 0;
        $i_h = $image_height;
        $o_h = $image_height;
    }
    $trumb_height = $o_h;
    //    ,
    //     ,
    //  ,
    //  
    $dst_img_t = imagecreatetruecolor($trumb_width, $trumb_height);
    $white = imagecolorallocate($dst_img_t, 255, 255, 255);
    imagefill($dst_img_t, 0, 0, $white);
    ImageColorTransparent($dst_img_t, $white);
    $outputfunc = 'image' . $ftype;
    imagecopyresampled($dst_img_t, $src_img, $o_x, $o_y, $i_x, $i_y, $o_w, $o_h, $i_w, $i_h);
    $outputfunc($dst_img_t, $name, 100);
    chmod($name, 0666);
    ImageDestroy($dst_img_t);
    ImageDestroy($src_img);
    return $name;
}

// 
function MakeTrumbalFixHeight($file, $name, $trumb_height) {
    //     
    if (!file_exists($file)) {
        echo 'file not found';
        return false;
    }
    $trumb_width = 0;
    //   
    list ($image_width, $image_height, $image_type) = @GetImageSize($file);
    //      
    switch ($image_type) {
        case 1:
            $src_img = imagecreatefromgif($file);
            $type = 'gif';
            $ftype = 'gif';return $name;
            
            break;
        case 2:
            $src_img = imagecreatefromjpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
        case 3:
            $src_img = imagecreatefrompng($file);
            $type = 'png';
            $ftype = 'png';
            break;
        default:
            $src_img = imagecreatefromjpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
    }
    $c_h = $image_height / $trumb_height;
    if ($image_height >= $trumb_height) {
        //   
        $i_y = 0;
        $o_y = 0;
        $i_h = $image_height;
        $o_h = $trumb_height;
        $i_x = 0;
        $o_x = 0;
        $i_w = $image_width;
        $o_w = $image_width / $c_h;
    } else {
        //   
        $i_y = 0;
        $o_y = (int) (($trumb_height - $image_height) / 2);
        $i_h = $image_height;
        $o_h = $image_height;
        $i_x = 0;
        $o_x = 0;
        $i_w = $image_width;
        $o_w = $image_width;
    }
    $trumb_width = $o_w;
    //    ,
    //     ,
    //  ,
    //  
    $dst_img_t = imagecreatetruecolor($trumb_width, $trumb_height);
    $white = imagecolorallocate($dst_img_t, 255, 255, 255);
    imagefill($dst_img_t, 0, 0, $white);
    ImageColorTransparent($dst_img_t, $white);
    $outputfunc = 'image' . $ftype;
    imagecopyresampled($dst_img_t, $src_img, $o_x, $o_y, $i_x, $i_y, $o_w, $o_h, $i_w, $i_h);
    $outputfunc($dst_img_t, $name, 100);
    chmod($name, 0666);
    ImageDestroy($dst_img_t);
    ImageDestroy($src_img);
    return $name;
}

function MakeTrumbalOut($file, $name, $trumb_width, $trumb_height) {
    //     
    if (!file_exists($file)) {
        echo 'file not found ' . $file . '<br/>';
        return false;
    }
    //   
    list ($image_width, $image_height, $image_type) = @GetImageSize($file);
    //      
    switch ($image_type) {
        case 1:
            $src_img = imagecreatefromgif($file);
            $type = 'gif';
            $ftype = 'gif';return $name;
            break;
        case 2:
            $src_img = imagecreatefromjpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
        case 3:
            $src_img = imagecreatefrompng($file);
            $type = 'png';
            $ftype = 'png';
            break;
        default:
            $src_img = imagecreatefromjpeg($file);
            $type = 'jpg';
            $ftype = 'jpeg';
            break;
    }
    $or_w = $image_width;
    $or_h = $image_height;
    if ($or_w >= $or_h) {
        $or_h_n = intval($trumb_width / $or_w * $or_h);
        $or_w_n = $trumb_width;
    } else {
        $or_w_n = intval($trumb_width / $or_h * $or_w);
        $or_h_n = $trumb_width;
    }
    //    ,
    //     ,
    //  ,
    //  
    $dst_img_t = imagecreatetruecolor($or_w_n, $or_h_n);
    $white = imagecolorallocate($dst_img_t, 255, 255, 255);
    imagefill($dst_img_t, 0, 0, $white);
    ImageColorTransparent($dst_img_t, $white);
    $outputfunc = 'image' . $ftype;
    imagecopyresized($dst_img_t, $src_img, 0, 0, 0, 0, $or_w_n, $or_h_n, $or_w, $or_h);
    $outputfunc($dst_img_t, $name);
    ImageDestroy($dst_img_t);
    ImageDestroy($src_img);
    return $name;
}

?>
