<?php
/**
 *  
 * @param array  
 */

/**
 *  
 *
 * @param infosection $infosection
 * @param id $id
 * @param array $active_array
 * @param id $ul_id
 * @param boolean openMenu -   
 * @return string
 */

function get_infosection_left_menu(infosection $infosection, $id, $active_array, $ul_class='',$always_open = false) {
    global $db;
    $o = '';
    if ($infosection->child_array[$id]) {
        $main_sect = $infosection->data[$id]['name'];
        if ($ul_class){
            $__mainitem = $infosection->data[$id]['name'];
            // 1  - 
            // if (empty($active_array) or (count($active_array)>2 && in_array($id,$active_array)))
                // $__mainitem = '<a href="'.$infosection->get_cannon_url($id).'">'.$__mainitem.'</a>';
            // $o = '<div class="mtitle">'.$__mainitem.'</div>';
        }
        $o .= '<ul ' . ($ul_class ? 'class="' . $ul_class . '"' : '') . '>';
        $last = end($infosection->child_array[$id]);
        $active_array = array_filter($active_array);
        foreach ($infosection->child_array[$id] as $v) {
            if (!$infosection->data[$v]['visible'])
                continue;
            $o =str_replace('%LAST%','',$o);
            $css_class = '';

            //   " "
            if (in_array($v,$active_array) && $infosection->child_array[$v] && count($active_array)==2)
                $css_class="active";
            elseif(in_array($v,$active_array) && $infosection->child_array[$v])
                $css_class="open";
            elseif(in_array($v,$active_array))
                $css_class="active";

            // var_dump($css_class != 'active' , !empty($db->qa[1]) , $db->qa[1] == $v);die();
            if ($css_class != 'active' && (!empty($db->qa[1]) && $db->qa[1] == $infosection->data[$v]['uri'])){
                $css_class = 'active';
            }
            $o .= '<li class="' . $css_class . ' %LAST%">
            <span><a href="' . $infosection->get_cannon_url($v) . '">' . ($infosection->data[$v]['menu_text'] ? $infosection->data[$v]['menu_text'] : $infosection->data[$v]['name']) . '</a></span>';
            if (in_array($v, $active_array) or $always_open == true)
                $o .= get_infosection_left_menu($infosection, $v, $active_array,'',$always_open);
            $o .= '</li>';
            if ($last==$v && ($infosection->child_array[$v]) && in_array($v,$active_array))
                $o =str_replace('%LAST%','',$o);
        }
        $o .= '</ul>';
    }
    $o =str_replace('%LAST%','last',$o);
    return $o;
}

function get_infosection_left_menu1(infosection $infosection, $id, $active_array, $ul_class='',$always_open = false) {
    global $db;
    $o = '';
    //  
    $loader = App::get()->loader;
    $pid = $obj->data[$id]['pid'];
    if ($infosection->child_array[$id]) {
        $main_sect = $infosection->data[$id]['name'];
        $o .= '<ul ' . ($ul_class ? 'class="' . $ul_class . '"' : '') . '>';
        $active_array = array_filter($active_array);
        if ($id=='2'){
            if ($loader->serviceActive('vacancy'))
                $o.='<li><a ' . (($db->qa[0]=='vacancy') ? 'class="active"' : '' ) . '  href="/vacancy/">'.$loader->serviceName('vacancy').'</a></li>';
            if ($loader->serviceActive('personal'))
                $o.='<li><a ' . (($db->qa[0]=='personal') ? 'class="active"' : '' ) . '  href="/personal/">'.$loader->serviceName('personal').'</a></li>';
            if ($loader->serviceActive('news'))
                $o.='<li><a ' . (($db->qa[0]=='news') ? 'class="active"' : '' ) . '  href="/news/">'.$loader->serviceName('news').'</a></li>';
        }
        foreach ($infosection->child_array[$id] as $v) {
            if (!$infosection->data[$v]['visible'])
                continue;
            $css_class = '';

            //   " "
            if(in_array($v,$active_array) && $infosection->child_array[$v])
                $css_class="active";
            elseif(in_array($v,$active_array))
                $css_class="active";
            $o .= '<li class="' . (!empty($db->qa[1]) && $db->qa[1] == $v ? 'active' : '') . ' %LAST%">
            <a class="'.$css_class.'" href="/section/'.$v.'/"><span>' . ($infosection->data[$v]['menu_text'] ? $infosection->data[$v]['menu_text'] : $infosection->data[$v]['name']) . '</span></a>';
            if (in_array($v, $active_array) or $always_open == true)
                $o .= get_infosection_left_menu($infosection, $v, $active_array,'',$always_open);
            $o .= '</li>';
        }
        $o .= '</ul>';
    }
    return $o;
}

function get_infosection_text($id){
    if (!is_numeric($id))return false;
    global $db;
    $infosection = new infosection($db);
    $infosection->id = $id;
    $infosection->load();
    return $infosection->curent['text'];
}
function get_blog_menu_section($blog){
    $blog_array = $blog->get_last_blog();
    $news_menu_sect = '';
    if($blog_array) foreach($blog_array as $v){
        $blog_menu_sect .= '<div class="gitem">'.(!empty($v['date']) ? '<span>'.strftime('%d %B',$v['date']).'</span>' : '').'<a href="'.$_SESSION['eka_url'].'/news/'.$v['id'].'/">'.$v['name'].'</a></div>';
    }
    return $blog_menu_sect;
}


function get_pretext($id, $text_only=false){
    if (!is_numeric($id))return false;
    global $db;
    $pretext = new pretext($db);
    $data = $pretext->loadById($id);
    return $text_only ? $data['text'] : $data; 
}

function get_object_widget($object_name,$id){
    if (!is_numeric($id))return false;
    global $db;
    //    
    $show_title = true;
    $object = new $object_name($db);
    $data = $object->loadById($id);
    if (!$data)return false;
    switch ($object_name) {
        case 'pretext':$content = trim($data['text']);$show_title = $data['box']; if (empty($content)) return''; break;
        case 'banners':{
            $show_title = false;
            //*
            if ($data['type']=='image'){
                $content ='<div class="banner"><a href="'.$data['href'].'" alt="'.htmlspecialchars($data['name']).'" ><img src="'.$object->getPath().$data['image'].'" /></a></div>';
            }
            elseif($data['type']=='flash'){
                $banners[] ='<div class="banner flash banr'.$v['id'].'" data-flash-el=".banr'.$v['id'].'" data-falsh-path="'.$bnr->getPath().$v['image'].'"></div>';
            }
            
            // $content = routateBanr(null, $data['id']);
            break;
        }
    }
    
    if ($content && $show_title) $o = '
    <div class="box">
        '.($show_title ? '<div class="title"><span>'.$data['name'].'</span></div>':'').'
        <div class="inner">'.$content.'</div>
    </div>
    ';
    else return '<div class="box unstyled">'.$content.'</div>';

    return $o;
}


function parse_left_menu($array, $level = 0) {
    global $db;
    $out = '';
    $url_path = array_filter($db->qa);
    if (!empty($array['items']) && is_array($array)) {
        foreach ($array['items'] as $item) {
            if (!$item['name']) continue;
            $url_sect = array_filter(explode('/', $item['link'] ));
            // 
            $url_sect = array_values($url_sect);
            if ($url_sect[0] == $url_path[0] && end($url_sect) == end($url_path))
                $out .='<li>' . $item['name'] . ' '.($item['notice'] ? $item['notice'] : '').' </li>';
            else
                $out .= '<li><a  href="' . $item['link'] . '">' . $item['name'] . '</a> '.($item['notice'] ? $item['notice'] : '').'</li>';
        }
    }
    if ($out)
        return '<div class="box '.(isset($array['class']) && $array['class'] ? $array['class'] : '' ).'">
                	<div class="title">
                    	<span>' . $array['name'] . '</span>
                    </div>
                    <div class="inner">
                    	<ul class="mlist">
                        ' . $out . '
                        </ul>
						<div class="lt"></div><div class="rt"></div>
                    </div>
                    <div class="rb"></div><div class="lb"></div>
                </div>';
}

/**
 *  
 *
 * @param catalog $obj
 * @param array $active_array
 * @param int $id
 * @param string $ul_class
 * @param string $url
 * @param int $level
 * @return string
 */
function get_catalog_left_menu($obj, $active_array, $id=0, $ul_class='' ,$url = '/catalog/', $level = 0,$open = false) {
    global $db;
    $level++;
    $menu = '';
    $addbr = new goods_filter();
    $currbrand=$_GET['filter']['brand'] ;
    if ($obj->child_array[$id]) {
        $menu .= '<ul class="' . $ul_class . '">';
        foreach ($obj->child_array[$id] as $_id) 
        {
            if (!$obj->data[$_id]['vis'])
                continue;
            $submenu = '';

            if  (in_array($_id, $active_array) or $open==true) 
                { 
                   $submenu =  get_catalog_left_menu($obj, $active_array, $_id, '', $url, $level) ;
                   if ($submenu=='<ul class=""></ul>'){
                     $addbrmas = $addbr->get_brands($_id);
                     $addbr->clearbr();
                     if ($addbrmas)
                    foreach ($addbrmas as $k => $v) 
                    {
                        $br[$k]=$v['name'];
                    }
                    $addbrmas = '' ;
                    $linkbrands ='';
                   
                        if($br)
                            foreach ($br as $kk => $vv) 
                            {
                                $urlbrand=$kk;
                                $titlebrand = ($currbrand==$kk) ? '<strong> '.$vv.' </strong>' : $vv ;
                                $linkbrands .= '<li><span> 
                                <div data-link="filter%5Bbrand%5D='.$urlbrand.'" class="relinkfiltr" data-parentlink="'.$url.$obj->getUriById($_id).'">   '.$titlebrand.'  </a>
                                </span></li>';
                            }
                    $submenu = '<ul class="' . $ul_class . '"> '.$linkbrands.'</ul>' ;
                   }
                   $br='';

                }
                else 
                {   
                   
      
                }   


            $menu .= ' <li ' . (in_array($_id, $active_array) ? 'class="active"' : '') . '>  <span> ' . ((in_array($_id, $active_array) or $open==true) ? '<a href="' . $url . '' . $obj->getUriById($_id) . '/"><strong>' . $obj->data[$_id]['name'] . '</strong></a>' : '<a href="' . $url . '' . $obj->getUriById($_id) . '/">' . $obj->data[$_id]['name'] . '</a>') . ' </span>' . $submenu .' ' . '</li>';
        
        }
        $menu .= '</ul>';
    }
    return $menu;
}

/**
 * Enter description here...
 *
 * @param news $news
 * @return unknown
 */
function get_news_menu_section($news) {
    $news_array = $news->get_last_news();
    $news_menu_sect = '';
    if ($news_array)
        foreach ($news_array as $v) {
            $news_menu_sect .= '<div class="gitem">' . (!empty($v['date']) ? '<span>' . strftime('%d %B', $v['date']) . '</span>' : '') . '<a href="/news/' . $v['id'] . '/">' . $v['name'] . '</a></div>';
        }
    return $news_menu_sect;
}

//TODO   
function show_form($form, $array = null, $error = null) {
    global $loader;
    if (!$loader->serviceActive('forms')){
        return false;
    }
    $o = '';
    $o .= '<form action="' . $_SERVER['REQUEST_URI'] . '#generated_form" method="post" enctype="multipart/form-data" class="style_form  generated_form" id="form' . $form['id'] . '">';
    if ($form['header_site']){
        $o .= '<div class="title">'.$form['header_site'].'</div>';
    }
    $errorString = array();
    if ($form['fields'])
        foreach ($form['fields'] as $v) {
            if ($v['alias'] && isset($array[$v['alias']]))
                $value = $array[$v['alias']];
            elseif ($array['field'][$v['id']])
                $value = $array['field'][$v['id']];
            else
                $value = '';
            $value = stripslashes($value);
            //if($error&&$error['required_empty'][$v['id']]) $o .= '<tr><td></td><td>  </td>';
            if ($error && $error['required_empty'][$v['id']]) {
                $errorString[] = '<li>'.$v['name'].' -   </li>';
            }
            $o .= '<div class="row ' . (($v['type'] == 'date' or $v['type'] == 'time') ? 'small' : '') . ' fld' . $v['id'] . '">
                <label for="f' . $v['id'] . '">' . $v['name'] . ($v['required'] ? '<span class="required">*</span>' : '') . '</label>';
            switch ($v['type']) {
                case 'file':
                    $o .= '<input type="file"  name="field[' . $v['id'] . ']" class="itxt' . ($v['required'] ? ' light' : '') . '" value="' . $value . '"/>';
                    break;
                case 'radio':
                    $br = '';
                    if ($v['values']) foreach ($v['values'] as $v1) {
                        if ($v1['name']){
                            $o .= $br . '<label class="lbl"><input type="radio" ' . ($v['required'] ? 'required="required"' : '') . ' name="field[' . $v['id'] . ']" value="' . $v1['id'] . '" ' . ($value == $v1['id'] ? 'checked="checked"' : '') . '/>' . $v1['name'] . '</label>';
                            $br = '<!--br /-->';
                        }
                    }
                    break;
                case 'checkbox':
                    $br = '';
                    if ($v['values']) foreach ($v['values'] as $v1) {
                        if ($v1['name']){
                            $o .= $br . '<label><input type="checkbox"  name="field[' . $v['id'] . '][' . $v1['id'] . ']" value="' . $v1['id'] . '" ' . ($value[$v1['id']] ? 'checked="checked"' : '') . ' />' . $v1['name'] . '</label>';
                            $br = '<br />';
                        }
                    }
                    break;
                case 'select':
					$def_txt = $form['id'] == 12 ? " " : "";
					
                    $o .= '<select ' . ($v['required'] ? 'required="required"' : '') . ' id="f' . $v['id'] . '" name="field[' . $v['id'] . ']" class="select"><option value="">'.$def_txt.'</option>';
                    if ($v['values']) foreach ($v['values'] as $v1) {
                        if ($v1['name'])
                            $o .= '<option value="' . $v1['id'] . '" ' . ($v1['id'] == $value ? 'selected="selected"' : '') . '>' . $v1['name'] . '</option>';
                    }
                    $o .='</select>';
                    break;
                case 'textarea':
                    $o.= '<textarea ' . ($v['required'] ? 'required="required"' : '') . ' class="textarea" id="f' . $v['id'] . '" name="field[' . $v['id'] . ']" ' . ($v['required'] ? 'class="light"' : '') . '>' . $value . '</textarea>';
                    break;
                case 'date':
                    $o.= '<input ' . ($v['required'] ? 'required="required"' : '') . ' id="f' . $v['id'] . '" type="date" name="field[' . $v['id'] . ']" class="date-input" value="' . $value . '"/>';
                    break;
                case 'time':
                    $o.= '<input ' . ($v['required'] ? 'required="required"' : '') . ' id="f' . $v['id'] . '" type="text" name="field[' . $v['id'] . ']" class="time-input" value="' . $value . '"/>';
                    break;
				case 'time9-23':
                    $o.= '<input ' . ($v['required'] ? 'required="required"' : '') . ' id="f' . $v['id'] . '" type="time" min="09:00" max="23:00" name="field[' . $v['id'] . ']" class="time-input" value="' . $value . '"/>';
                    break;
                default: 
                $o .= '<input ' . ($v['required'] ? 'required="required"' : '') . ' placeholder="'.$v['hint'].'" id="f' . $v['id'] . '" type="text" name="field[' . $v['id'] . ']" class="text" value="' . $value . '"/>';
            }
            $o .='</div>';
        }
    if ($form['kcaptcha']) {
        include DR . 'kcaptcha/kcaptcha.php';
        $o .= '<div class="nom row">
        		<label for="fCaptcha"> <span class="required">*</span>:</label>
         		<div class="num"><img src="/kcaptcha/?' . session_name() . '=' . session_id() . '" alt="" style="margin:0;" /></div>
         <input type="text" id="fCaptcha" name="kcaptcha" class="captcha text"/></div>';
        if (isset($error['kcaptcha']))
            $errorString[] = '<li>   </li>';
    }
    $o .= '
        <div class="row">
            <input type="hidden" name="form' . $form['id'] . '" value="1" />
            <input type="submit" value="" class="btn btn-small">
        </div>';
    if ($errorString) {
        $o = '<ul class="error_list">' . implode('', $errorString) . '</ul>' . $o;
    }
    return $o;
}

function renderPager($itemsCount, $currentPage = 1, $itemsOnPage = 10, $urlPattern = '') {
    if (!$itemsCount)
        return '';
    $pagesCount = ceil($itemsCount / $itemsOnPage);
    $pages = '<div class="navi full_box">';
    if ($pagesCount > 1) {
        if ($currentPage > 1)
            $pages .= '<a href="' . str_replace('{page}', $currentPage - 1, $urlPattern) . '"></a> ';
        for ($i = 1; $i <= $pagesCount; $i++) {
            $pages .= ( $i == $currentPage) ? '<strong>' . $i . '</strong> ' : '<a href="' . str_replace('{page}', $i, $urlPattern) . '">' . $i . '</a> ';
        }
        if ($pagesCount > 1 && $currentPage < $pagesCount)
            $pages .= '<a href="' . str_replace('{page}', $currentPage + 1, $urlPattern) . '"></a>';
    }
    $pages .= '</div>';
    $s = ($currentPage - 1) * $itemsOnPage + 1;
    $e = ($currentPage - 1) * $itemsOnPage + $itemsOnPage;
    return $pages;
}

/**
 *   navigation
 * @deprecated
 */
function getStatusString($ss) {
    $ss = explode(' / ', $ss);
    if (end($ss) != '') {
        $last_el = array_pop($ss);
        $last_el = strip_tags($last_el);
        array_push($ss, $last_el);
    }
    $ss = implode(' / ', $ss);
    return $ss;
}


function formGenerator($formData) {
        global $db, $loader;

    $output = '';
    if (empty($formData['only_fields']) || false == $formData['only_fields']) {
        $output .= '<form action="' . $formData['action'] . '" method="post" class="style_form ' . (!empty($formData['class']) ? $formData['class'] : '') . '" enctype="multipart/form-data">';
    }

    if (!empty($formData['elements'])) {
        foreach ($formData['elements'] as $element) {
            if (empty($element))
                continue;


            $id = str_replace(array('[', ']'), array('_', ''), $element['name']);
            $elAttribs = '';
            if (!empty($element['attribs'])) {
                foreach ($element['attribs'] as $k => $v) {
                    $elAttribs .= $k . ' = "' . $v . '"';
                }
            }

            $required = (!empty($element['attribs']['meta:validator']) && strstr($element['attribs']['meta:validator'], 'filled') !== false) ? true : false;

            switch ($element['type']) {
                case 'hidden':
                    $output .= '<input type="hidden" name="' . $element['name'] . '"' . $elAttribs . ' />';
                    break;

                case 'file':
                    $output .= '
                    <div class="row">
                        <label for="' . $id . '">' . $element['label'] . '</label>
                        <input type="file" class="file" name="' . $element['name'] . '" id="' . $id . '"' . $elAttribs . ' />
                    </div>';
                    break;

                case 'text':
                    $output .= '
                    <div class="row">
                        <label for="' . $id . '">' . $element['label'] . ($required ? '<span class="required">*</span>' : '') . '</label>
                        <input ' . ($required ? 'required="required"' : '') . ' type="text" class="text" name="' . $element['name'] . '" id="' . $id . '"' . $elAttribs . ' />
                    </div>
                    ';
                    break;

                case 'checkbox':
                    $output .= '
                    <div class="row">
                        <input type="checkbox" style="float:left;" class="checkbox" name="' . $element['name'] . '" id="' . $id . '"' . $elAttribs . ' />
                        <label for="' . $id . '" style="float:left;">' . $element['label'] . ($required ? '<span class="required">*</span>' : '') . '</label>
                            <div class="clear"></div><br />
                    </div>
                    ';
                    break;

                case 'textarea':
                    $output .= '
                    <div class="row">
                        <label for="' . $id . '">' . $element['label'] . ($required ? '<span class="required">*</span>' : '') . '</label>
                        <textarea ' . ($required ? 'required="required"' : '') . ' class="textarea" name="' . $element['name'] . '" id="' . $id . '"' . $elAttribs . '>'.$element['value'].'</textarea>
                    </div>
                    ';
                    break;

                case 'comment':
                if (class_exists('account')){

                    $avatar = account::getAvatar(App::get()->account->current['id']);
                    if (!$avatar)
                        $avatar = noimg('avatar');
                    $output .= '
                    <div class="row comment">
                        <div class="avatarium"><img src="'.$avatar.'" /></div>
                        <div class="comment_field">
                            <textarea  placeholder="' . $element['label'] . '" ' . ($required ? 'required="required"' : '') . ' class="textarea" name="' . $element['name'] . '" id="' . $id . '"' . $elAttribs . '></textarea>
                        </div>
                    </div>
                    ';
                }
                    break;
                case 'sticker':
                if (class_exists('account')){
                    $output .= '
                    <div class="row sticker">
                        <div class="sticker_field">
                            <textarea  placeholder="' . $element['label'] . '" ' . ($required ? 'required="required"' : '') . ' class="textarea" name="' . $element['name'] . '" id="' . $id . '"' . $elAttribs . '></textarea>
                        </div>
                    </div>
                    ';
                }
                    break;

                case 'documents':
                    if (class_exists('account') && class_exists('account_documents')){
                        $user_id = App::get()->account->current['id'];
                        $docs = new account_documents($user_id);
                        $folders = $docs->get_folders();
                        $items = '';
                        if (!empty($folders)){
                            $items .= '<div class="list">
                            <h3> :</h3>
                                <ul class="folder_items attach">';
                            foreach($folders as $folder){
                                $files = $docs->get_items($folder['folder_id']);
                              $items .= '<li><a class="ico folder" href="#">'.$folder['name'].' 
                              ('.count($files).')</a>
                                <a class="add_file hidden" href="/account/documents?folder='.$folder['folder_id'].'" target="blank"> </a>
                              ';
                                if (!empty($files)){
                                    $items .= '<ul class="files">';
                                        foreach($files as $file){
                                            global $account;
                                            $items .='<li>
                                            <label>
                                                <input type="checkbox" name="document[]"
                                            value="'.$file['id'].'" />
                                                <img src="/template/images/files/ico_'.get_ico_class(pathinfo($file['full_path'],PATHINFO_EXTENSION)).'.png" />
                                                '.$file['alias'].'
                                            </label>
                                            <a class="download_link" title="'.$file['alias'].'<br/>: '.convertSize($file['size']).'" href="http://'.$_SERVER['HTTP_HOST'].'/account/get_document/?user='.$account->get_login($user_id).'&file_id='.$file['id'].'" target="blank"></a>
                                            </li>';
                                        }
                                    $items .= '</ul>';
                                }
                                $items .='</li>';
                            }
                            $items .= '</ul>
                            </div>';
                        }
                    $output .='
                    <div class="row menager">
                        '.$items.'
                    </div>
                    ';
                    }
                    break;

                case 'password':
                    $output .= '
                    <div class="row">
                        <label for="' . $id . '">' . $element['label'] . ($required ? '<span class="required">*</span>' : '') . '</label>
                        <input ' . ($required ? 'required="required"' : '') . ' type="password" class="text" name="' . $element['name'] . '" id="' . $id . '"' . $elAttribs . ' />
                    </div>
                    ';
                    break;

                case 'date':
                    $output .= '
                    <div class="row">
                        <label for="' . $id . '">' . $element['label'] . ($required ? '<span class="required">*</span>' : '') . '</label>
                        <input ' . ($required ? 'required="required"' : '') . ' type="text" class="text date" name="' . $element['name'] . '" id="' . $id . '"' . $elAttribs . ' />
                    </div>
                    ';
                    break;

                case 'select':									
                    if (!is_array($element['value']) || !count($element['value'])){
                        continue;
                    }														
                    $output .= '
                    <div class="row">
                        <label for="' . $id . '">' . $element['label'] . ($required ? '<span class="required">*</span>' : '') . '</label>
                        <select ' . ($required ? 'required="required"' : '') . ' class="select" name="' . $element['name'] . '" id="' . $id . '"' . $elAttribs . '>' . $element['value'] . '</select>
                    </div>';
                    break;

                case 'doc_list':
                    $output .= '<div class="row"><label for="' . $id . '">' . $element['label'] . '</label>';
                    $output .= '
                    <div class="add_doc_list">
                    </div>
                    <a href="#" id="add_doc"> </a>';
                    $output .= '</div>';
                    break;

                // 
                case 'cart_list':
                if (function_exists('getCartTable')){
                        global $cart;
                        $output .='<div class="cart-box">' . getCartTable($cart->get_cart()) . '</div>';
                    }
                    else $output .= '   ';
                    break;
                case 'in_cart':

               
    $goods_arr = goods::columnGood2($db);
    $render = new Template();
    $item_render = new Template();
    global $stock,$catalog;
    if (!$stock)    $stock = new goods_stock($db);
    if (!$catalog)  $catalog = new catalog($db);
    if ($goods_arr)
    foreach ($goods_arr as $item) {
        if (!$item['vis'])
            continue;
 
        $filename = $item['image'];
        if ($item['image'] != '') {
            $item_preview = array(
                'image' => catalog::$uploadFolder . $item['image'],
                'thumb' => catalog::$uploadFolder . catalog::$popPrefix . $item['image']
            );
        } else {
            $item_preview = false;
        }

        // 
        $stock_data = array();
        if($item['stock_data']){
            $stock_data = unserialize($item['stock_data']);
            $stock_data = $stock->loadById(key($stock_data));
        }
  
        $preview_thumb = noimg();
        if ($item_preview != false) {
            $preview_thumb_file = rtrim($_SERVER['DOCUMENT_ROOT'], DIRECTORY_SEPARATOR) . $item_preview['thumb'];
            if (file_exists($preview_thumb_file)) {
                $preview_thumb = $item_preview['thumb'];
            }
        }
        
        $uri = $catalog->getUriById($item['cid']);
        $item['href'] = "/catalog/{$uri}/{$item['uri']}/";
        $items .= $item_render
                ->set('item', $item)
                ->set('stock', $stock_data)
                ->set('preview_thumb', $preview_thumb)
                ->render("/catalog/good/item3.php");
        $i_num++;
      
    }
    $items       = $render->renderWrap("/catalog/good/in_cart.php", $items);
    $output .=$render
                ->set('items', $items)
                ->render("/catalog/show.php");

                    break;
                case 'cart_delevery':
                if (function_exists('getCartDelevery')){
                        global $cart;
                        $output .='<div class="row">' . getCartDelevery($element) . '</div>';
                    }
                    else $output .= '   ';
                    break;
				case 'payment':                    
					$output .='<div class="row">
							<label for="' . $id . '">' . $element['label'] . '</label>
							<select id="' . $id . '" name="' . $element['name'] . '">' . getPaymentTypes() . '</select>
						</div>';
                    break;
					
                case 'label':
                    $output .= '<div class="' . $element['style_class'] . '">' . $element['label'] . '</div>';
                    break;
            }
        }
    }
    if (!empty($formData['show_submit'])) {
        $output .= '<div class="row"><input type="submit" name="send" class="btn btn-small"' . (!empty($formData['submit_text']) ? ' value="' . $formData['submit_text'] . '"' : '') . ' /></div>';
    }
    if (empty($formData['only_fields']) || false == $formData['only_fields']) {
        $output .= '<div class="row"><input type="submit" name="send" class="btn btn-small"' . (!empty($formData['submit_text']) ? ' value="' . $formData['submit_text'] . '"' : '') . ' /></div>';
        $output .= '</form>';
    }

    return $output;
}

function renderErrors(array $errors = null) {
    if (!is_array($errors))
        return;

    $output = '';
    foreach ($errors as $error) {
        if ($error['message']) {
            $output .= '<li>' . implode(', ', $error['message']);
        } else {
            $message = $error['meta']['label'] . ' -   ';

            global $errorMessages;
            $validatorKey = preg_replace('/.*::/', '', $error['validator']);
            if (isset($errorMessages[$validatorKey])) {
                $message = sprintf($errorMessages[$validatorKey], $error['meta']['label']);
            }

            $message = strip_tags($message);
            $message = str_replace(array('*'), '', $message);

            $output .= '<li>' . $message . '</li>';
        }
    }

    if (!empty($output))
        return '<ul class="error_list">' . $output . '</ul>';
}


function insert_pretext($id){
    global $db, $loader;
    if (!$loader->serviceActive('infosection','insert_pretext')){
        return false;
    }
    $pretext = new pretext();
    $item = $pretext->loadById($id);
    $out = '';
    if ($item){
    $_pretext_img = '';
    $subgallery = new subgallery($db);
    $subgallery->load($item['id'], 'pretext');
        if ($subgallery->gallery){
            foreach ($subgallery->gallery as $v) {
                if (!$v['visible']) continue;
                $_pretext_img .= '<img title="' . str_replace('"','\'',$v['name']) . '" alt="' . str_replace('"','\'',$v['name']) . '" src="' . subgallery::$path . '' . $v['file'] . '">';
            }
        }
        $out .= $item['title'] ? '<div class="mtitle">'.$item['title'].'</div>' : '';
        $out .= $item['text'] ? $item['text'] : '';
        if ($_pretext_img)
            $out .='<div class="mpartner"><div class="im">'.$_pretext_img.'</div></div>';
        return $out ? '<div class="seps"></div>'.$out.'<div class="seps"></div>' : '';

    }
}

function insert_form($alias){
    global $db, $loader;
    if (!$loader->serviceActive('infosection','insert_form')){
        return false;
    }
    $forms = new forms($db);
    $error = array();
    $form = $forms->load_on_alias($alias);

    // $_out = $form['header_site'] ? '<h2>'.$form['header_site'].'</h2>' : '';

    if (!$form)
        return;
    if($forms->submit($errors)){
        $_out .= '<div class="form_response">   .<br/>      .</div>';
    }else $_out .= show_form($form,$_REQUEST,$errors,$alias);

    return '<div id="generated_form" class="feed insertform">'.$_out.'</div>';
}


function get_unread($num,$type,$title = ''){
    if ($num)
    return '<span '.($title ? 'title="'.$title.'"':'').' class="unread '.$type.'">'.$num.'</span>';
}
function is_main(){
    global $db;
    return !$db->qa[0];
}
function showComments(){
    global $db,$loader;
    if (!$loader->serviceActive('netcomments')){
        return false;
    }
    $item_render = new Template();
    $render = new Template();

    $body_sect = '';

    if (!$loader->serviceActive('netcomments')) return '';
    if (!$db->qa[0]) return '';
    // arbora:         
    $this_page = $db->qa[0].($db->qa[1] ? '_':'').($db->qa[2] ? '_':'');
    $com = new NETComments($db);              
            $conf = $com->loadConfig();         
            $arr_conf = unserialize($conf['arr_conf']);
            if ($arr_conf[$this_page]) {
                //     
                $comments = $com->loadForUrl(@implode('/', $db->qa));
                $items = '';

                if ($comments) {    
                    foreach ($comments as $k => $v) {  
                         $items .= $item_render
                                  ->clear()
                                  ->set('item', $v)
                                  ->render('/comments/item.php');
                    }
                }
            //   
            if ($_POST['addComment']) {
                $result = $com->user_validData($_POST);
                if (is_array($result)) {

                    $keys = array_keys($_POST);
                    if ($result !== true) {
                        $errors = array();
                        foreach ($result['errors'] as $key => $messages) {
                            if (in_array($key, $keys)) {
                                // $body_sect .= '<p class="error">'.$messages[0].'</p>';
                                $errors[] = $messages[0];
                            }
                        }
                        $alerts_html .= $item_render
                                  ->clear()
                                  ->set('errors', $errors)
                                  ->render('/comments/alerts/errors.php');    
                    }
                } elseif ($result === true) {
                    $com->createComment(@implode('/', $db->qa));
                    $alerts_html .= $item_render
                                  ->clear()
                                  ->set('message', '  .       .')
                                  ->render('/comments/alerts/success.php');

                    $form_comment = '';

                    //  

					/**
					 *      .
					 * @author      Tony Stark <546f6e79@gmail.com>
					 */
					$from = '';
					$title = null;
					if(strpos($_SERVER['REQUEST_URI'], 'catalog')){
						if (preg_match('/(?P<digit>\d+)/sim', $_SERVER['REQUEST_URI'], $match)) {
							$goods = new goods($db);
							$tovar = $goods->getGood($match['digit']);

							if(!empty($tovar)){
								$title = '    '.$tovar['name'];
								$from = " \r\n    ".$tovar['name'].'('.$_SERVER['host'].$_SERVER['REQUEST_URI'].')';
							}
						}
					}

                    $name = strip_tags(trim($_REQUEST['name']));
                    $email = strip_tags(trim($_REQUEST['email']));
                    $comment = strip_tags(trim($_REQUEST['comment']));


                    mails::send_email('form-new-comment', $title, null, array(
                        'user-name'    => $name,//$email,
                        'user-email'   => $email,//$send_mail,
                        'user-comment' => $comment.$from
                    ));
                }            
            }
            $form_comment .= $render
                ->clear()
                ->set('items', $items)
                ->set('alerts', $alerts_html)
                ->render("/comments/list.php");

            $body_sect .= $form_comment;
        /*   -  */
        
        }
        return $body_sect;
}

function render_filter(array $filter_array = array()){
    $out = '';
        $__link = $_GET;
        unset($__link['qs'],$__link['page']);
       
        foreach($filter_array as $get_arg => $args_arr){
        $link = $_GET['filter'];
        // ,      
        unset($link[$get_arg]);
  
        $out .= '<div class="line"><strong class="caption" style="float:left">'.$args_arr['name'].':</strong>
        <ul class="nav nav-pills" style="display:inline-block;">';
        foreach($args_arr['args'] as $arg => $item){
            $link[$get_arg] = $arg;
            $_link = array();
            $_link['filter'] = $link;
            
            $_link = array_merge($__link,$_link);

            $_link = http_build_query($_link);
            if (($_GET['filter'][$get_arg] == $arg) or  (!$_GET['filter'][$get_arg] && $arg =='all'))
                $out .='<li class="active"><span>'.$item['name'].'</span></li>';
            elseif(isset($item['disabled']) && $item['disabled'])
                $out .='<li><span class="disabled">'.$item['name'].'</span></li>';
            else{
				/*
				 *      
				 * @author      Tony Stark <546f6e79@gmail.com>
				 */
//				if($arg != 'all'){
//					$_link = str_replace('filter%5Bbrand%5D=', '', $_link);
//				}
                $lengthlink=iconv_strlen($_GET['qs'])-1;
                $parentlink=$_GET['qs'];
                if ($parentlink[$lengthlink]=='/') 
                {
                    $parentlink=substr($parentlink, 0 , -1);
                }
				//print_r($_link);
				// sort%5Bby%5D=rating&sort%5Border%5D=DESC&filter%5Bbrand%5D=10
				// sort%5Bby%5D=rating&sort%5Border%5D=DESC&10
                $out .='<li><span><span class="relinkfiltr" data-link="'.$_link.'" data-parentlink="/'.$parentlink.'"><span>'.$item['name'].'</span></></span></li>';
            }

        }
        $out .= '</ul></div>';
    }

    return $out;
}


function render_filter_sort(array $filter_array){
    $__link = $_GET;
    unset($__link['qs']);
    $__link['sort']['order'] = $_GET['sort']['order']=='DESC' ? 'DESC' : 'ASC';
    $out = '<div class="sort"><strong> :</strong>';
        foreach($filter_array['sort_by'] as $arg=>$item){
            $link['by'] = $arg;
            $_link = array();
            $_link['sort'] = $link;    
            $_link = array_merge($__link,$_link);
            $link_asc = $_link;

            $curr = false;
            if ($__link['sort']['by'] ==$arg or (!$__link['sort']['by'] && $item['default']))
                $curr = true;
                if ($curr){
                    if (!$__link['sort']['order'] or $__link['sort']['order']=='ASC'){
                        $_link['sort']['order']='DESC';
                        }
                    else 
                        $_link['sort']['order']='ASC';
                }
                $link_asc['sort']['order']='ASC';
                    $link_asc = http_build_query($link_asc);
            $link_desc = $_link;
                $link_desc['sort']['order']='DESC';
                    $link_desc = http_build_query($link_desc);
            $_link = http_build_query($_link);


            $out .= '<span class="'.($curr ? 'active' : '').' with_arrows">
                        <a class="first btn btn-small" href="?'.$_link.'">'.$item['name'].'</a>
                        <a href="?'.$link_asc.'" class="'.($__link['sort']['order'] == 'ASC' ? 'curr ' : '').'up"></a>
                        <a href="?'.$link_desc.'" class="'.($__link['sort']['order']== 'DESC' ? 'curr ' : '').'down"></a>
                    </span>';
        }

    $out .= '</div>';
    return $out;
}

function noimg($type=''){
    $path = TP.'images/no_foto.png';
    // return '<div></div>'
    return $path;
}



?>
