<?php
if (false == $account->load_current()) {
    return;
}
if (isset($db->qa[3]))
    $order_id = $db->qa[3];

$cart = new cart($db);


/***************************************************
 *   
 ***************************************************/
if (!$notice instanceof account_notice) $notice = new account_notice();

///===--------------------------------------------------------------------===///
///                               
///===--------------------------------------------------------------------===///
if ($db->qa[2] == 'show' && isset($order_id) && $order_id && $order = $cart->getOrderById($order_id)
) {
    //  ,       .
    if (!$profile_id){
        if ($order['user_id']!=$account->id){
                $_breadtitle = $account->get_user_name($order['user_id']);
                $_breadlink = 'account/edit/'.$order['user_id'].'/';
            }
            else {
                $_breadlink = '/account/history';
                $_breadtitle = ' ';
            }
        navigation::add_breadcrumb($_breadtitle, $_breadlink);
        }
    navigation::add_breadcrumb("   $order_id", '/account/history/show/' . $order_id);
    $header_sect = "   $order_id";

/***************************************************
 *      
 ***************************************************/
$notice->delete_notice($account->id,'order',$order_id);
$notice->delete_notice($account->id,'history_message',$order_id);

if ($account->can('change_order_status')){
$statuses = $cart->get_all_statuses();
    if (!empty($statuses)){
        $show_status = '<div class="fright status_change">
        <div class="h3 nospace"> :</div>
        <form class="style_form" method="post" action="/account/users/actions/change_order_status/'.$order_id.'">
        <select name="status" class="select width190">';
        foreach($statuses as $status){
            $show_status .= '<option '.($order['status']==$status['status_id'] ? 'selected="selected"' : '').' value="'.$status['status_id'].'">'.$status['name'].'</option>';
        }
        $show_status .='</select>
            <input class="button" type="submit" value="" /></form></div>';
        echo $show_status;
    }
}
    ?>
    <table class="information">
        <tr>
            <td class="b">id </td>
            <td><?= $order['id']; ?></td>
        </tr>
        <tr>
            <td class="b"> </td>
            <td><?= date('d.m.Y H:i', strtotime($order['date'])); ?></td>
        </tr>
        <tr>
            <td class="b">  :</td>
            <td><?= number_format($order['summ'], 0, '', ' '); ?> .</td>
        </tr>
        <tr>
            <td class="b"> </td>
            <td><?= $order['items_num']; ?> .</td>
        </tr>
        <tr>
            <td class="b"> </td>
            <td><span class="status" style="
            <?php 
            if (file_exists(SR.cart::$status_img_path.'status'.$order['status_id'].'.png'))
            echo 'background-image:url(/'.cart::$status_img_path.'status'.$order['status_id'].'.png'.');';
            ?>"><?= $order['status_name']; ?></span></td>
        </tr>
        
        <?php
        $user = @unserialize($order['user']);
        if (!empty($user)) {
            $out = '';
            $user_array = array(
                'organization' => '',
                'phone' => ' ',
                'email' => 'Email',
                'delevery_town' => ' ',
                'delevery_address' => ' ',
                'order_comment' => '');
            foreach ($user_array as $k => $v):
                if (isset($user[$k]) && $user[$k]):
                    ?><tr>
                        <td><b><?=$v?></b></td>
                        <td><?=nl2br($user[$k])?></td>
                    </tr>
                    <?php
                endif;
            endforeach;
        }
        ?>
    </table>
    <?php
    $items = @unserialize($order['items']);
    $i = 0;
    if (!empty($items)) {
       $out = '';

        if ($account->can('edit_order')){
            $goods = new goods($db);
            $goods->load();
            $good_list = array();
                foreach($goods->data as $good){
                    $good_list[$good['id']]='<option data-item-price="'.$good['price'].'" value="'.$good['id'].'" empty>'.$good['name'].'</option>';
                }
        }
        /*
              ""     ,   true,
               .
        */
        $deadline_flag = false;

        foreach ($items as $k => $item) {
            //var_dump($item);
            // 
            if ($item['unfixed_price']){
                $unfixed = true;
                $deadline_flag = true;
            }
            else 
                $unfixed = false;
               $i++;
            $price = number_format($item['price'], 0, '', ' ');

            if ($unfixed && !$item['price']){
                //  ....
                if ($item['unfixed_title'])
                    $price = $item['unfixed_title'];
                else
                    $price = ' ';
            }
            $count =$item['count'];
          if ($account->can('edit_order')){
                if ($good_list){
                    //  ,     
                    $good_list_clone = $good_list;
                    //  
                    $item_name = $item['name'];
                //     ,    
                $item['name'] = '<select class="select goods_list'.$item['id'].'" name="item['.$item['id'].']">';
                    if (array_key_exists($item['id'], $good_list)){
                    $good_list_clone[$item['id']] = str_replace('empty', 'selected="selected"', $good_list_clone[$item['id']]);
                }
                else
                    $item['name'] = '<span title=" " class="is_deleted ajax" data-good-id="'.$item['id'].'">' . $item_name . '</span>' . $item['name'];
                $good_list_clone = implode(' ',$good_list_clone);
                $item['name'] .= '<option value="'.$item['id'].'" selected="selected">'.$item_name.'</option>';
                $item['name'] .= $good_list_clone;
                $item['name'] .= '</select>';

                $item['count'] = '<input type="text" class="text width40 " name="count['.$item['id'].']" value="'.$count.'" />';
                }
                if ($unfixed){
                    $price = '<input type="text" class="text width40" name="price['.$item['id'].']" value="'.(int)$item['price'].'" />';
                }
            }
            $out .= '<tr class="item item'.$item['id'].'">
                        <td>' . $i . '</td>
                        <td>' . $item['name'] . '</td>
                        <td>' . $price . '</td>
                        <td>' . $item['count'] . '</td>
                        <td>' . number_format(($item['price'] * $count), 0, '', ' ') . '</td>
                        '.($account->can('edit_order') ? '
                        <td><a class="account_action" data-method="delete_order_item" data-user-id="'.$item['id'].'" title=" " href="/account/users/actions/delete_from_order/'.$order['id'].'?item='.$item['id'].'">
                        <img src="/template/images/cross-button.png" /></a></td>' : '').'
                     </tr>';
        }
        if ($account->can('edit_order')){
            echo '<form class="style_form" action="/account/users/actions/change_order_items/'.$order_id.'" method="post" >';
            $add_good = '
            <tr class="add_good_to_order"><td colspan="6"><span class="add_item"><img src="/template/images/add_green.png"></span></td></tr>
            <tr class="add_good_to_order_field">
                <td>'.($i+1).'</td>
                <td><select class="select goods_list add_good" name="item[new]"><option></option>'.implode('',$good_list).'</select></td>
                <td><span class="item_new_price">0</span></td>
                <td><input type="text" class="text width40 " name="count[new]" value="1" /></td>
                <td colspan="2"></td>
            </tr>';
            }
        echo '<table class="order_items">
                    <tr>
                        <th></th>
                        <th></th>
                        <th>, .</th>
                        <th>-</th>
                        <th>, .</th>
                        '.($account->can('edit_order') ? '<th>&nbsp;</th>' : '').'
                    </tr>' . $out . ($account->can('edit_order') ? $add_good : '') . '</table>';
            if ($deadline_flag){
                if (!$order['deadline'])
                    $_deadclass='wait';
                elseif ($order['deadline']<mktime())
                    $_deadclass='end';
                else 
                    $_deadclass='life';

            if ($account->can('edit_order')){

            $deadline_date ='<input type="text" class="date text width100" name="deadline" value="'.($order['deadline'] ? date('d.m.Y',$order['deadline']) : date('d.m.Y',mktime()+60*60*24*14)).'" />';
                }
                elseif($order['deadline']) $deadline_date = date('d.m.Y',$order['deadline']);
                if ($order['deadline'])
                    echo '<div class="deadline '.$_deadclass.'">  :  '.$deadline_date.'</div>';
                elseif($account->can('edit_order'))
                    echo '<div class="deadline '.$_deadclass.'">    '.$deadline_date.'</div>';
            }
        if ($account->can('edit_order')){
            echo '<p class="right account_el"><input type="submit" class="button" value=""/></p></form>';
        }
echo 
'<div class="print history">
    <a target="blank" class="print_button ib" href="/cart/print/'.$order['id'].'"> </a><br/>
    <a target="blank" class="print_button ib" href="/cart/print/'.$order['id'].'?bill"> </a><br/>
'.
(($account->current['role']=='2' or $account->current['role']=='3') ? '
<a target="blank" class="print_button ib act" href="/cart/print/'.$order['id'].'?act">   </a> <input data-order-id="'.$order['id'].'" type="text" readonly="true" class="date" value="'.date('d.m.Y').'"/>
' : '').'
</div>';
    }

///===--------------------------------------------------------------------===///
///                             
///===--------------------------------------------------------------------===///    
    include 'history_messages.php';
}

///===--------------------------------------------------------------------===///
///                             
///===--------------------------------------------------------------------===///
else {
    $user_cart = $cart->getUnuserOrders();

$user_info = '';

    $header_sect = " ";
    //table_param full table_padding
    ?>
    <table class="tablesorter table_orders" cellspacing="0" cellpadding="0">
    <thead>
        <tr>
            <th></th>
            <th>ID </th>
            <th> </th>
            <th>...</th>
            <th></th>
            <th>- </th>
            <th>&nbsp;</th>
            <th>&nbsp;</th>
        </tr>
    </thead>
    <tbody>
        <?php if ($user_cart)
            foreach ($user_cart as $b) : 
        /*if ($new_order_messages = $notice->get_notice(
            array('user_id' => $account->id, 'object_type'=>'order_message', 'from_user'=>$v['id']))){
            $user_info .= get_unread($new_order_messages,'orders_message',' ');
        }*/
/* **************************************************
 *     
 * **************************************************/
$unread = false;
$user_info = '';
if ($new_orders = $notice->get_notice(array('user_id'=>$account->id,'object_type'=>'unregister_order','object_id'=>$b['id']))){
    $unread = true;
    $user_info.= get_unread($new_orders,'unregister_order',' ');
    }
/*if ($new_messages = $notice->get_notice(array('user_id'=>$account->id ,'object_type'=>'history_message','object_id'=>$b['id']))){
    $unread = true;
    $user_info.= get_unread($new_messages,'history_message',' ');      
   }*/

$user = unserialize($b[user]);
        ?>
        <tr class="status <?php echo ($unread ? 'unread' : '')  ?>"
            style="<?php  echo 'background:'.$b['color'].';';?>">
                    <td><?php echo $user_info ?></td>
                    <td style="text-align: left;"><?= ($b['id']); ?></td>
                    <td style="text-align: left;"><?= date('d.m.Y H:i', strtotime($b['date'])); ?></td>
                    <td><?= $user['name'] ?></td>
                    <td><?= $b['items_num'] ?></td>
                    <td style="text-align: left;"><?= number_format($b['summ'], 0, '', ' ') ?> .</td>
                    <td class="center"><?php
                        if (file_exists(SR.cart::$status_img_path.'status'.$b['status_id'].'.png'))
                        echo '<img alt="'.$b['status_name'].'" title="'.$b['status_name'].'"
                        src="/'.cart::$status_img_path.'status'.$b['status_id'].'.png'.'" />';
                    ?></td>
                    <td><a href="/account/history/show/<?= $b['id'] ?>"></a></td>
                </tr>
            <?php endforeach; ?>
        </tbody>
    </table>
    <?php
}
?>
