<?php

if (!defined('NO_PRINT')){
    define('NO_PRINT', true);
}

if(!$loader->serviceActive('cart'))go404();

/*
 * ***************************************************************************************
 * !!!       
 *     getCartTable()  func/cart/view.php   formGenerator()
 * ***************************************************************************************
 */
load_lib('cart/view');

$template = 'full.php';

$goods = new goods($db);
$cart = new cart($db);

/*
 * *******************************
 *             *
 * *******************************
 */
 
 //    
 if ($db->qa[1] == 'paymentSuccess') {
    $header_sect = '    !';
    $body_sect = '  ,    .    .     
        <a href="/account/myPayments/"> </a>,    ,      ,
      e-mail\'   .';
    return 0;
 }
 
 //   
 if ($db->qa[1] == 'paymentFail') {
    $header_sect = '  !';
    $body_sect = ' ,       .       ,
      <a href="/cart/">  </a>';
    return 0;
 }
 
 
if (isset($_GET['addCart']) && $_GET['addCart']) {
    $count = (isset($_GET['count']) && (int) $_GET['count']) ? (int) $_GET['count'] : 1;
    $goodAdd = $goods->getGood($_GET['addCart']);
    if ($goodAdd) {
        $cart_array = array(
            'price' => $goodAdd['price'],
            'count' => $count,
            'id' => $goodAdd['id'],
            'name' => $goodAdd['name'],
            'link' => 'catalog/'.catalog::getUriById($goodAdd['cid']).'/'.$goodAdd['uri'],
        );
        /*if ($goodAdd['not_fixed']){
            $cart_array['unfixed_price'] = $goodAdd['not_fixed'];
            $cart_array['unfixed_title'] = $goodAdd['price_descript'];
        }*/

        $cart->set($cart_array, true);
    }
    if (isAjax()) {
        echo json_encode(array('total_items' => $cart->total_items(), 'total_price' => number_format($cart->total(), 0, '', ' ')));
        die();
    } else {
        header('Location: ' . $_SERVER['HTTP_REFERER']);
        die();
    }
}

/*
 * ********************************
 *                 *
 * ********************************
 */

if (isset($_GET['clear'])) {
    $cart->destroy();
    if (isAjax()) {
        echo json_encode(array('total_items' => 0, 'total_price' => 0));
        die();
    }
    else
        header('Location: ' . $_SERVER['HTTP_REFERER']);
    die();
}

/*
 * ********************************
 *              *
 * ********************************
 */
if (isset($_POST['count'])) {
    if (is_array($_POST['count'])) {
        foreach ($_POST['count'] as $_it => $_co) {
            $cart->set(array('id' => $_it, 'count' => $_co));
        }
    }
}
/*
 * ********************************
 *               *
 * ********************************
 */
if (isset($_GET['del'])) {
    $cart->deleteitem($_GET['del']);
    if (isAjax()) {
    }
    else
        header('Location: ' . $_SERVER['HTTP_REFERER']);
    die();
}
/*
 * ********************************
 *      *
 * ********************************
 */
if (isset($_GET['cart_table']) && isAjax()) {
    header('Content-Type: text/html; charset=windows-1251');
    echo getCartTable($cart->get_cart(), false);
    die();
}

/*
 * ********************************
 *            *
 * ********************************
 */
if (isset($_GET['cart_data']) && isAjax()) {
    echo json_encode(array('total_items' => $cart->total_items(), 'total_price' => number_format($cart->total(), 0, '', ' ')));
    die();
}

/*
 * *****************************************************************************
 *                                                                      *
 * *****************************************************************************
 */
 
 /*
 *        IM
 */
 
 //
 $payment = new payment($db);
 
 $conf = $payment->conf_getConfigurate();
 
 //   
 $x = pow(10,8); //100 000 000
 $orderId = mt_rand(0,$x);

 $eshopId = $conf['eshopId'];
 
 $serviceName = "    #" . $orderId;
 
 $recipientAmount = $cart->total();
 
 //     - 
 $recipientCurrency = 'RUR';
 
 //    
 $successUrl = 'http://' . $_SERVER['SERVER_NAME'] . '/cart/paymentSuccess/';
 
 //    
 $failUrl = 'http://' . $_SERVER['SERVER_NAME'] . '/cart/paymentFail/';
 
 if(App::get()->account->current) {
    $userName = App::get()->account->get_fname();
    $userEmail = App::get()->account->current['email'];
    $userField_1 = App::get()->account->current['id'];
 }
 else {
    $userName = '';
    $userEmail = '';
    $userField_1 = '0';
 }
 
 
 
 
   
 //  
 $formPayment = "<form class='style_form' method='post' action='https://merchant.intellectmoney.ru/ru/' >".
    "<input id='orderId' type='hidden' value='$orderId' name='orderId'/>".
    "<input id='eshopId' type='hidden' value='$eshopId' name='eshopId'/>".
    "<input id='serviceName' type='hidden' value='$serviceName' name='serviceName'/>".
    "<input id='recipientAmount' type='hidden' value='$recipientAmount' name='recipientAmount'/>".
    "<input type='hidden' value='$recipientCurrency' name='recipientCurrency'/>".
    "<input type='hidden' value='$successUrl' name='successUrl'/>".
    "<input type='hidden' value='$failUrl' name='failUrl'/>".
    "<input id='userName' type='hidden' value='$userName' name='userName'/>".
    "<input id='userEmail' type='hidden' value='$userEmail' name='user_email'/>".
    "<input id='userField_1' type='hidden' value='$userField_1' name='userField_1'/>".
    "<input type=submit class='button' value='' /><br/>".
    "</form>";
 
 /*
 * END
 */
 
 
$header_sect = '';
navigation::add_breadcrumb("", "/catalog/");
navigation::add_breadcrumb("", "/cart/");
$allCart = $cart->get_cart();
//

$fp = new html_formpersister();
$metaForm = new html_metaform('secre7_d1g1tal_signatur3_KFw53C5r');
$metaFormAction = new html_metaformaction($metaForm);
switch ($metaFormAction->process()) {
    //get
    case 'INIT':
        break;
    case 'send':
        //  
        if ($_POST['user']){
            $user_data = array_map('clearUserText', $_POST['user']);

            //      
            if (App::get()->account->id){
                    $user_data['name'] = App::get()->account->current['name'].' '.App::get()->account->current['family'];
                    $user_data['email'] = App::get()->account->current['email'];
                    $user_data['phone'] = App::get()->account->current['phone'] ? App::get()->account->current['phone'] : $user_data['phone'];
                }
            }

        $order_data = array(
            'user_id' => !empty(App::get()->account->current) ? App::get()->account->current['id'] : '', 
            'user' => !empty($user_data) ? $user_data : '',
            'items' => $allCart,
            'summ' => $cart->total(),
            'items_num' => $cart->total_items(),
        );


    $delevery = new cart_delevery();
    $delevery_params = $delevery->load_by_id($user_data['delivery_type']);
    if ($delevery_params['name'])
        $order_data['delivery_type'] = $delevery_params['name'];
    $payment = new cart_payment();
    $payment_params = $payment->load_by_id($user_data['payment']);
    if ($payment_params['name'])
        $order_data['payment'] = $payment_params['name'];
       if (!empty($order_data['items'])){
            $order_id = $cart->saveOrder($order_data);
            if (!isset($_SESSION['cart_orders']))
                $_SESSION['cart_orders'] = array();
            $_SESSION['cart_orders'][] = $order_id;
        }
    break;
}
/*
 * *****************************************************************************
 *                                                                 *
 * *****************************************************************************
 */
if ($db->qa[1]=='print' && $cart->order_exists($db->qa[2])){

$order = $cart->getOrderById($db->qa[2]);
//  :     ,  
//         -     
//       ID,     
//    -     

$user_data = unserialize($order['user']);

if(App::get()->account->current){ // 
    $uid = App::get()->account->current['id'];
    if($order['user_id'] != $uid) 
        go404();
}elseif(isset($_SESSION['cart_orders'])){
    $oid = ltrim($order['id'],'0');
    if (!in_array($oid, $_SESSION['cart_orders']))
        go404();
}else go404();

    // ,    
    if (isset($_GET['act'])){
        $act = true;
        $type = '';
        $hide_colontituls = true;
    }
    elseif (isset($_GET['bill'])){
        $bill = true;
        $type = '';
        $hide_colontituls = true;
    }
    elseif (isset($_GET['invoice'])){
        $invoice = true;
        $type = ' ';
        $hide_colontituls = true;
    }
    else {
        $type='';
        $all_fields = true;
    }
    $sett = $settings->load('shop');

    $template = 'print.php';
    navigation::add_breadcrumb($type."  {$db->qa[2]}", "/cart/print/{$db->qa[2]}");


if ($act or $bill){
    $body_sect .='<div class="agent">
    <u>'.get_array_value($sett['agent']).'</u><br/>: '.get_array_value($sett['address']).'</div>';
}

$body_sect .= '<div id="print">';

if ($bill){
    $body_sect .='<br/><h3>   </h3>';
    $body_sect .= '<table>
    <tr>
        <td>: '.get_array_value($sett['inn']).'</td>
        <td>: '.get_array_value($sett['kpp']).'</td>
        <td rowspan="2" class="center">. :</td>
        <td rowspan="2">'.get_array_value($sett['user_order']).'</td>
    </tr>
    <tr>
        <td colspan="2">:<br/> '.get_array_value($sett['agent']).'</td>
    </tr>
    <tr>
        <td rowspan="2" colspan="2"> :<br/> '.get_array_value($sett['bank']).'</td>
        <td class="center"></td>
        <td>'.get_array_value($sett['bik']).'</td>
    </tr>
    <tr>
        <td class="center">C. </td>
        <td>'.get_array_value($sett['bank_order']).'</td>
    </tr>
    </table>';
}
if ($invoice){
    $date = date('d.m.Y');
    $body_sect .= '
        <table class="unstyled">
            <tr>
                <td style="vertical-align:top;"></td>
                <td>'.$sett['supplier']['value'].'</td>
            </tr>
            <tr>
                <td></td>
                <td>'.$user_data['name'].'</td>
            </tr>
        </table>
    ';
}
elseif ($act){
    if ($_GET['act']){
        $_GET['act'] = strtotime($_GET['act']);
        $date = date('d',$_GET['act']) . ' ' . get_rus_month(date('n',$_GET['act']),2) . ' ' . date('Y',$_GET['act']);
    }
    else
        $date = date('d') . ' ' . get_rus_month(date('n'),2) . ' ' . date('Y');
    }
else
    $date = date('d',strtotime($order['date'])). ' '.get_rus_month(date('n',strtotime($order['date'])),2).' ' .date('Y',strtotime($order['date']));


$body_sect .= '<h2>'.$type.'  '.$order['id'].'  '.$date. ' .</h2>';




/*
$body_sect .= '
        <table class="information">
        <tr>
            <td class="b">  :</td>
            <td>'.number_format($order['summ'], 0, '', ' ').' .</td>
        </tr>
        <tr>
            <td class="b"> </td>
            <td>'.$order['items_num'].' .</td>
        </tr>';
*/
    
        /*
        $user = @unserialize($order['user']);
        if (!empty($user)) {
            $out = '';
            $user_array = array(
                'organization' => '',
                //'phone' => ' ',
                'email' => 'Email',
                'delivery_city' => ' ',
                'delevery_address' => ' ',
                'order_comment' => '');
            foreach ($user_array as $k => $v):
                if (isset($user[$k]) && $user[$k]):
                    $body_sect .='<tr>
                        <td><b>'.$v.'</b></td>
                        <td>'.nl2br($user[$k]).'</td>
                    </tr>';
                endif;
            endforeach;
        }
        */



if ($all_fields){
    ob_start();
?>

<table class="unstyled" style="border:none;text-align:left;">
      <tr>
        <th>/ :</th>
        <th>
          <?=date('d',$order_date_time)?> <?=get_rus_month(trim(substr($order_date_time,5,2),'0'),2)?> <?=date('Y')?> ., <?=date('H:i', strtotime($order_date_time))?>        </th>
      </tr>
      <tr><th>... :</th><th><?=$user_data['name']?></th></tr>
      <? if($user_data['organization']):?>
        <tr><th>:</th><th><?=$user_data['organization']?></th></tr>
      <?endif?>
      <tr><th>:</th><th><?=$user_data['phone']?></th></tr>
      <tr><th>E-mail:</th><th><?=$user_data['email']?></th></tr>
      <? if($user_data['delivery_city']):?>
        <tr><th> :</th><th><?=$user_data['delivery_city']?></th></tr>
      <?endif?>
      <? if($user_data['delevery_address']):?>
        <tr><th> :</th><th><?=$user_data['delevery_address']?></th></tr>
      <?endif?>
      <? if($user_data['delivery_price']):?>
        <tr><th> :</th><th><?=$user_data['delivery_price']?></th></tr>
      <?endif?>
      <?/*
      <tr>
        <th>  :</th>
        <td></td>
      </tr>
      <tr><th> :</th><td></td></tr>
      <tr><th> :</th><td></td></tr>*/?>
      <tr><th>:</th><th><?=$user_data['order_comment']?></th></tr>
    </table>


<?php
    $body_sect .= ob_get_contents();
    ob_clean();

}






        if ($order['user_id']){
            $account = new account();
            $user = $account->load($order['user_id']);
            // if ($config->account->more_fields && $user['more_fields']){
                // $more_fields = unserialize($user['more_fields']);
                // $client = array_filter(array($more_fields['organization'], $more_fields['zip'], $more_fields['address']));
            // }
            // else
                $client = array_filter(array($user_data['name'], $user_data['patronim'], $user_data['family']));
            
            if (!empty($client))
                $client = implode(' ', $client);
            else {
                // var_dump($user);die();
                $client = '';
            }
        }
        else {
            $user = @unserialize($order['user']);
            $client = $user_data['name'];
        }


    $body_sect .='<div style="margin: 10px 0;">';
            if (!$invoice){
                if ($bill){
                    if ($more_fields){
                            $client_bill = $more_fields['organization'];
                            $client_bill .= $more_fields['innkpp'] ? '\: '.$more_fields['innkpp'] : '';
                        }
                        else $client_bill = $client ;
                 $body_sect .= ': '.$client . '<br/>: '.$client_bill.'';
                }
                else 
                $body_sect .= ': '.$client . '';
            }


            if ($act)
            $body_sect .= '<br/>: '.$order['id'] . '  '.date('d.m.Y',strtotime($order['date'])).'';
    $body_sect .='</div>';

    $items = @unserialize($order['items']);
    $i = 0;
    if (!empty($items)) {
        $out = '';
        $items_count = 0;
        $price_count = 0;
        foreach ($items as $k => $item) {
            $i++;
            $items_count += $item['count'];
            $price_count += $item['price'] * $item['count'];

            $price = number_format($item['price'], 0, '', ' ');

            $out .= '<tr>
                        <td>' . $i . '</td>
                        <td>' . $item['name'] . '</td>
                        <td>' . $price . '</td>
                        <td>.</td>
                        <td>' . $item['count'] . '</td>
                        <td>' . number_format(($item['price'] * $item['count']), 0, '', ' ') . '</td>
                     </tr>';
        }
        $NDS = $sett['nds']['value'] ? $sett['nds']['value'] : 18;
        $body_sect .= '<table>
                    <tr>
                        <th></th>
                        <th></th>
                        <th>, .</th>
                        <th>.</th>
                        <th>-</th>
                        <th>, .</th>
                    </tr>' . $out;
                    if ($invoice){ // 
                        if ($sett['invoice_nds']['value']){
                            $price_nds  = $price_count - ($price_count/((float)('1.'.$NDS)));
                            $price_without_nds = $price_count - $price_nds;
                            $body_sect .= '
                             <tr>
                                <td class="bolder right border_nl border_nb border_nt" colspan="5">:</td>
                                <td class="nowrap">'.number_format($price_without_nds,2,',',' ').'</td>
                            </tr>
                            <tr>
                                <td class="bolder right border_nl border_nb  border_nt" colspan="5"> ('.$NDS.'%):</td>
                                <td class="nowrap">'.number_format($price_nds,2,',',' ').'</td>
                            </tr>
                            <tr>
                                <td class="bolder right border_nl border_nb  border_nt" colspan="5">  :</td>
                                <td class="nowrap">'.number_format($price_count,0,'',' ').'</td>
                            </tr>';
                        }else
                            $body_sect .= '<tr>
                                <td class="bolder right border_nl border_nb  border_nt" colspan="5">  ():</td>
                                <td class="nowrap">&mdash;</td>
                            </tr>
                            <tr>
                                <td class="bolder right border_nl border_nb  border_nt" colspan="5">  :</td>
                                <td class="nowrap">'.number_format($price_count,0,'',' ').'</td>
                            </tr>';
                    }else
                        $body_sect .= ((!$act and !$bill) ? '
                         <tr>
                            <td class="bolder right border_nl border_nb border_nt" colspan="5">:</td>
                            <td class="nowrap">'.number_format($price_count,0,'',' ').'</td>
                        </tr>
                        <tr>
                            <td class="bolder right border_nl border_nb  border_nt" colspan="5">  ():</td>
                            <td class="nowrap">&mdash;</td>
                        </tr>
                        <tr>
                            <td class="bolder right border_nl border_nb  border_nt" colspan="5">  :</td>
                            <td class="nowrap">'.number_format($price_count,0,'',' ').'</td>
                        </tr>':'');
                    
                    $body_sect .= '
                    </table>';
                }
        if ($invoice){
  
            $body_sect .= ' : '.$items_count.',   '.number_format($price_count,0,'',' ');
            $temp = trim(num2str($price_count));
            $temp[0] = strtoupper($temp[0]);
            $body_sect .= '<br/><b class="redline">'.($temp).'</b><br><br><br>';


            $body_sect .= '<div style="text-align:center;"><strong>  </strong></div>'.
            $sett['invoice_terms']['value']
            .'<p style="padding-top:5px;font-weight:bold;">"    . 
                        ,  "</p>';
            ;
            $body_sect .= '
                <span style="width:48%;display:inline-block;border-bottom:1px solid #000;"><span style="display:inline-block;background: #fff;margin-bottom:-2px;padding-right:5px;line-height: 17px;"></span></span>
                <span style="width:45%;display:inline-block;border-bottom:1px solid #000;margin-left:4%;"><span style="display:inline-block;background: #fff;margin-bottom:-2px;padding-right:5px;line-height: 17px;"></span></span>
            ';
        }else{
            $body_sect .= ' : '.$items_count.',   '.number_format($price_count,0,'',' ');
            $temp = trim(num2str($price_count));
            $temp[0] = strtoupper($temp[0]);
            $body_sect .= '<br/><b class="redline">'.($temp).'</b>';

            if ($act){
                $body_sect .='
                <div class="signature">
                    <div class="fright signature_box" style="display:inline-block;">
                        <div class="fright signature_line">&nbsp;</div>
                        <span>: </span>
                    </div>
                    <div class="signature_box" style="display:inline-block;">
                        <div class="fright signature_line">&nbsp;</div>
                        <span>: </span>
                    </div>
                </div>';
            }elseif($bill){
                $body_sect .= '
                    <div class="signature">
                    <div class="fright signature_box" style="display:inline-block;">
                        <div class="fright signature_line">&nbsp;</div>
                    </div>
                ';
            }        
            $body_sect .= '</div>';
        }

    }

/*
 * ********************************
 *              *
 * ********************************
 */
elseif ($order_id && !empty($order_data['items'])) {
    $header_sect = '  ';

    $delevery = new cart_delevery();
    $delevery_params = $delevery->load_by_id($user_data['delivery_type']);
    if ($delevery_params['name'])
        $delevery_type = $delevery_params['name'];
    $payment = new cart_payment();
    $payment_params = $payment->load_by_id($user_data['payment']);
    if ($payment_params['name'])
        $payment_type = $payment_params['name'];

	$order_id = str_pad($order_id, 5, "0", STR_PAD_LEFT);
		
    $body_sect = '<div class="h2">  !</div>
            <!--p>       .</p-->
			<div id="order_response"></div>
            <div class="order_id">id  : ' . str_pad($order_id, 5, "0", STR_PAD_LEFT) . '
            <br/>
             : '.$payment_type.'<br/>
            : '.$delevery_type.'<br/>
            </div>
         :';
    $table = '<table class="order_list table bordered"><tr>
                        <th></th>
                        <th></th>
                        <th>, .</th>
                        <th>-</th>
                        <th>, .</th>
                    </tr>';
    $i = 0;
    foreach ($order_data['items'] as $item) {
        $i++;

        if ($item['unfixed_price']){
            $price = $item['unfixed_title'];
        }
        else
            $price = number_format(($item['price']), 0, '', ' ');

        $table .= '<tr>
                    <td>' . $i . '</td>
                    <td>' . $item['name'] . '</td>
                    <td>' . $price . '</td>
                    <td>' . $item['count'] . '</td>
                    <td>' . number_format(($item['price'] * $item['count']), 0, '', ' ') . '</td>
                   </tr>';
    }
    $table .= '</table>';
    $body_sect .= $table;
		
	
	/////countdown
$countdown = <<<HTML
	<script type="text/javascript">
	(function($) {		
		
		$('#order_response').html('<p>     10 .<br />  ,      500 !*</p><div class="timer2">&nbsp;</div><p style="font-size:10px; line-height:14px;"><br /><br />*  ,   <br> -  10.00  19.00<br>   10.00  16.00</p>');
		(function($) {
			var today = new Date();
			var year = today.getFullYear();
			var month = today.getMonth();
			var day = today.getDate();
			var hours = today.getHours();
			var minutes = today.getMinutes()+10;
			var seconds = today.getSeconds();
			var card_num = today.valueOf();
			card_num+=''; card_num=card_num.substring(card_num.length-8, card_num.length);

			var newdate = new Date(year, month, day, hours, minutes, seconds);
			year = newdate.getFullYear();
			month = newdate.getMonth();
			day = newdate.getDate();
			hours = newdate.getHours();
			minutes = newdate.getMinutes();
			seconds = newdate.getSeconds();

			jQuery('.timer2').countdown(year+'/'+(month+1)+'/'+day+' '+hours+':'+minutes+':'+seconds)
			.on('update.countdown', function(event){jQuery(this).html(event.strftime('<div><span>%M</span><br>  </div><div><span>%S</span><br>  </div>'));})
			.on('finish.countdown', function(event){
				
				data='order='+{$order_id}+'&card_num='+card_num;
				console.log(data);

				jQuery.ajax({
					type: 'post',
					url: '/ordercountdown/',
					dataType: 'json',
					cache: false,
					async: false,
					data: data,
					success : function (response) {
						jQuery('#order_response').html('<p>   <strong>'+card_num+'</strong>.</p><p>   .</p>');

						return false;
					},
					error : function (adata, textStatus) {
					}
				});
				return false;
			});
		})(jQuery);

		return false;

	})(jQuery);
</script>
HTML;
	$body_sect .= "{$countdown}";
	/////countdown 
	
/*    */    

                //  
            if ($send_mail = $db->settings['main']['email']['value']){ //    e-mail.ru

                $order = $cart->getOrderById($order_id);
                    $items = @unserialize($order['items']);
                    $i = 0;
                    if (!empty($items)) {
                        $out = '';
                        $items_count = 0;
                        $price_count = 0;
                        foreach ($items as $k => $item) {
                            $i++;
                            $items_count += $item['count'];
                            $price=$item['price'];
                            //$price_count += $item['price'] * $item['count'];
                            $price_count += $price * $item['count'];
                            
                            //$price = price_format($item['price']);

                            $out .= '<tr>';
                            //<td>'.$ready_id.'</td>
                            $out .= '   <td>' . $i . '</td>         
                                        <td>'.$item['t_kod'].'</td>
                                        <td><a href="http://'.rtrim($_SERVER['HTTP_HOST'],'/').'/'.$item['link'].'">' . $item['name'] . '</a></td>
                                        <td align="right">' . $price . '</td>
                                        <td>.</td>
                                        <td align="right">' . $item['count'] . '</td>
                                        <td align="right">' . $price * $item['count']/*price_format(($item['price'] * $item['count']))*/ . '</td>
                                     </tr>';
                        }

                $mail_text .= '
                <h2>  :</h2>
                  <table border="1" style="border-spacing:1px;">  
                    <tr>
                      <td> : </td><td>'.str_pad($order_id, 5, "0", STR_PAD_LEFT).'</td>
                    </tr>
                    <tr>
                      <td></td><td>'.$user_data['name'].'</td>
                    </tr>
                    <tr>
                      <td>:</td><td> '.$user_data['phone'].'</td>
                    </tr>
                    <tr>
                      <td>E-mail:</td><td> '.$user_data['email'].'</td>
                    </tr>
                    <tr>
                      <td> :</td><td> '.$delevery_type.'</td>
                    </tr>
                    <tr>
                      <td>:</td><td>'.$user_data['delivery_city'].'</td>
                    </tr>
                    <tr>
                      <td> :</td><td>'.$user_data['delevery_address'].'</td>
                    </tr>
                    <tr>
                      <td> :</td><td>'.$payment_type.'</td>
                    </tr>
                    <tr>
                      <td> :</td><td>'.$user_data['order_comment'].'</td>
                    </tr>
                </table>
                <h2>:</h2>
                <table border="1" style="border-spacing:1px;">
                  <tr>
                    <th></th>
                    <th></th>
                    <th></th>
                    <th>, .</th>
                    <th>.</th>
                    <th>-</th>
                    <th>, .</th>
                  </tr>' . $out . '
                  <tr>
                    <td class="bolder right border_nl border_nb border_nt" colspan="6">:</td>
                    <td class="nowrap">'.$price_count/*price_format($price_count)*/.'</td>
                  </tr>
                  <tr>
                    <td class="bolder right border_nl border_nb  border_nt" colspan="6">  ():</td>
                    <td class="nowrap">&mdash;</td>
                  </tr>
                  <tr>
                    <td class="bolder right border_nl border_nb  border_nt" colspan="6">  :</td>
                    <td class="nowrap">'.$price_count /*price_format($price_count)*/.'</td>
                  </tr>
                </table>';
                    }
                    
                    $mail_text .= '<div style="padding-top: 8px;"> : '.$items_count.',   '. $price_count/*price_format($price_count)*/." . </div>";
                    $sessionlog='';
                    /*
                     *     
                     * @author      Tony Stark <546f6e79@gmail.com>
                     */
                    foreach ($_SESSION['sessionlog'] as $key => $value) {
                        if($key==0){
                            $ccrawler = parse_url($value);
                            $slashed_value = addslashes($value);

                            //   
                            if (strpos($value, 'yandex.ru')) {
                                $search = 'text=';
                                $crawler = 'Yandex';
                            } elseif (strpos($value, 'rambler.ru')) {
                                $search = 'words=';
                                $crawler = 'Rambler';
                            } elseif (strpos($value, 'google.com')) {
                                $search = 'q=';
                                $crawler = 'Google';
                            } elseif (strpos($str, 'google.ru')) {
                                    $search = 'q=';
                                    $crawler = 'Google';
                            } elseif (strpos($str, 'mail.ru')) {
                                $search = 'q=';
                                $crawler = 'Mail.ru';
                            }
                            //   -
                            elseif (strpos($value, 'vk.com')) {
                                $ccrawler = '';
                            } elseif (strpos($value, 'facebook.com')) {
                                $ccrawler = 'Facebook';
                            } elseif (strpos($value, 'twitter.com')) {
                                $ccrawler = 'Twitter';
                            }


                            if (isset($crawler)) {
                                //    referer     
                                $phrase = urldecode(trim($value));

                                //     referer
                                eregi($search.'([^&]*)', $phrase.'&', $phrase2);
                                if(!empty($phrase2[1])){
                                    //$phrase2 = $phrase2[1];
                                    $phrase2 = iconv('utf-8', 'windows-1251', $phrase2[1]);
                                } else {
                                    $phrase2 = '';
                                }

                                $sessionlog.="    ->{$crawler}  ($phrase2)({$slashed_value})<br/>        <br/>";
                            } else {
                                $sessionlog.="    ->{$ccrawler['host']}({$slashed_value})<br/>        <br/>";
                            }

                        } else {
                            $sessionlog.='  '.$key.' -> '.$value.'<br/>';
                        }
                    }
                    mails::send_email('form-order-accepted-manager', $send_mail, $send_mail, array(
                        'order-data'    => $mail_text.$sessionlog,
                        'user-name'     => $send_mail
                    ));



                    //   21.04.14  
                    $message2=" : ".str_pad($order_id, 5, "0", STR_PAD_LEFT)."\n : ".$price_count." .\n: ".$user_data['name']."\n";
                    $message2.=": ".$user_data['phone']."\nE-mail: ".$user_data['email']."\n : ".$delevery_type."\n";
                    $message2.=": ".$user_data['delivery_city']."\n : ".$user_data['delevery_address']."\n";
                    $message2.=" : ".$payment_type."\n : ".$user_data['order_comment'];
                    if(strlen($message2)>279){
                        $message2=substr($message2, 0, 279);
                        $message2.='...';
                    }
                    $mess=iconv('windows-1251', 'UTF-8', $message2);
                    if($mess)mail("sms@massreach.com","a7afb527722d54b4 79220374435","[SENDER]ROBOT96[/SENDER][SMS]".$mess."[/SMS]","Content-type:text/plain; charset = utf-8\r\nFrom:MENOCOM");
                    //   END



                if ($user_data['email']){
                    if (filter_var($user_data['email'], FILTER_VALIDATE_EMAIL)) {
                        mails::send_email('form-order-accepted', $user_data['name'], $user_data['email'], array(
                            'order-data'    => $mail_text.'<br/>                  -       ..   <a href="mailto::director@robot96.ru">director@robot96.ru</a>,      .',
                            'user-name'     => $user_data['name'],
                            'user-phone'    => $user_data['phone'],
                            
                        ),array('manager-receive' => false));
                        // @send_email2($send_mail_text, $db->settings['main']['title']['value'].':  ',array(array('email'=>$user_data['email'],'name'=>$user_data['name'])),false);
                    }
                }
            }
//  sms  (http://www.smsfeedback.ru/smsapi/extendedphp.php)
$notice_sett = new settings($db);
$notice_sett = $notice_sett->load('notification');


if ($notice_sett['send_sms_to']['value'] && $loader->serviceActive('smsfeedback')){
    $gate = new smsfeedback($notice_sett['sms_fb_login']['value'], $notice_sett['sms_fb_password']['value']);
    $result = $gate->handleSending($notice_sett['send_sms_to']['value'],$user_data['name'] . '  '.$user_data['phone'].'. : ' . number_format($cart->total(), 0, '', ' ') . ' . (' . $cart->total_items() . ' .)');
    // var_dump($result);die();
}
    //   ,   
    //TODO .    
            $notice = new account_notice();
            if (App::get()->account->current['role']!=2 && App::get()->account->current['id']){
                $chains = new account_chains();
                $moders = $chains->get_linked_moders(App::get()->account->current['id']);
                $moder_arr = array();
                if (!empty($moders)) foreach($moders as $moder){
                    $moder_arr[] = array('id'=>$moder['uid'], 'name'=>$moder['name'], 'email'=>$moder['email']);
                }
                //  
                    //$notice->set_notice('order',$order_id, App::get()->account->current['id'] ,$moder_arr, ' ','   '.$order_id);
                
                $account = new account();
                $admins = $account->load_users_by_role(2);
                //    ,     _
                $admin_arr = array();
                if (!empty($admins)) foreach($admins as $admin){
                        $admin_name = array_filter(array($admin['name'], $admin['patronim'],$admin['family']));
                        if ($admin_name) $admin_name = implode(' ',$admin_name);
                        $admin_arr[] =  array('id'=>$admin['id'],'name'=>$admin_name, 'email'=>$admin['email']);
                    }
                //  
                $send_to = array_merge($moder_arr,$admin_arr);
                    $notice->set_notice('order',$order_id, App::get()->account->current['id'], $send_to, ' ','   <a href="http://'.$_SERVER['HTTP_HOST'].'/account/history/show/'.str_pad($order_id, 5, "0", STR_PAD_LEFT).'">'.str_pad($order_id, 5, "0", STR_PAD_LEFT). '</a><br/>'.$mail_text);
                }
                //  
                elseif(!App::get()->account->current) {
                $account = new account();
                $send_user_arr = array();
                $send_users = array_merge($account->load_users_by_role(2),$account->load_users_by_role(3));
                if (!empty($send_users)) foreach($send_users as $send_user){
                        $user_name = array_filter(array($send_user['name'], $send_user['patronim'],$send_user['family']));
                        if ($user_name) $user_name = implode(' ',$user_name);
                        $send_user_arr[] =  array('id'=>$send_user['id'],'name'=>$user_name, 'email'=>$send_user['email']);
                    }
                    //  
                    $notice->set_notice('unregister_order',$order_id, null,$send_user_arr, ' ','   <a href="http://'.$_SERVER['HTTP_HOST'].'/account/history/show/'.str_pad($order_id, 5, "0", STR_PAD_LEFT).'">'.str_pad($order_id, 5, "0", STR_PAD_LEFT). '</a>   <br/>'.$mail_text);
                }
    /* END */

if (App::get()->account->current && $config->account->has_cart_history){
    $body_sect .='<a target="blank" href="/account/history/show/'.$order_id.'/" id="show_history">  </a>';
    }
    /*
    $body_sect .= '<div class="print"><a href="/cart/print/'.str_pad($order_id, 5, "0", STR_PAD_LEFT).'/" class="print_button" target="blank"></a></div>';
    $body_sect .= '<div class="print"><a href="/cart/print/'.str_pad($order_id, 5, "0", STR_PAD_LEFT).'/" class="print_button" target="blank"></a></div>';
    $body_sect .= '<div class="print"><a href="/cart/print/'.str_pad($order_id, 5, "0", STR_PAD_LEFT).'/" class="print_button" target="blank"></a></div>';
    */
  $body_sect .= '<div class="print history" style="clear:both;"><br>
    <a target="_blank" class="print_button ib" href="/cart/print/'.$order_id.'"> </a><br/>
    </div>
';
/*
 <a target="_blank" class="print_button ib" href="/cart/print/'.$order_id.'?bill"> </a><br/>
    <a target="_blank" class="print_button ib" href="/cart/print/'.$order_id.'?invoice"> </a><br>
    <a target="_blank" class="print_button ib" href="/cart/print/'.$order_id.'?act">   </a> <input data-order-id="'.$order['id'].'" type="text" readonly="true" class="date" value="'.date('d.m.Y').'"/>

*/
$cart->destroy(true);
}
/*
 * ********************************
 *         *
 * ********************************
 */
    elseif (!empty($allCart)) {
    if (App::get()->account->current){
        $user = App::get()->account->current;
        if ($config->account->more_fields)
            $user_data['more_fields'] = @unserialize_mysql($user_data['more_fields']);
    }

    $payment = new cart_payment();
    $paymentList = $payment->load();
    $paymentList = getSelectArray($paymentList);
    $delevery = new cart_delevery();
    $deleveryList = $delevery->load();
    //$deleveryList = getDeleveryArray($deleveryList,$cart->total());
    $formData = array(
        'action' => $_SERVER['REQUEST_URI'],
        'submit_text' => '',
        'elements' => array(
            ' label' => array(
                'type' => 'label',
                'label' => '',
                'style_class' => 'h2'
            ),
            '' => array(
                'type' => 'cart_list',
                'label' => '',
            ),
            ' ' => array(
                'type' => 'in_cart',
                'label' => '     ',
            ),
            ' ' => array(
                'type' => 'label',
                'label' => ' ',
                'style_class' => 'h2'
            ),
            ', ' => array(
                'label' => ', ',
                'type' => 'text',
                'name' =>  'user[name]',
                'attribs' =>  array(
                    'meta:validator' => 'filled',
                    'value' =>  '',
                )
            ),
           
           /* '' => array(
                'type' => 'text',
                'label' => '',
                'name' => 'user[organization]',
                'attribs'=> $user && $user['more_fields'] ? array(
                    'value' => $user && $user['more_fields'] ? $user['more_fields']['organization'] : '',
                ) :'',
            ),*/
            ' ' => array(
                'type' => 'text',
                'label' => ' ',
                'name' => 'user[phone]',
                'attribs' => array(
                    'meta:validator' => 'filled',
                    'value' =>  '',
                )
            ),
            ' e-mail' => array(
                'type' => 'text',
                'label' => ' e-mail',
                'name' =>  'user[email]' ,
                'attribs'=> '',
            ),
            ' ' => array(
                'type' => 'text',
                'label' => '  ',
                'name' => 'user[card]',
                'attribs'=>'',            
            ),
            ' ' => array(
              'type' => 'payment',//'select',
              'label' => ' ',
              'name' => 'user[payment]',
              'value' => 'paymentList',
              'attribs' => array(
                'meta:validator' => 'filled',
                'default' => 0
              ),
            ),
            ' ' => array(
                'type' => 'text',
                'label' => ' ',
                'name' => 'user[delivery_city]',
                'attribs' => array(
                    'value' => ''
                )
            ),
            ' ' => array(
              'type' => 'cart_delevery',
              'label' => ' ',
              'name' => 'user[delivery_type]',
              'value' => 'deleveryList',
            ),
            ' ' => array(
                'type' => 'text',
                'label' => ' ',
                'name' => 'user[delevery_address]',
            ),

            '   ' => array(
                'type' => 'textarea',
                'label' => '   ',
                'name' => 'user[order_comment]',
                'attribs' => array(
                )
            ),
        )
            /*
             *  :
              'parent_id' => !isset($_GET['c']) ? array(
              'type' => 'select',
              'label' => '', 
              'name' => 'requisit[parent_id]',
              'value' => 'requisitUserList',
              'attribs' => array(
              'meta:validator' => 'filled',
              'default' => 0`
              )) : null,
             */
    );
if (empty($user))
        $body_sect .= '';
    $form = $metaForm->process($fp->process(formGenerator($formData)));
    $body_sect .= ($_POST['HTML_MetaForm'] ? renderErrors($metaFormAction->getErrors()) : '' ) . $form;
    $form = '' . formGenerator($formData) . '';
    if ($conf['shopStatus']) $body_sect .= $formPayment;
    //<div class="row"><input type="submit" class="button" value=" "/></div>
}

/*
 * ********************************
 *   ,   *
 * ********************************
 */
else
    $body_sect = '    .       <a href="/catalog/"></a>';