<?php

$render = new Template();
$item_render = new Template();
$config = Config::load();

///===---------------------------------------------------------------------===//
//    
///===---------------------------------------------------------------------===//
$pid = $id == false ? 0 : $id;
$catalog->setId($pid);
$catalog->load();


if ($catalog->id) 
{
    if(isset($_GET['filter']['brand']) && $_GET['filter']['brand'] != ''){
        $bid = $_GET['filter']['brand'];
        $q = "SELECT `name`,`description` FROM `catalog_brands` WHERE `id` = '".$bid."'";
        $brnd = mysql_fetch_assoc($db->query($q));
        $header_sect = $brnd['name'];
        $render->set('text', $brnd['description']);
    }else{
        $header_sect = $catalog->current['name'];
        $render->set('text', $catalog->current['content']);
    }
}
elseif(($db->qa[1]))
{
    go404();
}
else 
{
    $c_text      = new texts($db, 'catalog');
    $c_info      = $c_text->load();
    $header_sect = ($c_info['header']['text'] ? $c_info['header']['text'] : $loader->serviceName('catalog'));
    $render->set('text', $c_info['main_catalog']['text']);
}

///===---------------------------------------------------------------------===//
//    
///===---------------------------------------------------------------------===//
$imagepreview = array();
if ($catalog->current['image'])
    $imagepreview = array(
        'image' => catalog::$uploadFolder . $catalog->current['image'],
        'thumb' => catalog::$uploadFolder . catalog::$popPrefix . $catalog->current['image'],
        'name'  => $catalog->current['name']
    );
$render->set('image', $imagepreview);


///===---------------------------------------------------------------------===//
//  
///===---------------------------------------------------------------------===//
$subcatalogs = '';
if ($config->catalog->has_subcatalogs || $id == null) 
{
    if (isset($catalog->child_array[$pid]) && !empty($catalog->child_array[$pid])) 
    foreach ($catalog->child_array[$pid] as $cid) 
    {
        $child = $catalog->data[$cid];
        if (!$child['vis'] ) continue;
        $uri = $catalog->getUriById($cid);
        $child['href'] = "/catalog/{$uri}/";
        $preview_image = catalog::$uploadFolder . catalog::$popPrefix . $child['image'];
        $preview_thumb = noimg();
        if ($child['image'] != false) 
        {
            $preview_thumb_file = rtrim($_SERVER['DOCUMENT_ROOT'], DIRECTORY_SEPARATOR) . $preview_image;
            if (file_exists($preview_thumb_file)) 
            {
                $preview_thumb = $preview_image;
            }
        }
        $goods->getGoodsCid($child['id'],$child['id']);
        $_goods = $goods->goodsCid[$child['id']];
        $subcatalogs .= $item_render
                      ->clear()
                      ->set('item', $goods->getGoods($id,array('limit'=>array('page'=>($_GET['page']?$_GET['page']:0) ))) )
                      ->set('goods', $_goods)
                      ->set('catalog', $child)
                      ->set('preview_thumb', $preview_thumb)
                      ->render('/catalog/item.php');
    }
    $subcatalogs = $render->renderWrap("/catalog/list.php", $subcatalogs);
}


///===---------------------------------------------------------------------===//
//  
///===---------------------------------------------------------------------===//

if ($config->catalog->has_filter)
{
    $goods->setFilter($_GET['filter']);
    $filter_items = array(
                'brand' => array(
                    'name' => '',
                    'args' => array(
                        'all' => array(
                            'name'=>''
                            )
                        ),
                    )
            );
    //
    $_filter = new goods_filter();
    $_filter_brands = $_filter->get_brands($id);

    //       

    $filter_items['brand']['args'] = $filter_items['brand']['args'] + $_filter_brands;
    $filter = $item_render->clear()->set('filter_items',$filter_items)->render('/catalog/filter.php');
}
if ($config->catalog->has_sort)
{
    $goods->setSort($_GET['sort']);
}

$goods_arr = $goods->getGoods($id);
$goods_num = $goods->goodsNum($id);
$items = '';
$goodimg = new subgallery($db);
$stock = new goods_stock($db);
$i_num = 0;

if ($goods_arr)
    foreach ($goods_arr as $item) 
    {
        if (!$item['vis']) continue;

        $filename = $item['image'];
        if ($item['image'] != '') 
        {
            $item_preview = array(
                'image' => catalog::$uploadFolder . $item['image'],
                'thumb' => catalog::$uploadFolder . catalog::$popPrefix . $item['image']
            );
        } 
        else 
        {
            $item_preview = false;
        }

        if ($loader->serviceActive('catalog', 'stock')) 
        {
            // 
            $stock_data = array();
            if($item['stock_data'])
            {
                $stock_data = unserialize($item['stock_data']);
                $stock_data = $stock->loadById(key($stock_data));
            }
        }

        $preview_thumb = noimg();
        if ($item_preview != false) 
        {
            $preview_thumb_file = rtrim($_SERVER['DOCUMENT_ROOT'], DIRECTORY_SEPARATOR) . $item_preview['thumb'];
            if (file_exists($preview_thumb_file)) 
            {
                $preview_thumb = $item_preview['thumb'];
            }
        }
        
        $uri = $catalog->getUriById($item['cid']);
        $item['href'] = "/catalog/{$uri}/{$item['uri']}/";
        $items .= $item_render
                ->set('item', $item)
                ->set('stock', $stock_data)
                ->set('preview_thumb', $preview_thumb)
                ->render("/catalog/good/item.php");
        $i_num++;
        $items .='<div class="separ"></div>';
    }
$items       = $render->renderWrap("/catalog/good/list.php", $items);


///===---------------------------------------------------------------------===//
//   
///===---------------------------------------------------------------------===//
$body_sect .= $render
                ->set('children', $subcatalogs)
                ->set('items', $subcatalogs=='' ?$items:'')
                ->set('filter',$subcatalogs=='' ?$filter:'')
                ->set('catalog', $subcatalogs=='' ?$catalog->current:'')
                //->set('pagination',renderPager($goods_num,($_GET['page']?$_GET['page']:1),$config->catalog->goods_per_page,'?page={page}'))
                //
                ->render("/catalog/show.php");
// $body_sect .= $render
//                 ->set('children', $subcatalogs)
//                 ->set('items', $items)
//                 ->set('filter',$filter)
//                 ->set('catalog',$catalog->current)
//                 //->set('pagination',renderPager($goods_num,($_GET['page']?$_GET['page']:1),$config->catalog->goods_per_page,'?page={page}'))
//                 //
//                 ->render("/catalog/show.php");
//                 ?>