<?php
$render = new Template();
$item_render = new Template();
$goods->setId($good_id);
$goods->load();

// $header_sect = $goods->current['name'];

$body_sect = '';
//$status_string .= ' / '.$goods->current['name'];
navigation::add_breadcrumb($goods->current['name'], '/catalog/'.Catalog::getUriById($goods->current['cid']).'/'.$goods->current['uri']);


///===---------------------------------------------------------------------===//
//    
///===---------------------------------------------------------------------===//
$goodimg = new subgallery($db);
$goodimg->load($goods->current['id'], 'goods');
$images = array();
if ($goodimg->gallery) 
  foreach ($goodimg->gallery as $img) {
    if ($img['visible']) {
        $images[] = array_merge($img, array(
            // 'link' => '/getFile/?obj=subgallery&id='.$img['id'],
            "link" => subgallery::$path . $img['file'],
            "image" => subgallery::$path . $img['file'],
            "thumb" => subgallery::$path . 's' . $img['file'],
            "medium_thumb" => subgallery::$path . 'm' . $img['file'],
            "title" => $img['name']
        ));
    }
}


///===---------------------------------------------------------------------===//
//    
///===---------------------------------------------------------------------===//
if ($config->catalog->goods_files){
    $subfile = new subfile($db);
    $subfile->load($goods->current['id'], 'goods');
    if($subfile->files){
        $p = subfile::$path;
        $hash = setHash();
        $files = array();
        foreach($subfile->files as $file){
            if(!$file['visible']) continue;
            switch ($file['ext']){
                case 'rar': case 'zip':case'tar':case'gz': $ico = 'zip';break;
                case 'xls': case'xlsx': case 'ods': $ico = 'xls';break;
                case 'doc': case'docx': case 'odt': $ico = 'doc';break;
                case 'jpg': case 'jpeg': case 'gif': case 'png': case 'bmp': $ico = 'img';break;
                case 'htm':case 'html': case 'chm': $ico = 'web';break;
                case 'ptt': $ico = 'ptt';break;
                case 'pdf': $ico = 'pdf';break;
                default : $ico = 'empty';
            }
            $files[]= array_merge($file,array(
                    'link' => '/getFile/?hash='.$hash.'&obj=subfile&id='.$file['id'],
                    'ico' => $ico,
                ));
        }
    }
}
else $files = null;


///===---------------------------------------------------------------------===//
// .  
///===---------------------------------------------------------------------===//
if ($loader->serviceActive('catalog', 'character')){
    $char = new character($db);
    $char_id = $char->getCharId($goods->current['cid']);
    $characters = $char->getCharacter($goods->current['id'], $char_id,true);
}
else $characters = null;


///===---------------------------------------------------------------------===//
// 
///===---------------------------------------------------------------------===//
if ($loader->serviceActive('catalog', 'brands')){
    $brand = new goods_brands();
    $goods->current['brand-name'] = $brand->get_brand_name($goods->current['brand-id']);
    $goods->current['brand-url'] = $brand->get_brand_url($goods->current['brand-id']);

	//    
	$uri = $catalog->getUriById($goods->current['cid']);
	$href = "/catalog/{$uri}/?filter[brand]=".$goods->current['brand-id'];
	$goods->current['brand-href'] = $href;
}


///===---------------------------------------------------------------------===//
//  .  
///===---------------------------------------------------------------------===//
if ($loader->serviceActive('catalog', 'same_goods')){
    $goods_arr = $goods->sameGoods($db, $goods->current['id'], 20, $goods->current['cid'], $goods->current['price']);
    $goods_num = count($goods_arr);
    $sameGoods = '';
    if ($goods_arr)
        foreach ($goods_arr as $item) {
            if (!$item['vis'])
                continue;

            $filename = $item['image'];
            if ($item['image'] != '') {
                $item_preview = array(
                    'image' => catalog::$uploadFolder . $item['image'],
                    'thumb' => catalog::$uploadFolder . catalog::$popPrefix . $item['image']
                );
            } else {
                $item_preview = false;
            }

            $preview_thumb = noimg();
            if ($item_preview != false) {
                $preview_thumb_file = rtrim($_SERVER['DOCUMENT_ROOT'], DIRECTORY_SEPARATOR) . $item_preview['thumb'];
                if (file_exists($preview_thumb_file)) {
                    $preview_thumb = $item_preview['thumb'];
                }
            }
            
            $uri = $catalog->getUriById($item['cid']);
            $item['href'] = "/catalog/{$uri}/{$item['uri']}/";
            $sameGoods .= $item_render
                    ->set('item', $item)
                    ->set('preview_thumb', $preview_thumb)
                    ->render("/catalog/good/item.php");
            $sameGoods .='<div class="separ"></div>';
        }
    $sameGoods       = $render->renderWrap("/catalog/good/list.php", $sameGoods);
}


///===---------------------------------------------------------------------===//
//  -    
///===---------------------------------------------------------------------===//
if ($loader->serviceActive('catalog', 'stock')){
    $stock = new goods_stock($db);
    $stock_data = array();
    if($goods->current['stock_data']){
        $stock_data = unserialize($goods->current['stock_data']);
        $stock_data = $stock->loadById(key($stock_data));
    }
}


///===---------------------------------------------------------------------===//
//  
///===---------------------------------------------------------------------===//
if ($loader->serviceActive('catalog', 'goods_rating')){
    $rating = new rating($db);
    $rating->load($goods->current['id'], 'goods');
    $rating_data = $render
                ->clear()
                ->set('object_id', $goods->current['id'])
                ->set('object_type', 'goods')
                ->set('href', '/actions/?obj=rating&do=vote&object_id='.$goods->current['id'].'&object_type=goods')
                ->set('item_count', 5)
                ->set('vote_count', $rating->data['total_votes'])
                ->set('current_rating', $rating->data['total_value'])
                ->set('current_percent', 150/5*$rating->data['total_value'])
                ->render('/rating/show.php');
}


///===---------------------------------------------------------------------===//
//    
///===---------------------------------------------------------------------===//
$render
    ->set("current",    $goods->current)
    ->set('images',     $images)
    ->set('rating',     $rating_data)
    ->set('stock',      $stock_data)
    ->set('files',      $files)
    ->set('characters', $characters)
    ->set('sameGoods',  $sameGoods)
    ;

$body_sect .= $render->render('/catalog/good/show.php');