<?php
$module = 'docs';
if (!$loader->serviceActive('docs')) {
	go404();return;
}
$module_name = $loader->serviceName('docs');
$docs = new $module($db);
$header_sect = $module_name;
navigation::add_breadcrumb($module_name , '/'.$module);
	
if ($db->qa[1]){
	$doc = $docs->loadById($db->qa[1]);
	navigation::add_breadcrumb($doc['name'] , $_SERVER['REQUEST_URI']);
	$header_sect = $doc['name'];
	$body_sect .= $doc['text'];
	$subfile = new subfile($db);
	$subfile->load($doc['id'], 'docs');
	if($subfile->files){
	    $p = subfile::$path;
	    $hash = setHash();
	    $files = array();
	    foreach($subfile->files as $file){
	        if(!$file['visible']) continue;
	        switch ($file['ext']){
	            case 'rar': case 'zip':case'tar':case'gz': $ico = 'zip';break;
	            case 'xls': case'xlsx': case 'ods': $ico = 'xls';break;
	            case 'doc': case'docx': case 'odt': $ico = 'doc';break;
	            case 'jpg': case 'jpeg': case 'gif': case 'png': case 'bmp': $ico = 'img';break;
	            case 'htm': case 'html': case 'chm': $ico = 'web';break;
	            case 'ptt': $ico = 'ptt';break;
	            case 'pdf': $ico = 'pdf';break;
	            default : $ico = 'empty';
	        }
	        $files[]= array_merge($file,array(
                'link' => '/getFile/?hash='.$hash.'&obj=subfile&id='.$file['id'],
                'ico' => $ico,
            ));
	    }
	}
	if ($files && !empty($files)){
	    $body_sect .= '<div  class="list"><div class="full_box">:</div><ul>';
	    foreach ($files as $file){	
        $size = convertSize($file['size']);
	        $body_sect .= '<li><a class="ico '.$file['ico'].'" href="'.$file['link'].'">'.$file['name'].'</a> '.$file['ext'].', ('.$size.') </li>';
	    }
	    $body_sect .= '</ul></div>';
	}

}else{ //  
	$data = $docs->load();
	$body_sect .= '<div class="docs">';
	 foreach ($data as $item) {
	 	$img = is_file(SR . docs::$path . $item['image']) ? '<img src="'.docs::$path . $item['image'] . '">' : '';
      $body_sect .='
      <div class="item">
      	<div class="img">'.$img.'</div>
      	<div class="txt">
      		<a href="/'.$module.'/'.$item['id'].'/">'.$item['name'].'</a>
      	</div>
      </div>
      <hr style="clear:both;">';
    }
    $body_sect .= '</div>';
}


?>