<?php
if (!$loader->serviceActive('gallery')){
    go404(); return;
}

$template = 'full.php';

$module 		= 'gallery';
$module_name 	= $loader->serviceName('gallery');//'';

$render 		= new Template();
$item_render 	= new Template();

$obj 			= new $module($db);
$body_sect 		= '';

navigation::add_breadcrumb($module_name,'/'.$module.'/');

///===--------------------------------------------------------------------===///
///                            
///===--------------------------------------------------------------------===///
if($db->qa[1] && is_numeric($db->qa[1])){
	$obj->id = (int)$db->qa[1];
	$data = $obj->load();
	$header_sect = $data['name'];

	navigation::add_breadcrumb($data['name'],'/'.$module.'/'.$data['id']);

	$subgallery = new subgallery($db);
	$subgallery->load($obj->id,$module);
	if($subgallery->gallery){
		$p = subgallery::$path;		
	}

	foreach($subgallery->gallery as $v){
		if(!$v['visible']) continue;
		$v['href'] = $p.$v['file'];
		$v['image'] = $p.'s'.$v['file'];
		$items .= $item_render
                 ->clear()
                 ->set('item', $v)
                 ->render('/gallery/album/item.php');
	}
	if ($items){
		$body_sect = $render
						->set('items', $items)
						->set('text', $data['text'])
						->render("/gallery/album/list.php");
	}
}
///===--------------------------------------------------------------------===///
///                            
///===--------------------------------------------------------------------===///
elseif ($db->qa[1]) {
    go404(); return;
} else {
	$currentPage = 1;
	$rowsOnPage = 10;

	if(!empty($db->qa[1]) && preg_match('/^page([0-9]+)$/', $db->qa[1], $matches)) {
		$currentPage = $matches[1];
	}

	$objByPage = $obj->loadByPage($currentPage, $rowsOnPage);

	$header_sect = $loader->serviceName('gallery');
	$data = $objByPage['items'];     
	$items = ''; 
	if($data) foreach($data as $v){
		if(!$v['visible']) continue;
		if ($v['image']){
			if (is_file(SR.$obj->getPath().$v['image'])){
				$v['image'] = $obj->getPath().$v['image'];
			}else{
				$v['image'] = noimg('gallery');
			}
		}else $v['image'] = noimg();
		$items .= $item_render
                 ->clear()
                 ->set('item', $v)
                 ->render('/gallery/item.php');
	}
	if ($items){
		$body_sect = $render->renderWrap("/gallery/list.php", $items);
	}
	if ($objByPage['count'] > $rowsOnPage)
		$body_sect .= renderPager($objByPage['count'], $currentPage, $rowsOnPage, '/gallery/page{page}');
}

?>