<?php
if (!$loader->serviceActive('goods_news')){
    go404(); return;
}
    
$module = 'goods_news';
$module_name = $loader->serviceName('goods_news');

$render         = new Template();
$item_render    = new Template();


//$status_string .= ' / <a href="/' . $module . '">' . $module_name . '</a>';
//if($db->qa[1] && is_numeric($db->qa[1])){
	navigation::add_breadcrumb($module_name , '/'.$module);	
//}

$header_sect = $module_name;
$obj = new $module($db);

$news_menu_sect = get_news_menu_section($obj);

$body_sect = '';
 
if ($db->qa[1] == 'date' && $db->qa[2]) {
    $nws_arr = array();
    $i = 0;
    $header_sect .= '  ' . $v['date'];
    foreach ($obj->load() as $k => $v) {
        if ($v['visible'] && $db->qa[2] == date('Y-m-d', $v['date'])) {
            if (is_file(SR . $obj->getPath() . $v['image']))
                $img = $news->getPath() . $v['image'];
            else
                $img='';

            $href = '/' . $module . '/' . $v['id'] . '/';

            $items .= $item_render
                 ->clear()
                 ->set('item', $v)
                 ->set('img', $img)
                 ->set('href', $href)
                 ->render('/goods_news/item.php');
        }
    }
    if ($items){
        $body_sect = $render->renderWrap("/goods_news/list.php", $items);
    }
    if ($i == 0) {
        go404(); return; 
    }
}
elseif ($db->qa[1] && is_numeric($db->qa[1])) {
    $backlink = '  ';
    $obj->id = (int) $db->qa[1];
    $data = $obj->load();
    $header_sect = $data['name'];
    
    //$status_string .= ' / ' . $data['name']; 
    navigation::add_breadcrumb($data['name'], null);
    
    $seo = new seo($db, $module, $data['id'], 'main');
    $seo->populateMetaTags($seo->get_seo());
    
    $subgallery = new subgallery($db);
    $subgallery->load($obj->id, 'goods_news');
    if ($subgallery->gallery) {
        $gallery = '';
        $p = subgallery::$path;
        foreach ($subgallery->gallery as $v) {
            if (!$v['visible'])
                continue;
            $v['href'] = $p.$v['file'];
            $v['image'] = $p.'s'.$v['file'];
            $gallery_items .= $item_render
                     ->clear()
                     ->set('item', $v)
                     ->render('/gallery/album/item.php');
        }
    }
    $img = $data['image'];
    $body_sect .= $item_render
         ->clear()
         ->set('item', $data)
         ->set('img', $img)
         ->set('gallery', $gallery_items)
         ->set('module', $module)
         ->render('/goods_news/show.php');
    if ($db->qa[1]=='1010') $body_sect.='<div style="margin-top:20px;">'.$news1010.'</div>';

} elseif($db->qa[1]) {
    go404(); return;  
} else {
    $currentPage = 1;
    $rowsOnPage = 10;
    if (!empty($db->qa[1]) && preg_match('/^page([0-9]+)$/', $db->qa[1], $matches)) {
        $currentPage = $matches[1];
    }
    $objByPage = $obj->loadByPage($currentPage, $rowsOnPage);
    $header_sect = $loader->serviceName('goods_news');
    $data = $objByPage['items'];
    if ($data){	
        
        function get_item_html($v,$obj,$module,$item_render){
            if (!$v['visible'])
                continue;
            $href = '/' . $module . '/' . $v['id'] . '/';
            if (is_file(SR . $obj->getPath() . $v['image']))
                $img = $obj->getPath() . $v['image'];
            else
                $img='';
            return $item_render
                 ->clear()
                 ->set('item', $v)
                 ->set('href', $href)
                 ->set('module', $module)
                 ->set('img', $img)
                 ->render('/goods_news/item.php');
        }


        $items='';
        foreach ($data as $v) {
            $items .= get_item_html($v, $obj, $module,$item_render);                        
        }		
		
        if ($items){
            $body_sect = $render->renderWrap("/goods_news/list.php", $items);
        }
    }        
    $body_sect .= renderPager($objByPage['count'], $currentPage, $rowsOnPage, '/' . $module . '/page{page}');
}
?>