<?php
if (!$loader->serviceActive('vacancy')){
    go404(); return;
}
$header_sect = $loader->serviceName('vacancy');

navigation::add_breadcrumb($loader->serviceName('vacancy'),'/vacancy/');

$module         = 'vacancy';
$vacancy        = new $module($db);

$render         = new Template();
$item_render    = new Template();

if($db->qa[1]){
    $vacancy->id=(int)$db->qa[1];
    $data = $vacancy->load_data();
    $header_sect = $data['name'].'';
    
    navigation::add_breadcrumb($data['name'],'/vacancy/'.$data['id']);
    
    $over = array(
        '' => 'job',
        '' => 'shedule',
        '' => 'schooling',
        '' => 'age',
        '' => 'sex',
        ' ' => 'experience',
        ' ' => 'shedule',
        '' => 'pay',
    );

    $chars = array();
    foreach ($over as $name=>$key){
        if (!$data[$key]) continue;
        $chars[] = array(
            'name'  => $name,
            'value' => $data[$key]
        );
    }
    

//
$fp = new html_formpersister();
$metaForm = new html_metaform('secre7_d1g1tal_signatur3_KFw53C5r');
$metaFormAction = new html_metaformaction($metaForm);

        switch($metaFormAction->process()){
            //get
            case 'INIT':
                break;
            case 'send':
                $vacancy_id = $vacancy->add_resume();
                if (!$vacancy_id)
                    $sended = false;
                else
                    $sended = true;
                $user_resume = $vacancy->get_resume($vacancy_id);
                $_email = $db->settings['main']['email']['value'];
                $mail_text =  '   '.$user_resume['name'].'<br/><a href="http://'.$_SERVER['HTTP_HOST'].'/getFile/?obj=vacancy&id='.$vacancy_id.'"></a>';
                send_email($mail_text,' ',array(array('email'=>$_email,'name'=>$_email)));
        }
    $formData = array(
        'action' => $_SERVER['REQUEST_URI'],
        'submit_text' => '',
        'elements' => array(
            'vacancy_id'=>array(
                'type'=>'hidden',
                'name'=>'vacancy_id',
                'attribs' => array(
                        'value'=> $data['id']
                    ),
                ),
            '...' => array(
                'label' => '...',
                'type' => 'text',
                'name' => 'name',
                'attribs' =>array(
                    'meta:validator'=>'filled',
                )
            ),
            '' => array(
                'label' => '',
                'type' => 'file',
                'name' => 'resume',
                'attribs' =>array(
                    'meta:validator'=>'filled',
                )
            ),
        )
    );
    $form = $metaForm->process($fp->process(formGenerator($formData)));

    if ($sended){
        $success = '    !       ';
    }else{   
        if ($_POST['HTML_MetaForm']){
            $errors = $metaFormAction->getErrors();
            // renderErrors($metaFormAction->getErrors());
        }
    }

    $body_sect .= $render
        ->set('chars', $chars)
        ->set('data', $data)
        ->set('success', $success)
        ->set('errors', $errors)
        ->set('form', $form)
        ->render('/vacancy/show.php');

}else{
    $data = $vacancy->load_data();
    $items = '';
    if($data) foreach($data as $v){
        $href = '/' . $module . '/' . $v['id'] . '/';
        $items .= $item_render
             ->clear()
             ->set('item', $v)
             ->set('href', $href)
             ->render('/vacancy/item.php');
    }
    $body_sect .= $render->renderWrap('/vacancy/list.php', $items);
}
?>