<?php
if ($loader->serviceActive('catalog') && $loader->serviceActive('leaders')){
    $cgoods = goods::columnGood($db);
    if (!empty($cgoods) && is_array($cgoods)) {
        ?>
        <div class="box">
            <div class="title">
                <span><?php echo $loader->serviceName('leaders') ?></span>
                <div class="ico"><img alt="" src="<?=TP?>images/ico-leader.png" /></div>
            </div>
            <div class="inner">
                <div class="leader">
                    <?php
                    $i = 0;
                    foreach ($cgoods as $good) {
                        $i++;
                        if ($good && $good['vis']):
                            if (is_file(goods::$uploadFolder . $good['image']))
                                $img = '/' . goods::$uploadFolder  . goods::$popPrefix . $good['image'];
                            else
                                $img='<?=TP?>images/noimg.jpg';
                            ?>
                            <div class="item">
                                <div class="inner_item">
                                    <div class="img">
                                        <a href="<?= '/catalog/' . catalog::getUriById($good['cid']) . '/' . $good['uri'] ?>/"><img src="<?= $img ?>" alt="" /></a>
                                    </div>
                                    <div class="txt">
                                        <a href="<?= '/catalog/' . catalog::getUriById($good['cid']) . '/' . $good['uri'] ?>/"><?=$good['name'] ?></a>
                                        <br /><br />
                                        <?php
                                        $cartUrl = Cart::$addCartUrl . '?' . http_build_query(array('addCart' => $good['id']));
                                        ?>
                                        <a href="<?= $cartUrl ?>" class="abask addCart" data-item-id="<?= $good['id']; ?>"></a>
                                    </div>
                                </div>
                                <div class="cost">
                                    <?php
                                    if ($good['not_fixed']==1){
                                        echo stripslashes($good['price_descript']);
                                    }
                                    else
                                        echo number_format($good['price'], 0, '', ' ').' .';
                                    ?> 
                               </div>
                            </div>
                                <?php
                                if ((!$db->qa[0] && $i%2 == 0) or $db->qa[0]): ?>
                                <?php endif; ?>
                            <?php
                        endif;
                    }
                    ?>
                </div><!--leader -->
            </div>
        </div><!--box -->
        <?php
    }

}
?>
