<?php 
if ($loader->serviceActive('banners')):
	$bnr = new banners($db);
	$ban_arr = $bnr->load();
	if (empty($ban_arr))
		return;
	$main_page = empty($db->qa[0]);

	$banners = array();

	$uri = explode('?',$_SERVER['REQUEST_URI']);
	$uri = @array_shift($uri);
	$uri = trimpath($uri);
	foreach ($ban_arr as $v){
		$show_in = unserialize_mysql($v['show_in']);
		if ($show_in && is_array($show_in))
			$show_in =array_map('trimpath',$show_in);
		if($v['visible'] and
			is_file(DR.$bnr->getPath().$v['image']) and 
			(
				($main_page && $v['show_main'])
			or
				(!$main_page && $v['show_other'])
			or
		 		($show_in && in_array($uri,$show_in))
			)
		)
		{
	    	if ($v['type']=='image'){
	    		$banners[] ='<div class="banner"><a href="'.$v['href'].'" alt="'.htmlspecialchars($v['name']).'" ><img src="'.$bnr->getPath().$v['image'].'" /></a></div>';
	    	}
	    	elseif($v['type']=='flash'){
	    		$banners[] ='<div class="banner flash banr'.$v['id'].'" data-flash-el=".banr'.$v['id'].'" data-falsh-path="'.$bnr->getPath().$v['image'].'"></div>';
	    	}
		}

		//$banners[] = '<div class="banner"><a href="'.$v['href'].'"><img src="'.$bnr->getPath().$v['image'].'" alt="'.$v['name'].'" /></a></div>';
	}
	if (!empty($banners))
		echo '<div class="banners">'.implode("\n",$banners).'</div>';
endif;
?>