<?php
if ($loader->serviceActive('polls')):
$polls = new polls($db);
$poll = $polls->load_current();
if ($poll) :
    $poll['results'] = $polls->sort_results(unserialize($poll['results']));
    ?>
	
	<div class="box">
        <div class="title">
            <span><?php echo $loader->serviceName('polls') ?></span>
        </div>
        <div class="inner">
            <?php if ($polls->is_voiced() == false) : ?>
                <form method="post">
                    <input type="hidden" name="poll-id" value="<?= $poll['id'] ?>" />
                <?php endif; ?>
                <div class="poll">
                    <strong><?php echo $poll['name'] ?></strong>
                    <div class="area">
                        <?php foreach ($poll['results'] as $id => $answer) : ?>
                            <div class="line<?php echo ($polls->is_voiced()) ? ' result' : ''; ?>">
                                <?php if ($polls->is_voiced() == false) : ?>
                                    <label>
                                        <?php if (true || $poll['capacity'] == 1) : ?>
                                            <input type="radio" class="chose" name="voices[]" value="<?php echo $id; ?>" /><span class="question"><?php echo $answer['name']; ?></span>
                                        <?php else : ?>
                                            <input type="checkbox" class="chose" name="voices[]" value="<?php echo $id; ?>" /> <span class="question"> <?php echo $answer['name']; ?></span>
                                        <?php endif; ?>
                                    </label>
                                <?php else : ?>
                                    <label><?php echo $answer['name']; ?>: </label>
                                    <?php
                                    if ($poll['count'])
                                        $num = ($answer['res'] / $poll['count']) * 100;
                                    else
                                        $num = 0;
                                    ?>
                                    <div class="res">
                                        <div class="space">
                                            <div class="persent" style="background:<?php echo ($num < 50 ? '#5b4a2d' : '#a10812'); ?>; width:<?php echo ceil($num); ?>%;">
                                            </div>
                                        </div>
                                        <span><?= $answer['res'] . ' ' . ('.'); ?></span>
                                    </div>
                                <?php endif; ?>
                            </div>
                        <?php endforeach; ?>
                    </div>
                    <?php if ($polls->is_voiced() == false) : ?>
                        <div class="button"><input type="submit" class="poll_vote" value="<?php echo ''; ?>"></div>
                    <?php endif; ?>
                <!--<span class="butt fright"><a href="/polls"><?php echo (''); ?></a></span>-->
                </div>
                <?php if ($polls->is_voiced() == false) : ?>
                </form>
            <?php endif; ?>
        </div>
    </div>

<?php endif;
endif; ?>