var map, mapsx, maps = new Array(), geocoder, google, googleAttached = 0;
var flash_bnr_width = 220;
function loadGMap(callback) {

    if(!googleAttached) {
        var script = document.createElement("script");
        script.type = "text/javascript";
        script.src = "http://maps.google.com/maps/api/js?sensor=false" + (callback ? "&callback=" + callback : "");
        document.body.appendChild(script);
        googleAttached = 1;	
    }

}


function toggle(el){
    $(el).slideToggle(100);
}

function get_info($this) {
    var $parent = $this.parent().parent();
    var $info = $parent.find('.info');
    if ($info.size() == 0) {
        $parent.append('<span class="info"></span>');
        $info = $parent.find('.info');
    }
    return $info;
}

function ajax_validate(form, fields) {
    var $this = $(this);
    fields = fields || [ this.name ];
    form = $this.parents('form');

    //   
    var params = {};
    params['form-name'] = 'register';
    for(var i in fields) {
        var name = fields[i];
        var $value = $(form).find(':input[name=' + name + ']');
        if ($value.size() != 0) {
            params[name] = $value.get(0).value;
        }
        $value.removeClass('error').removeClass('success');
        get_info($value).text('').removeClass('error');
    }

    $.post('/account/register', params, function(data) {
        for(var i in fields) {
            var name = fields[i];
            var $value = $(form).find(':input[name=' + name + ']');

            if (data != true && data[name] && data[name] !== true) {
                $value.addClass('error');
                if ($value.size() != 0) {
                    get_info($value).text(data[name]).addClass('error');
                }
            } else if ($this.get(0).value != '') {
                $value.addClass('success');
            }
        }
    }, 'json');
}

// Return TRUE if the given function has been defined
// +   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
// +   improved by: Steve Clay
// +   improved by: Legaev Andrey
function function_exists( function_name ) {
    if (typeof function_name == 'string'){
        return (typeof window[function_name] == 'function');
    } else{
        return (function_name instanceof Function);
    }
}


function attachGMap() {
    var mapOptions = {
        zoom: 16,
        mapTypeId: google.maps.MapTypeId.ROADMAP,
        disableDefaultUI: false,
        center: new google.maps.LatLng(56.8379, 60.5983)
    };

    geocoder = new google.maps.Geocoder();

    $.each($(".gmap"), function(i){
        var $this = $(this);
        var coords = $this.data('coords');
        var geoAddress = $this.data('address');
        var marker;

        mapsx = new google.maps.Map(this, mapOptions);

        if(coords && coords.latitude && coords.longitude) {
            var point = new google.maps.LatLng(coords.latitude, coords.longitude);
            marker = new google.maps.Marker({
                map: mapsx,
                position: point
            });
            mapsx.setCenter(point);
        }
        else if(geoAddress) {
            geocoder.geocode( {
                'address': geoAddress
            }, function(results, status) {
                if (status == google.maps.GeocoderStatus.OK) {
                    mapsx.setCenter(results[0].geometry.location);
                    marker = new google.maps.Marker({
                        map: mapsx,
                        position: results[0].geometry.location
                    });
                }
            })
        }
    });
}
function attachYMap() {
   if (typeof YMaps == undefined) return;
    $.each($(".gmap"), function(i){
        var geoResult;
        var $this = $(this);
        var geoAddress = $this.data('address');
        window.coords     = $this.data('coords');
        window.myPlacemark = null;
        var obj = this;
        
        if(coords && coords.latitude && coords.longitude) {
            myPlacemark = new ymaps.Placemark(
                    [coords.latitude, coords.longitude], {
                    }, {
                        draggable: false,
                        hideIconOnBalloonOpen: false
                    }
                );
        }
        else if(geoAddress) {
            var myGeocoder = ymaps.geocode(geoAddress);
            myGeocoder.then(
                function (res) {
                    var point = res.geoObjects.get(0);
                    coords = point.geometry.getCoordinates();
                    var myMap = new ymaps.Map(obj, {
                        center: coords,
                        zoom: 15,
                        type: "yandex#map"
                    });
                    myMap.controls.add("mapTools")
                                    .add("zoomControl")
                                    .add("typeSelector");
                    myMap.geoObjects.add(point);
                }
            );
        }
    });
} 

function str_replace(search, replace, subject) {
    return subject.split(search).join(replace);
}

function dialogClose(){
    $('#dialog-box').dialog("close");
}

function updateCart(price, items){
    if ($('.cart_box').hasClass('hidden'))
        $('.cart_box').removeClass('hidden');
    if (items==0)
        $('.cart_box').addClass('hidden');
    $('.cart_total_item').html(items);
    $('.cart_total_price').html(price);
}
var timeoutObj;

/*
function sliderClick(){
    $("#topslider .next").click();
}
*/
$(function(){ // document.ready    
    $('.relinkfiltr').live('click',function(){
        //var link =$(this).attr('data-parentlink')+'/'+'?filter%5Bbrand%5D=' +$(this).attr('data-link');
        var link =$(this).attr('data-parentlink')+'/'+'?' +$(this).attr('data-link');
        document.location.href=link ;
        return false;
    })
    $('body').on('touchstart.dropdown', '.dropdown-menu', function (e) { e.stopPropagation(); });
    $('input[name="city"]').live('change',function(){
        // $.cookie('city', $(this).val(), { expires: 7,path:'/' });
        // location.href="?city="+$(this).val();
        $.post('/',{city:$(this).val()},function(){
            location.reload();
        });
    })
// 
    //    
    $('.sendForm').bind('click',function(e){
        e.preventDefault();
        $(this).closest('form').submit();
    });
    //   
    $('.clearForm').bind('click',function(e){
        e.preventDefault();
        $('.filter_price').val('').closest('form').submit();

    });
    $('.fanret').live('click',function(){
        var link = $(this).attr('href');
        $.get( link,{},function(data){
            $('.rating-holder').html(data);
        });
      return false;
    });
//  
    $('.btn_compras').live('click',function(e){
        e.preventDefault();
        var obj = $(this).parent();
        $.get(
            '/compras/?addCompras='+$(obj).data('id'),
            {},
            function(data){
                $('#compras-wrap').html(data);
                $(obj).html('<span> </span>')
            }
        );
    });
    $('.btn-compras-del').live('click',function(e){
        e.preventDefault();
        var obj = this;
        $.get(
            '/compras/?delete&id='+$(obj).data('id')+'&cid='+$(obj).data('cid'),
            {},
            function(data){
                $('#compras-wrap').html(data);
                //       
                //  
                var a = '<a href="/compras/?addCompras='+$(obj).data('id')+'" class="btn_compras"><span></span></a>'
                $('.incomp[data-id='+$(obj).data('id')+']').html(a);
            }
        );
    });
    $('.btn-compras-del-link').live('click',function(e){
        e.preventDefault();
        var obj = this;
        $.get(
            '/compras/?delete&id='+$(obj).data('id')+'&cid='+$(obj).data('cid'),
            {},
            function(data){
                $('#compras-wrap').html(data);
                //       
                //  
                location.href = '/compras/?getUri';
            }
        );
    });


    // show_hint, shot_tooltip.. etc.
    $('.btn_hint').click(function(){
        var obj = this;
        $('.hint_content').html('');
        $.get(
            '/actions/?obj='+$(this).attr('tt_obj')+'&do=tooltip&id='+$(this).attr('tt_id'),
            {},
            function(data){
                $(obj).parent().children('div').html(data);
            }
        );
    });
    $('.hint .icon-remove-sign').live('click',function(){
        // $(this).parent().remove();
        $('.hint_content').html('');
    });




/*!
 * Convert <select> elements to Dropdown Group
 *  
 */
 //*
jQuery(function($){
    $('select').each(function(i, e){
        if (!($(e).data('convert') == 'no')) {
            $(e).hide().wrap('<div class="btn-group" id="select-group-' + i + '" />');
            var select = $('#select-group-' + i);
            var current = ''; 
            if($(e).data('caption')){
                current = $(e).data('caption');
            }else if ($(e).val()){
                current = $(e).children('option[value='+$(e).val()+']').text();
            }else{
                current = $(e).val();
            }
			
            select.html('<input type="hidden" value="' + $(e).val() + '" name="' + $(e).attr('name') + '" id="' + $(e).attr('id') + '" class="' + $(e).attr('class') + '" />\
						<a class="btn btn-pnl dropdown-toggle" data-toggle="dropdown" href="javascript:;">' + current + '</a>\
						<a class="btn styled rounded-right dropdown-toggle" data-toggle="dropdown" href="javascript:;">\
							<span class="caret caret-white"></span>\
						</a>\
						<ul class="dropdown-menu" role="menu">\
						</ul>'
			);					
			
            $(e).find('option').each(function(o,q) {
                    select.find('.dropdown-menu').append('<li><a href="javascript:;" data-value="' + $(q).attr('value') + '">' + $(q).text() + '</a></li>');
                    if ($(q).attr('selected')) 
						select.find('.dropdown-menu li:eq(' + o + ')').click();
            });
            
			select.find('.dropdown-menu a').click(function() {
                    select.find('input[type=hidden]').val($(this).data('value')).change();
                    select.find('.btn:eq(0)').text($(this).text());
            });
			
			if( $(".btn.btn-pnl.dropdown-toggle", "#select-group-" + i ).text() == "" ){
				var t = $(".dropdown-menu li:eq(0) a", "#select-group-" + i ).text();			
				$(".btn.btn-pnl.dropdown-toggle", "#select-group-" + i ).text(t);
			}
			
			
        }
    });
});
//*/
// compressed
// jQuery(function(a){a("select").each(function(b,c){if(!(a(c).data("convert")=="no")){a(c).hide().wrap('<div class="btn-group" id="select-group-'+b+'" />');var d=a("#select-group-"+b);var e=a(c).val()?a(c).val():" ";d.html('<input type="hidden" value="'+a(c).val()+'" name="'+a(c).attr("name")+'" id="'+a(c).attr("id")+'" class="'+a(c).attr("class")+'" /><a class="btn" href="javascript:;">'+e+'</a><a class="btn dropdown-toggle" data-toggle="dropdown" href="javascript:;"><span class="caret"></span></a><ul class="dropdown-menu"></ul>');a(c).find("option").each(function(b,c){d.find(".dropdown-menu").append('<li><a href="javascript:;" data-value="'+a(c).attr("value")+'">'+a(c).text()+"</a></li>");if(a(c).attr("selected"))d.find(".dropdown-menu li:eq("+b+")").click()});d.find(".dropdown-menu a").click(function(){d.find("input[type=hidden]").val(a(this).data("value")).change();d.find(".btn:eq(0)").text(a(this).text())})}})})


//sliders

$('#partners_slider').jcarousel({
    scroll : 1,
    visible : 4
});

function sliderClick(){
    $("#topslider .next").click();
}
//*
    if( $("#topslider").length ){
        $('#topslider .cut ul li').css('position','absolute');
        $("#topslider").each(function(){
            var $mutex = true;
            var $parent = $(this);
            var $box = $(".slidebox", $parent);
            var $elm = $("li", $box);
            var $prev = $(".prev", $parent);
            var $next = $(".next", $parent);

            var $speed = 500;
            if(!$("li:first-child", $box).is(".current")){
                $elm.first().addClass("current");
            }
            
            $prev.click(function(){
                var $shift = $box.width();
                var $curElm = $(".current", $box);
                if($curElm.is(":first-child")){
                    var $needElm = $elm.last();
                } else {
                    var $needElm = $curElm.prev("li");
                }
                if($mutex == true){
                    $needElm.css({left:-$shift, zIndex:5});
                    shiftElm($curElm, $needElm, $shift);
                }
                return false;
            });
            $next.click(function(){
                var $shift = $box.width();
                var $curElm = $(".current", $box);
                if($curElm.is(":last-child")){
                    var $needElm = $elm.first();
                } else {
                    var $needElm = $curElm.next("li");
                }
                if($mutex == true){
                    $needElm.css({left:$shift, zIndex:5});
                    var $shift = -($shift);
                    shiftElm($curElm, $needElm, $shift);
                }
                return false;
            });
            function shiftElm($curElm, $needElm, $shift){
                $curElm.animate({
                    left:$shift
                },$speed,function(){
                    $(this).removeClass("current").css({left:0,zIndex:1});
                });
                $needElm.animate({
                    left:0
                },$speed,function(){
                    $(this).addClass("current");
                    $mutex = true;
                });
            }
            
        });
    }
    setInterval(sliderClick,8500);
//*/

    if (typeof ymaps !='undefined'){
        ymaps.ready(function () { 
            attachYMap();
        });
    }
    
    if ($('.fileupload').length){
        $('.fileupload').fileupload();    
    }
   
    // $('a.popup').fancybox();
    $("a.popup").fancybox({
        ajax:{
            dataType : 'html',
            headers  : { 'X-fancyBox': true }
        },
        height:'90%'
    });

     // bootstrap popovers
     // $('[rel=popover]').popover('show');
    // $('[rel=popover]').popover('show',{placement: 'left'});

    $('[rel=tooltip]').tooltip();

    $('[rel=popover]').popover({
        offset: 10,
        trigger: 'manual',
        html: true,
        placement: 'left',
        template: '<div class="popover" onmouseover="clearTimeout(timeoutObj);$(this).mouseleave(function() {$(this).hide();});"><div class="arrow"></div><div class="popover-inner"><h3 class="popover-title"></h3><div class="popover-content"><p></p></div></div></div>'
    }).mouseenter(function(e) {
        $(this).popover('show');
    }).mouseleave(function(e) {
        var ref = $(this);
        timeoutObj = setTimeout(function(){
            ref.popover('hide');
        }, 50);
    });
    //    
    $('.news.nav-tabs a').click(function(e) {
      e.preventDefault();
      $(this).tab('show');
    });


    $('.toggle').click(function(e){
        e.preventDefault();
        el = $(this).data('el');
        if (el)
            $(el).slideToggle(100);
    });

    if (function_exists('check_login'))
        $('#register').each(check_login);


    var $calendar = $("#calendar");
    if($calendar.length) {
        $calendar.find(".prev, .next").live("click", function(e){
            e.preventDefault();
            var $link = $(this);
            var url = $link.attr('href') + '&c';
            $.get(url, {}, function(r){
                $calendar.html(r);
            });
        })
    };

    $('.cartdel').click(function(e){
        e.preventDefault();
        href = $(this).attr('href');
        goodName = $(this).data('name');
        $( "#dialog:ui-dialog" ).dialog( "destroy" );
        $('#dialog-box').html('<p style="text-align:center">  <b>' + goodName + '</b>?</p>');
        $( "#dialog-box" ).dialog({
            height:120,
            width:250,
            modal: true,
            buttons: {
                "": function() {
                    window.location = href
                },
                "": function() {
                    $( this ).dialog( "close" );
                }
            }
        });
    });

    $('.addCart').click(function(e){
        e.preventDefault();
        var itemId = $(this).data('item-id');
        var url = '/cart/?addCart=' + itemId;
        $.getJSON(url)
        .success(function(data) {
            updateCart(data.total_price,data.total_items);
            $( "#dialog:ui-dialog" ).dialog( "destroy" );
            $('#dialog-box').html('<p style="text-align:center">    !<br/>\n\
            <b><a href="javascript:dialogClose();"> </a></b>  <b><a href="/cart/">  </a></b></p>');
            $( "#dialog-box" ).dialog({
                modal: true,
                height:95,
                width:350,
                buttons: {}
            });
        })
    /*.error(function() {
            alert("error");
        })
        .complete(function() {
            alert("complete");
        })*/;
   

    })
    
  $('.addCart2').click(function(e){
        e.preventDefault();
        var itemId = $(this).data('item-id');
        var url = '/cart/?addCart=' + itemId;
        $.getJSON(url)
        
    /*.error(function() {
            alert("error");
        })
        .complete(function() {
            alert("complete");
        })*/;
   

    })


    function update_cart_field(){
        $this = $(this);
        if ($this.val() == '') return;
        var itemId = $this.data('item-id');
        $.ajax({
            type: 'POST',
            url : '/cart/',
            data: "count["+itemId+"]="+$this.val(),
            success: function(){
                //  
                $.getJSON('/cart/?cart_data').success(function(data){
                    //    
                   if(data.total_items==0){
                        location.reload(true);
                    }else{
                        updateCart(data.total_price,data.total_items);
                    }
                });
                // 
                $('.cart-box').load('/cart/?cart_table',{},function(){
                    $('.updatefield', this).keyup(update_cart_field);
                    $('.updatefield', this).focus();

                });
                
            }
        })
    }

    $('.updatefield').keyup(update_cart_field).blur(update_cart_field);
    
    $('.clearCart').click(function(e){
        e.preventDefault();
        if ($('.cart_total_item').text() == 0){
            $('#dialog-box').html('  ');
            $( "#dialog:ui-dialog" ).dialog( "destroy" );
            $( "#dialog-box" ).dialog({
                modal:true, 
                buttons:{}, 
                height:50,
                width:250                
            });
        }
        else{
            $('#dialog-box').html(' ?');
            $( "#dialog-box" ).dialog({
                height:90,
                width:250,
                modal: true,
                buttons: {
                    "": function() {
                        $( this ).dialog( "close" );
                        url =$('.clearCart').attr('href');
                        $.getJSON(url).success(function(data){
                            updateCart(data.total_price,data.total_items);
                            $( "#dialog:ui-dialog" ).dialog( "destroy" );
                            $('#dialog-box').html(' !');
                            $( "#dialog-box" ).dialog({
                                modal: true,
                                height:100,
                                buttons: {
                                    ok: function() {
                                        $( this ).dialog( "close" );
                                    }
                                }
                            });
                        })
                    },
                    "": function() {
                        $( this ).dialog( "close" );
                    }
                }
            });
        }
    });


    $("#enter .enter").click(
        function(){
            $(this).closest("#enter").toggleClass("open");
        },
        function(){
            $(this).closest("#enter").toggleClass("open");
        }
        );
    $("#enter .close_login").click(function(){
        $(this).closest("#enter").toggleClass("open");
    })

    // : +/-  
    $('.raiting i').live('click',function(){
        //     
        //  = like == true ?  :  
        var parent = $(this).parent();
        var like = $(this).attr('class') == 'icon-plus';
        $.get(
            '/actions/?obj=subgallery&do=raiting&id='+($(this).parent().attr('oid'))+'&param='+(like ? 'up' : 'down'), 
            {}, 
            function(r){
                $('.photo-rate .result').html(r);
                $(parent).hide('slow');
            }); 
    });


 if ($('.showbig').length){
    $(".showbig").fancybox({
        ajax:{
            dataType : 'html',
            headers  : { 'X-fancyBox': true }
        },
        height:'90%'
    });
    $(".showbig").live('hover',function(e){
        e.preventDefault();
        parentDiv = $(this).parent('.image');
        imgTo =str_replace('subgallery/','subgallery/m',$(this).attr("link"));
        $(".bigimg a").attr({'href' : $(this).attr("href")}).find('img').attr({'src': imgTo});
        // var temp = $(".bigimg a").find('img').attr('src');
        // console.log(temp);
        parentDiv.siblings().removeClass("active");
        parentDiv.addClass("active");

    });
    $('.bigimg a').click(function(e){
        e.preventDefault();
        console.log($(this).attr('href'));

        $('.imglist a.showbig[href*="'+ $(this).attr('href') +'"]').trigger('click');
    });
}
    $(".show_link").click(function(){
        $(this).select();
    })
/*
 $("[title]").mbTooltip({ // also $([domElement]).mbTooltip  >>  in this case only children element are involved
      opacity : .7,       //opacity
      wait:100,           //before show
      mb_fade:100, //the time to fade-in
      cssClass:"default",  // default = default
      timePerWord:70,      //time to show in milliseconds per word
      hasArrow:false,           // if you whant a little arrow on the corner
        imgPath:"/template/images/",
      ancor:"mouse", //"parent"  you can ancor the tooltip to the mouse position or at the bottom of the element
    });
*/
    $('input.date').datepicker({
        dateFormat: 'dd.mm.yy', 
        monthNames: ['','','','','','','','','','','',''],
        firstDay:1,
        dayNamesMin: ['','', '', '', '', '', '']
    });

    $('.history .date').change(function(){
        order_id = $(this).data('order-id');
       $('.history .act').attr({'href':'/cart/print/'+order_id+'?act='+$(this).val()});
    });

    if ($('.order_items .is_deleted').length){
        $('.order_items .is_deleted').each(function(){
            $('.goods_list' + $(this).data('good-id')).hide();
        })
        $('.order_items .is_deleted').click(function(){
          $('.goods_list' + $(this).data('good-id')).slideToggle(100);
        })
    }

    $('.poll .line').click(function(){
        $('.poll .line').removeClass('active');
        $(this).addClass('active');
    })

    if ($('.flash').length){
        $.each($('.flash'), function(key, value) {
            url = $(value).data('falsh-path');
            el = $(value).data('flash-el');
            if (url && $(el).length){
            $(el).flash(
                {
                    src: url,
                    width: flash_bnr_width,
                }
            );
        }
        });
    }

	var ya_review = 
		'<div class="review-service" style="clear: both;/*margin-left: 200px;*/margin-top:-54px;">\
			<br>\
			<img src="/template/meno_v2.3/images/services/yandex.jpg">\
			<div class="reviews-count">\
				<a data-href="http://market.yandex.ru/shop-opinions.xml?shop_id=151862" target="_blank" href="http://market.yandex.ru/shop-opinions.xml?shop_id=151862">76 </a></div>\
			<div class="reviews-send" style="margin-top: 10px;">\
				<a target="_blank" href="http://market.yandex.ru/shop/151862/reviews/add" class="btn"> </a>\
			</div>\
		</div>';
	
	$('#form17 [type="submit"]').val(" ");
	
	$("#form17 .row.fld90").on('click','label',function(){
		if( $("input:checked", this).length > 0 ){
			$(this).parent().append(ya_review);			
		}else{
			$(".review-service").remove();
		}
		
	});
		
	$('.btn.presentation').on("click", function(){
		$.scrollTo($('#form12'), 800);
		return false;
	});
	
})


$(document).ready(function(){
    $('a[data-toggle="tab"]').click(function(){
        $(document).find('a[data-toggle="tab"]').parent().removeClass('active')
        href=$(this).attr('href');
        $(document).find('a[href="'+href+'"]').parent().addClass('active')
        $('.tab-pane').hide(); $(href).show();
    });
})