var map, mapsx, maps = new Array(), geocoder, google, googleAttached = 0;

function loadGMap(callback) {

    if(!googleAttached) {
        var script = document.createElement("script");
        script.type = "text/javascript";
        script.src = "http://maps.google.com/maps/api/js?sensor=false" + (callback ? "&callback=" + callback : "");
        document.body.appendChild(script);
        googleAttached = 1;	
    }

}

function attachGMap() {
    var mapOptions = {
        zoom: 16,
        mapTypeId: google.maps.MapTypeId.ROADMAP,
        disableDefaultUI: false,
        center: new google.maps.LatLng(56.8379, 60.5983)
    };
    geocoder = new google.maps.Geocoder();
    $.each($(".gmap"), function(i){
        var $this = $(this);
        var coords = $this.data('coords');
        var geoAddress = $this.data('address');
        var marker;
        mapsx = new google.maps.Map(this, mapOptions);
        if(coords && coords.latitude && coords.longitude) {
            var point = new google.maps.LatLng(coords.latitude, coords.longitude);
            marker = new google.maps.Marker({
                map: mapsx,
                position: point
            });
            mapsx.setCenter(point);
        }
        else if(geoAddress) {
            geocoder.geocode( {
                'address': geoAddress
            }, function(results, status) {
                if (status == google.maps.GeocoderStatus.OK) {
                    mapsx.setCenter(results[0].geometry.location);
                    marker = new google.maps.Marker({
                        map: mapsx,
                        position: results[0].geometry.location
                    });
                }
            })
        }
    });
}

$(function(){
    loadGMap("attachGMap");
	print();
})


