<?php
/**
 * 
 */
class account_notice extends Module {

    /**
     *   
     * @var string - db name
     */
    public static $table = 'account_notice';
    

    public function load(){}
    /**
     *    
     * var string $object_type
     * var int $object_id
     * var id $from_user - id   
     * var array $users
     * var text message - ,   email 
     * 
     * : set_notice('order_message',25,array(1,2,3), '   ');
     */
    
    public function set_notice($object_type,$object_id, $from_user ,$users = array(), $title = '', $text = ''){
        $emails = array();
        if (!empty($users)){
                foreach($users as $user){
                    $this->db->insert(self::$table, array(
                        'object_type'   => $object_type,
                        'object_id'     => $object_id,
                        'user_id'       => $user['id'],
                        'from_user'       => $from_user,
                ));
                $emails[] = array('name'=>$user['name'], 'email'=>$user['email']);
            }
            $this->send_email($text,$title,$emails);
        }
    }
    /**
     * ?
     *    
     * var int $user_id - id 
     * var string $object_type -  
     * var int $object_id (default - null) -  
     */
    /*public function get_notice($user_id,$object_type,$object_id = null){
        $param_list = array('table' => self::$table , 'user_id' => $user_id , 'object_type' => $object_type);
        if ($object_id != null)
        return $this->db->query('SELECT * FROM :table WHERE `user_id`=:user_id and `object_type`=:object_type '.($object_id != null ? ' and `object_id`=:object_id') , $param_list, db::FERCH_RESULT);
    }*/


    /**
     *    
     * var array $params_array  -   
     *  :
     *      int user_id - id 
     *      int from_user - id   
     *      string object_type -  
     *      int object_id -  
     *      
     */
    public function get_notice($params_array = array()){
        if (empty($params_array) or !is_array($params_array)) return false;
        foreach($params_array as $key=>$val){
            $param_list[$key] = $val;
        }
           $query = array();
            if (!empty($param_list)) foreach ($param_list as $key=>$qu){

                $query[] = ' `'.$key.'`=:'.$key;
            }
            $query = implode(' and ', $query);
        return $this->db->query('SELECT COUNT(*) FROM `'.self::$table.'` WHERE 
         '.$query
        , $param_list, db::FETCH_RESULT);
    }

    /**
     *   (  )
     * var int $user_id - id 
     * var string $object_type -  
     * var int $object_id -  
     */
    public function delete_notice($user_id,$object_type,$object_id){
        $this->db->delete(self::$table , 
            array(
                   'user_id'=>$user_id , 
                   'object_type' => $object_type, 
                   'object_id' => $object_id
                )
             );
        /*$this->db->query('DELETE FROM :table WHERE `user_id`=:user_id `object_type`=:object_type and `object_id`=:object_id' ,  
        array('user_id'=>$user_id , 'object_type' => $object_type, 'object_id' => $object_id));*/
    }

    /**
     *        (   )
     * var string $object_type -  
     * var int $object_id -  
     */
    public function delete_notice_from_object($object_type,$object_id){
        $this->db->delete(self::$table , 
            array(
                   'object_type' => $object_type, 
                    'object_id' => $object_id
                )
            );
    }


    /**
     *  ,      
     * 
     * @param array $addresses
     * @return type 
     */
    public function send_email($mailText, $mailTitle = '', $addresses = array()) {

        //    
        $url_site = $_SERVER['HTTP_HOST'];
        $settings = new settings($db);
            $site_settings = $settings->load();
        $title_site = $site_settings['title']['value'];
        //    
        $variables['site-name'] = $title_site;
        $variables['site-url']  = $url_site;
        $variables['site-link'] = '<a href="http:/' . $url_site . '/">' . htmlentities($title_site, null, 'windows-1251') . '</a>';
        ///  
        $mail = new PHPMailer();
        $mail->IsMail();
        $mail->From = $e_mail;
        $mail->CharSet = "windows-1251";
        $mail->FromName = $title_site . ' (' . $url_site . ')';
        $mail->IsHTML(true);
        $mail->Subject = $mailTitle;

        $mail->Body = $mailText;

        $mail->AltBody = "";

        foreach ($addresses as $address) {
            $mail->ClearAddresses();
            $mail->Body = '
            <div style="margin-bottom:5px;padding:5px; border-bottom:1px solid #eeeeee; text-align:right;">
            <img src="http:/' . $url_site . '/template/images/logo.png" title="'.$title_site.'" />
            </div>
            <span style="font-family:Arial;font-size:26px;font-weight:bold;line-height:26px;color:#000000;">, '.$address['name'].'!</span> 
            <br/>
            <p style="font-family:Arial;font-size:14px;line-height:21px;color:#000000;">
              '.$variables['site-link'].' '.$mailText
            .'</p>
            <div style="color:#cccccc; margin-top:10px; padding-top:10px; border-top:1px solid #eeeeee;">,     ,   .</div>';
            $mail->AddAddress($address['email'], $address['name']);
            $mail->Send();
        }
    }
}

?>