<?php

/**
 *     
 */
class account_role extends Module {

    /**
     *   
     * @var string - db name
     */
    public static $table = 'account_role';
    protected static $undelete_roles = array(1, 2, 3);

    public function load_all() {
        return parent::_load_all(self::$table);
    }

    public function load_short() {
        return $this->db->query("SELECT `id`,`name` FROM `" . self::$table . '`', null, DB::FETCH_ALL);
    }

    public function load() {
        if ($this->id !== null) {
            if (($row = $this->_load(self::$table, $this->id))) {
                $this->current = $row;
                return $row;
            }
        }
        return false;
    }

    public function update(array $options = null) {
        if (!$options)
            $options = $this->get_request(self::$table, $options);
        parent::_update(self::$table, $this->id, $options);
    }

    public function update_all(array $options = null) {
        $this->get_request(self::$table);
        $fields = self::$table_columns[self::$table];
        //id  
        unset($fields[0], $fields[1]);
        if (!$options)
            $options = $_REQUEST['group'];

        foreach ($options as $id => $items) {
            $update_row = array();
            foreach ($fields as $field) {
                if (isset($items[$field]))
                    $update_row[$field] = 1;
                else
                    $update_row[$field] = 0;
            }
            parent::_update(self::$table, $id, $update_row);
        }
    }

    public function create(array $options = null) {
        $options = $this->get_request(self::$table, $options);
        parent::_create(self::$table, $options);
    }

    public function delete() {
        if (!in_array($this->id, self::get_undelete_roles()))
            $this->_delete(self::$table, $this->id);
    }

    public static function get_undelete_roles() {
        return self::$undelete_roles;
    }
    
    public function can($premiss,$role_id){
        $this->get_request(self::$table, array());
        if (in_array($premiss , self::$table_columns[self::$table])){
            return (int)$this->db->query("SELECT `$premiss` FROM `". self::$table . "` WHERE `id`=:id", array('id'=>$role_id), DB::FETCH_RESULT);
        }
        else return 0;
    }
}

?>