<?php

/**
 *     
 */
class Account extends Module {

    /**
     *   
     * @var string - db name
     */
    public static $table = 'account';
    
    protected $validate_options = array();

    public function setId($id) {
        if (!$this->id_exists($id)) {
            $this->id = $id;
            return true;
        }
        return false;
    }

    /**
     *    
     * @var null/array 
     */
    static $_filter = null;

    //  -   
    public function login_exists($login) {
        $result = $this->db->query('SELECT 1 FROM `' . self::$table . '` WHERE `login` = :login', array(
                    "login" => $login
                ));
        return @mysql_result($result, 0, 0) == 1;
    }

    public function email_exists($email) {
        $result = $this->db->query('SELECT 1 FROM `' . self::$table . '` WHERE `email` = :email', array(
                    "email" => $email
                ));
        return @ mysql_result($result, 0, 0) == 1;
    }
    public function get_email($id){
        $retult = $this->db->query('SELECT `email` FROM `' . self::$table . '` WHERE `id` = :id' , array(
            "id" => $id
        ));
        return @ mysql_result($result, 0, 0) == 1;    
    }

    public function get_login($id){
        return $this->db->query('SELECT `login` FROM `' . self::$table . '` WHERE `id` = :id' , array(
            "id" => $id),db::FETCH_RESULT);
    }

    public function get_user_name($id){
        return $this->db->query('SELECT CONCAT_WS(" ",`name`,`patronim`,`family`) FROM `' . self::$table . '` WHERE `id` = :id' , array(
            "id" => $id),db::FETCH_RESULT);
    }

    public function get_id_by_login($login){
        return $this->db->query('SELECT `id` FROM `' . self::$table . '` WHERE `login` = :login' , array(
            "login" => $login),db::FETCH_RESULT);
    }

    public function get_id_by_email($email){
        return $this->db->query('SELECT `id` FROM `' . self::$table . '` WHERE `email` = :email' , array(
            "email" => $email),db::FETCH_RESULT);
    }

    public function id_exists($id) {
        $result = $this->db->query('SELECT 1 FROM `' . self::$table . '` WHERE `id` = :id', array("id" => $id));
        return @mysql_result($result, 0, 0);
    }
    
    /**
     *    id,   $array
     * var $array
     */
    public function get_users_from_array($array){
        if (is_array($array)){
            return $this->db->query('SELECT *,CONCAT_WS(" ",name, patronim, family) as name FROM :table
            WHERE `id` IN (:ids)',array('table'=>new db_name(self::$table),'ids'=>$array),db::FETCH_ALL);
        }
    }

    /**
     *  
     * @var array   
     * 
     */
    public static function set_filter($arr){
        $arr = array_filter($arr);
        if ($arr)
            self::$_filter = $arr;
        }

        /**
         *    
         */
    public function create_filter_query(){
        $filter = array(
                'query' => array(),
                'values' => array()
            );
        if (self::$_filter === null && !is_array(self::$_filter) && !empty(self::$_filter))
            return $filter;
        foreach(self::$_filter as $key=>$val){
            $filter['query'][]=$key.'=:'.$key;
            $filter['values'][$key]=$val;
        }
        $filter['query'] = implode(' and ',$filter['query']);
        return $filter;
    }
    /**
     *    ():
     * 
     * current_login
     * current_email
     * 
     * @param array $array 
     */
    public function set_validate_option($array){
        $this->validate_options = $array;
    }

    public function validate(array $values = null, array $non_values = array(), $is_insert = false) {
        $values = $this->get_request(self::$table, $values);
        $values['name'] = strip_tags(trim($values['name']));
        $values['family'] = strip_tags(trim($values['family']));
        $values['patronim'] = strip_tags(trim($values['patronim']));
        $values['login'] = strip_tags(trim($values['login']));
        $values['phone'] = strip_tags(trim($values['phone']));
        $errors = array();
        if (isset($values['password']) || $is_insert) {
            if (!isset($values['password']) || $values['password'] == '') {
                if ($is_insert)
                    $errors['password'][] = '  ';
            } elseif (strlen($values['password']) < 6 || 20 < strlen($values['password'])) {
                $errors['password'][] = "      6     20 ";
            } elseif (!isset($non_values['password_confirm']) || $values['password'] !== $non_values['password_confirm']) {
                $errors['password_confirm'][] = "  ";
            }
        }
        /*
        if ($is_insert) {
            if (!isset($values['login']) || $values['login'] == '') {
                $errors['login'][] = '  ';
            } elseif (strlen($values['login']) < 4 || 20 < strlen($values['login'])) {
                $login = htmlspecialchars($values['login']);
                $errors['login'][] = "  '{$login}'     5     30 ";
            } elseif (preg_match('/$[a-z](_?[a-z0-9]*)+^/si', $values['login'])) {
                $errors['login'][] = "        ,     ";
            } elseif ($this->login_exists($values['login']) && $is_update == false) {
                $login = htmlspecialchars($values['login']);
                $errors['login'][] = "   '{$login}'  ";
            }
        } else {
            unset($values['login']);
        }
        */
        if (!isset($values['name']) || $values['name'] == '') {
            $errors['name'][] = " ";
        }

        if (!isset($values['family']) || $values['family'] == '') {
            $errors['family'][] = ('    ');
        }

        if (!isset($values['email']) || $values['email'] == '') {
            $errors['email'][] = ('  e-mail');
        } elseif (!filter_var($values['email'], FILTER_VALIDATE_EMAIL)) {
            $errors['email'][] = "E-mail  ";
        } elseif ($is_insert == false && $values['email'] == $this->current['email'] or ($this->validate_options['current_email']==$values['email'])) {
// break;`
        } elseif ($this->email_exists($values['email']) && $is_update == false) {
            $email = htmlspecialchars($values['email']);
            $errors['email'][] = "  e-mail '{$email}'  ";
        }
        include DR . 'kcaptcha/kcaptcha.php';

        if (isset($non_values['kcaptcha']) || $is_insert) {
            if (!isset($non_values['kcaptcha']) || $non_values['kcaptcha'] == '') {
                $errors['kcaptcha'][] = '    ';
            } elseif ($_SESSION['captcha_keystring'] != $non_values['kcaptcha']) {
                $errors['kcaptcha'][] = '     ';
            }
        }

        if (isset($non_values['agree']) || $is_insert) {
            if (!isset($non_values['agree'])) {
                $errors['agree'][] = '     ?';
            }
        }
        if (!empty($errors)) {
            return array(
                "values" => $values,
                "errors" => $errors
            );
        }
        return true;
    }

    public function load($id = null) {
        if ($id !== null) {
            if (($row = $this->_load(self::$table, $id))) {
                return $row;
            }
        }
        if ($this->id !== null) {
            if (($row = $this->_load(self::$table, $this->id))) {
                $this->current = $row;
                return $row;
            }
        }
        return false;
    }

    public function load_all() {
        return parent::_load_all(self::$table);
    }
    
    /**
     * 3 - 
     * @param int $role
     * @return array 
     */
    public function load_users_by_role($role = 3){
        return $this->db->query('SELECT * FROM `'.self::$table.'` WHERE `role`=:role',array('role'=>$role),db::FETCH_ALL);
    }

    public function load_from_page($page = null, $item_per_page = 20) {
        if ($page == null)
            $page = 1;
        return parent::_load_page(self::$table, $page, $item_per_page);
    }

    public function register(array $options = null) {
        $options = $this->get_request(self::$table, $options);
        $options['password'] = md5($options['password']);
        $options['activate_code'] = $activate_code = $this->random_password(32, 32);
        $options['registration_date'] = date("Y-m-d H:i:s", mktime());
        $options['affiliate'] = isset($_SESSION['affiliate-id']) && $this->id_exists($_SESSION['affiliate-id']) ? $_SESSION['affiliate-id'] : null;
        $options['subcribed'] = $options['subcribed'] ? 1 : 0;
        $config = config::load();
        if ($config->has_activate_without_email) {
            $options['activate_date'] = date("Y-m-d H:i:s", mktime());
        } else {
            unset($options['activate_date']);
        }
if ($options['subcribed']){
    $settings = new settings($db);
    $_ = $settings->load();
    if ($_['mc_api']['value']){
    $MCAPI  = new mcapi($_['mc_api']['value']);
    $retval = $MCAPI->campaigns(array(),0,1);
        if (!$MCAPI->errorCode){
            $campaign_id = 0;
            if (sizeof($retval['data'])){
                foreach($retval['data'] as $c)
                    $campaign_id = $c['id'];

                    $lists = $MCAPI->lists(array(),0,1);
                    if (sizeof($lists['data'])){
                        $list_id = 0;
                        foreach ($lists['data'] as $list)
                            $list_id = $list['id'];

                        if ($list_id){
                            $MCAPI->listSubscribe($list_id,$options['email'],array('LNAME'=>$options['family'],'FNAME'=>$options['name']));
							}
                    }
            }
        }
    }
}
       $this->db->insert(self::$table, $options);

        /*
        $MCAPI  = new mcapi();
*/  
        $this->id = $this->db->get_id();

        $data = $this->load();
        if ($config->has_activate_without_email) {
            return;
        } else {
            $url_site = $_SERVER['HTTP_HOST'];
            $title_site = $this->db->settings['main']['title']['value'];
            $e_mail = $this->db->settings['main']['email']['value'];
            $url_activate = "http://$url_site/account/activate/?c=" . $activate_code;

            mails::send_email('form-user-register', $this->get_fname(), $data['email'], array(
                'link-activate' => '<a href="' . $url_activate . '">' . $url_activate . '</a>',
                'user-name'     => $this->get_fname()
            ));
        }
        return $data;
    }

    public function activate($code) {
        $id = $this->db->query("SELECT id FROM `" . self::$table . "` WHERE activate_code = :code AND activate_date IS NULL", array(
                    'code' => $code
                        ), db::FETCH_RESULT);
        if ($id) {
            $this->db->update(self::$table, array('activate_date' => date("Y-m-d H:i:s", mktime())), array('id' => $id));
            return true;
        }
        return false;
    }

    public function activate_admin($id=null) {
        if (!$id)
            $id = $this->id;
        if (is_numeric($id)) {
            $this->db->update(self::$table, array('activate_date' => date("Y-m-d H:i:s", mktime())), array('id' => $id));
            return true;
        }
        return false;
    }

    public function update(array $options = null, $id = null) {
        if (!$id)
            $id = $this->id;
                $options = $this->get_request(self::$table, $options);

        if (isset($options['password'])) {
            if (empty($options['password'])) {
                unset($options['password']);
            } else {
                $options['password'] = md5($options['password']);
            }
        } elseif (isset($_REQUEST['pass']) && $_REQUEST['pass'] != '') {
            $options['password'] = md5($_REQUEST['pass']);
        }

        //
        if ($_FILES['avatar']['name']) {
            //   1
            if ($_FILES['avatar']['size'] <= (1000 * 1000)) {
                $resize = new upload($_FILES['avatar']['tmp_name']);
                if ($resize->uploaded) {
                    $type = $_FILES['avatar']['type'];
                    $type = explode('/', $type);
                    if ($type[0] == 'image') {
                        $resize->file_new_name_body = 'user' . $id;
                        $resize->file_overwrite = true;
                        //$resize->file_new_name_ext = 'jpg';
                        $resize->image_convert = 'jpg';
                        $resize->jpeg_quality = '100';
                        $resize->image_resize = true;
                        $resize->image_x = 100;
                        $resize->image_ratio_y = true;
                        $resize->process(SR . 'content/user_files/account');
                        if ($resize->error)
                            echo $resize->error;
                    }
                }
            }
        }

        parent::_update(self::$table, $id, $options);
    }   

    public function create(array $options) {
        $options = $this->get_request(self::$table, $options);
        $options['password'] = md5($options['password']);
        parent::_create(self::$table, $options);
    }

    public function delete($id = null) {
        if (!$id)
            $id = $this->id;
        $this->_delete(self::$table, $id);
    }

    public function is_activate() {
        return $this->current['activate_date'] != null;
    }

    public function load_current() {
        if ($this->autologin()){
            return $this->is_activate();
        }
        if (isset($_SESSION['account-id'])) {
            if ($this->id == null || $this->id != $_SESSION['account-id'] || empty($this->current)) {
                $this->id = $_SESSION['account-id'];
                if (false !== $this->load()) {
                    return $this->is_activate();
                }
            } else {
                return $this->is_activate();
            }
        }
        return false;
    }

    public function get_user_by_login($login){
        return $this->db->query('SELECT * FROM `' . self::$table . '` WHERE `login` = :login',array('login'=>$login),db::FETCH_ROW);
    }

    public function autologin(){
        if (isset($_COOKIE['__ulogin']) && isset($_COOKIE['__upwd'])){
            if ($this->login_exists($_COOKIE['__ulogin'])){
                $user = $this->get_user_by_login($_COOKIE['__ulogin']);
                if ($_COOKIE['__upwd'] == md5(trim($_SERVER['REMOTE_ADDR'].$user['password']))){
                    $this->current = $user;
                    $this->id = $user['id'];
                    return true;
                }
                else return false;
            }
            //else return false;
        }
        return false;
    }

    protected function kill_autologin(){
            setcookie('__ulogin','',time()-1,'/');
            setcookie('__upwd','',time()-1,'/');    
    }

    public function remember_user($email,$password){
        //   
        if(!isset($_COOKIE['__ulogin']) && !isset($_COOKIE['__upwd'])){
            setcookie('__ulogin',$email,time()+60*60*24*30,'/');
            setcookie('__upwd',md5($_SERVER['REMOTE_ADDR'].md5($password)),time()+60*60*24*30,'/');
        }
    }

    public function login($email, $password) {
        $result = $this->db->query('SELECT * FROM `' . self::$table . '` WHERE `email` = :email AND `password` = :password', array(
                    "email" => $email,
                    "password" => md5($password)
                ));

        if (mysql_num_rows($result) == 1) {
            $this->current = mysql_fetch_assoc($result);
            $this->id = $this->current['id'];
            $this->login_current();
                $this->remember_user($email,$password);
            return true;
        }
        return false;
    }

    public function logout() {
        if (!isset($_SESSION)) {
            session_start();
        }
        session_regenerate_id(true);
            // 
            $this->kill_autologin();
        unset($_SESSION['account-id']);
    }

    public function login_current() {
        if (!isset($_SESSION)) {
            session_start();
        }
        session_regenerate_id(true);
        $_SESSION['account-id'] = $this->id;
    }

    public function get_fname($with_patronim = true) {
        return self::format_fname($this->current, $with_patronim);
    }

    public static function format_fname($data, $with_patronim = true) {
        if (!isset($data['fname'])) {
            $name = $data['name'];
            if ($with_patronim && isset($data['patronim'])) {
                $name .= ' ' . $data['patronim'];
            }
            $name .= ' ' . $data['family'];
            $data['fname'] = $name;
        }
        return $data['fname'];
    }

    public function restore_password($email) {
        $data = $this->_load(self::$table, $email, "email");
        if ($data == false)
            return false;

        $this->current = $data;
        $this->id = $data['id'];

        $url_site = $_SERVER['HTTP_HOST'];
        $title_site = $this->db->settings['main']['title']['value'];
        $e_mail = $this->db->settings['main']['email']['value'];

        $password = self::random_password();
        $this->db->update(self::$table, array(
            "password" => md5($password)
                ), array(
            "id" => $this->id
        ));
        
        mails::send_email('form-user-restore', $this->get_fname(), $data['email'], array(
            'link-activate' => '<a href="' . $url_activate . '">' . $url_activate . '</a>',
            'user-name'     => $this->get_fname(),
            'new-password'  => $password,
            'user-email'    => $data['email']
        ));
        /*
        $mail = new PHPMailer();
        //$mail->IsSMTP();
        $mail->From = $e_mail;
        $mail->CharSet = "windows-1251";
        $mail->FromName = $title_site . ' (' . $url_site . ')';
        $mail->AddAddress($email, $email);
        $mail->AddReplyTo($e_mail);
        $mail->IsHTML(true);
        $mail->Subject = '  ' . $title_site . ' (' . $url_site . ')';
        $mail->Body = $mailText;
        $mail->AltBody = "";
        $mail->Send();
        */
        return true;
    }

    public static function random_password($min = 7, $max = 12) {
        mt_srand();
        $len = mt_rand($min, $max);
        $numbs = array('1', '2', '3', '4', '5', '6', '7', '8', '9', '0');
        $words = array('q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p', 'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', 'z', 'x', 'c', 'v', 'b', 'n', 'm');
        $wordsbigg = array('Q', 'W', 'E', 'R', 'T', 'Y', 'U', 'I', 'O', 'P', 'A', 'S', 'D', 'F', 'G', 'H', 'J', 'K', 'L', 'Z', 'X', 'C', 'V', 'B', 'N', 'M');
        $method = array($numbs, $words, $wordsbigg);
        $randpassitem = '';
        for ($i = 0; $i <= $len; $i++) {
            $randarray = $method[array_rand($method)];
            $randpassitem .= $randarray[rand(0, count($randarray) - 1)];
        }
        return $randpassitem;
    }

    public static function getAvatar($user_id) {
        if (file_exists('content/user_files/account/user' . $user_id . '.jpg')) {
            return '/content/user_files/account/user' . $user_id . '.jpg';
        }
        else
            return false;
    }

    /**
     *
     *  /  
     * @param int $id
     */
    function ban($id = null) {
        if (!$id)
            $id = $this->id;
        return $this->db->query('UPDATE `' . self::$table . '` SET `ban`=IF(`ban`,0,1) WHERE `id`=' . $id);
    }

    /**
     *    
     * @param string $param
     * @return int 
     */
    public function can($param) {
        $role_id = $this->current['role'];
        $roles = new account_role();
        return $roles->can($param, $role_id);
    }
}

?>