<?php

class character {

    /**
     *  
     * @var table
     */
    private static $table = 'character';
    /**
     *    
     * @var table
     */
    private static $fieldTable = 'character_field';
    /**
     *    
     * @var table
     */
    private static $charTable = 'character_goods';
    /**
     *
     * @var db $db
     */
    private static $db;

    /**
     * @param int $id 
     */
    public $id;
    
    function __construct($db) {
        self::$db = $db;
}

    function setId($id){
        $this->id=$id;
    }

    function __get($name){
            return $_REQUEST[$name];
    }
    
    /**
     *    
     * @return array
     */
    function getCharacters() {
        return self::$db->resultAsArray('SELECT * FROM `' . self::$table . '`');
    }

    /**
     *     ID
     * @return array
     */
    function getCharById($id) {
        if (!is_numeric($id)) return false;
        return self::$db->query('SELECT * FROM `' . self::$table . '` WHERE `id`="'.$id.'"',null,db::FETCH_ROW);
    }

    /**
     *   
     * @param int $id
     * @return array
     */
    function getCharacterName($id) {
        return self::$db->resultAsArray('SELECT * FROM `' . self::$table . '` WHERE id = ' . $id . '');
    }

    /**
     * 
     *    
     * @param id_group $id
     */
    function getCharList() {
        if (!$this->id) return false;
        return @self::$db->resultAsArray('SELECT * FROM `' . self::$fieldTable . '` WHERE `char_id`=' . $this->id . ' ORDER BY `pos` ASC');
    }

    /**
     *   
     */
    function getCharacter($good_id, $catalog_id) {
        $arr = self::$db->query('SELECT * FROM `' . self::$fieldTable . '` as `F` LEFT JOIN `' . self::$charTable . '` as `G`  ON `F`.id=`G`.`field_id` WHERE `F`.`char_id`=' . $catalog_id . ' and `G`.`good_id`=' . $good_id . ' ORDER BY `pos` ASC, `id`',array(),db::FETCH_ALL);
        if (empty($arr))
            $arr = self::$db->query('SELECT * FROM `' . self::$fieldTable . '` WHERE `char_id`=' . $catalog_id . ' ORDER BY `pos` ASC',array(),db::FETCH_ALL);

        return $arr;
    }

    /**
     *  
     * @param string $name
     * @return boolean
     */
    function createChar() {
        $name = clearUserText($_REQUEST['name']);
        $name = mysql_real_escape_string($name);
        return self::$db->insert(self::$table, array('name'=>$name));
        //return self::$db->query('INSERT INTO `' . self::$table . '` (`name`) VALUES ("' . $name . '")');
    }

    /**
     *  
     * @param int $id
     * @return boolean
     */
    function deleteCharacter() {
        if (!$this->id) return false;
        return self::$db->delete(self::$table, array('id'=>$this->id));
    return self::$db->query('DELETE FROM `' . self::$table . '` WHERE `id`=' . $id);
    }

    /**
     *    
     * @param int $char_id
     * @param int $name
     * @return boolean
     */
    function createCharacterField() {

        /*ddp=- 09.08.2013 
         *          . 
         *               
         */

        if (!$this->id) return false;
        $name = clearUserText($this->name);
        $name = mysql_real_escape_string($name);
        // var_dump($this);die();
        $tooltip = clearUserText($_POST['tooltip']);
        $tooltip = mysql_real_escape_string($tooltip);
        //$q='SELECT MAX(id) as id FROM ' . self::$fieldTable.' WHERE char_id='.$this->id;
        //$res=  self::$db->resultAsArray($q);
		
        //$q= 'SELECT good_id as id FROM '.self::$charTable.' WHERE field_id='.$res[0]['id'];
        //$res=  self::$db->resultAsArray($q);
        $q='SELECT MAX(id) as id FROM ' . self::$fieldTable.' WHERE char_id='.$this->id;
        $res=  self::$db->resultAsArray($q);
    
        
         self::$db->query("INSERT INTO " . self::$fieldTable . "
                                                       (char_id, name, tooltip, pos)
                                         VALUES (
                                                 " . $this->id . ",
                                                 '" . $name . "',                                                 
                                                 '" . $tooltip . "',                                                 
                                                 '(SELECT MAX(pos) FROM " . self::$fieldTable . " WHERE char_id =" . $this->char_id . ")+1'
                                                 )
                                        ");

        $q='SELECT MAX(id) as id FROM ' . self::$fieldTable;
        $idnext=  self::$db->resultAsArray($q);
        $idnext=$idnext[0]['id'];
        $addchart='INSERT INTO '.self::$charTable.'(field_id, good_id) VALUES ';
		
		
       
		$q= 'SELECT good_id as id FROM '.self::$charTable.' WHERE field_id='.$res[0][id];
      
        $res=  self::$db->resultAsArray($q);
      
		if ($res)
        foreach ($res as $k => $v)
        {
            $addchart.="(".$idnext.", " .$v['id']." )";
            if ($res[$k+1]) {
                $addchart.=', ';
            }
            
        }   
        if ($res) {
        if (self::$db->justquery($addchart)) return true;
        else return false ; }
    }

    /**
     *    
     * @param string $name -  
     * @param int $pos - 
     * @param string $grupName -  
     * @param int $grupId - id 
     * @return boolean
     */
    function updateCharacterField() {
        $grupName = clearUserText($this->grupName);
        $grupName = mysql_real_escape_string($this->grupName);
        self::$db->query('UPDATE `' . self::$table . '` SET `name`="' . $grupName . '" WHERE `id`=' . (int) $this->id);

        foreach ($this->name as $k => $v) {
            $v = clearUserText($v);
            $v = mysql_real_escape_string($v);
            self::$db->query('UPDATE `' . self::$fieldTable . '` SET `name`="' . $v . '" WHERE `id`=' . $k);
        }

        foreach ($this->tooltip as $k => $v) {
            self::$db->query('UPDATE `' . self::$fieldTable . '` SET `tooltip`="' . $v . '" WHERE `id`=' . $k);
        }

        foreach ($this->pos as $k => $v) {
            self::$db->query('UPDATE `' . self::$fieldTable . '` SET `pos`="' . (int) $v . '" WHERE `id`=' . $k);
        }
        return true;
    }

    /**
     *    
     * @param int $id
     * @return boolean 
     */
    function deleteCharapterField() {
        if (!$this->id) return false;
        return self::$db->delete(self::$fieldTable, array('id'=>$this->id));
        //return self::$db->query('DELETE FROM `' . self::$fieldTable . '` WHERE `id`=' . $id);
    }

    /**
     *  id   
     * @param int $cat_id -  
     * @return int
     */
    function getCharId($cat_id) {
        $res = @array_pop(self::$db->resultAsArray('SELECT `char_id` FROM `' . Catalog::$table . '` WHERE `id`=' . $cat_id));
        return $res['char_id'];
    }

    /**
     *    
     * @param id $id  
     * @param $array
     */
    function saveCharacter($id,$array) {
        if (!$id) return false;
        //  
        self::$db->delete(self::$charTable, array('good_id'=>$id));
        //   
        foreach ($array as $k => $v) {
            self::$db->insert(self::$charTable, array('field_id'=>$k, 'good_id'=>$id,'param'=>$v));
        }
    }

    /**
     *     
     * @param int $id - id 
     * @param int $id_char - id 
     * @return boolean
     */

    function setCharacter($id, $id_char=null) {
        return self::$db->query('UPDATE `' . Catalog::$table . '` SET `char_id`="' . $id_char . '" WHERE `id`=' . $id);
    }

    /**
     *  
     */
    function tooltip(){
        if (!$_REQUEST['id']) return false;
        return self::$db->getOne(self::$fieldTable,'tooltip',array('id' => $_REQUEST['id']));
    }
}