<?php

/*
*  
*/

class comments{

    public static $table_name = 'comments';
    private $db;
    public $data;
    public $id = null;

	//
    function __construct($db,$id = null){
        $this->db = $db;
        if($id === null){
            if(isset($_REQUEST['id'])) $this->id = (int)$_REQUEST['id'];
        }else $this->id = (int)$id;
    }
    
	//    
	public function user_validData($values) {
		$values['nameUser'] = strip_tags(trim($values['nameUser']));
        $values['emailUser'] = strip_tags(trim($values['emailUser']));
        $values['comment'] = strip_tags(trim($values['comment']));
		
		$errors = array();
		
		//  
		if (!isset($values['nameUser']) || $values['nameUser'] == '') {
            $errors['nameUser'][] = " !";
        }
		
		//  
		if (!isset($values['comment']) || $values['comment'] == '') {
            $errors['comment'][] = "    !";
        }
		
		//e-mail
		if (!isset($values['emailUser']) || $values['emailUser'] == '') {
            $errors['emailUser'][] = ('  e-mail!');
        } elseif (!filter_var($values['emailUser'], FILTER_VALIDATE_EMAIL)) {
            $errors['emailUser'][] = "E-mail  !";
		}
			
		
		include DR . 'kcaptcha/kcaptcha.php';

		//
        if (isset($values['kcaptcha'])) {
            if (!isset($values['kcaptcha']) || $values['kcaptcha'] == '') {
                $errors['kcaptcha'][] = '    ';
            } elseif ($_SESSION['captcha_keystring'] != $values['kcaptcha']) {
                $errors['kcaptcha'][] = '     ';
            }
        }
		
		//  
		if (!empty($errors)) {
            return array(
                "values" => $values,
                "errors" => $errors
            );
        }
        return true;
	}
	
	//    () 
	public function user_getComment($class = null, $recordId = null) {
		if (!$class || !$recordId) return false;
		$id = intval($recordId);
		return $this->db->query('SELECT * FROM `'.self::$table_name.'` WHERE `class`="'.$class.'" AND `recordId`='.$id, array(), db::FETCH_ALL);
	}
	
	//   
	public function user_addComment($array = null, $class = null, $recordId = null) {
		if (!$class || !$recordId) return false;
		if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }
		$nameUser = trim(mysql_real_escape_string($array['nameUser']));
		$comment = trim(mysql_real_escape_string($array['comment']));
		
		$addDate = mktime();
		
		$q = 'INSERT INTO `'.self::$table_name.'` (`nameUser`, `emailUser`, `comment`, `class`, `recordId`, `addDate`) VALUES ("'.$nameUser.'", "'.$array['emailUser'].'", "'.$comment.'", "'.$class.'", "'.$recordId.'", "'.$addDate.'")';
		
		if ($this->db->query($q)) return true;
	}
	
	// 
	public function user_updateComment($array = null) {
	    if($array===null){
            if(get_magic_quotes_gpc()) $array=array_map('stripslashes',$_REQUEST);
            else $array = $_REQUEST;
        }
		
		$id = (int) $array['id'];
		
		$nameUser = trim(mysql_real_escape_string($array['nameUser']));
		$emailUser = trim(mysql_real_escape_string($array['emailUser']));
		$comment = trim(mysql_real_escape_string($array['comment']));
		
		$q = 'UPDATE `'.self::$table_name.'` SET `nameUser`="'.$nameUser.'", `emailUser`="'.$emailUser.'", `comment`="'.$comment.'" WHERE `id`='.$id;
		
		if ($this->db->query($q)) return true;
	}
	
	public function getCount($class = null, $recordId = null) {
		if (!$class || !$recordId) return false;
		$id = intval($recordId);
		return $this->db->query('SELECT COUNT(*) FROM `'.self::$table_name.'` WHERE `class`="'.$class.'" AND `recordId`="'.$recordId.'"', array(), db::FETCH_RESULT);
	}
	
	//   
	public function getComment($id = null) {
		$id = (int) $id;
		$q = 'SELECT * FROM `'.self::$table_name.'` WHERE `id`='.$id;
		$result = $this->db->query($q);
			while ($row = mysql_fetch_assoc($result)) {
				$comment = $row;
			}
		if ($comment) $this->data = $comment;
		return $comment;
	}
	
	//  
	public function getAllComments() {
		$q = 'SELECT * FROM `'.self::$table_name.'`';
		$result = $this->db->query($q);
			while ($row = mysql_fetch_assoc($result)) {
				$allComment[$row['id']] = $row;
			}
		if ($allComment) $this->data = $allComment;
		return $this->data;
	}
	
	//  
	public function getRandoms($limit=3) {
		$q = 'SELECT * FROM `'.self::$table_name.'` WHERE `visible`="1" ORDER BY RAND() LIMIT '.$limit;
		return $this->db->resultAsArray($q);
	}

	// 
	public function show() {
		if (!$this->id) return false;
		$id = (int) $this->id;
		$q = 'UPDATE `'.self::$table_name.'` SET `visible`=1 WHERE `id`='.$id;
		if ($this->db->query($q)) return true;
	}
	
	// 
	public function hide() {
		if (!$this->id) return false;
		$id = (int) $this->id;
		$q = 'UPDATE `'.self::$table_name.'` SET `visible`=0 WHERE `id`='.$id;
		if ($this->db->query($q)) return true;
	}
	
	// 
	public function delete() {
		if (!$this->id) return false;
		$id = (int) $this->id;
		$q = 'DELETE FROM `'.self::$table_name.'` WHERE `id`='.$id;
		if ($this->db->query($q)) return true;
	}
	
}
?>