<?php


/**
 * @author Arbora Sergey (http://arbora.ru)
 *   
 * 
 **/


class design {
    public $allowed_exts = array('swf','png','gif','jpg','jpeg');
    public static $table_name = 'settings';
    public static $module = 'design';
    public static $data = array();

    private $path = '/content/images/design/';
    protected $db;

    function __construct($db){
        $this->db = $db;
    }
   
    public function load(){
        if(self::$data) return self::$data;
        $q = 'SELECT * FROM `'.self::$table_name.'` WHERE `module`="'.mysql_real_escape_string(self::$module).'" ORDER BY `sort`';
        if(!$r = $this->db->query($q)) return false;
        self::$data = array();
        while($row = mysql_fetch_assoc($r)){
            self::$data[$row['field']] = array('name'=>$row['name'],'value'=>$row['value'],'type'=>$row['type'],'comment'=>$row['comment'],'field'=>$row['field']);
        }
        return self::$data;
    }

    function update($array=null){
        if($array === null){
            $array = get_magic_quotes_gpc()?array_map('stripslashes',$_REQUEST):$_REQUEST;
        }
        if(!key_exists(self::$module,self::$data)) $this->load(self::$module);
        unset(self::$data['logo']);
        if(self::$data) foreach(self::$data as $k=>$v){
            $q = 'UPDATE `'.self::$table_name.'` SET `value`="'.mysql_real_escape_string($array[$k]).
                 '" WHERE `module`="'.mysql_real_escape_string(self::$module).'" AND `field`="'.$k.'"';            
            $this->db->query($q);
        }
        $this->updateLogo();
        $this->updateFavicon();
    }


    function updateLogo(){
      if (is_uploaded_file($_FILES['logo']['tmp_name'])) {
            $name = $_FILES['logo']['name'];
            $name = explode('.', $name);
            $ext = end($name);
            $name = 'logo';
            if (!in_array($ext,$this->allowed_exts)) return '';
            $update = array();
            $update['value'] = "$name.$ext";
            $file = ($_FILES['logo']['tmp_name']);
            if (!move_uploaded_file($_FILES['logo']['tmp_name'],SR.$this->path.$name.'.'.$ext)) 
                return false;

            $this->db->update(self::$table_name,$update,array('module'=>self::$module,'field'=>'logo'));
        }
    }

    function updateFavicon(){
      if (is_uploaded_file($_FILES['favicon']['tmp_name'])) {
            $name = $_FILES['favicon']['name'];
            $name = 'favicon.ico';
            $update = array();
            $update['value'] = "$name";
            $file = ($_FILES['favicon']['tmp_name']);
            if (!move_uploaded_file($_FILES['favicon']['tmp_name'],SR.$this->path.$name.'.'.$ext)) 
                return false;

            $this->db->update(self::$table_name,$update,array('module'=>self::$module,'field'=>'favicon'));
        }
    }

    function delete_file($name=null){
        if (!$name && isset($_REQUEST['name'])){
            $name = $_REQUEST['name'];
        }else return false;
        
        // var_dump (is_file(SR . $this->getPath().$name));die();
        if (is_file(SR . $this->getPath().$name)) {
            if (isset($_REQUEST['field'])){
                $this->db->update(self::$table_name,array('value'=>''),array('module'=>self::$module,'field'=>$_REQUEST['field']));
            }
        }
        return true;
    }

    public function getPath() {
        return $this->path;
    }
}

?>