<?php


/**
 * @author Arbora Sergey (http://arbora.ru)
 *
 *         
 * -   ;-)
 *
 * ..  :D
 **/


class FCKeditor {
    public $Value;
    public $Id;
    public $Name;
    public $Toolbar = 'full';
    public $Class;
    public $Tabs = false;

    function __construct($id, $is_class = false) {
        if ($is_class == false) {
            $this->Id = $id;
        } else {
            $this->Id = $id;
            $this->Class = $id;
        }
    }

    function CreateHtml($name = null, $value = null) {
        if ($value === null)
          $value = $this->Value;
        if ($value == '')
          $value = '<div></div>';

        $height = $this->Toolbar != 'text' ? 300 : 130;
        if ($name === null)
            $name = $this->Name ? $this->Name : $this->Id;
        $class  = $this->Class ? 'class="' . $this->Class . '"' : 'id="' . $this->Id . '"';
        $ident  = ($this->Class ? '.' : '#') . $this->Id;


        if ($this->Tabs) {
          $init = 'addClass("elrite-lazy").data("lazy-editor", opts)';
        } else {
          $init = 'elrte(opts)';
        }

        $ATR = ATR;

        $html = <<<HTML
        <textarea {$class} name="{$name}">{$value}</textarea>
        <script type="text/javascript"
>            var editor = CKEDITOR.replace( '{$name}', {
                toolbar: 'default'
            });
            CKFinder.setupCKEditor( editor, '{$ATR}source/ckfinder/' );

/*
            $(function(){
               var opts = {
                  lang         : 'ru',   // set your language
                  styleWithCSS : false,
                  height       : {$height},
                  toolbar      : '{$this->Toolbar}',
                  fmAllow      : true,
                  fmOpen : function(callback) {
                      $('<div id="myelfinder" />').elfinder({
                          url : '/admin/connector.php',
                          lang : 'ru',
                          dialog : { width : 900, modal : true, title : '' }, //    
                          closeOnEditorCallback : true, //    
                          editorCallback : callback //  callback  
                      });
                   }
                };
                $('{$ident}').{$init};
          });
          */
        </script>
HTML;
      return $html;
    }
}