<?php

class forms {

    public static $table_name = 'forms';
    public static $fields_table_name = 'forms_fields';
    public static $values_table_name = 'forms_values';
    public static $submit_table_name = 'forms_submit';
    public $id = null;
    public $data = array();
    public $submit_data = array();
    public static $type = array('text', 'checkbox', 'radio', 'file', 'textarea', 'select', 'submit', 'date','time','time9-23');
    public static $type_with_values = array('checkbox', 'radio', 'select');
    public $reply_id;
    /**
     * Enter description here...
     *
     * @var db
     */
    private $db = null;

    function __construct($db, $id=null) {
        $this->db = $db;
        if ($id === null)
            $this->id = (int) $_REQUEST['id'];
        else
            $this->id = (int) $id;
    }

    function load() {
        if ($this->id) {
            $q = 'SELECT * FROM `' . self::$table_name . '` WHERE `id`=' . $this->id;
            $r = $this->db->query($q);
            $row = mysql_fetch_assoc($r);
            if ($row) {
                $this->data[$row['id']] = $row;
                $q = 'SELECT * FROM `' . self::$fields_table_name . '` WHERE `pid`=' . $this->id . ' ORDER BY `pos`';
                $r = $this->db->query($q);
                while ($row2 = mysql_fetch_assoc($r)) {
                    $this->data[$row['id']]['fields'][$row2['id']] = $row2;
                    if (in_array($row2['type'], self::$type_with_values)) {
                        $q = 'SELECT * FROM `' . self::$values_table_name . '` WHERE `pid`=' . $row2['id'];
                        $r1 = $this->db->query($q);
                        while ($row3 = mysql_fetch_assoc($r1)) {
                            $this->data[$row['id']]['fields'][$row2['id']]['values'][$row3['id']] = $row3;
                        }
                    }
                }
                return $this->data[$row['id']];
            }else
                return false;
        }else {
            $q = 'SELECT * FROM `' . self::$table_name . '`';
            $r = $this->db->query($q);
            while ($row = mysql_fetch_assoc($r)) {
                $this->data[$row['id']] = $row;
            }
            return $this->data;
        }
    }

    function load_on_alias($alias) {
        $q = 'SELECT `id` FROM `' . self::$table_name . '` WHERE `alias`="' . mysql_real_escape_string($alias) . '"';
        $r = $this->db->query($q);
        if (mysql_num_rows($r)) {
            $this->id = mysql_result($r, 0, 0);
            return $this->load();
        }else
            return false;
    }

    function load_unprocessed($page = 1, $count = 50) {
        $result = $this->db->query("SELECT * FROM :table WHERE processed != 1 ORDER BY date DESC", array(
                    'table' => db_name(self::$submit_table_name)
                        ), Db::FETCH_ALL);

        return $result;
    }

    function create($array = null) {
        if ($array === null)
            $array = array_map('stripslashes', $_REQUEST);
        $q = 'INSERT INTO `' . self::$table_name .
                '` (`name`, `header_site`, `alias`,`kcaptcha`) VALUES ("' . mysql_real_escape_string(strip_tags($array['name'])) .
                '", "' . mysql_real_escape_string(strip_tags($array['header_site'])) .
                '", "' . mysql_real_escape_string(strip_tags($array['alias'])) . '",' . (int) $array['kcaptcha'] . ')';
        $this->db->query($q);
        $id = $this->db->get_id();
        /*    
        $q_field = 'INSERT INTO `' . self::$fields_table_name . '` (`pid`, `name`, `type`, `required`) 
        			VALUES ("' . $id . '","  ","submit","0")';
        $this->db->query($q_field);
        */
        return $id;
    }

    function update($array = null) {
        if ($array === null) {
            if (get_magic_quotes_gpc())
                $array = array_map('stripslashes', $_REQUEST);
            else
                $array = $_REQUEST;
        }

        $q = 'UPDATE `' . self::$table_name .'` SET 
                `name`="' . mysql_real_escape_string(strip_tags($array['name'])) . '", 
                `header_site`="'.mysql_real_escape_string(strip_tags($array['header_site'])) .'",
                `text`="'.mysql_real_escape_string($array['text']) .'",
                `sys_email`="'.($array['sys_email'] ? '1':'0') .'",
                `email`="'.mysql_real_escape_string(strip_tags($array['email'])) .'",
                `kcaptcha`=' . (int) $array['kcaptcha'] . ' WHERE `id`=' . $this->id;
        $this->db->query($q);

        $this->prepare_fields();
    }

    function prepare_fields() {
        $this->data = array();
        $data = $this->load();
        $pos = 0;
        if (!empty($data['fields']))
            foreach ($data['fields'] as $id => $field) {
                $this->db->update(self::$fields_table_name, array(
                    'pos' => ++$pos
                        ), array(
                    'id' => $id
                ));
            }

        return $pos;
    }

    function create_field($array = null) {
        if (!$this->id)
            return false; else

        if ($array === null)
            $array = array_map('stripslashes', $_REQUEST);
        if (!in_array($array['type'], self::$type))
            return false;
        $data = $this->load();
        $q = 'INSERT INTO `' . self::$fields_table_name . '` (`pid`,`name`,`type`,`required`, `pos`) VALUES (' . $this->id . ',"' . mysql_real_escape_string(strip_tags($array['name'])) . '","' . $array['type'] . '",' . (int) $array['required'] . ',' . (int) ($array['pos'] ? $array['pos'] : $pos ) . ')';
        $this->db->query($q);
        $id = $this->db->get_id();
        return $id;
        $pos = $this->prepare_fields();
    }

    function update_field($array = null, $field_id = null) {
        if ($field_id === null)
            $field_id = (int) $_REQUEST['field_id'];
        if ($array === null)
            $array = array_map('stripslashes', $_REQUEST);
        if (!in_array($array['type'], self::$type));
        $q = 'UPDATE `' . self::$fields_table_name .
                '` SET `name`="' . mysql_real_escape_string(strip_tags($array['name'])) .
                '",`type`="' . $array['type'] .
                '",`required`=' . (int) $array['required'] .
                ',`pos`=' . (int) $array['pos'] .
                ',`hint`="' . mysql_real_escape_string(trim(strip_tags($array['hint']))) .
                '",`alias`="' . mysql_real_escape_string(trim(strip_tags($array['alias']))) .'"
                 WHERE `id`=' . $field_id;
        $this->db->query($q);
        $this->prepare_fields();
        if (in_array($array['type'], self::$type_with_values)) {
            if (is_array($_REQUEST['values']))
                foreach ($_REQUEST['values'] as $k => $v) {
                    $q = 'UPDATE `' . self::$values_table_name . '` SET `name`="' . mysql_real_escape_string(strip_tags(stripslashes($v))) . '" WHERE `id`=' . (int) $k . ' AND `pid`=' . $field_id;
                    $this->db->query($q);
                }
            if (is_array($_REQUEST['new_values']))
                foreach ($_REQUEST['new_values'] as $v) {
                    $v = trim(strip_tags(stripslashes($v)));
                    if (!$v)
                        continue;
                    $q = 'INSERT INTO `' . self::$values_table_name . '` (`pid`,`name`) VALUES (' . $field_id . ',"' . mysql_real_escape_string($v) . '")';
                    $this->db->query($q);
                }
        } else {
            $q = 'DELETE FROM `' . self::$values_table_name . '` WHERE `pid`=' . $field_id;
            $this->db->query($q);
        }
    }

    function delete_field($field_id = null) {
        if ($field_id === null)
            $field_id = (int) $_REQUEST['field_id'];
        else
            $field_id = (int) $field_id;
        $q = 'DELETE FROM `' . self::$fields_table_name . '` WHERE `id`=' . $field_id;
        $this->db->query($q);
        $q = 'DELETE FROM `' . self::$values_table_name . '` WHERE `pid`=' . $field_id;
        $this->db->query($q);
        $this->prepare_fields();
    }

    static function get_type_options($value = null) {
        $o = '';
        foreach (self::$type as $v) {
            $o .= '<option value="' . $v . '" ' . ($value == $v ? 'selected="selected"' : '') . '>' . $v . '</option>';
        }
        return $o;
    }

    function ajax_field_form() {
        if (!$this->id)
            return '  ';
        $field = stripslashes($_REQUEST['field']);
        if (!$field)
            return '  ';
        $this->load();
        if (!$this->data[$this->id]['fields'][$field])
            return '  ';
        $data = $this->data[$this->id]['fields'][$field];
        $values = '';
        if ($data['values'])
            foreach ($data['values'] as $v) {
                $value .= '<input type="text" name="values[' . $v['id'] . ']" class="forma" value="' . $v['name'] . '"/><br/>';
            }
        $o = '';
        $o .= '<form action="'.GO.'?menu=services&amp;page=forms&amp;do=update_field" method="post"><table>
        	   <tr><th></th><td><input type="hidden" name="field_id" value="' . $data['id'] . '" /><input type="text" name="name" value="' . $data['name'] . '" class="forma"/></td></tr>
                   <tr><th></th><td><input name="pos" class="forma" value="' . $data['pos'] . '"/></td></tr>
                   <tr>
                    <th style="vertical-align: top;"> </th>
                    <td>
                    <select name="alias" class="forma">
                        <option></option>
                        <option '.($data['alias']=='name' ? 'selected="selected"' : '').' value="name"></option>
                        <option '.($data['alias']=='telephone' ? 'selected="selected"' : '').' value="telephone"></option>
                        <option '.($data['alias']=='email' ? 'selected="selected"' : '').' value="email">Email</option>
                    </select>
<!--<input name="alias" class="forma" value="' . $data['alias'] . '"/>-->
                        <div class="hint">
                            <p> -      </p>
                            <p> -      </p>
                            <p>Email -     email </p>
                        </div>
                    </td>
                    </tr>
        	   <tr><th></th><td><select name="type" class="forma">' . self::get_type_options($data['type']) . '</select></td></tr>
        	   <tr><th></th><td><input type="checkbox" value="1" name="required" ' . ($data['required'] ? 'checked="checked"' : '') . ' /></td></tr>
        	   <tr><th></th><td>' . $value . '<input type="text" class="forma" name="new_values[]" onchange="add_value_field(this)"; /></td></tr>
                <tr><th></th><td><input type="text" class="forma" name="hint" value="'.$data['hint'].'"/></td></tr>
        	   <tr><td><input type="submit" value="" class="btn" /></td><td><a href="" onclick="document.getElementById(\'edit_field\').style.display=\'none\';return false;"></a></td></tr>        	   
        	   </table>
        	   </form>        	   
        	   ';
        return $o;
    }

    //TODO   
    function submit(&$errors = array(), array $values = array(), $other_email='') {
        if (!$_REQUEST['form' . $this->id])
            return false;
        if (!$this->id)
            return false;
        if (!$this->data[$this->id]['fields'])
            return false;
        if ($this->data[$this->id]['kcaptcha']) {
            if ($_SESSION['captcha_keystring'] != $_REQUEST['kcaptcha'])
                $errors['kcaptcha'] = 1;
        }
        $fields = array();
        foreach ($this->data[$this->id]['fields'] as $id => $opts) {
            if (isset($opts['alias']) && !empty($opts['alias'])) {
                $fields[$opts['alias']] = $id;
            }
        }
        foreach ($values as $id => $options) {
            if (isset($fields[$id])) {
                $tag = $fields[$id];
                $this->data[$this->id]['fields'][$tag]['values'] = $options;
            }
        }
        $insert = array(
            'forms_id' => $this->id
        );
        	
        foreach ($this->data[$this->id]['fields'] as $v) {
            $value[$v['id']] = array('field' => $v['name'], 'alias' => $v['alias'], 'type' => $v['type']);
            if(is_array($_REQUEST['field'][$v['id']])){
                $_REQUEST['field'][$v['id']] = $_REQUEST['field'][$v['id']];
            }else{
                $_REQUEST['field'][$v['id']] = stripcslashes($_REQUEST['field'][$v['id']]);
            }
            
            switch ($v['type']) {
                case 'submit':
                    unset($value[$v['id']]);
                    break;

                case 'file':
                    if (is_uploaded_file($_FILES['field']['tmp_name'][$v['id']])) {
                        $name = $_FILES['field']['name'][$v['id']];
                        $ext = array_pop(explode('.', $name));
                        $new_name = get_name_to_file() . ($ext ? '.' . $ext : '');
                        $path = SR . 'content/user_files/';
                        move_uploaded_file($_FILES['field']['tmp_name'][$v['id']], $path . $new_name);
                        $value[$v['id']]['value'] = $name;
                        $value[$v['id']]['real_path'] = $path . $new_name;
                        $value[$v['id']]['local_path'] = '/content/user_files/' . $new_name;
                    } elseif ($v['required']) {
                        $errors['required_empty'][$v['id']] = 1;
                    }
                    break;
                case 'checkbox':
                    if ($v['required'] && !trim($_REQUEST['field'][$v['id']])) {
                        $errors['required_empty'][$v['id']] = 1;
                    }
                    $zpt = '';
                    $value[$v['id']]['value'] = '';
                    $value[$v['id']]['value_id'] = array();
                    if (is_array($_REQUEST['field'][$v['id']]))
                        foreach ($_REQUEST['field'][$v['id']] as $v1) {
                            $value[$v['id']]['value'] .= $zpt . $v['values'][$v1]['name'];
                            $value[$v['id']]['value_id'][$v['values'][$v1]['id']] = $v['values'][$v1]['id'];
                            $zpt = ', ';
                        }
                    break;
                case 'select': 
                case 'radio':
                    if ($v['required'] && !trim($_REQUEST['field'][$v['id']])) {
                        $errors['required_empty'][$v['id']] = 1;
                    }
                    $value[$v['id']]['value'] = $v['values'][$_REQUEST['field'][$v['id']]]['name'];
                    $value[$v['id']]['value_id'] = $_REQUEST['field'][$v['id']];
                    break;
                default: {
                        if ($v['required'] && !trim($_REQUEST['field'][$v['id']])) {
							$errors['required_empty'][$v['id']] = 1;
                        }
                        $value[$v['id']]['value'] = $_REQUEST['field'][$v['id']];
                    }
            }
        
            switch ($v['alias']) {
                case 'email':
                    $insert['email'] = $value[$v['id']]['value'];
                    break;

                case 'telephone':
                    $insert['telephone'] = $value[$v['id']]['value'];
                    break;

                case 'name':
                    $insert['name'] = $value[$v['id']]['value'];
                    break;
            }
        }

        if ($errors)
            return false;
        if (function_exists('meno_callback_send_form'))
            meno_callback_send_form($this, &$value);

        $insert['value']   = serialize($value);
        $this->db->insert(self::$submit_table_name, $insert);
        $this->reply_id = mysql_insert_id();
        
        $url_site   = $_SERVER['HTTP_HOST'];
        $title_site = $this->db->settings['main']['title']['value'];
        $e_mail     = $this->db->settings['main']['email']['value'];
        $url_site   = "http://$url_site/";
        $replay_email = @$insert['email'];
        $replay_name = @$insert['name'];
        $message = '';
        $name_form = $this->data[$this->id]['name'];
        $message = '<b>' . $name_form . '</b><br/>';
        $message2=$name_form."\n";
        foreach ($value as $m) {
            if ($m['type'] == 'submit' || $m['value'] == '')
                continue;
            $message .= '<b>' . $m['field'] . ': </b>' . $m['value'] . '<br />';
            $message2.=$m['field'].': '.$m['value']."\n";
        }

        //   18.04.14  
        if(strlen($message2)>279){
            $message2=substr($message2, 0, 279);
            $message2.='...';
        }
        $mess=iconv('windows-1251', 'UTF-8', $message2);
        if($mess)mail("sms@massreach.com","a7afb527722d54b4 79220374435","[SENDER]ROBOT96[/SENDER][SMS]".$mess."[/SMS]","Content-type:text/plain; charset = utf-8\r\nFrom:MENOCOM");
        //   END


        if ($replay_email)
        {
            mails::send_email('form-submit', $replay_email, $replay_email, array(
                'form-name'    => $this->data[$this->id]['name'],
                'form-message' => $message . ' <br/>                  -       ..   <a href="mailto::director@robot96.ru">director@robot96.ru</a>,      .' ,
            ),array('manager-receive' => $replay_email));
        }

        if ($this->data[$this->id]['email']){
            mails::send_email('form-submit', $this->data[$this->id]['email'], $this->data[$this->id]['email'], array(
                'form-name'    => $this->data[$this->id]['name'],
                'form-message' => $message,
            ),array('manager-receive' => $this->data[$this->id]['sys_email']));
        }

        if ($other_email){
            mails::send_email('form-submit', $other_email, $other_email, array(
                'form-name'    => $this->data[$this->id]['name'],
                'form-message' => $message,
            ),array('manager-receive' => $this->data[$this->id]['sys_email']));
        }

        return true;
    }

    function load_submit_data($id = null) {
        if ($id == null) {
            if (!$this->id)
                return false;
            $q = 'SELECT * FROM `' . self::$submit_table_name . '` WHERE `forms_id`=' . $this->id . ' ORDER BY `date` DESC';
            $r = $this->db->query($q);
            $this->submit_data = array();
            while ($row = mysql_fetch_assoc($r)) {
                $this->submit_data[$this->id][$row['id']] = $row;
                $this->submit_data[$this->id][$row['id']]['value'] = unserialize($row['value']);
            }
            return $this->submit_data[$this->id];
        } else {
            $q = 'SELECT * FROM `' . self::$submit_table_name . '` WHERE `id`=' . (int) $id;
            $r = $this->db->query($q);
            while ($row = mysql_fetch_assoc($r)) {
                return $row;
            }
            return false;
        }
    }

    function delete_submit_data($id = null) {
        if ($id === null)
            $id = (int) $_REQUEST['submit_data_id'];
        else
            $id = (int) $id;
        $q = 'DELETE FROM `' . self::$submit_table_name . '` WHERE `id`=' . $id;
        $this->db->query($q);
    }

    function process_submit_data($id = null) {
        if ($id === null)
            $id = (int) $_REQUEST['submit_data_id'];
        else
            $id = (int) $id;
        $this->db->update(self::$submit_table_name, array('processed' => true), array( 'id' => $id ));
    }
    
    function saveComment(){
        $q = "UPDATE `".self::$submit_table_name."` SET `comment`='{$_POST['comment']}' WHERE id={$_POST['idid']} ";
        $this->db->query($q);        
    }
    
}

?>