<?php

class goods {

    // 
    public static $table = 'catalog_goods';
    //   
    private static $popCWidth       = '169';
    private static $popCHeight      = '103';
    
    //    
    private static $lidCWidth       = '95';
    private static $lidCHeight      = '111';

    //     
    private static $cidCWidth       = '60';
    private static $cidCHeight      = '';
    
    public static $popPrefix        = 's_';
    public static $lidPrefix        = 'l_';
    public static $cidPrefix        = 'c_';

    public static $uploadFolder     = '/content/user_files/catalog/';

    private $toPage = 10000;

    public static $limit;
    public $id = null;
    public $data = array();
    public $current = array();
    public $settings = array();
    public $goodsCid = array();

    //    
    public $filter = array();
    public $sort;


    /**
     * 
     * @var db $db
     */
    public static $db;

    function __construct($db) {
        self::$db = $db;

    global $config;
    if ($config->catalog->goods_per_page)
       $this->toPage = $config->catalog->goods_per_page;
    }

    function setId($id) {
        $this->id = $id;
    }

    /**
     *  
     * @param int $id - good id
     */
    function getGood($id=null) {
        $sql = 'SELECT * FROM `' . self::$table . '` WHERE `id`=' . ($this->id ? $this->id : $id);
        return @array_pop(self::$db->resultAsArray($sql));
    }
    function getGoodcart() {
        $sql = 'SELECT * FROM `' . self::$table . '` WHERE `in_cart`=1';
        return @array_pop(self::$db->resultAsArray($sql));
    }

    function getGoodsCid ($cid,$id) {
        if(!isset($this->goodsCid[$id])) $this->goodsCid[$id] = array();

        if(!$cid) return false;

        $sql = 'SELECT * FROM `' . self::$table . '` WHERE `cid`=' . $cid . ' ORDER BY price ASC' ;

        $this->goodsCid[$id] = array_merge($this->goodsCid[$id] ,self::$db->resultAsArray($sql));

        $sql = "SELECT id FROM catalog_sect WHERE vis = '1' AND pid = '".$cid."'";
        $res = self::$db->resultAsArray($sql);

        if(sizeof($res)>0){
            foreach ($res as $r) {
                $this->getGoodsCid($r['id'],$id);
            }
        }
        return $this->goodsCid;
    }

    function load() {
        $this->data = array();
        $this->current = array();
        $q = 'SELECT `a`.`id`,`a`.`cid`,`a`.`vis`,`a`.`pos`,`a`.`name`,`a`.`show-main`,`a`.`column-show`,`a`.`price`,`b`.`isseo`,`a`.`not_fixed`  FROM `' . self::$table .
                '` as `a` LEFT JOIN (SELECT `object_id`,1 as `isseo` FROM `' . seo::$table_name .
                '` WHERE `module`="catalog" AND `object_type`="good") as `b` ON `a`.`id`=`b`.`object_id`  ORDER BY `a`.`price` ASC, `a`.`pos` DESC, `a`.`id`';
        $r = self::$db->query($q);
        while ($row = mysql_fetch_assoc($r)) {
            $this->data[$row['id']] = $row;
        }
        if ($this->id) {
            $q = 'SELECT * FROM `' . self::$table . '` WHERE `id`=' . $this->id;
            $r = self::$db->query($q);
            if ($row = mysql_fetch_assoc($r))
                $this->current = $row;
        }
        return $this->data;
    }

    /**
     *    
     * @param int $id - catalog id
     */
    function getGoods($id, $limit=array(), $all=false) {
        $this->setFilter($_GET['filter']);
        if (!$id){
            $where = array(0 => ($all ? '' : '`vis`'));
        }else{
            $where = array(0 => ($all ? '' : '`vis` AND') . '`cid`=' . $id);
        }
		
        if (!empty($this->filter)){
            $where = array_merge($where,$this->filter);        
        }
        // var_dump($this->filter); die();
        $where = implode(' AND ',$where);
        $order = ($this->sort ? $this->sort : 'ORDER BY `price` ASC , `pos` ');
		
		$join = "";
		if( !empty($_GET['filter']['char']) ){
			$join = $this->filterChars($_GET['filter']['char']);
			//print_r($join); exit;
		}
		
        if (!empty($limit)) {
            if (isset($limit['limit'])) {
                if ($_SESSION['LookAt'])
                    $this->toPage = $_SESSION['LookAt'];
                if (isset($limit['limit']['page']) && $limit['limit']['page']) {
                    $st = ($limit['limit']['page'] * $this->toPage) - $this->toPage;
                    $lim = ' LIMIT ' . $st . ',' . $this->toPage;
                }
                else
                    $lim=' LIMIT 0,' . $this->toPage;
            }
        }
        // if($_GET['sort']['by'] == 'rating'){
        //     $where = array(0 => ($all ? '' : '`i`.`vis` AND ') . '`i`.`cid`=' . $id);
        //     if (!empty($this->filter)){
        //         $where = array_merge($where,$this->filter);        
        //     }
        //     $where = implode(' AND ',$where);
        //     $order = 'ORDER BY `r`.`total_value` '.$_GET['sort']['order'].', `i`.`price` ASC , `i`.`pos` ';
        //     // $order = 'ORDER BY `r`.`total_value` DESC, `i`.`price` ASC , `i`.`pos` ';
        //     $sql = 'SELECT `i`.*, `r`.`total_value` FROM `' . self::$table . '` as `i`
        //     LEFT JOIN `rating` as `r` ON `r`.`object_id` = `i`.`id` WHERE '. $where .' '. $order .'  ' . (isset($lim) && $lim ? $lim : '');
        // }else{
            $sql = 'SELECT g.* FROM `' . self::$table . '` g '.$join.' WHERE '. $where .' '. $order .'  ' . (isset($lim) && $lim ? $lim : '');
            // var_dump($sql); die();
        // }
        // var_dump($sql);
        return self::$db->resultAsArray($sql);
    }

    function getNewGoods() {
        $this->setFilter(array('new'=>1));
        if (!$id){
            $where = array(0 => ($all ? '' : '`vis`'));
        }else{
            $where = array(0 => ($all ? '' : '`vis` AND') . '`cid`=' . $id);
        }
        if (!empty($this->filter)){
            $where = array_merge($where,$this->filter);        
        }
        // var_dump($this->filter); die();
        $where = implode(' AND ',$where);
        $order = ($this->sort ? $this->sort : 'ORDER BY `price` ASC , `pos` ');
        if (!empty($limit)) {
            if (isset($limit['limit'])) {
                if ($_SESSION['LookAt'])
                    $this->toPage = $_SESSION['LookAt'];
                if (isset($limit['limit']['page']) && $limit['limit']['page']) {
                    $st = ($limit['limit']['page'] * $this->toPage) - $this->toPage;
                    $lim = ' LIMIT ' . $st . ',' . $this->toPage;
                }
                else
                    $lim=' LIMIT 0,' . $this->toPage;
            }
        }
        // if($_GET['sort']['by'] == 'rating'){
        //     $where = array(0 => ($all ? '' : '`i`.`vis` AND ') . '`i`.`cid`=' . $id);
        //     if (!empty($this->filter)){
        //         $where = array_merge($where,$this->filter);        
        //     }
        //     $where = implode(' AND ',$where);
        //     $order = 'ORDER BY `r`.`total_value` '.$_GET['sort']['order'].', `i`.`price` ASC , `i`.`pos` ';
        //     // $order = 'ORDER BY `r`.`total_value` DESC, `i`.`price` ASC , `i`.`pos` ';
        //     $sql = 'SELECT `i`.*, `r`.`total_value` FROM `' . self::$table . '` as `i`
        //     LEFT JOIN `rating` as `r` ON `r`.`object_id` = `i`.`id` WHERE '. $where .' '. $order .'  ' . (isset($lim) && $lim ? $lim : '');
        // }else{
            $sql = 'SELECT * FROM `' . self::$table . '` WHERE '. $where .' '. $order .'  ' . (isset($lim) && $lim ? $lim : '');
            // var_dump($sql); die();
        // }
        // var_dump($sql);
        return self::$db->resultAsArray($sql);
    }

	private function filterChars($data){
		$result = "JOIN character_goods cg ON g.id=cg.good_id AND ";
		
		$on = array();
	//print_r($data);
		foreach($data as $field_id => $val){
			if(is_array($val)){
				$cond = array();
				foreach($val as $v)
					$cond[] = "FIND_IN_SET('{$v}', REPLACE(cg.param, ' ', ''))";
				$on[] = "(cg.field_id={$field_id} AND (" . implode(' AND ', $cond) . ") )\n";

			}else{
				if(empty($val))
					continue;
					
				switch($field_id){
					case 14 : 
						$on[] = "( cg.field_id={$field_id} AND CAST(cg.param as UNSIGNED)>='{$val}' )";
						break;

					default:
						$on[] = "( cg.field_id={$field_id} AND LCASE(cg.param)=LCASE('({$val}') )";
				}
				
			}
		}
		
		return $result . "(" . implode(' AND ', $on) . ")";
	
	}
	
    function goodsNum($cid) {
        $sql = 'SELECT `id` FROM `' . self::$table . '` WHERE `cid`=' . $cid . ' and `vis`';
        return @mysql_num_rows(self::$db->query($sql));
    }
    function goodsNewNum() {
        $sql = 'SELECT `id` FROM `' . self::$table . '` WHERE `vis` and `new`';
        return @mysql_num_rows(self::$db->query($sql));
    }

    function setLimit() {
        if (isset($_SESSION['LookAt'])) {
            $this->limit = $_SESSION['LookAt'];
        }
    }

    /**
     *   $this->goodId    ,     
     * @return boolean 
     */
    function editGood() {
        if (isset($_POST['stock'])){
            $stock = serialize($_POST['stock']);
        }
        if (isset($_POST['price'])){$_POST['price'] = preg_replace("/\D/","",$_POST['price']);}
        // if (isset($_POST['price_descript'])){$_POST['price_descript'] = preg_replace("/\D/","",$_POST['price_descript']);}
        
        //       -  ,   .
        if ($_POST['price'] <= $_POST['price_descript'])
            unset($_POST['not_fixed']);
        

         // var_dump($_POST['not_fixed_on'], $_POST['not_fixed']);die();
         if (isset($_POST['not_fixed_on'])){
            if (!isset($_POST['not_fixed1'])){ //     
                $_POST['not_fixed'] = 2;
            }else{
                $_POST['not_fixed'] = $_POST['not_fixed1'];
            }
         }else{
            $_POST['not_fixed'] = 0;
         }


        $update = array(
            'name' => (clearUserText($_POST['name'])),
            'content' => (clearUserText($_POST['content'])),
            'brand-id' => (clearUserText($_POST['brand-id'])),
            'pre_content' => (clearUserText($_POST['pre_content'])),
            'price' => (clearUserText($_POST['price'])),
            'column-show' => (isset($_POST['column-show']) ? 1 : 0),
            'not_fixed' => ($_POST['not_fixed']),
            'stock_data' => $stock,
            'rating'=>(int)$_POST['rating'],
            'new'=>isset($_POST['new'])&&$_POST['new']=='1'?1:0,
            'icon1'=>isset($_POST['icon1'])&&$_POST['icon1']=='1'?1:0,
            'icon2'=>isset($_POST['icon2'])&&$_POST['icon2']=='1'?1:0,
            'icon3'=>isset($_POST['icon3'])&&$_POST['icon3']=='1'?1:0,
            'icon4'=>isset($_POST['icon4'])&&$_POST['icon4']=='1'?1:0,
            'icon5'=>isset($_POST['icon5'])&&$_POST['icon5']=='1'?1:0,
            'icon6'=>isset($_POST['icon6'])&&$_POST['icon6']=='1'?1:0,
            'icon7'=>isset($_POST['icon7'])&&$_POST['icon7']=='1'?1:0,
            'icon8'=>isset($_POST['icon8'])&&$_POST['icon8']=='1'?1:0,
            'icon9'=>isset($_POST['icon9'])&&$_POST['icon9']=='1'?1:0,
            'price_descript'=>(clearUserText($_POST['price_descript'])),
            'grade' => (clearUserText($_POST['grade'])),
            'videos' => (clearUserText($_POST['videos']))
        );
        //  
        if (isset($_POST['show-main']) && $_POST['show-main'])
            $this->setMainGood();

        $uri = clearUri($_POST['uri']);
        $uriExists = $this->uriExists($uri);
        if (!$uriExists && $uri != '') $update['uri'] = $uri;
        if ($this->id) {
            self::$db->update(self::$table, $update, array('id' => $this->id));
            //  ,  
            if (isset($_REQUEST['rating'])){
                self::$db->update(
                    'rating',
                    array(
                        'total_votes' => $_REQUEST['rating']['total_votes'],
                        'total_value' => $_REQUEST['rating']['total_value']
                    ),
                    array(
                        'id' => 'good'.$this->id
                    )
                );
            }
        } elseif ($_POST['name']) {
            $ins = self::$db->insert(self::$table, array(
                        'vis' => 1,
                        'cid' => (int) $_POST['cid'],
                        'name' => (clearUserText($_POST['name']))
                    ));
            if ($ins) {
                self::$db->update(self::$table, array('uri' => mysql_insert_id(),'pos'=>mysql_insert_id()), array('id' => mysql_insert_id()));
            }
        }

        // :
        //
        if (isset($_POST['char'])) {
            $char = new character(self::$db);
            $char->saveCharacter($this->id, $_POST['char']);
        }
			
		if(!empty($_POST['same'])){
			$this->saveSame($_POST['same']);
		}
		
		if(!empty($_POST['rec'])){
			$this->saveRec($_POST['rec']);
		}
		
        // ()
        if ($_FILES['photo']['name'])
            $this->uploadImage();
        // 
        $subgallery = new subgallery(self::$db);
        $subgallery->preview_prefix = array('s','m');
        $subgallery->load_size_for_module('goods');
        if ($this->id)
            $subgallery->add($this->id, 'goods');
        else
            $subgallery->add(mysql_insert_id(), 'goods');

        $subfile = new subfile(self::$db);
        if ($this->id)
            $subfile->add($this->id,'goods');
        else
            $subfile->add(mysql_insert_id(),'goods');

        return true;
    }
	
	private function saveSame($data){
		if(!$this->id)
			return false;
	
		self::$db->query("DELETE FROM `catalog_same` WHERE good1={$this->id}");
		
		foreach($data as $id => $v){
			self::$db->query("INSERT INTO `catalog_same` (good1, good2) VALUES ({$this->id}, {$id}) ");
		}		
		
	}
	
	private function saveRec($data){
		if(!$this->id)
			return false;
	
		self::$db->query("DELETE FROM `catalog_rec` WHERE good1={$this->id}");
		
		foreach($data as $id => $v){
			self::$db->query("INSERT INTO `catalog_rec` (good1, good2) VALUES ({$this->id}, {$id}) ");
		}		
		
	}

    function setMainGood() {
        self::$db->update(self::$table, array('show-main' => 0), array('show-main' => 1));
        self::$db->update(self::$table, array('show-main' => 1), array('id' => $this->id));
    }

    static function getMainGood($db) {
        $item = $db->resultAsArray('SELECT * FROM `' . self::$table . '` WHERE `show-main`=1');
        if ($item)
            return array_shift($item);
        else
            return false;
    }

    // @param count=0 - infinite
    static function columnGood($db,$limit=3,$visible_only=true) {
        if ($limit){$limit = ' LIMIT '.$limit;}
        else{$limit='';}
        if ($visible_only){$visible_only = ' AND `vis`';}
        else{$visible_only='';}
        $item = $db->resultAsArray('SELECT * FROM `' . self::$table . '` WHERE `column-show`=1'.$visible_only.$limit);
        if ($item)
            return $item;
        else
            return false;
    }
    static function columnGood2($db) {

        $item = $db->resultAsArray('SELECT * FROM `' . self::$table . '` WHERE `in_cart`=1 ORDER BY RAND() LIMIT 4');
        if ($item)
            return $item;
        else
            return false;
    }
    
    // @param limit = 0 - infinite
    // @param cid   = 0 - infinite (from definite category only) 
    //  [ ]
    static function randomGoods($db,$limit=3,$cid=null) {
        if ($limit){$limit = ' LIMIT '.$limit;}
        else{$limit='';}
        if ($cid){$cid = 'AND `cid`="'.$cid.'"';}
        $item = $db->resultAsArray('SELECT * FROM `' . self::$table . '` WHERE `vis`="1" '.$cid.' ORDER BY RAND()'.$limit);
        if ($item)
            return $item;
        else
            return false;
    }

    static function sameGoods($db,$id,$limit=3,$cid=null,$price=2000) {
		return $db->resultAsArray("
			SELECT * FROM `catalog_same` s
			JOIN `".self::$table."` g ON s.good2=g.id
			WHERE s.good1={$id} AND g.vis=1 AND g.id!={$id}
			LIMIT {$limit}
		");
	
		////	////	////	////
	
        if ($limit){
            $limit = ' LIMIT '.$limit;
        }else{
            $limit='';
        }
        if ($cid){
            $cid = 'AND `cid`="'.$cid.'"';
        }
        if ($price){
            $max = $price+2000;
            $min = $price-2000;
            $price = 'AND `price`<="'.$max.'" AND `price`>="'.$min.'" ';
        }else{
            $price = '';
        }
        $item = $db->resultAsArray('SELECT * FROM `' . self::$table . '` WHERE `vis`="1" AND `id` <> '.$id.' '.$cid.' '.$price.' '.$limit);
		
		if(!$item)
			$item = $db->resultAsArray('SELECT * FROM `' . self::$table . '` WHERE `vis`="1" AND `id` <> '.$id.' '.$cid.' '.$limit);
		
        if ($item)
            return $item;
        else
            return false;
    }
    /**
     *
     *  
     * @param int $cid:   
     * @param array $array
     */
    static function lastGoods($db,$limit=3,$cid=null) {
        if ($limit){$limit = ' LIMIT '.$limit;}
        else{$limit='';}
        if ($cid){$cid = 'AND `cid`="'.$cid.'"';}
        $item = $db->resultAsArray('SELECT * FROM `' . self::$table . '` WHERE `vis`="1" '.$cid.' ORDER BY `price` ASC, `id` DESC'.$limit);
        if ($item)
            return $item;
        else
            return false;
    }    

    /**
     *
     *     
     * @param array $array
     */
    function chpos() {
        $array = $_POST['change'];
        foreach ($array as $key=>$v) {
            $update = array(
                'name' => $v['name'],
                'pos' => $v['pos']
                );
            self::$db->update(self::$table,$update,array('id'=>$key));

//self::$db->query('UPDATE `' . self::$table . '` SET `pos`=' . (int) $v . ' WHERE `id`=' . $k);
        }
        return true;
    }

    /**
     *
     *  
     * @param int $id
     */
    function delete() {
        //TODO   
        if ($this->id)
            return self::$db->query('DELETE FROM `' . self::$table . '` WHERE `id`=' . $this->id);
    }

    /**
     *
     * /
     * @param int $id
     */
    function chvis() {
        if ($this->id) {
            return self::$db->query('UPDATE `' . self::$table . '` SET `vis`=IF(`vis`,0,1) WHERE `id`=' . $this->id);
        }
    }

    /*
     *     .
     */

    static function getImage($id) {
        $sql = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`=' . $id;
        $o = @array_pop(self::$db->resultAsArray($sql));
        if ($o)
            return $o['image'];
    }

    function deleteImage() {
        if (!$this->id)
            return false;
        $sql = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`=' . ($this->id);
        $img = @array_pop(self::$db->resultAsArray($sql));
        if (isset($img['image']))
            $img = $img['image'];
        @unlink(SR . self::$uploadFolder . $img);
        @unlink(SR . self::$uploadFolder . self::$popPrefix . $img);
        return self::$db->query('UPDATE `' . self::$table . '` SET `image`="" WHERE `id`=' . $this->id);
    }

    function uploadImage() {
        if (!$this->id)
            return false;
        $sql = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`=' . ($this->id);
        $img = @array_pop(self::$db->resultAsArray($sql));
        $img = stripslashes($img['image']);
        @unlink(SR . '/' . self::$uploadFolder . $img);
        @unlink(SR . '/' . self::$uploadFolder . self::$popPrefix . $img);
        $name = get_name_to_file();
        $ext = $_FILES['photo']['name'];
        $ext = explode('.', $ext);
        $ext = array_pop($ext);
        //$name.='.' . $ext;
        $resize = new upload($_FILES['photo']['tmp_name']);
        if ($resize->uploaded) {
            $type = $_FILES['photo']['type'];
            $type = explode('/', $type);
            if ($type[0] != 'image') {
                continue;
            }
            $resize->file_new_name_body = $name;
            $resize->file_new_name_ext = $ext;
            $resize->process(SR . self::$uploadFolder);
            
            if ($ext == 'gif'){
                $resize->image_resize = false;
            }else{
                $resize->image_resize = true;
            }

            $resize->image_resize = true;
            $imgsize = @getimagesize(SR . self::$uploadFolder . $name . '.' . $ext);
            $resize->file_new_name_body = self::$popPrefix . $name;
            $resize->file_new_name_ext = $ext;

            if (self::$popCHeight > 0 && self::$popCWidth > 0) {
                $resize->image_x = self::$popCWidth;
                $resize->image_y = self::$popCHeight;
                $resize->image_ratio_fill = true;
            } elseif (self::$popCWidth > 0 && !self::$popCHeight) {
                $resize->image_x = self::$popCWidth;
                $resize->image_ratio_y = true;
            } elseif (self::$popCHeight > 0 && !self::$popCWidth) {
                $resize->image_y = self::$popCHeight;
                $resize->image_ratio_x = true;
            }
            $resize->file_overwrite = true;
            $resize->process(SR . self::$uploadFolder);
            
            //  
            $imgsize = @getimagesize(SR . self::$uploadFolder . $name . '.' . $ext);
            $resize->file_new_name_body = self::$lidPrefix . $name;
            $resize->file_new_name_ext = $ext;
            if (self::$lidCHeight > 0 && self::$lidCWidth > 0) {
                $resize->image_x = self::$lidCWidth;
                $resize->image_y = self::$lidCHeight;
                $resize->image_ratio_fill = true;
            } elseif (self::$lidCWidth > 0 && !self::$lidCHeight) {
                $resize->image_x = self::$lidCWidth;
                $resize->image_ratio_y = true;
            } elseif (self::$lidCHeight > 0 && !self::$lidCWidth) {
                $resize->image_y = self::$lidCHeight;
                $resize->image_ratio_x = true;
            }
            $resize->file_overwrite = true;
            $resize->process(SR . self::$uploadFolder);

            //  
            $resize->image_resize = true;
            $resize->image_ratio_crop = 'L';
            $imgsize = @getimagesize(SR . self::$uploadFolder . $name . '.' . $ext);
            $resize->file_new_name_body = self::$cidPrefix . $name;
            $resize->file_new_name_ext = $ext;

            if (self::$cidCHeight > 0 && self::$cidCWidth > 0) {
                $resize->image_x = self::$cidCWidth;
                $resize->image_y = self::$cidCHeight;
                $resize->image_ratio_fill = true;
            } elseif (self::$cidCWidth > 0 && !self::$cidCHeight) {
                $resize->image_x = self::$cidCWidth;
                $resize->image_ratio_y = true;
            } elseif (self::$cidCHeight > 0 && !self::$cidCWidth) {
                $resize->image_y = self::$cidCHeight;
                $resize->image_ratio_x = true;
            }
            $resize->file_overwrite = true;
            $resize->process(SR . self::$uploadFolder);
            

            if ($resize->error)
                echo $resize->error;
            return self::$db->query('UPDATE `' . self::$table . '` SET `image`="' . mysql_real_escape_string($name) . '.' . $ext . '" WHERE `id`=' . $this->id);
        }
    }

    static function getNameById($id) {
        $sql = 'SELECT `name` FROM `' . self::$table . '` WHERE `id`=' . $id;
        $res = self::$db->resultAsArray($sql);
        if ($res) {
            $name = array_pop($res);
            return $name['name'];
        }
    }

    // 
    static function getAllGood() {
        $sql = 'SELECT `id`,`name`,`cid` FROM `' . self::$table . '` ORDER BY `price` ASC , `name`';
        return self::$db->resultAsArray($sql);
    }

    function uriExists($uri) {
        $q = 'SELECT `uri` FROM `' . self::$table . '` WHERE `uri`="' . $uri . '"';
        $r = mysql_query($q);
        return @mysql_result($r, 0, 0) ? true : false;
    }

    static function getIdByUri($uri) {
        $q = 'SELECT `id` FROM `' . self::$table . '` WHERE `uri`="' . $uri . '"';
        $r = mysql_query($q);
        if ($r)
            return @mysql_result($r, 0, 0);
    }

    static function getParent($id){
        $q = 'SELECT `cid` FROM `' . self::$table . '` WHERE `id`="' . $id . '"';
        $r = mysql_query($q);
        if ($r)
            return @mysql_result($r, 0, 0);   
    }

    static function getUriById($id) {
        $q = 'SELECT `uri` FROM `' . self::$table . '` WHERE `id`="' . $id . '"';
        $r = mysql_query($q);
        if ($r)
            return @mysql_result($r, 0, 0);
    }

    static function getCover($id) {
        $q = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`="' . $id . '"';
        $r = mysql_query($q);
        if ($r)
            return @mysql_result($r, 0, 0);
    }

    static function search($text) {
        $text = trim(stripslashes(strip_tags($text)));
        $text = explode(' ', $text);
        $or = array();
        $fields = array('name', 'content', 'pre_content');
        foreach ($text as $sr) {
            foreach ($fields as $v) {
                $or[] = '`' . $v . '` LIKE \'%' . $sr . '%\'';
            }
        }
        $or = implode(' OR ', $or);
        $sql = 'SELECT * FROM `' . self::$table . '` WHERE (' . $or . ')';
        return self::$db->resultAsArray($sql);
    }

    function checkVisible($id) {
        return self::$db->getOne(self::$table, 'vis', array('id' => $id));
    }
    /**
     * 
     * 
     */
    function getListGood($where='',$limit=4){
        return self::$db->query('SELECT * FROM :table '.($where ? 'WHERE '.$where: '').' ORDER BY RAND() LIMIT 4',array('table'=>db_name(self::$table)),db::FETCH_ALL);
    }


    function ajax_form_move() {
        load_lib('admin');
        $this->id = $_REQUEST['id'];
        $catalog = new catalog(self::$db);
        $tree = $catalog->get_tree(array($this->id));
        echo meno_show_move_tree(
                $tree, 
                meno_build_go(array('do' => 'move', 'id' => $this->id,'obj'=>'goods'), null, 'catalog'), 
                false,
                'cid');
    }
    function ajax_form_leaders() {
        load_lib('admin');
        $this->id = $_REQUEST['id'];
        $catalog = new catalog(self::$db);
        if (!$this->data)$this->load();
        $tree = $catalog->get_tree(array($this->id),$this->data);

        echo meno_show_leaders_tree(
                $tree, 
                meno_build_go(array('do' => 'update_leaders', 'id' => $this->id,'obj'=>'goods'), null, 'catalog'), 
                true,
                false);
    }

    function move($to = null){
        $this->id = $_REQUEST['id'];
        if ($to === null)
            //$to = (int) $_REQUEST['cid'];
            $to = (int) $_REQUEST['pid'];
        else
            $to = (int) $to;
        $q = 'UPDATE `' . self::$table . '` SET `cid`=' . $to . ' WHERE `id`=' . $this->id;
        self::$db->query($q);
        return true;
    }

    function mass_action(){
        // var_dump($_REQUEST['item']);die();
        switch($_REQUEST['action']){

            case 'hide':
                if (is_array($_REQUEST['item'])){
                    foreach($_REQUEST['item'] as $item_id=>$item){
                        self::$db->update(
                            self::$table,
                            array('vis'=>0),
                            array('id'=>$item_id)
                            );
                    }
                }
            break;
            case 'show':
                if (is_array($_REQUEST['item'])){
                    foreach($_REQUEST['item'] as $item_id=>$item){
                        self::$db->update(
                            self::$table,
                            array('vis'=>1),
                            array('id'=>$item_id)
                            );
                    }   
                }
            break;
            case 'delete':
                if (is_array($_REQUEST['item'])){
                    foreach($_REQUEST['item'] as $item_id=>$item){
                        self::$db->delete(
                            self::$table,
                            array('id'=>$item_id)
                            );
                    }
                }
            case 'move':
                if (is_array($_REQUEST['item']) && $_REQUEST['catalog_id']){
                    foreach($_REQUEST['item'] as $item_id=>$item){
                        self::$db->update(
                            self::$table,
                            array('cid'=>$_REQUEST['catalog_id']),
                            array('id'=>$item_id)
                            );
                    }
                }
            break;  
        }
    }
        function showGoodChars($chars,$item){
    // .  
        $char_id = $chars->getCharId($item['cid']);
        $characters = $chars->getCharacter($item['id'], $char_id);  
        //$characters = array_reverse($characters);
        if($characters && !empty($characters)): 
            $params = '';
            foreach($characters as $char){
                if($char['param']){
                    $params.= '<div>'.(
                        $char['name'] == '' ? '<b>'.$char['param'].'</b>' : 
                        ($char['name'] == '' ? '<div>.: '.$char['param']."</div>" : 
                        ($char['name'] == '' ? '<div>'.$char['param']." - </div>" : 
                        ($char['name'] == ' (-)' ? '<div style="padding-top:5px;"><div> :</div>'.$char['param']."</div>" : 
                        
                        $char['param'])))
                    ).'</div>';
                }
            } 
        if ($params){ 
            echo $params;
        }else{  
            echo $item['pre_content'];
        }
        endif;
    }

    /*
      
    @param array ID 
    */
    function update_leaders(){
        if (empty($_POST))return false;
        
        $in='(';
        foreach($_POST as $key => $value){
            $in.=$key.',';
        }
        $in = substr($in, 0,strlen($in)-1).')';
        $q = 'UPDATE `'.self::$table.'` SET `column-show` = CASE WHEN `id` IN '.$in.' THEN 1 ELSE 0 END';
        // $q = 'UPDATE `'.self::$table.'` SET `column-show`=1 WHERE `id` IN '.$in.', SET `column-show`=0 WHERE `id` NOT IN '.$in;
        mysql_query($q);
    }

    function loadByYml($itms = false) {
        if(!$itms) return false;
        $items = array();
        foreach ($itms as $value) {
            $items[] = "'".$value."'";
        }
        $this->data = array();
        $this->current = array();
        $q = 'SELECT `a`.`id`,`a`.`cid`,`a`.`vis`,`a`.`pos`,`a`.`name`,`a`.`price`,`b`.`isseo`,`a`.`t_kod`, `a`.`content`, `a`.`pre_content`, `a`.`image`  FROM `' . self::$table .
                '` as `a` LEFT JOIN (SELECT `object_id`,1 as `isseo` FROM `' . seo::$table_name .
                '` WHERE `module`="catalog" AND `object_type`="good") as `b` ON `a`.`id`=`b`.`object_id` 
                WHERE `a`.`id` IN ('.implode(',', $items).')
                ORDER BY `a`.`price` ASC , `a`.`pos` DESC, `a`.`id`';
        // var_dump($q); die();
        $r = self::$db->query($q);
        while ($row = mysql_fetch_assoc($r)) {
            $this->data[$row['id']] = $row;
        }
        if ($this->id) {
            $q = 'SELECT * FROM `' . self::$table . '` WHERE `id`=' . $this->id;
            $r = self::$db->query($q);
            if ($row = mysql_fetch_assoc($r)){
                $this->current = $row;
                if ($_GET['test_load']) var_dump("<h1>row(current):</h1><pre>",$row,"</pre>");
            }
        }
    }

        /**
     *     
     * @param array $filter
     */
    function setFilter($filter = array()){
        $_filter = array();
        if (isset($filter['brand']) && $filter['brand'] && $filter['brand']!='all'){
            $_filter[] = '`brand-id`='.$filter['brand'];
        }
        if (isset($filter['sex']) && $filter['sex'] && $filter['sex']!='all'){
            $_filter[] = '`sex`="'.$filter['sex'].'"';
        }
        if (preg_match('/catalog\\/new\\/$/',$_SERVER['REQUEST_URI'])){
            $_filter[] = '`new`="'.(int)$filter['new'].'"';
        }
        //. 
        if ($filter['price_from']  && $filter['price_to']){
            //  ,   
            //         
            $_filter[]='
            IF( `not_fixed`, `price_descript`
            BETWEEN "'.$filter['price_from'].'" AND "'.$filter['price_to'].'" , 
                `price`
            BETWEEN "'.$filter['price_from'].'" AND "'.$filter['price_to'].'")';
        }
        if ($filter['price_from'] && !$filter['price_to']){
            $_filter[]='
            IF( `not_fixed`,
            `price_descript`>="'.$filter['price_from'].'",
            `price`>="'.$filter['price_from'].'"
            )';
        }
        if ($filter['price_to'] && !$filter['price_from']){
            $_filter[]='
            IF( `not_fixed`,
            `price_descript`<="'.$filter['price_to'].'",
            `price`<="'.$filter['price_to'].'"
            )';
        }
		
        if (!empty($_filter))
            $this->filter = $_filter;
    }

    /**
     *     
     * @param array $sort
     */
    function setSort($sort = array()){
        $_sort  = '';
        $_ask    = $sort['order'] == 'DESC' ? ' DESC' : ' ASC';
        switch ($sort['by']){
            case 'price':
                $_sort = 'ORDER BY IF (`not_fixed`, `price_descript`, `price`)'.$_ask;
             break;
            //          
            case 'pos':
                // $_sort = '`'.$sort['by'].'`';
                $_sort = 'ORDER BY `stock_data`'.$_ask.',`pos`'.$_ask;
                // $_sort .= ' GROUP BY `name`';
            break;
            case 'name':
                $_sort = 'ORDER BY `'.$sort['by'].'`'.$_ask;
            break;
            case 'rating':
                $_sort = 'ORDER BY `'.$sort['by'].'`'.$_ask;
            break;
        }
        $this->sort = $_sort;
    }

	
	public static function getSameById($id){		
		return self::$db->resultAsArray("
					SELECT g.id, g.name, g.image, CONCAT_WS('/','catalog', c.uri, g.uri) as `href` FROM `catalog_same` s 
					JOIN `".self::$table."` g ON g.id=s.good2
					JOIN `".catalog::$table."` c ON g.cid=c.id
					WHERE s.good1={$id} AND g.vis=1
				");
	}
	
	public function getSameIdsAsArray($id){
		$result = self::$db->resultAsArray("
			SELECT good1, GROUP_CONCAT(good2 separator ',') as `g2` FROM `catalog_same`
			WHERE good1={$id}
			GROUP BY good1			
		");
		
		if(!empty($result[0]['g2']))
			return explode(',',$result[0]['g2']);
		else
			return array();
	}
	
	public static function getRecById($id){
                $result = array();
		$qres =  self::$db->resultAsArray("
					SELECT g.id, g.name, g.image, CONCAT_WS('/','catalog', c.uri, g.uri) as `href`, g.image, g.price FROM `catalog_rec` s 
					JOIN `".self::$table."` g ON g.id=s.good2
					JOIN `".catalog::$table."` c ON g.cid=c.id
					WHERE s.good1={$id} AND g.vis=1
				");
                         
                if( $qres )
                    foreach ( $qres as &$v )
                        $result[$v['id']] = $v;
                    
                
                return $result;     
	}
	
	public function getRecIdsAsArray($id){
		$result = self::$db->resultAsArray("
			SELECT good1, GROUP_CONCAT(good2 separator ',') as `g2` FROM `catalog_rec`
			WHERE good1={$id}
			GROUP BY good1			
		");
		
		if(!empty($result[0]['g2']))
			return explode(',',$result[0]['g2']);
		else
			return array();
	}
	
}

?>