<?php

class infofiles {

    public static $table_name = 'infofiles';
    private $db;
    public $data;
    public static $path = 'content/user_files/infofiles/';
    public static $fileVarName = 'file';
    public static $allowedExts = array('zip', 'rar', 'tar', 'gz', 'txt', 'xls', 'xlsx', 'doc', 'docx', 'odt', 'pdf', 'ods', 'rtf');
    public $id = null;

    function __construct($db, $id = null) {

        $this->db = $db;
        if ($id === null) {
            if (isset($_REQUEST['id']))
                $this->id = (int) $_REQUEST['id'];
        }else
            $this->id = (int) $id;
    }

    function setPath($path) {
        self::$path = $path;
    }

    function getPath() {
        return self::$path;
    }

    function setFileVarName($var) {
        self::$fileVarName = $var;
    }

    function count($vis=true) {
        $where = array();
        if ($vis == true)
            $where[] = '`visible`=1';
        if ($where)
            $where = ' WHERE ' . implode(', ', $where);
        else
            $where = '';
        $q = 'SELECT COUNT(1) FROM `' . self::$table_name . '` ' . $where;
        $r = $this->db->query($q);
        if ($r)
            return mysql_result($r, 0, 0);
    }

    function loadByPages($page=1, $hidden = false, $countByPages = 10) {
        if ($hidden)
            $where = '`visible` = 1';
        else
            $where = '';
        $q = 'SELECT * FROM `' . self::$table_name . '` ' . $where . ' ORDER BY `name`, `id` DESC  LIMIT ' . (($page - 1) * $countByPages) . ',' . $countByPages . '';
        $r = $this->db->query($q);
        while ($row = mysql_fetch_assoc($r)) {
            $this->data[$row['id']] = $row;
        }
        return $this->data;
    }

    function load($id = null) {
        if ($id === null && $this->id === null) {
            $q = 'SELECT * FROM `' . self::$table_name . '`
            	 ORDER BY `name`';
            $r = $this->db->query($q);
            while ($row = mysql_fetch_assoc($r)) {
                $this->data[$row['id']] = $row;
            }
            return $this->data;
        } else {
            if ($id !== null)
                $this->id = (int) $id;
            $q = 'SELECT * FROM `' . self::$table_name . '`
            	 WHERE `id`=' . $this->id;
            $r = $this->db->query($q);
            $this->data[$this->id] = mysql_fetch_assoc($r);
            if ($this->data[$this->id])
                return $this->data[$this->id];
            else
                return false;
        }
    }

    function create() {
        $f = $this->uploadFile();
        if (!$f)
            return false;
        $name = $_POST['name'] ? $_POST['name'] : $f['name'];
        $q = 'INSERT INTO `' . self::$table_name . '` (`name`,`file`,`size`,`ext`)
			 VALUES ("' . mysql_real_escape_string(clearUserText($name)) . '"
			 		,"' . mysql_real_escape_string($f['newname'] . '.' . $f['ext']) . '"
			 		,"' . mysql_real_escape_string($f['size']) . '"
			 		,"' . mysql_real_escape_string($f['ext']) . '")';
        $r = $this->db->query($q);
        $this->id = $this->db->get_id();
        return $this->id;
    }

    function update($array = null) {
        if (!$this->id)
            return false;
        if (!empty($_FILES[self::$fileVarName])) {
            $this->deleteFile();
        }
        $file = $this->uploadFile();
        $this->load();
        if ($array === null) {
            if (get_magic_quotes_gpc())
                $array = array_map('stripslashes', $_REQUEST);
            else
                $array = $_REQUEST;
        }
        $q = 'UPDATE `' . self::$table_name . '` SET `name`="' . mysql_real_escape_string(strip_tags($array['name'])) .
                '"
			' . ($file ? ', `file`="' . $file['newname'] . '.' . $file['ext'] . '",`ext`="' . $file['ext'] . '", `size`="' . $file['size'] . '"' : '') . '
             WHERE `id`=' . $this->id;
        $this->db->query($q);
    }

    function uploadFile() {
        $r = array();
        if (empty($_FILES[self::$fileVarName]))
            return false;
        $f = $_FILES[self::$fileVarName];
        $path_info = pathinfo($f['name']);
        $ext = isset($path_info['extension']) ? $path_info['extension'] : '';
        $r['ext'] = $ext;
        if (!in_array($ext, self::$allowedExts))
            return false;
        $r['name'] = $path_info['filename'];
        $r['size'] = $f['size'];
        $newname = get_name_to_file();
        $r['newname'] = $newname;
        if (move_uploaded_file($f['tmp_name'], SR . self::$path . $newname . '.' . $ext))
            return $r;
        else
            return false;
    }

    function deleteFile() {
        if (!$this->id)
            return false;
        $a = $this->load();
        if (is_file(SR . self::$path . $a['file']))
            unlink(SR . self::$path . $a['file']);
    }

    function show() {
        $q = 'UPDATE `' . self::$table_name . '` SET `visible`=1 WHERE `id`=' . $this->id;
        $this->db->query($q);
    }

    function hide() {
        $q = 'UPDATE `' . self::$table_name . '` SET `visible`=0 WHERE `id`=' . $this->id;
        $this->db->query($q);
    }

    function delete() {
        if (!$this->id)
            return false;
        $this->deleteFile();
        $q = 'DELETE FROM `' . self::$table_name . '` WHERE `id`=' . $this->id;
        $this->db->query($q);
        return true;
    }

    public function getFile($id) {
        $q = 'SELECT * FROM ' . self::$table_name . ' WHERE id="' . (int) $id . '"';
        $r = $this->db->query($q);
        if ($r)
            $file = mysql_fetch_assoc($r);
        if (is_file(SR . self::$path . $file['file'])) {
            header('Content-type: application/otherType');
            header('Content-Disposition: attachment; filename="' . $file['name'] . '.' . $file['ext'] . '"');
            echo file_get_contents(SR . self::$path . $file['file']);
        }
    }

}

?>