<?php

/**
 *
 *  Sergey:   -        )))   ,  :D
 *          ..
 *
 *       ,     
 *
 **/

class personal extends Module{
    
    public static $table_name = 'personal';
    public static $office_table_name = 'personal_office';
    public static $questions_table_name = 'personal_questions';
    public static $photo_height = 130;
    public static $photo_width = 130;
    public static $imgPrefix = 's_';
    public $persona_id = null;
    public $office_id = null;
    public $persona = null;
    public $office = null;
    public $path = null;

    function __construct($office_id = null,$persona_id = null){
        parent::__construct();
        $this->path = 'content/images/';

        if($office_id) $this->office_id = (int)$office_id;
        else{
            if(isset($_REQUEST['office_id'])) $this->office_id = (int)$_REQUEST['office_id'];
        }
        if($persona_id) $this->persona_id = (int)$persona_id;
        else{
            if(isset($_REQUEST['persona_id'])) $this->persona_id = (int)$_REQUEST['persona_id'];
        }
        if($this->office_id){
            $row = $this->db->query('SELECT * FROM :office_table WHERE `id`=:id',
            array('office_table'=>new db_name(self::$office_table_name),'id'=>$this->office_id ),db::FETCH_ROW);
            /*$r = mysql_query('SELECT * FROM `'.self::$office_table_name.'` WHERE `id`='.$this->office_id, db::FETCH_ROW);*/
            if($row){
                $this->office = (object)$row;
            }
        }
        if($this->persona_id){
            $this->load_persona($this->persona_id);
        }

    }

    public function load($id = null) {}
    function getPath(){
        return $this->path;
    }
    public function loadAllWorkers($officeId) {
        $workers = array();
        $q = 'SELECT p.*
              FROM `'.self::$table_name.'` as `p`
              LEFT JOIN `'.self::$office_table_name.'` as `o` ON `p`.`pid` = `o`.`id`
              WHERE `p`.`visible` = 1 AND `o`.`visible` = 1 AND `p`.`pid` = '.intval($officeId).'
              ORDER BY `p`.`sort` DESC';
        $r = mysql_query($q);

        while($a = mysql_fetch_assoc($r)){
            $workers[$a['id']] = $a;
        }
        return $workers;
    }

    function load_persona($id){
        $r = mysql_query('SELECT * FROM `'.self::$table_name.'` WHERE `id`='.$id);
        $row = mysql_fetch_assoc($r);
        if($row){
            $this->persona = (object)$row;
        }
    }

    function create_office($name = null,$sort = null){
        if($name===null)$name = (string)$_REQUEST['name'];
        else $name = (string)$name;
        if($sort===null)$sort = (int)$_REQUEST['sort'];
        else $sort = (int)$sort;
        $name = mysql_real_escape_string($name);
        $q = 'INSERT INTO `'.self::$office_table_name.'` (`name`,`sort`) VALUES ("'.$name.'",'.$sort.')';
        $r = mysql_query($q);
        $id = mysql_insert_id();
        if($id) return $id;
        return false;
    }

    function create_persona($name = null,$sort = null){
         
        if($name===null)$name = (string)$_REQUEST['name'];
        else $name = (string)$name;
        if($sort===null)$sort = (int)$_REQUEST['sort'];
        else $sort = (int)$sort;
        $name = mysql_real_escape_string($name);
        $q = 'INSERT INTO `'.self::$table_name.'` (`pid`,`name`,`sort`) VALUES ('.$this->office_id.',"'.$name.'",'.$sort.')';
        $r = mysql_query($q);
        $id = mysql_insert_id();
        if($id) return $id;
        return false;
    }

    function update_office($array = null){
        $path = SR . $this->path;
        if($array === null) $array = array_map('stripslashes',$_REQUEST);
        $q = 'UPDATE `'.self::$office_table_name.'` SET `name`="'.mysql_real_escape_string($array['name']).'",
        	  `description`="'.mysql_real_escape_string($array['description']).'",
        	  `sort`='.(int)$array['sort'].',
        	  `visible`='.(int)(isset($array['visible'])?$array['visible']:0).'
        	  WHERE `id`='.$this->office_id;
        mysql_query($q);
        if(isset($_POST['delphoto'])&&$this->office->photo){
            @unlink($path.$this->office->photo);
            @unlink($path.'s_'.$this->office->photo);
            $q = 'UPDATE `'.self::$office_table_name.'` SET `photo`="" WHERE `id`='.$this->office_id;
            mysql_query($q);
        }elseif(is_uploaded_file($_FILES['photo']['tmp_name'])){
            $name = $_FILES['photo']['name'];
            $name = explode('.',$name);
            $ext = array_pop($name);
            $name = implode('.',$name);
            $type = $_FILES['photo']['type'];
            $type = explode('/',$type);
            if(strtolower($type[0])=='image'){
                if($this->office->photo){
                    @unlink($path.$this->office->photo);
                    @unlink($path.'s_'.$this->office->photo);
                }
                move_uploaded_file($_FILES['photo']['tmp_name'],$path.'office_'.$this->office_id.'.'.$ext);
                MakeTrumbal($path.'office_'.$this->office_id.'.'.$ext,$path.'s_office_'.$this->office_id.'.'.$ext,self::$photo_width,self::$photo_height);
                $q = 'UPDATE `'.self::$office_table_name.'` SET `photo`="'.'office_'.$this->office_id.'.'.$ext.'" WHERE `id`='.$this->office_id;
                mysql_query($q);
            }
        }
    }

    function update_persona($array = null){
        $path = SR . $this->path;
        if($array === null) $array = array_map('stripslashes',$_REQUEST);
        $q = 'UPDATE `'.self::$table_name.'` SET 
              `name`="'.mysql_real_escape_string($array['name']).'",
        	  `email`="'.mysql_real_escape_string($array['email']).'",
              `description`="'.mysql_real_escape_string($array['description']).'",
              `short_description`="'.mysql_real_escape_string($array['short_description']).'",
        	  `pid`='.(int)$array['pid'].',
        	  `sort`='.(int)$array['sort'].',
        	  `visible`='.(int)(isset($array['visible'])?$array['visible']:0).'
        	  WHERE `id`='.$this->persona_id;
        $subgallery = new subgallery($this->db);
        $subgallery->add($this->persona_id,'persona');
//        subgallery::add($this->persona_id,'persona',2);

        mysql_query($q);
        if(isset($_POST['delphoto'])&&$this->persona->photo){
            @unlink($path.$this->persona->photo);
            @unlink($path.'s_'.$this->persona->photo);
            $q = 'UPDATE `'.self::$table_name.'` SET `photo`="" WHERE `id`='.$this->persona_id;
            mysql_query($q);
        }elseif(is_uploaded_file($_FILES['photo']['tmp_name'])){
            $name = $_FILES['photo']['name'];
            $name = explode('.',$name);
            $ext = array_pop($name);
            $name = implode('.',$name);
            $type = $_FILES['photo']['type'];
            $type = explode('/',$type);
            if(strtolower($type[0])=='image'){
                if($this->persona->photo){
                    @unlink($path.$this->persona->photo);
                    @unlink($path.'s_'.$this->persona->photo);
                }
                move_uploaded_file($_FILES['photo']['tmp_name'],$path.'persona_'.$this->persona_id.'.'.$ext);
                MakeTrumbal($path.'persona_'.$this->persona_id.'.'.$ext,$path.'s_persona_'.$this->persona_id.'.'.$ext,self::$photo_width,self::$photo_height);
                $q = 'UPDATE `'.self::$table_name.'` SET `photo`="'.'persona_'.$this->persona_id.'.'.$ext.'" WHERE `id`='.$this->persona_id;
                mysql_query($q);
            }
        }
    }



    function persona_add_photo($array = null){
//        $path = $this->path;
//        if($array === null) $array = array_map('stripslashes',$_REQUEST);
//        $q = 'UPDATE `'.self::$table_name.'` SET `name`="'.mysql_real_escape_string($array['name']).'",
//        	  `description`="'.mysql_real_escape_string($array['description']).'",
//        	  `pid`='.(int)$array['pid'].',
//        	  `sort`='.(int)$array['sort'].',
//        	  `visible`='.(int)(isset($array['visible'])?$array['visible']:0).'
//        	  WHERE `id`='.$this->persona_id;
//        subgallery::$height = 0;

        subgallery::add($this->persona_id,'persona_photo');
//        subgallery::add($this->persona_id,'persona',2);

//        mysql_query($q);
//        if(isset($_POST['delphoto'])&&$this->persona->photo){
//            @unlink($path.$this->persona->photo);
//            @unlink($path.'s_'.$this->persona->photo);
//            $q = 'UPDATE `'.self::$table_name.'` SET `photo`="" WHERE `id`='.$this->persona_id;
//            mysql_query($q);
//        }elseif(is_uploaded_file($_FILES['photo']['tmp_name'])){
//            $name = $_FILES['photo']['name'];
//            $name = explode('.',$name);
//            $ext = array_pop($name);
//            $name = implode('.',$name);
//            $type = $_FILES['photo']['type'];
//            $type = explode('/',$type);
//            if(strtolower($type[0])=='image'){
//                if($this->persona->photo){
//                    @unlink($path.$this->persona->photo);
//                    @unlink($path.'s_'.$this->persona->photo);
//                }
//                move_uploaded_file($_FILES['photo']['tmp_name'],$path.'persona_'.$this->persona_id.'.'.$ext);
//                MakeTrumbal($path.'persona_'.$this->persona_id.'.'.$ext,$path.'s_persona_'.$this->persona_id.'.'.$ext,self::$photo_width,self::$photo_height);
//                $q = 'UPDATE `'.self::$table_name.'` SET `photo`="'.'persona_'.$this->persona_id.'.'.$ext.'" WHERE `id`='.$this->persona_id;
//                mysql_query($q);
//            }
//        }
    }




    function show_office(){
        $q = 'UPDATE `'.self::$office_table_name.'` SET `visible`=1 WHERE `id`='.$this->office_id;
        mysql_query($q);
    }

    function show_persona(){
        $q = 'UPDATE `'.self::$table_name.'` SET `visible`=1 WHERE `id`='.$this->persona_id;
        mysql_query($q);
    }

    function hide_office(){
        $q = 'UPDATE `'.self::$office_table_name.'` SET `visible`=0 WHERE `id`='.$this->office_id;
        mysql_query($q);
    }

    function hide_persona(){
        $q = 'UPDATE `'.self::$table_name.'` SET `visible`=0 WHERE `id`='.$this->persona_id;
        mysql_query($q);
    }
    function delete_office(){
        if($this->office->photo){
            @unlink(SR . $this->path.$this->office->photo);
            @unlink(SR . $this->path.'s_'.$this->office->photo);
        }
        $r = mysql_query('SELECT `id` FROM `'.self::$table_name.'` WHERE `pid`='.$this->office_id);
        while($i = mysql_fetch_assoc($r)){
            $this->load_persona($i['id']);
            $this->delete_persona();        
        }
        $q = 'DELETE FROM `'.self::$office_table_name.'` WHERE `id`='.$this->office_id;
        mysql_query($q);
    }

    function delete_persona(){
        if($this->persona->photo){
            @unlink(SR . $this->path.$this->persona->photo);
            @unlink(SR . $this->path.'s_'.$this->persona->photo);
        }
        //$this->db->delete(self::$table_name,array('id'=>$this->persona->id))
        $q = 'DELETE FROM `'.self::$table_name.'` WHERE `id`='.$this->persona->id;
        mysql_query($q);
        $subgallery = new subgallery($this->db);
        $subgallery->clear_object($this->persona->id,'persona');
    }

    static function get_all_office(){
        $q = 'SELECT `id`,`name`,`visible`,`photo`,`sort`,`description` FROM `'.self::$office_table_name.'` ORDER BY `sort` DESC';
        $r = mysql_query($q);
        $o = array();
        while($a = mysql_fetch_assoc($r)){
            $o[$a['id']] = $a;
        }
        return $o;
    }

    static function get_office_on_id($id){
        $id = (int)$id;
        $q = 'SELECT * FROM `'.self::$office_table_name.'` WHERE `id`='.$id;
        $r = mysql_query($q);
        $o = mysql_fetch_assoc($r);
        if(!$o) return false;
        $o['personal']=array();
        $q = 'SELECT `id`,`name`,`visible`,`sort` FROM `'.self::$table_name.'` WHERE `pid`='.$id.' ORDER BY `sort` DESC';
        $r = mysql_query($q);
        while($a = mysql_fetch_assoc($r)){
            $o['personal'][$a['id']] = $a;
        }
        return $o;
    }

    static function get_persona_on_id($id){
        $id = (int)$id;
        $q = 'SELECT * FROM `'.self::$table_name.'` WHERE `id`='.$id;
        $r = mysql_query($q);
        $o = mysql_fetch_assoc($r);
        if($o) return $o;
        return false;
    }

    function get_random_personal($limit=3){
        $id = (int)$id;
        $q = 'SELECT * FROM `'.self::$table_name.'` ORDER BY `id` DESC LIMIT '.$limit;
        $r = mysql_query($q);
        $o = array();
        while($a = mysql_fetch_assoc($r)){
            $o[$a['id']] = $a;
        }
        return $o;   
    }
}
?>