<?php

class polls {

    public static $table_name = 'polls';
    private $db;
    public $data;
    public $current;
    public $id = null;

    public function __construct($db, $id = null) {
        $this->db = $db;
        if ($id === null) {
            if (isset($_REQUEST['id']))
                $this->id = (int) $_REQUEST['id'];
        } else
            $this->id = (int) $id;
    }

    public function load($id = null) {
        if ($id === null && $this->id === null) {
            $q = 'SELECT * FROM `' . self::$table_name .
                    '` ORDER BY `id` DESC';
            $r = $this->db->query($q);
            while ($row = mysql_fetch_assoc($r)) {
                $this->data[$row['id']] = $row;
            }
            return $this->data;
        } else {
            if ($id !== null)
                $this->id = (int) $id;
            $q = 'SELECT * FROM `' . self::$table_name . '` WHERE `id`=' . $this->id;
            $r = $this->db->query($q);
            $this->data[$this->id] = $this->current = mysql_fetch_assoc($r);
            if ($this->data[$this->id])
                return $this->data[$this->id];
            else
                return false;
        }
    }

    public function load_current() {
        $q = 'SELECT * FROM `' . self::$table_name . '` WHERE `isOpen` and `vis` ORDER BY `id` DESC LIMIT 1';
        $r = $this->db->query($q);
        $this->data = $this->current = mysql_fetch_assoc($r);
        $this->id = $this->data['id'];
        return $this->data;
    }

    public function create($array=null) {
        if ($array === null) {
            if (get_magic_quotes_gpc())
                $array = array_map('stripslashes', $_REQUEST);
            else
                $array = $_REQUEST;
        }
        $q = 'INSERT INTO `' . self::$table_name . '` (`name`) VALUES (
        "' . mysql_real_escape_string(strip_tags($array['name'])) . '"
        )';
        $r = $this->db->query($q);
        $this->id = $this->db->get_id();
        return $this->id;
    }

    public function update($array = null) {
        if (!$this->id)
            return false;
        $this->load();
        if ($array === null) {
            if (get_magic_quotes_gpc())
                $array = array_map('stripslashes', $_REQUEST);
            else
                $array = $_REQUEST;
        }
        return $this->db->update(self::$table_name, array(
            'name'     => $array['name'],
            // 'capacity' => $array['capacity']
        ), array('id' => $this->id));
    }

    public function set_voices(array $voises) {
        if (!$this->id)
            return false;
        $has_voices = false;
        $this->load();
        $data = $this->data[$this->id];
        $results = unserialize($data['results']);

        $i = 1; // ($data['capacity'] - 1) 0;
        foreach ($voises as $key) {
            $has_voices = true;
            $results[$key]['res'] = $results[$key]['res'] + 1;
            if ($i-- < 1)
                break;
        }
        
        $results = serialize($results);
        $q = 'UPDATE `' . self::$table_name . '` SET `results`="' . mysql_real_escape_string($results) . '", `count`=count+1 WHERE `id`=' . $this->id;
        $this->db->query($q);    

        if ($has_voices)
            $_SESSION['poll-voiced'][$this->id] = true;
        return true;
    }

    public function add_field($array = null) {
        if (!$this->id)
            return false;
        $this->load();
        if ($array === null) {
            if (get_magic_quotes_gpc())
                $array = array_map('stripslashes', $_REQUEST);
            else
                $array = $_REQUEST;
        }
        $data = $this->data[$this->id];
        $res = unserialize($data['results']);
        if (empty($res))
            $res = array();

        $name = trim(strip_tags($_REQUEST['name']));
        if ($name != '') {
            array_push($res, array('name' => $array['name'], 'res' => 0, 'order' => count($res) + 1));
            $res = serialize($res);
            $q = 'UPDATE `' . self::$table_name . '` SET `results`="' . mysql_real_escape_string($res) . '" WHERE `id`=' . $this->id;
            $this->db->query($q);
            return true;
        }
        return false;
    }

    public function update_field() {
        if ($this->id == null)
            $this->id = $_REQUEST['id'];
        $current = $this->load();
        if ($current == null)
            return false;

        $field = (int) stripslashes($_REQUEST['field']);
        $results = unserialize($current['results']);
        if (!isset($results[$field]))
            return false;

        $name = trim(strip_tags($_REQUEST['name']));
        if ($name != '')
            $results[$field]['name'] = $name;
        return $this->db->update(self::$table_name, array('results' => serialize($results)), array('id' => $this->id));
    }
    
    public function update_position() {
        if ($this->id == null)
            $this->id = $_REQUEST['id'];
        $current = $this->load();
        if ($current == null)
            return false;

        $results = unserialize($current['results']);
        foreach ($_REQUEST['position'] as $key => $pos) {
            if (isset($results[$key])) {
                $results[$key]['order'] = (int) $pos;
            }
        }

        return $this->db->update(self::$table_name, array('results' => serialize($results)), array('id' => $this->id));
    }
    
    public function delete_field() {
        if (!$this->id && !isset($_REQUEST['key']))
            return false;
        $this->load();
        $data = $this->data[$this->id];
        $res = unserialize($data['results']);
        unset($res[$_REQUEST['key']]);
        $res = serialize($res);
        $q = 'UPDATE `' . self::$table_name . '` SET `results`="' . mysql_real_escape_string($res) . '" WHERE `id`=' . $this->id;
        $this->db->query($q);
        return true;
    }

    public function show() {
        $q = 'UPDATE `' . self::$table_name . '` SET `vis`=1 WHERE `id`=' . $this->id;
        $this->db->query($q);
    }

    public function hide() {
        $q = 'UPDATE `' . self::$table_name . '` SET `vis`=0 WHERE `id`=' . $this->id;
        $this->db->query($q);
    }

    public function open() {
        if (!$this->id)
            return false;
        $q = 'UPDATE `' . self::$table_name . '` SET `isOpen`=0 WHERE id !=' . $this->id;
        $this->db->query($q);
        $q = 'UPDATE `' . self::$table_name . '` SET `isOpen`=IF(`isOpen` = 1, 0, 1) WHERE `id`=' . $this->id; //IF(`isOpen`=1,0,1)
        $this->db->query($q);
    }

    public function delete() {
        if (!$this->id)
            return false;
        $q = 'DELETE FROM `' . self::$table_name . '` WHERE `id`=' . $this->id;
        $this->db->query($q);
        return true;
    }

    public function is_voiced() {
        if (isset($_SESSION['poll-voiced'][$this->id]))
            return true;
        else
            return false;
    }

    public function load_random() {
        if (isset($_SESSION['poll-random'])) {
            if (time() - $_SESSION['poll-random']['time'] > 120) {
                unset($_SESSION['poll-random']);
            } else {
                $result = $this->db->query('SELECT * FROM ' . self::$table_name . ' WHERE isOpen = 1 AND vis = 1 AND id = ' . $_SESSION['random']['id']);
                $data = mysql_fetch_array($result);

                if ($data === false) {
                    unset($_SESSION['poll-random']);
                }
            }
        }

        if (!isset($_SESSION['poll-random'])) {
            $result = $this->db->query('SELECT * FROM ' . self::$table_name . ' WHERE isOpen = 1 AND vis = 1 ORDER BY RAND() LIMIT 1');
            $data = mysql_fetch_array($result);
            if ($data !== false) {
                $_SESSION['poll-random']['time'] = time();
                $_SESSION['poll-random']['id'] = $data['id'];
            }
        }

        return $data;
    }

    public function sort_results($result) {
        if ($result)
            uasort($result, array($this, '_sort'));
        else
            $result = array();
        return $result;
    }
    
    public function _sort($r1, $r2) {
        $o1 = @$r1['order'];
        $o2 = @$r2['order'];
        
        if ($o1 == $o2) {
            $n1 = @$r1['name'];
            $n2 = @$r2['name'];
            return strnatcasecmp($n1, $n2);
        }
        return $o1 < $o2 ? -1 : 1;
    }
    
    function ajax_field_form() {
        load_lib('admin');
        if (!$this->id)
            return '  ';
        $field = (int) stripslashes($_REQUEST['field']);
        
        $current = $this->load();

        $results = unserialize($current['results']);
        if (!isset($results[$field]))
            return '  ';

        $data = $results[$field];
        $o = '';
                $o .= '
    <form action="' . meno_build_go(array('do' => 'update_field', 'id' => $this->id, 'field' => $field), 'polls', 'services') . '" method="post">
        <table>
            <tr>
                <th></th>
                <td>
                    <input type="text" name="name" value="' . $data['name'] . '" class="forma"/>
                </td>
            </tr>
            <tr>
                <td>
                    <input type="submit" value="" class="btn" />
                </td>
                <td><a href="" onclick="document.getElementById(\'edit_field\').style.display=\'none\';return false;"></a>
            </td>
        </tr>
        </table>
    </form>        	   
        	   ';
        return $o;
    }
}