<?php

class seo {

    public static $table_name = 'seo';
    public $data = array();
    private $db;
    public $module = null;
    public $object_id = null;
    public $object_type = null;

    function __construct($db, $module=null, $object_id=null, $object_type=null) {
        $this->db = $db;
        if ( $module === null)
            $this->module = stripcslashes($_REQUEST['module']);
        else
            $this->module = $module;
        if ($object_id === null)
            $this->object_id = (int) $_REQUEST['object_id'];
        else
            $this->object_id = (int) $object_id;
        if ($object_type === null)
            $this->object_type = stripslashes($_REQUEST['object_type']);
        else
            $this->object_type = $object_type;
        if (!$this->object_type)
            $this->object_type = 'main';
    }

    function get_seo() {
        $q = 'SELECT `title`,`description`,`keywords` FROM `' . self::$table_name .
                '` WHERE `module`="' . mysql_real_escape_string($this->module) .
                '" AND `object_type`="' . mysql_real_escape_string($this->object_type) .
                '" AND `object_id`=' . (int) $this->object_id;
        $r = $this->db->query($q);
        if ($r && mysql_num_rows($r) == 1) {
            $this->data[$this->module][$this->object_type][$this->object_id] = mysql_fetch_assoc($r);
            return $this->data[$this->module][$this->object_type][$this->object_id];
        }
        return false;
    }

    function set_seo($array = null) {
        $module = $this->module;
        $object_id = $this->object_id;
        $object_type = $this->object_type;
        if ($array === null)
            $array = array_map('stripslashes', $_REQUEST);
        $q = 'SELECT count(*) FROM `' . self::$table_name .
                '` WHERE `module`="' . mysql_real_escape_string($module) .
                '" AND `object_type`="' . mysql_real_escape_string($object_type) .
                '" AND `object_id`=' . (int) $object_id;
        $r = $this->db->query($q);
        if (mysql_result($r, 0, 0) == 1) {
            $q = 'UPDATE `' . self::$table_name . '` SET `title`="' . mysql_real_escape_string(strip_tags($array['title'])) .
                    '", `description`="' . mysql_real_escape_string(strip_tags($array['description'])) .
                    '", `keywords`="' . mysql_real_escape_string(strip_tags($array['keywords'])) .
                    '" WHERE `module`="' . mysql_real_escape_string($module) .
                    '" AND `object_type`="' . mysql_real_escape_string($object_type) .
                    '" AND `object_id`=' . (int) $object_id;
        } else {
            $q = 'INSERT INTO `' . self::$table_name . '` (`module`,`object_type`,`object_id`,`title`,`description`,`keywords`) VALUES (' .
                    '"' . mysql_real_escape_string($module) .
                    '","' . mysql_real_escape_string($object_type) .
                    '",' . (int) $object_id .
                    ',"' . mysql_real_escape_string(strip_tags($array['title'])) .
                    '","' . mysql_real_escape_string(strip_tags($array['description'])) .
                    '","' . mysql_real_escape_string(strip_tags($array['keywords'])) . '")';
        }
        $this->db->query($q);
        return true;
    }

    function clear_seo() {
        $q = 'DELETE FROM `' . self::$table_name . '` WHERE `module`="' . mysql_real_escape_string($this->module) .
                '" AND `object_type`="' . mysql_real_escape_string($this->object_type) .
                '" AND `object_id`="' . (int) $this->object_id;
        $this->db->query($q);
    }

    function show_form_edit() {
        $o = '<script>
        	  function show_seo_edit(module,object_type,object_id){
        	  	var get = \'subservices/ajax.php?service=seo&do=form&module=\'+module+\'&object_type=\'+object_type+\'&object_id=\'+object_id;
        	  	document.getElementById(\'seo_edit\').innerHTML = get_ajax_data(get);
        	  		toggle(\'#seo_edit\');
        	  }
        	  </script>
        	  <div id="seo_edit" class="hide modal">
        	  </div>';
        return $o;
    }

    function ajax_form() {
        $data = $this->get_seo();
        $o = '
        <div class="modal-header">
            <h3>  </h3>
        </div>
        <form action="go.php?menu=subservices&amp;service=seo&amp;do=set_seo" method="post">
            <div class="modal-body">
                <table><tr><td>title</td><td>
                <input type="hidden" name="module" value="' . htmlspecialchars($_REQUEST['module']) . '" />
                <input type="hidden" name="object_type" value="' . htmlspecialchars($_REQUEST['object_type']) . '" />
                <input type="hidden" name="object_id" value="' . htmlspecialchars($_REQUEST['object_id']) . '" />
                <input type="text" class="span5" id="seo_title" name="title" value="' . $data['title'] . '" /></td></tr>
                <tr><td>description</td>
                    <td><textarea class="span5" id="seo_description" rows="5" name="description">' . $data['description'] . '</textarea></td></tr>
                <tr><td>keywords</td>
                    <td><textarea class="span5" rows="5" id="seo_keywords" name="keywords">' . $data['keywords'] . '</textarea></td></tr>
              </table>
            </div>
            <div class="modal-footer">
                <a href="#" onclick="javascript:toggle(\'#seo_edit\');" class="btn"></a>
                <input type="submit" class="btn btn-primary" value="" />
            </div>
        </form>';
        return $o;
    }

    public function populateMetaTags($meta) {
        if (empty($meta) || !is_array($meta)) {
            return false;
        }

        global $metaTitle, $metaDescription, $metaKeywords;

        if (!empty($meta['title'])) {
            $metaTitle = $meta['title'];
        }

        if (!empty($meta['description'])) {
            $metaDescription = $meta['description'];
        }

        if (!empty($meta['keywords'])) {
            $metaKeywords = $meta['keywords'];
        }
    }

}

?>