<?php
class goods_stock extends Module{
    public static 	$table 			= 'catalog_stock';
    public static 	$uploadFolder 	= 'content/user_files/catalog/stock/';
    private static 	$imgWidth 		= 0;
    private static 	$imgHeight 		= '70';
    public static 	$imgPrefix 		= 's_';
    
    public function load(){
        return $this->db->query('SELECT * FROM :table',array('table'=>db_name(self::$table)),db::FETCH_ALL);
    }
    function loadById($id){
        return $this->db->query('SELECT * FROM :table WHERE id=:id',array('table'=>db_name(self::$table),'id'=>$id),db::FETCH_ROW);
    }
    function create(){
    	parent::_create(self::$table);
    }
    function update(){
      if ($_FILES['photo']['name'])
         $_REQUEST['image'] = $this->uploadImage();
    	parent::_update(self::$table,$this->id);
    }
    function delete(){
    	parent::_delete(self::$table,$this->id,'id');
    }
    function uploadImage(){
        if (!$this->id)
            return false;
        $sql = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`=' . ($this->id);
        $img = @array_pop($this->db->resultAsArray($sql));
        $img = stripslashes($img['image']);
        @unlink(SR . '/' . self::$uploadFolder . $img);
        @unlink(SR . '/' . self::$uploadFolder . self::$imgPrefix . $img);
        $name = get_name_to_file();
        $ext = $_FILES['photo']['name'];
        $ext = explode('.', $ext);
        $ext = array_pop($ext);
        $resize = new upload($_FILES['photo']['tmp_name']);
        if ($resize->uploaded) {
            $type = $_FILES['photo']['type'];
            $type = explode('/', $type);
            if ($type[0] != 'image') {
                continue;
            }
            $resize->file_new_name_body = $name;
            $resize->file_new_name_ext = $ext;
            $resize->process(SR . self::$uploadFolder);

            $imgsize = @getimagesize(SR . self::$uploadFolder . $name . '.' . $ext);
            $resize->file_new_name_body = self::$imgPrefix . $name;
            $resize->file_new_name_ext = $ext;
            $resize->image_resize = false;
            /*
            if (self::$imgHeight > 0 && self::$imgWidth > 0) {
                $resize->image_x = self::$imgWidth;
                $resize->image_y = self::$imgHeight;
                $resize->image_ratio_fill = true;
            } elseif (self::$imgWidth > 0 && !self::$imgHeight) {
                $resize->image_x = self::$imgWidth;
                $resize->image_ratio_y = true;
            } elseif (self::$imgHeight > 0 && !self::$imgWidth) {
                $resize->image_y = self::$imgHeight;
                $resize->image_ratio_x = true;
            }
            */
            $resize->file_overwrite = true;
            $resize->process(SR . self::$uploadFolder);
            if ($resize->error)
                echo $resize->error;
            return mysql_real_escape_string($name) . '.' . $ext;
        }
    }
    function deleteImage() {
        if (!$this->id)
            return false;
        $sql = 'SELECT `image` FROM `' . self::$table . '` WHERE `id`=' . ($this->id);
        $img = @array_pop($this->db->resultAsArray($sql));
        if (isset($img['image']))
            $img = $img['image'];
        @unlink(SR . self::$uploadFolder . $img);
        @unlink(SR . self::$uploadFolder . self::$imgPrefix . $img);
        return $this->db->query('UPDATE `' . self::$table . '` SET `image`="" WHERE `id`=' . $this->id);
    }
}
?>