<?php

ini_set('max_execution_time','3600');

/*
*  YML-  -
* @author: menocom /All Right Reserved/
*/

load_lib('admin');

class yml extends Module {

/*
*       
*/

	private $non_YML_cat = array ();
/*
* END
*/

/*
*  ,  100%   .
*/

	private $non_YML_symbol = array (	  '"',
										  '\'',
										  '>',
										  '<',
										  '&'
									);

/*
* END
*/

/*
*     <shop>
*/
#DATA#
	private $shop_attrib = array ('company'	=> ' ',
								  'platform'   		=> 'MenoCMS',
								  'version'    		=> '1.5',
								  'agency'     		=> 'MENOCOM',
								  'email'      		=> 'info@menocom.ru',
								  'name'			=> ' 96',
								  );
/*
* END
*/

private $goods_obj = null;
private $goods_data = null;
private $pathImage = '/content/images/subgallery/';

    public function __construct(){
        parent::__construct();
        $this->goods_obj = new goods($this->db);
        $this->itms = isset($_POST['items'])?$_POST['items']:false;
        $this->goods_obj->loadByYml($this->itms);
        $this->goods_data = $this->goods_obj->data;
    }

    public function load(){
        return false;
    }

    public function create_yml() {
	    #TIME#
		$mtime = microtime();
        $mtime = explode(" ", $mtime);
        $tstart = $mtime[1] + $mtime[0];
		#END
		#YML-FILE#
		$yml_file = SR.'robot.yml.xml';

		#HEADER_STATIC#
		$header = '<?xml version="1.0" encoding="windows-1251"?>
				   <!DOCTYPE yml_catalog SYSTEM "shops.dtd">
				   ';
		#HEADER_END#

		#START_YML#
		$yml_catalog_start = '<yml_catalog date="'.date('Y-m-d H:s').'">
							 ';

			#SHOP#
			$shop_start = '<shop>
						  ';

				#DATA#
				$settings 	= new settings($this->db);
				$data 		= $settings->load('shop');
				$data_yml 	= $settings->load('yml_settings');
				$data_main 	= $settings->load('main');
				#DATA_END#

			$shop_body = '<name> 96</name>
						  <company> 96</company>
						  <url>http://'.$_SERVER['SERVER_NAME'].'</url>
						 ';

			#CURRERCIES#

				$currercies_start = '<currencies>
									';

					/*
					* RUR - , USD - , EUR - 
					* CBRF in rate -     
					*/

					$currercies_body ='<currency id="RUR" rate="1" />
									   ';

				$currercies_end = '</currencies>
								  ';

			#END_CERRERCIES#

			#CATEGORIES#

				$catalog = new catalog($this->db);
				$catalog->load();
				$categories_start = '<categories>
									';
				$categories_body = '
								   ';
				foreach ($catalog->data as $v) {
					if (in_array($v['id'], $this->non_YML_cat)) continue;
					if($v['pid']==0){
						$categories_body .= '<category id="'.$v['id'].'">'.$this->yml_replace($v['name']).'</category>	';
					}else{
						$categories_body .= '<category id="'.$v['id'].'" parentId="'.$v['pid'].'">'.$this->yml_replace($v['name']).'</category>	';
					}
					
										
				}
				$categories_end = '</categories>
								  ';

			#END_CATEGORIES#

			#LOCAL_DELIVERY_COST#

				$local_delivery_cost = '<local_delivery_cost>200</local_delivery_cost>
									   ';

			#END_LOCAL_DELIVERY_COST#

			#OFFERS#

				$goodimg = new subgallery($this->db);
				$offers_start = '<offers>
								';

				foreach ($this->goods_data as $v) {
					if (!$v['vis']) continue;
					//+     
					if (!$v['price']) continue;
					if ($v['price'] == '0') continue;
					if ($v['price_man'] == '0' && $v['price'] == '0') continue;
					if (!$catalog->showning($v['cid'])) continue;
					if (in_array($v['cid'], $this->non_YML_cat)) continue;
					// if (!$v['in-stock']) continue;
					// if (($v['month-good'] || $v['sale-good'] || $v['is-new']) && ($v['in-stock'])) {
						$available = 'true';
					// } else {
						// $available = 'false';
					// }
					#  #
					$goodimg->load($v['id'], 'goods');
					$images = array();
					if ($goodimg->gallery) foreach ($goodimg->gallery as $img) {
					    if ($img['visible']) {
					        $images[] = array_merge($img, array(
					            "medium_thumb" => subgallery::$path . 'm' . $img['file']
					        ));
					    }
					}

					if ($images[0]['medium_thumb']) $image = 'http://' . $_SERVER['SERVER_NAME'] . $images[0]['medium_thumb'];
						else $image = '';

					#END#
					#  url  YML    + 30%#

					$_settings = new settings($this->db);
					$shop_settings =  $_settings->load('shop');
					if (abs(!defined('EXTRA')));
					define('EXTRA',$shop_settings['extra_charge']['value']);

						$url = $catalog->getUriById($v['cid']);
						$price = number_format($v['price'],2,'.','');


					#END#
					$offers_body .= '<offer id="'.$v['id'].'" available="' . $available . '">
										<url>http://' .$_SERVER['SERVER_NAME']. '/catalog/' . $url . '/' . $v['id'] . '/</url>
										<price>'.$price.'</price>
										<currencyId>RUR</currencyId>
										<categoryId>'.$v['cid'].'</categoryId>
										' . ($image ? '<picture>'. $image . '</picture>' : '') . '
										<name>'.$this->yml_replace($v['name']).'</name>
									 </offer>
									';
				}

				$offers_end = '</offers>
							  ';

			#END_OFFERS#

			$shop_end = '</shop>
						';
			#SHOP_END#

		#END_YML#
		$yml_catalog_end = '</yml_catalog>';

			/*
			*        
			*/
				//  $yml_data
				$yml_data = $header .
							$yml_catalog_start .
							$shop_start .
							$shop_body .
							$currercies_start .
							$currercies_body .
							$currercies_end .
							$categories_start .
							$categories_body .
							$categories_end .
							$offers_start .
							$offers_body .
							$offers_end .
							$shop_end .
							$yml_catalog_end;

				//
				if (file_exists($yml_file)) @unlink($yml_file);
				$yml_handle = fopen($yml_file, 'w');
				fwrite ($yml_handle, $yml_data);
				fclose($yml_handle);
				#TIME#
				$mtime = microtime();
				$mtime = explode(" ", $mtime);
				$mtime = $mtime[1] + $mtime[0];
				$mtime = $mtime - $tstart;
				#END#
				$t = explode(',', round($mtime, 2));
				// setMessage('   !');
				// setMessage('  (   ): <strong><font color="maroon">' . ($t ? $t[0] . ' , ' . $t[1] . '  ' : '  ...') . '</font></strong>');
				setMessage('   .: <input class="forma" style="color:red; font-weight: bold;" type="text" readonly="true" value="http://'.$_SERVER['SERVER_NAME'].'/robot.yml.xml" />');
				// setMessage('<b style="color:red;">, ,      .</b>');

			/*
			* END
			*/

	}

	//  yml-
	private function yml_replace($str) {
		if (!$str) return false;
		$out = str_replace($this->non_YML_symbol, '', $str);
		//     
		$out = strtolower($out);
		$out = ucfirst($out);
		return $out;
	}

}

?>