<?php

function get_link_id($arr_item){
	return $arr_item['id'];
}

function get_ico_class($extension){
	$extension = strtolower($extension);
	switch ($extension){
		case 'txt': $ico='txt'; break;
		case 'doc': case'docx': case'odt': case'sxw': case'rtf': $ico='doc'; break;
		case 'xls': case 'xlsx': case 'xml': case 'ods': case 'sxc':$ico='xls'; break;
		case 'pdf': $ico='pdf'; break;
		case 'zip': case'rar': case'gz': case'tar': $ico='zip'; break;
		case 'jpg': case'jpeg': case 'png': case 'gif': case 'bmp': case 'gif': $ico='img'; break;
		case 'html': case'htm':  $ico='web'; break;
		case 'ppt':  $ico='ppt'; break;
		default : $ico = 'empty';
	}
	return $ico;
}



function show_sticker($messages_array = array()) {
    global $account;
    if (empty($messages_array))
        return '';
    $i = 0;
    $out = '';
    foreach ($messages_array as $message) {
        $i++;
        $ico = '';
        $action = '';
			$action .='<a title=" " class="account_action" data-method="delete_message" data-user-id="'.$message['id'].'" href="/account/users/actions/delete_message/'.$message['id'].'"><img src="/template/images/cross-button.png"></a>';
        
        if ($message['user_role']==3){
            $ico .= '<span class="u_ico"><img src="/template/images/u_moder.png" title=""></span>';
        }elseif($message['user_role']==2){
            $ico .= '<span class="u_ico"><img src="/template/images/u_admin.png" title=""></span>';
        }
        $out .='<div class="sticker m_user'.$message['id'].'">
        	<span class="action fright">'.$action.'</span>
				<div class="text">' . nl2br($message['message']) . '</div>
				<div class="username"> ('.date('d.m.Y ',$message['date']) .' &mdash; '.date('H:i ',$message['date']) .') ' . $message['user_name'] . '</div>
            </div>';
    }
    if ($out)
        return '<div class="stickers_list list">' . $out . '</div>';
}

?>