<?php
/**
 *    
 */
// 
function getDeleveryArray(array $array,$price = 0){
        $return  = array();
    foreach($array as $k=>$v){
        $return[$v['id']]=$v['name'] . 
        ($price &&  $price <= $v['price_in']? 
                ($v['price_under'] ? ' (+'.$v['price_under'].' .)' : '')
            : 
                ($v['price_over'] ? ' (+'.$v['price_over'].' .)' : '')
            );
    }
    return $return;
}
/**
 *   
 */
function getCartDelevery($array){
    // 
    global $$array['value'], $cart;
    $total = $cart->total();
    $values = $$array['value'];
    
    $required = (!empty($array['attribs']['meta:validator']) && strstr($array['attribs']['meta:validator'], 'filled') !== false) ? true : false;
    $options = array();
    if(!count($values))
        return'';
    foreach($values as $value){
        $price_add = '';
        $data_params = '';
        if ($total && $total <=$value['price_in']){
            if ($value['price_under']) {
                $price_add = ' (+'.$value['price_under'].' .)';
                $data_params = 'data-price="'.$value['price_under'].'" data-delevery-name="'.$value['name'].'"';
            }
            else $price_add ='';
        }
        else{
            if ($value['price_over']) {
                $price_add = ' (+'.$value['price_over'].' .)';
                $data_params = 'data-price="'.$value['price_over'].'" data-delevery-name="'.$value['name'].'"';
            }
            else $price_add ='';
        }
        $options[] = '<option '.$data_params.' value="'.$value['id'].'">'.$value['name'].$price_add.'</option>';
    }


    $return = '<label>' . $array['label'] . ($required ? '<span class="required">*</span>' : '') . '</label><select ' . ($required ? 'required="required"' : '') . ' class="select change_delevery" name="' . $array['name'] . '" ' . $elAttribs . '>' . implode('',$options) . '</select>';
    return $return;
}


/**
 *   ,    
 */
function getCartTable(array $cart_array, $update = true) {
    global $cart;	
	
    $table = '<table class="table">
        <tr>
            <th style="width: 200px;">&nbsp;</th>
            <th></th>
            <th style="width: 100px;">-</th>
            <th style="width: 100px;"></th>
            <th style="width: 100px;">&nbsp;</th>
        </tr>';
    $i = 0;
    
    $rcmd = array();
    
    foreach ($cart_array as $item) {
        $i++;
        $item['price'] = $item['not_fixed'] ? $item['price_descript'] : number_format($item['price'], 0, '', ' ');

        $image = goods::getImage($item['id']);
        if (file_exists(SR.goods::$uploadFolder . goods::$popPrefix . $image)) {
            $img = goods::$uploadFolder . goods::$popPrefix . $image;
        }
        else
            $img = noimg('good');

        $safename = str_replace('"', "'", $item['name']);
        // var_dump($item);die();
        // var_dump($item['not_fixed']);die
        if ($item['unfixed_price']){
            //$price = '<div title="  ">*</div>';
			$price ='<span class="big">'.$item['price'].'</span> .';
        }
        else
            $price ='<span class="big">'.$item['price'].'</span> .';
			
      if ($item['count']!=0) {
        $rcmd += goods::getRecById($item['id']);		
		
        $table .= <<<HTML
        <tr>
            <td><img src="{$img}" /></td>
            <td>{$item['name']}</td>
            <td><input type="text" class="text width40 updatefield" data-item-id="{$item['id']}"  name="count[{$item['id']}]" value="{$item['count']}" /></td>
            <td class="nowrap">{$price}</td>
            <td><a class="async cartdel" data-name="{$safename}" href="?del={$item['id']}"></td>    
        </tr>
HTML;
	} 
                
    }
    $table .= '
        <tr>
            <td colspan="2">&nbsp;</td>
            <td><i>:</i><br/><span class="big bibig">' . $cart->total_items() . '</span></td>
            <td class="nowrap"><i> :</i><br/><span class="big total_price" data-summ="'.$cart->total().'">' . number_format($cart->total(), 0, '', ' ') . '</span> <i>.</i></td>
            <td>' . ($update ? '' : '' ) . '</td>
        </tr>
        </table>';       
    
    foreach ($cart_array as $item) {
        unset($rcmd[$item['id']]);
    }

    $table .= recommendation($rcmd);
    
    return $table;
}


function getPaymentTypes(){
    $payment=new Cart_payment;
    $arrList=$payment->load();    
    $show_payment='';
    //$show_payment.='<option value="0">...</option>';
    
    for($i=0, $j=count($arrList); $i<$j; $i++) {
        if ($selected==$arrList[$i]['name']) $set_selected=' selected';
        $show_payment.='<option value="'.$arrList[$i]['id'].'"'.$set_selected.'>'.$arrList[$i]['name'].'</option>';
        unset($set_selected);
    }
    return $show_payment;
}

function recommendation($arr){    
    if (empty($arr)) {
        return '';
    }
    
    $result = "<div class='h2'>   </div>";
    
    $result.=  '<table class="table">
                    <tr>
                        <th style="width: 200px;">&nbsp;</th>
                        <th></th>
                        
                        <th style="width: 100px;"></th>
                        <th style="width: 100px;">&nbsp;</th>
                    </tr>';           
    
    $rec_goods = "";
    foreach($arr as $item){
        $sg_image = $item['image'];//goods::getImage($item['id']);
        if (file_exists(SR.goods::$uploadFolder . goods::$popPrefix . $sg_image)) {
            $sg_img = goods::$uploadFolder . goods::$popPrefix . $sg_image;
        }else{
            $sg_img = noimg('good');
        }        
                    
        $result .= <<<HTML
        <tr>
            <td><img src="{$sg_img}" /></td>
            <td><a target="_blank" href="/{$item['href']}/">{$item['name']}</a></td>            
            <td class="nowrap"><span class="big">{$item['price']}</span> . </td>
            <td><a class="" data-name="{$safename}" href="?addCart={$item['id']}">  </td>    
        </tr>
HTML;
                    
    }    
    
    $result .= "</table>";
    
    return $result;
}
