<?php

/**
 *
 *	@author Sergey Arbora
 *
 * 	 ,      .... API )))
 *
 **/


load_lib('admin');
set_tz_by_offset(7); 


define('INIT_DB_FILE', DR.'inc/actions/install/db.sql');




if(isset($_GET['install'])){
	switch ($_GET['install']) {
		//  
		case 'db':{ //  DB (,     !!!)
			$data = $db->resultAsArray('SELECT * FROM `information_schema`.`tables` WHERE `table_name`="settings" LIMIT 1');
			if ($data) $data = $db->resultAsArray('SELECT * FROM `settings` LIMIT 1');
			if ($data) go404();

			$db = new mysqli($config->db->host, $config->db->user, $config->db->password, $config->db->db_name);
			$file = trim(file_get_contents(INIT_DB_FILE));
			$result = $db->multi_query($file);
			break;
		}
		default:break;
	}
	var_dump($result, error_get_last());
	die();
}elseif(isset($_GET['delete'])){
	switch ($_GET['delete']) {
		//       
		case 'subgallery_with_no_file':{
			$gallery = new subgallery($db);
			$data = $gallery->loadAll();
			$p = subgallery::$path;
			$i=0;
			foreach ($data as $k => $v) {
			    var_dump(is_file(SR.ltrim($p.$v['file'], '/')));
			    if(!is_file(SR.ltrim($p.$v['file'], '/'))){
			        $gallery->delete($v['id']);
			        ++$i;
			    }
			}
			die('<br><h1>Deleted: '.$i.'</h1>');
			break;
		}
	}

}elseif(isset($_GET['info'])){
	switch ($_GET['info']) {
		//     
		case 'version':{
			if (SITE_TYPE == 'link'){
				$index = SR.'index.php';
				$date_create = filectime($index);
				$date_modif  = filemtime($index);
				
				echo '<h2>SITE-LINK:</h2><ul>';
				echo '<li>created: '.date('d.m.Y H:i:s',$date_create).'</li>';
				echo '<li>modified: '.date('d.m.Y H:i:s',$date_modif).'</li>';
				echo '</ul>';
			}
			$index = DR.'index.php';
			$date_create = filectime($index);
			$date_modif  = filemtime($index);
			
			echo '<h2>SITE:</h2><ul>';
			echo '<li>created: '.date('d.m.Y H:i:s',$date_create).'</li>';
			echo '<li>modified: '.date('d.m.Y H:i:s',$date_modif).'</li>';
			echo '</ul>';			
			break;
		}
		case 'phpinfo':{
			phpinfo();
			break;
		}
	}
}elseif(isset($_GET['chmod'])){
	echo '<div>robots.txt: ' . (chmod (SR . 'robots.txt', '0777') ? 'success' : 'fail') . '</div>';
	echo '<div>sitemap.xml: ' . (chmod (SR . 'sitemap.xml', '0777') ? 'success' : 'fail') . '</div>';

	die('ok');
}elseif($db->qa[1] == 'rating'){
	require DR .'classes/modules/rating/rpc.php';
	die();
}



//  ajax-

if (!isAjax())go404();
if (!isset($_REQUEST['obj'])) die();
if (!isset($_REQUEST['do'])) die();

header('Content-Type: text/html; charset=windows-1251');
    
$obj	= new $_REQUEST['obj']($db);
$do 	= $_REQUEST['do'];
if(method_exists($obj,$do)) $result = $obj->$do();

switch ($do) {
	case 'tooltip':
		die('<div class="hint">'.$result.'<i class="icon-remove-sign"></i></div>');
		
	default:
		die($result);
		break;
}
die();
?>