<?php

if (!$loader->serviceActive('brands'))
    go404();

$module          = 'goods_brands';
$module_name 	  = $loader->serviceName('brands');

//$status_string .= ' / <a href="/' . $module . '">' . $module_name . '</a>';
//$header_sect     = $module_name;
$module_link     = 'brands';

global $catalog;
if (!$catalog) $catalog = new catalog($db);

navigation::add_breadcrumb($module_name , '/'.$module_link.'/');

$obj = new $module($db);
$body_sect = '<div class="brands_page">';

if ($db->qa[1]) {
	/* arbora:        ID,   ,   
	
	if(!is_numeric($db->qa[1])){ // 
		$data = $obj->load_by_url($db->qa[1]);
		navigation::add_breadcrumb($data['name'],'/'.$module_link.'/'.$data['url']);
	}else{ //   
		$data = $obj->load_by_id($db->qa[1]); 
		navigation::add_breadcrumb($data['name'],'/'.$module_link.'/'.$data['id']);
	}*/
	$data = $obj->load_by_url($db->qa[1]);
	if (!$data || $db->qa[2]){
		go404();
	}
	navigation::add_breadcrumb($data['name'],'/'.$module_link.'/'.$data['url']);
    if ($data){
		//var_dump($data);die();        
		//$header_sect = $data['name'];
            $body_sect .=    '<div class="content_description">'.$data['description'].'</div>';

            //load and print catalog section and  goods
            $goods = $obj->load_goods_by_brand($data['id']);
            $_goods = '';
            if (!empty($goods)){
            	$render = new Template();
            	$item_render = new Template();
	               foreach($goods as $catalog_id => $goods){
	               	$items .= '<div class="clear"></div> <div><h2>'.catalog::getNameById($catalog_id).'</h2></div>';
	               	foreach ($goods as $item) {
            		      if ($item['image'] != '') {
						            $item_preview = array(
						                'image' => catalog::$uploadFolder . $item['image'],
						                'thumb' => catalog::$uploadFolder . catalog::$popPrefix . $item['image']
						            );
						        } else {
						            $item_preview = false;
						        }

						        $preview_thumb = noimg();
						        if ($item_preview != false) {
						            $preview_thumb_file = rtrim($_SERVER['DOCUMENT_ROOT'], DIRECTORY_SEPARATOR) . $item_preview['thumb'];
						            if (file_exists($preview_thumb_file)) {
						                $preview_thumb = $item_preview['thumb'];
						            }
						        }
						        
						        $uri = $catalog->getUriById($item['cid']);
						        $item['href'] = "/catalog/{$uri}/{$item['uri']}/";
						        
            		      $items .= $item_render
								                ->set('item', $item)
								                ->set('preview_thumb', $preview_thumb)
								                ->render("/catalog/good/item.php");
	               	}
							$items .='<div class="separ"></div>';
	               }
					   $items = $render->renderWrap("/catalog/good/list.php", $items);
                  $body_sect .= $items;
            }
		$seo = new seo($db, 'catalog', $data['id'], 'brand');
        $seo->populateMetaTags($seo->get_seo());
    }


    $body_sect .= '<div class="back_link"><a href="/' . $module_link . '/">&larr;  </a></div>';

}else{
    $header_sect = '';
    $obj_data = $obj->load();
    if (is_array($obj_data)){
        $body_sect .= '<div class="brands_list"><ul>';
			foreach($obj_data as $data) {
                if ($data['name']) {
					if (!$data['url']) {
						goods_brands::setUrlAndUpdate($data['id']);
						$data['url'] = $data['id'];
					}
					$url = $data['url'];
					$body_sect .= '<li><a href="/'.$module_link.'/'.$url.'/">'.$data['name'].'</a></li>';
				}
            }
        $body_sect .= '</ul></div>';
    }
}
$body_sect .= '</div>';
?>