<?php
if (!$loader->serviceActive('catalog')) 
{
    go404();return;
}

$catalog = new catalog($db);
$goods = new goods($db);


$id = $catalog->getIdByUri($db->qa[1]) ?  $catalog->getIdByUri($db->qa[1]) : 0;

if ((!$catalog->checkVisible($id) || $db->qa[3]) && $db->qa[1] != 'new') 
{
    go404();
}
else 
{
    
	$statStr = $catalog->getStatusString($id);			
	//$status_array = !isset($statStr[0]) ? array(array('url'=>'/catalog/','name'=>$loader->serviceName('catalog'))) : array();
	$status_array = array_merge(array(array('url'=>'/catalog/','name'=>$loader->serviceName('catalog'))),$catalog->getStatusString($id));
  
    if ($status_array)
        foreach ($status_array as $v) 
        {
            if ($v['name'])
                navigation::add_breadcrumb($v['name'] , '/catalog/'.$v['uri']);
        }
    if (isset($db->qa[2]) && $db->qa[2]) 
    {

        $good_id = $goods->getIdByUri($db->qa[2]);
		
        if ((!$good_id or !$goods->checkVisible($good_id)) && !in_array($good_id,array(618,758,691,693,695,694,696,273))) 
        {
            go404(); 
        } 
        else 
        {	
            $item_type = 'good';
            $item_id = $good_id;
            include DR . 'inc/catalog/goods.php';
        }
    }
    else
    {
        if($db->qa[1] == 'new'){
            $item_type='new';
            $item_id= 'new';
            include DR . 'inc/catalog/catalog_new.php';
        }else{
            $item_type='main';
            $item_id= $id;
            include DR . 'inc/catalog/catalog.php';
        }
        
    }
    if ($item_id && $item_type)
    {
        $seo = new seo($db, 'catalog', $item_id, $item_type);
        $seo->populateMetaTags($seo->get_seo());
    }
}
