<?php
/**
 *   , , .
 * 1.      ,    .
 * 2.    -   .
 * 3.  (?,  30)   .
 * TODO   
 * @package     reobot96
 * @subpackage  reviews
 * @author      Tony Stark <546f6e79@gmail.com>
 */

if (!$loader->serviceActive('reviews')){
	go404(); return;
}

$render = new Template();
$error = array();
$faq= new reviews($db);

$header_sect = $loader->serviceName('reviews');
navigation::add_breadcrumb($loader->serviceName('reviews') , '/reviews/');

$module = 'reviews';
$reviews = new $module($db);

$render = new Template();
$item_render = new Template();

$data = $reviews->load_vible();

//  -  , ID-4
$count = $reviews->count(true, 4);
$ya_count_plural = pluralForm($count, '', '', '');

//  -  Mail, ID-5
$mailcount = $reviews->count(true, 5);
$mail_count_plural = pluralForm($mailcount, '', '', '');

$items = '';

if ($data)
	$items .= $item_render->clear()
		->set('items', $data)
		->set('ya_count', $count)
		->set('ya_count_plural', $ya_count_plural)
		->set('mail_count', $mailcount)
		->set('mail_count_plural', $mail_count_plural)
		->render('/reviews/list.php');
$body_sect .= $render->renderWrap('/reviews/index.php', $items);

function pluralForm($n, $form1, $form2, $form5){
	$n = abs($n) % 100;
	$n1 = $n % 10;
	if ($n > 10 && $n < 20) return $form5;
	if ($n1 > 1 && $n1 < 5) return $form2;
	if ($n1 == 1) return $form1;
	return $form5;
}

?>


