<?php

$items    = $this->get('items');
$ya_count    = $this->get('ya_count');
$ya_count_plural    = $this->get('ya_count_plural');
$mail_count = $this->get('mail_count');
$mail_count_plural = $this->get('mail_count_plural');
$rating = array(1,2,3,4,5);
//printPre($items);
?>

<div class="review-services-btns" style="text-align:center;">
	<div class="review-service" style="display:inline-block; padding-right:60px;">
		<img src="/template/meno_v2.3/images/services/yandex.jpg">
		<div class="reviews-count">
			<a data-href="http://market.yandex.ru/shop-opinions.xml?shop_id=151862" target="_blank" href="http://market.yandex.ru/shop-opinions.xml?shop_id=151862"><?php echo $ya_count. ' ' .$ya_count_plural; ?></a></div>
		<div class="reviews-send" style="margin-top: 10px">
			<a target="_blank" href="http://market.yandex.ru/shop/151862/reviews/add" class="btn"> </a>
		</div>
	</div>
	<div class="review-service" style="display:inline-block;">
		<img class="torg-mail-logo" src="/template/meno_v2.3/images/services/mailru.png">
		<div class="reviews-count">
			<a target="_blank" href="http://torg.mail.ru/shop/robot96-ru-cid17635/"><?php echo $mail_count. ' ' .$mail_count_plural; ?></a></div>
		<div class="reviews-send" style="margin-top: 10px">
			<a target="_blank" href="http://torg.mail.ru/upload/review/?proc=add_review&type_id=2&client_id=17635" class="btn"> </a>
		</div>
	</div>
	<div></div>
	<div></div>
</div>
<?php if(!empty($items)){ ?>
<div class="reviews-list">
	<?php foreach($items as $item){ ?>
		<div class="reviews-item">
			<div class="reviews-info">
				<span title="<?php echo $item['rating']; ?> " class="reviews-item-rating">
						<?php foreach($rating as $rat){ ?>
							<?php if($item['rating'] >= $rat){ ?>
								<i class="fa fa-star fa-lg fa-color-orange"></i>
							<?php } else { ?>
								<i class="fa fa-star-o fa-lg"></i>
							<?php } ?>
						<?php } ?>
				</span>
				<span class="reviews-author"><?php echo($item['name']) ?></span>
				<span class="reviews-date"><?php echo(date('d.m.Y', strtotime($item['created_at']))) ?></span>
			</div>
			<div class="reviews-content">
				<b>: </b> <?php echo $item['worth']; ?>
				<br>
				<b>: </b>
				<?php echo $item['limitations']; ?>
				<br>
				<b>: </b> <?php echo($item['comment']) ?>
				<?php if(!empty($item['store_comment'])){ ?>
					<br>
					<div class="reviews-store">
						<a href="javascript:void(0)" class="reviews-store-comment" data-pk="<?php echo $item['id']; ?>"><span class="b-link__inner"> </span></a>
						<div class="reviews-store-comment-content" id="reviews-store-comment-content<?php echo $item['id']; ?>" style="display:none;">
							<div class="reviews-store-content">
								<b> Robot96.ru</b>
								<br>
								<?php echo $item['store_comment']; ?>
							</div>
						</div>
					</div>
				<?php } ?>
			</div>

		</div>
	<?php } ?>
</div>
<?php } ?>

<script type="text/javascript">
	$(document).ready(function(){
<!--		$("#reviews-store-comment--><?php //echo $item['id']; ?><!--").click(function() {-->
<!--			$(this).show( "slow" );-->
<!--		});-->
		$(".reviews-store-comment").on('click', function () {
			var pk = $(this).data('pk');
			//console.log(pk);
			$('#reviews-store-comment-content'+pk).toggle();
		});
	});
</script>
